/*============================================================================
 * filename:		mod_auth.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
 * license to use, modify, and market this program using their tradename
 * T.Rex.	
 *
 *
 * (C) COPYRIGHT R. James Livermore 1999-2000.  All rights reserved.
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1999-2000.
 * All right reserved.
 *
 *
 * Date written:	N/A
 * last update:		February   8, 2000
 *
 *
 *============================================================================*/
/* ====================================================================
 * Copyright (c) 1995-1999 The Apache Group.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * 4. The names "Apache Server" and "Apache Group" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Apache Group
 *    for use in the Apache HTTP server project (http://www.apache.org/)."
 *
 * THIS SOFTWARE IS PROVIDED BY THE APACHE GROUP ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE APACHE GROUP OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Group and was originally based
 * on public domain software written at the National Center for
 * Supercomputing Applications, University of Illinois, Urbana-Champaign.
 * For more information on the Apache Group and the Apache HTTP server
 * project, please see <http://www.apache.org/>.
 *
 */

/*
 * http_auth: authentication
 * 
 * Rob McCool
 * 
 * Adapted to Apache by rst.
 *
 * dirkx - Added Authoritative control to allow passing on to lower
 *         modules if and only if the user-id is not known to this
 *         module. A known user with a faulty or absent password still
 *         causes an AuthRequired. The default is 'Authoritative', i.e.
 *         no control is passed along.
 */

#include "httpd.h"
#include "http_config.h"
#define CORE_PRIVATE
#include "http_core.h"
#undef CORE_PRIVATE
#include "http_log.h"
#include "http_protocol.h"
#include "firewall.h"
#include "gwuser.h"
#include "ap_md5.h"

module MODULE_VAR_EXPORT gwauth_module;

static char *get_gw(request_rec *r, char *user, struct GWUSER *gwuptr)
{
    int rc;
    char *msg;

    if ((rc = get_gwuser(user, gwuptr)) < 0) {
	ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
			"User \"%s\" not found", user);
	ap_table_set(r->notes, "gwuser-msg", "Either the username or password "
			"entered is not correct, please correct and try "
			"again.");
	return NULL;
    }

    switch (rc) {
	case 0:	if( strlen(gwuptr->password[0]) == 0) {
		    ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
				"Access denied - Null password in gwuser db "
				"for user \"%s\"", user);
		    msg = ap_pstrcat(r->pool, "The username entered (", user,
				") has not been setup with a password, please "
				"contact your system administrator.", NULL);
		    ap_table_set(r->notes, "gwuser-msg", msg);
		    return NULL;
		}
		return((char *)gwuptr);	/* successful return is any non-zero*/
	case 1:	ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
				"Access denied - User \"%s\" record locked.",
				user);
		msg = ap_pstrcat(r->pool, "The username entered (", user,
			") has been locked, please "
			"contact your system administrator.", NULL);
		ap_table_set(r->notes, "gwuser-msg", msg);
		return NULL;
	case 2: ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
				"Access denied - Current date outside of "
				"effective start and stop dates for user "
				"\"%s\"", user);
		msg = ap_pstrcat(r->pool, "Current date outside of effective "
			"start and stop dates for user \"", user,
			"\", please contact your system administrator for "
			"the effective dates.", NULL);
		ap_table_set(r->notes, "gwuser-msg", msg);
		return NULL;
	case 3: ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
				"Access denied - Current time is not within "
				"the allowed access times.");
		msg = ap_pstrcat(r->pool, "Current time is not within the "
			"allowed access times for user \"", user,
			"\", please try again within the allowed times.", NULL);
		ap_table_set(r->notes, "gwuser-msg", msg);
		return NULL;
	default:
		ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, NULL,
                                "Access denied - get_gwuser returned %d", rc);
		ap_table_set(r->notes, "gwuser-msg", "User login failed, please "
			"contact your system administrator for assistance.");
		return NULL;
    }
}

static char *get_pw(request_rec *r, char *user, struct GWUSER *gwuptr)
{
    if (get_gw(r, user, gwuptr))
	return(ap_pstrdup(r->pool, gwuptr->password[0]));
    return NULL;
}

static table *groups_for_user(request_rec *r, char *user)
{
    struct GWUSER gwu;
    table *grps = ap_make_table(r->pool, 2);

    if (get_gw(r, user, &gwu) == NULL)
	return(NULL);

    ap_table_set(grps, gwu.groupname, "in");
    return grps;
}

/* These functions return 0 if client is OK, and proper error status
 * if not... either AUTH_REQUIRED, if we made a check, and it failed, or
 * SERVER_ERROR, if things are so totally confused that we couldn't
 * figure out how to tell if the client is authorized or not.
 *
 * If they return DECLINED, and all other modules also decline, that's
 * treated by the server core as a configuration error, logged and
 * reported as such.
 * 
 * Note that this particular function in this module (mod_gwauth) will not
 * defer an auth decision so it never returns DECLINED.
 */

/* Determine user ID, and check if it really is that user, for HTTP
 * basic authentication...
 */

static int authenticate_basic_user(request_rec *r)
{
    conn_rec *c = r->connection;
    const char *sent_pw;
    char *real_pw;
    char *invalid_pw;
    int res;
    uid_t euid;
    struct GWUSER gwu;
    extern struct GWCONF conf;
    core_dir_config *coreconfig;
    
    /*======================================================================
     * LSLI
     * Set the core module ap_auth_type and ap_auth_name if they are not set.
     * We do it here so as to contain the gwauth changes within the module
     * instead of havong to make changes in http_core.c.
     * We want this change so that the user doesn't need to specify AuthName
     * and AuthType in the config file.
     *=====================================================================*/
    coreconfig = (core_dir_config *)ap_get_module_config(r->per_dir_config,
		    						&core_module);
    if (coreconfig->ap_auth_type == NULL)
	coreconfig->ap_auth_type = "Basic";
    if (coreconfig->ap_auth_name == NULL)
	coreconfig->ap_auth_name = "Proxy";

    if ((res = ap_get_basic_auth_pw(r, &sent_pw)))
	return res;

    if (sent_pw == NULL || strlen(sent_pw) == 0) {
	char *msg;
	ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, r->server,
		"NULL password entered.");
	msg = ap_pstrdup(r->pool, "No password was entered, please enter a "
		"password.");
	ap_table_set(r->notes, "gwuser-msg", msg);
	ap_note_basic_auth_failure(r);
	return AUTH_REQUIRED;
    }

    /*=======================================================================
     * Switch back to root for a second to do the gwuser stuff
     *======================================================================*/
    euid = geteuid();
    if (euid != 0)
#if !defined(__hppa)
	seteuid(0);
#else
	setresuid(-1, 0, -1);
#endif

    if (!(real_pw = get_pw(r, c->user, &gwu))) {
	if (euid != 0)
#if !defined(__hppa)
	    seteuid(euid);
#else
	    setresuid(-1, euid, -1);
#endif

	ap_note_basic_auth_failure(r);
	return AUTH_REQUIRED;
    }
    if (strcmp(real_pw, sent_pw)) {
	ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, r->server,
		    "user %s: password mismatch: %s", c->user, r->uri);
	ap_table_set(r->notes, "gwuser-msg", "Either the username or password "
			"entered is not correct, please correct and try "
			"again.");
	set_nologins(gwu.username,1,conf.no_login_attempts);
	if (euid != 0)
#if !defined(__hppa)
	    seteuid(euid);
#else
	    setresuid(-1, euid, -1);
#endif
	ap_note_basic_auth_failure(r);
	return AUTH_REQUIRED;
    }
    set_nologins(gwu.username,0,conf.no_login_attempts);
    if (euid != 0)
#if !defined(__hppa)
	seteuid(euid);
#else
	setresuid(-1, euid, -1);
#endif

/* LSLI - add check for expired password */
    {
	time_t cur = time((time_t *)NULL);
	if (conf.password_max_age != 0 &&
		cur - gwu.passworddate > conf.password_max_age*24*60*60 &&
		gwu.status != LOCKED) {
	    ap_log_error(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, r->server,
			"Password for user \"%s\" has expired.", c->user);
	    ap_table_set(r->notes, "gwuser-msg",
			"Your password has expired.  You can "
			"telnet to the firewall and login with your username "
			"and current password and you will be prompted to "
			"change your password.  You can then try access "
			"again with your new password.");
	    ap_note_basic_auth_failure(r);
	    return AUTH_REQUIRED;
	}
    }
    return OK;
}

/* Checking ID */

static int check_user_access(request_rec *r)
{
    char *user = r->connection->user;
    int m = r->method_number;
    int method_restricted = 0;
    register int x;
    const char *t, *w;
    char *msg;
    uid_t euid;
    table *grpstatus;
    const array_header *reqs_arr = ap_requires(r);
    require_line *reqs;

    /* BUG FIX: tadc, 11-Nov-1995.  If there is no "requires" directive, 
     * then any user will do.
     */
    if (!reqs_arr)
	return (OK);
    reqs = (require_line *) reqs_arr->elts;

    /*=======================================================================
     * Switch back to root for a second to do the gwgroup stuff
     *======================================================================*/
    euid = geteuid();
    if (euid != 0)
#if !defined(__hppa)
	seteuid(0);
#else
	setresuid(-1, 0, -1);
#endif
    grpstatus = groups_for_user(r, user);
    if (euid != 0)
#if !defined(__hppa)
	seteuid(euid);
#else
	setresuid(-1, euid, -1);
#endif

    for (x = 0; x < reqs_arr->nelts; x++) {

	if (!(reqs[x].method_mask & (1 << m)))
	    continue;

	method_restricted = 1;

	t = reqs[x].requirement;
	w = ap_getword_white(r->pool, &t);
	if (!strcmp(w, "valid-user"))
	    return OK;
	if (!strcmp(w, "user")) {
	    while (t[0]) {
		w = ap_getword_conf(r->pool, &t);
		if (!strcmp(user, w))
		    return OK;
	    }
	}
	else if (!strcmp(w, "group")) {

	    while (t[0]) {
		w = ap_getword_conf(r->pool, &t);
		if (ap_table_get(grpstatus, w))
		    return OK;
	    }
	}
    }

    if (!method_restricted)
	return OK;

    ap_log_rerror(APLOG_MARK, APLOG_NOERRNO|APLOG_ERR, r,
	"access to %s failed, reason: user %s not allowed access",
	r->uri, user);
    msg = ap_pstrcat(r->pool, "Access permission not granted to user \"", user,
			"\", please contact your system administrator.", NULL);
    ap_table_set(r->notes, "gwuser-msg", msg);
	
    ap_note_basic_auth_failure(r);
    return AUTH_REQUIRED;
}

module MODULE_VAR_EXPORT gwauth_module =
{
    STANDARD_MODULE_STUFF,
    NULL,			/* initializer */
    NULL,			/* dir config creater */
    NULL,			/* dir merger --- default is to override */
    NULL,			/* server config */
    NULL,			/* merge server config */
    NULL,			/* command table */
    NULL,			/* handlers */
    NULL,			/* filename translation */
    authenticate_basic_user,	/* check_user_id */
    check_user_access,		/* check auth */
    NULL,			/* check access */
    NULL,			/* type_checker */
    NULL,			/* fixups */
    NULL,			/* logger */
    NULL,			/* header parser */
    NULL,			/* child_init */
    NULL,			/* child_exit */
    NULL			/* post read-request */
};
