/*============================================================================
 * filename:		../ftproxy/authenticate.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*============================================================================= 
 *
 * written by:		R. James Livermore 
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  
 * All rights reserved.   
 *   
 *
 * Date written:	April    23, 1995
 * Last modified:       July     11, 1996 - added support for anonymous ftp
 *                      November 20, 1996 - added support for private net
 *                      April    22, 1997 - added support for new gwuser
 * 			February  8, 2000 - added LPL
 *
 * functions:
 *		Prompt user for name and read gwuser record. 
 *		If user not found ask for password and reject so that they
 *		can Not tell which was wrong.  Allow ntries.  If user
 *		record is found then determine type of authentication.  
 * 
 * outputs: 
 *	return  0 if ok 
 *	return -1 error or not found. 
 *===========================================================================*/  
static	char	cprght[] = 
  		"(C) COPYRIGHT Freemont Avenue Software, Inc. 1995-2000 "
  		"ftproxy V 1.0 00/01/21";
#include	<sys/types.h> 
#include	<stdio.h>
#include	<stdlib.h> 
#include	<string.h>
#include	<ctype.h>
#include	<syslog.h>
#include	<time.h> 
#include 	<unistd.h>
#include	<fcntl.h>
#include	<sys/ioctl.h>
#include	<sys/errno.h> 
#include	<sys/signal.h>
#include	<arpa/telnet.h>
#include	<sys/time.h>   
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<netdb.h> 
#include	"firewall.h" 
#include	"ftproxy.h" 
#include	"gwuser.h"
/*===========================================================================
 * function prototypes
 *===========================================================================*/
int authuser(struct GWUSER *gwup, char *buf, char *sourceip, char *srcname); 
int get_gwuser(char *username, struct GWUSER *gwup);	  	/* rjl 4/22/97 */
int getline(int fd, unsigned char *buf, int siz); 
int say(int fd, char *s);
int sayn(int fd, char *s, int n);   
int snkverify(char *challenge, char *response, struct GWUSER *gwup); 
int strcasecmp(const char *, const char *);
int tnsecdyn(char *username, char *buffer);

static char	nprompt[] = "Username: ";
static char	pprompt[] = "Password: "; 
extern struct GWCONF	conf;
/*===========================================================================
 *
 *=========================================================================*/
int authenticate(struct GWUSER *gwuptr, struct FTPROXY *proxyptr,
                 char *failedusers, char *savedcmd)
{                                   

   static char  invalnpwd[] = "You entered an invalid login name or password.\r\n";
   static char	noauth[] = "Cannot connect to authentication server";
   static char	toobad[] = "Too many failed login attempts";
   static char	toobig[] = "501 User name too large.";
   static char	lostit[] = "Lost connection to authentication server";
   static char	loggedin[] = "Login Accepted";
   char		buf[CBUFSIZ];
   char		obuf[CBUFSIZ];
 /*  char		cbuf[128];*/
   char		*cp; 
   char         namebuf[UNMSIZ];
   char		*token1;
   char		*token2;
   char 	*token3;
   const char	tokensep[]   = "\t \n";
/*   char		ubuf[128]; */
   char		*user;
   int		i;
   int		j;
   int		ntries   = MAXTRIES;
   int		numalpha = 0;
   int		namelen; 
   int		rc;
   int		x;
    struct GWGROUP group; 
   failedusers[0] = '\0';	/* initialize end of string	*/
   /*============================================
    * give the user ntries to get it right	
    *===========================================*/
   while(ntries--) 
   {  
      /*===================================================================
       *  The FTP client prompts the user for their name and sends 
       * 'USER name" to the proxy. Most ftp clients send USER name first.
       * However: DEC sends STRU first, EXCEED sends SYST first.
       *==================================================================*/
      if( getline(0,(unsigned char *)buf,CBUFSIZ - 1) < 0 )
         goto close_go; 
      if( proxyptr->debug)
      {
         syslog(LOG_NOTICE,"command: %s",buf);
      }
      if( (token1 = strtok(buf,tokensep)) == NULL)
         goto close_go;
      if( strcasecmp(token1,"QUIT") == 0 )
      {
         syslog(LOG_ERR,"User QUIT. source = %s (%s)",
			 proxyptr->srcname, proxyptr->sourceIP); 
         say(0,"221 Goodbye.");
         return(-2);   
      } 
      if( ntries == 0 )
      {
         say(0,"221 Goodbye.");
         return(-2); 
      } 
      /* Added to support EXCEED and AS/400	*/
      if( strcasecmp(token1,"SYST") == 0)
      {
         say(0,"215 UNIX");
         ntries++;      	/* give them one more try	*/
         continue;	
      } 
      if( strcasecmp(token1,"STRU") == 0)
      {                 
         if( (token3 = strtok(NULL,tokensep)) == NULL )
         { 
	    sprintf(obuf,"500 %s unknown structure.", token1);            
         } 
         else
	    sprintf(obuf,"220 %s %s ok.", token1, token3);
         if( say(0,obuf) )
         {
            syslog(LOG_NOTICE,"Error: Can Not display stru x msg to %s (%s).",
		proxyptr->srcname, proxyptr->sourceIP);  
            exit(1);
         }
         strncpy(savedcmd,token1,5); 
         strcat(savedcmd," ");
         if( token3 != NULL)
            strcat(savedcmd,token3);  
         syslog(LOG_NOTICE,"%s",savedcmd);
         ntries++;      	/* give them one more try	*/
         continue;	
      }
      if( strcasecmp(token1,"USER") != 0 )
      {
         syslog(LOG_ERR,"Error: keyword 'USER' expected received '%s' instead."
			" source = %s (%s)",
			 token1, proxyptr->srcname, proxyptr->sourceIP); 
         syslog(LOG_ERR,"buffer:'%s'",token1); 
         say(0,"530 Please login with USER and PASS.");
         continue;  
      }
      if( (token2 = strtok(NULL,tokensep)) == NULL)
      {
         syslog(LOG_ERR,"Error: no user name specified. source = %s (%s)",
			proxyptr->srcname, proxyptr->sourceIP);
         return(-2); 
      } 
      user = token2;
 
      /*====================================================================
       * Validate Username: length > 0 and < maximum size, 
       * at least one alpha character 
       *===================================================================*/
      if((namelen = strlen(user)) == 0)
         continue;
      if( namelen > (UNMSIZ-1)) 
      {  
	 strncat(failedusers,user,UNMSIZ);
         strcat(failedusers," ");
         if( say(0,toobig) )
	    goto close_go;
	 continue;
      }
      strcat(failedusers,token2);
      strcat(failedusers," ");
      numalpha = 0;
      strcpy(namebuf,user); 
      for (i = 0; i < namelen; i++)
      {
         x = namebuf[i];
         if( x < 128 && x > 0)
	    if (isalpha(x) !=0) numalpha++; 
      }
      if( numalpha  == 0 ) 
      {
         say(0,"531 invalid user name."); 
         continue;  	/* try again	*/
      } 
      /*==================================================================
       * Check for private connections
       *=================================================================*/ 
      if (proxyptr->privateconnect == PRIVATE_CONNECT)
      {
         strcpy(proxyptr->username,user); 
         strcpy(gwuptr->username,user); 
         strcpy(proxyptr->autologname,user);  
         /*=================================================================== 
          * Read gwuser.conf file to get name of default group.
          * Read default GWGROUP record and copy ftp options to GWUSER record.
          *==================================================================*/
         if( get_gwuserconf(&conf) != 0)
         {
            syslog(LOG_ERR,"Error: authenticate unable to read gwuser.conf "
			"file");
            exit(1); 
         }
         if( get_gwgroup((char *)&conf.groupname,&group) != 0)
         {
            syslog(LOG_ERR,"Error: authenticate unable to read group \"%s\"",
			conf.groupname);
            exit(1);
         }      
         gwuptr->ftpaccess = group.ftpaccess;
         return(0);
      }
      /*==================================================================
       * Check for userid anonymous and specificatiion in conf file.
       *=================================================================*/ 
      if( (strcmp(user,"anonymous") == 0)  && 
          (strlen(proxyptr->anonymousftp) > 0) ) 
      {
         strcpy(proxyptr->username,user); 
         strcpy(gwuptr->username,user); 
         strcpy(proxyptr->autologname,user);
         strcpy(proxyptr->destname,proxyptr->anonymousftp); 
         /*=================================================================== 
          * Read gwuser.conf file to get name of default group.
          * Read default GWGROUP record and copy ftp options to GWUSER record.
          *==================================================================*/
         if( get_gwuserconf(&conf) != 0)
         {
            syslog(LOG_ERR,"Error: authenticate unable to read gwuser.conf "
			"file");
            exit(1); 
         }
         if( get_gwgroup((char *)&conf.groupname,&group) != 0)
         {
            syslog(LOG_ERR,"Error: authenticate unable to read group \"%s\"",
			conf.groupname);
            exit(1);
         }      
         gwuptr->ftpaccess = group.ftpaccess;
         return(0);
      }  

      strcpy(gwuptr->username,user);  
      if( (rc = dssapi(gwuptr)) == 0)  
      {  
         syslog(LOG_NOTICE,"user '%s' authenticated by DSS",gwuptr->username);
         return(0); 
      }
      switch (rc)
      {  
         case 1002:
            break;                
         case 5:
            syslog(LOG_NOTICE,"unknown user '%s' denied by DSS, rc = %d",
	           gwuptr->username,rc);
            return(-1); 
            break;  
         case 8:
            syslog(LOG_NOTICE,"user '%s' denied by DSS, rc = %d",
	           gwuptr->username,rc);
            return(-1); 
            break; 
         case 9:
            syslog(LOG_NOTICE,"user '%s' denied, DSS server busy, rc = %d",
	           gwuptr->username,rc);
            return(-1); 
            break;  
         default:
            syslog(LOG_NOTICE,"user '%s' denied, DSS rc = %d",
	           gwuptr->username,rc);
            return(-1); 
            break;  
      }

      



      /*==================================================================
       * Get user record.  If not found ask for password and send message
       * indicating invalid name or password. Let them try again. 
       * If record found and user is allowed to telnet then call authuser.  
       *=================================================================*/
      if( get_gwuser(user, gwuptr) == 0) 
      {   
         if( authuser( gwuptr, buf, proxyptr->sourceIP, proxyptr->srcname) == 0) 
         {
            return(0);
         }
         else
         {
	    sprintf(buf,"530 User %s access denied.",namebuf);
            if( say(0,buf) )
	       goto close_go;       
            continue;	/* try again	*/ 	
         }
      }
      else
      {  
         sprintf(buf,"331 Password required for %s.",namebuf);
         if( say(0,buf) )
	    goto close_go;
         if( getline(0,(unsigned char *)buf, CBUFSIZ - 1) < 0 ) 
	     goto close_go; 
         sprintf(buf,"530 User %s access denied.",namebuf);
         if( say(0,buf) )
	    goto close_go;
         continue;	/*  try again */
      } 
   }
  return(-1);  	/* user not found	*/

close_go:
   return(-2);
} 
/*===========================================================================
 * authenticate user using method specified in gwuser record
 * inputs:
 *		ptr to GWUSER record
 * outputs:
 *		 0 if OK
 *		-1 if failed	
 *==========================================================================*/ 
int authuser(struct GWUSER *gwup, char *buf, char *sourceip, char *srcname)
{
#define APE	1
#define NOAPE	0
   char         challenge[9]; 
   char		obuf[512];
   char		*token1;
   char		*token2;
   char		tokensep[]   = "\t \n";
   int		msglen;  
   int    	ichall;   
   int		ntries = 3;
   time_t	epoch; 
   strcpy(challenge,"\0\0\0\0\0\0\0\0"); 
   sprintf(obuf,"331 Password required for %s.", gwup->username); 
   msglen = strlen(obuf);
   /*=================================================================== 
    * If user is on a protected host use password for authentication
    * unless 	
    *==================================================================*/ 
   if( (ipsecure(sourceip) == SECURED)  )
   { 
      /* Send positive response to the ftp client for username. 	*/ 
      sprintf(obuf,"331 Password required for %s.", gwup->username); 
      if( say(0,obuf) < 0 )
         return(-1); 
      /*==============================================================
       *  The FTP client prompts the user for their password and sends 
       * "PASS password" to the proxy. 
       *=============================================================*/
      if( getline(0,(unsigned char *)buf, CBUFSIZ - 1) < 0 )
         return(-1);
      if( (token1 = strtok(buf,tokensep)) == NULL)
      {
         return(-1);  
      }
      if( strcasecmp(token1,"PASS") != 0 )
      {
         syslog(LOG_ERR,"Error: keyword 'PASS' not specified. source = %s (%s)",
			srcname, sourceip);
         return(-1); 
      }
      if( (token2 = strtok(NULL,tokensep)) == NULL)
      {
         syslog(LOG_ERR,"Error: no password specified for %s. source = %s (%s)",
			gwup->username, srcname, sourceip);
         return(-1); 
      } 

      if( !(gwup->ftpaccess & PRO_FTP) )
      {  
         syslog(LOG_NOTICE,"Access denied to %s. source = %s (%s).  PRO_FTP "
			"not allowed for user.",
			gwup->username, srcname, sourceip);
         return(-1);
      }  
      if( strlen(gwup->password[0]) == 0)
      {  
         syslog(LOG_NOTICE,"Access denied to %s. NULL password in user record.",
			   gwup->username);
         return(-1);
      }                      
      /*========================================================
       * compare password from user with password in record 	
       *=======================================================*/ 
      if( strcmp(token2,gwup->password[0]) != 0)
         return(-1);
      else 
      {
         int rc;
         time_t cur = time((time_t *)NULL);
         struct GWCONF *gwconf = &conf;
         if (gwuserconf()) 
         {
            say(0,"530 Cannot access gwuser config info, please contact "
                        "administrator.");
            return(-1);
         }
         if (gwconf->password_max_age != 0 &&
		cur - gwup->passworddate > gwconf->password_max_age*24*60*60) 
         {
            syslog(LOG_NOTICE,"ftproxy detected expired password for user %s "
                        "and has prompted user to use telnet to change "
                        "password.",gwup->username);
            say(0,"530 Password has expired.  Please use telnet to change "
                "password.");
            return(-1);
         }
         return(0);
      }
   }
   /*=================================================================== 
    * User is on an UN-Protected host use strong user authentication
    *  	
    *==================================================================*/ 
   else
   {   
#ifdef NOT_DEFINED
/* New Version 
      sprintf(obuf,"500 strong user authentication required.");
      if( say(0,obuf) < 0 )
         return(-1);
*/
      while(ntries--)
      {        

         if( getline(0,(unsigned char *)buf, CBUFSIZ - 1) < 0 )
            return(-1);
         if( (token1 = strtok(buf,tokensep)) == NULL)
         {
            return(-1);  
         }  
         if( strcasecmp(token1,"QUIT") == 0)
         {
            sprintf(obuf,"221 Goodbye.");
            say(0,obuf);
            return(-1);
         }     
	 if( strcasecmp(token1,"SYST") == 0)
         {
            sprintf(obuf,"215 UNIX");
            if( say(0,obuf) < 0)                                            
            {
	       return(-1);
            }  
	    ntries++;
            continue;        
         }
         if( strcasecmp(token1,"pass") != 0 )
         {
            syslog(LOG_ERR,"Error: keyword 'pass' expected received '%s' \
 instead. source = %s (%s)",
			token1, srcname, sourceip);
            return(-1); 
         }
         else
         {
            break; /* time to try security token	*/
         }
      }   
#endif

   } 
   /* select token type from users record	*/
   switch (gwup->tokentype)  
   {
      case CRYPTO:              /* CRYPTOCard support	  */
      case SNK:           	/* SecureNet Key  Support */   
      
         epoch = time(&epoch); 
         srand48((int) epoch);		/* seed the random # generator */
         ichall = (lrand48() & 0x03FFFFFF) + 32800000; 
         sprintf(challenge,"%d",ichall);
         sprintf(obuf,"331 Challenge: %s    Enter: Response",challenge);
         if( say(0,obuf) < 0)
	    return(-1); 
         /*=====================================================
          * get response and echo challenge 
          *=====================================================*/ 
         if(  getline(0,(unsigned char *)buf,CBUFSIZ - 1) < 0 )
         {
	    syslog(LOG_ERR,"500 Unable to read response to challenge %m.");
            return(-1); 
         } 
         if( (token1 = strtok(buf,tokensep)) == NULL)
         {      
            syslog(LOG_ERR,"500 NULL response to challenge.");
            return(-1);  
         } 
         if( strcasecmp(token1,"pass") != 0)
         {
            syslog(LOG_ERR,"500 expected keyword 'pass' received '%s' instead.",
			   token1);
            return(-1);  
         }                        
         if( (token2 = strtok(NULL,tokensep)) == NULL)
         {
            return(-1);  
         }

         if( !(gwup->ftpaccess & UNPRO_FTP) )
         {  
            syslog(LOG_NOTICE,"Access denied to %s. source = %s (%s) "
			"UNPRO_FTP not allowed for user.",
			gwup->username, srcname, sourceip);
            return(-1);
         }  
         return(snkverify(challenge, token2, gwup));     
         break;
   
      case SDI:			/* Security Dynamics Support    */
         return(tnsecdyn(gwup->username,buf));
         break;  
        
      case NONE: 
         sprintf(buf,"500 gwsh2: no security token specified.  Call your "
		     "systems administrator.\r\n"); 
         msglen = strlen(buf); 
         if(write(0,buf,msglen) != msglen)
	    return(-1); 
         return(-1);
         break;

      default:
         return(-1);
         break;

   } 
}
