/*============================================================================
 * filename:		../ftproxy/ftproxy.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * written by:		R. James Livermore 
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.
 * All rights reserved.   
 *
 * Date written:	April	  17, 1995 
 *			July      11, 1996 - added anonymous ftp support
 *			November  20, 1996 - added support for private nets
 *			September  7, 1999 - added Linux support
 * Last modified:	February   8, 2000 - added LPL
 *					             
 *
 * function:	file transfer proxy server	
 *               
 *	
 *	To run this program under a debugger execute it as follows, using some
 *	port number in place of 7777.  Then telnet to port 7777 to issue
 *	ftp commands.	
 *
 *           debugger ftproxy ftproxy -D 7777
 *
 *
 *============================================================================*/
                      

static  char	ident[] = "@(#) ftproxy, V 1.0 00/01/21"
 			  " (C) Freemont Avenue Software, Inc."
			  " 1995-2000";
#include	<stdlib.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<syslog.h>   
#include	<sys/ioctl.h>
#ifdef __sun
#include	<sys/sockio.h>		/* socket I/O controls 		*/
#endif
#include	<sys/errno.h>
#include	<sys/signal.h>
#include	<arpa/ftp.h>
#include	<arpa/telnet.h>
#include	<sys/time.h> 
#include	<sys/times.h>		/* cpu timings			*/
#include	<sys/types.h> 
#ifndef __hppa
#include 	<sys/select.h>		/* to support fd_set 		  */
#endif 
#include	<unistd.h>
#include	<sys/socket.h>
#include	<netinet/in.h> 
#include	<netdb.h>     		/* includes h_errno		  */ 
#include	"firewall.h" 
#include	"gwuser.h"
#include	"ftproxy.h"  

#ifdef __hppa
typedef		unsigned long	in_addr_t;
#endif

extern	int	h_errno; 
extern	char	*rindex();
extern	char	*index();
extern	int	errno;
#ifndef linux
extern	char	*sys_errlist[];
#else
extern const char *const sys_errlist[];
#endif
extern	char	*strtok();
extern	char	*inet_ntoa();  
extern	char	*optarg;

#ifndef	FTPPORT
#define	FTPPORT	21
#endif 
static	int			authenticated = 0;
static	int			authallflg    = 0;
static	int			authopened    = 0;
static	char			authuser[128];
static	char			autheduser[128];	/* successful */
static	char			**validests = (char **)0;
static	int			blockinput    = 0;
static	int			blockoutput   = 0;
static	int			boundport     = -1; 
static  long			clktck 	      = 0;
static	int			cmdcnt        = 0;
static  float			cpu; 
static	int			rfd = -1;	/* fd to remote */

struct 	GWUSER  		*gwuptr = 0; 
static	int			outgoing = -1;	/* fd for outgoing PORT data */
static	int			incoming = -1;	/* fd for outgoing PORT data */
static	struct sockaddr_in	clntport;
static	char			**saveresp = (char **)0;
static	int			saveresps = 0;  
	char         		lhostname[MAXHOSTLN+1]; /* local hostname     */  
        char			dest[MAXHOSTLN+1];      /*destination hostname*/

static	int			extendperm = 0;

static  char			lastcmd[32];		/* last user command */
static	time_t			starttime;
static	time_t			offtime; 
static  struct tms		tmsstart;
static  struct tms		tmsend; 
static	double			inbytcnt = 0;
static	double			outbytcnt = 0;


/*==========================================================================
 * function prototypes
 *=========================================================================*/
	int	authenticate(struct GWUSER *gwuptr, struct FTPROXY *proxyptr,
                             char *failedusers, char *savedcmd);
	int	noauth(char *inbuf, int bufsiz, char *obuf, 
                       struct GWUSER *gwuptr, struct FTPROXY *proxyptr); 
#if !defined(__sun)
	int 	chk_spoof(char *pname, struct in_addr inside_ipaddr,
			  int inside_port, struct in_addr clnt_ipaddr,
			  int clnt_port,int IPsecure);
#endif          
	int 	call_back();
static	int	cmd_user();       
static	int	cmd_port();
static	int	cmd_quit();
static	int	cmd_help();
static	int	cmd_noop();
static	int	cmd_abor();
static	int	cmd_passthru(); 
	void	debugbind(unsigned short debugport);
	int 	dicta(int fd, char *s, int n); 
	int 	getline(int fd, unsigned char *buf, int siz); 
static	void	saveline();
static	void	flushsaved();
	int 	ftproxconf(struct FTPROXY *proxptr);
	int 	ftrules(struct FTPROXY *proxyptr); 
	int 	peerinfo(int fd, struct FTPROXY * proxyptr);     
struct 	hostent *Pgethostbyname(const char *name);   
	int 	port_to_addr(char *s, struct sockaddr_in *a); 
	void	secureftp(struct FTPROXY *proxyptr );
static	void	trap_sigurg();  
	int 	sayfile(int fd, char *filename,int code);   
 
struct  FTPROXY	*proxyptr;        


#define	OP_CONN	001		/* only valid if connected 	*/
#define	OP_WCON	002		/* writethrough if connected 	*/
#define	OP_DENY	004		/* deny op 			*/
#define	OP_LOG	010		/* log op 			*/
#define	OP_AUTH	020		/* must be authenticated 	*/
#define	OP_AOK	040		/* never needs to be authenticated */
/*==================================================================
 * supported ftp options 
 *==================================================================*/
typedef	struct
{
   char	*name;
   int	flg;
   int	(*op)();
} FtpOp;

static	FtpOp	ops[] = 
{
   "port",	OP_CONN,		cmd_port,
   "user",	OP_AOK|OP_WCON,		cmd_user,
   "retr",	OP_CONN,		0,
   "stor",	OP_CONN,		0, 
   "pass",	OP_AOK|OP_WCON,		0,
   "cwd",	OP_CONN,		0,
   "pwd",	OP_CONN,		0,
   "list",	OP_CONN,		0,
   "nlst",	OP_CONN,		0,
   "site",	OP_CONN,		0,
   "cdup",	OP_CONN,		0,
   "smnt",	OP_CONN,		0,
   "help",	OP_WCON|OP_AOK,		cmd_help,
   "noop",	OP_WCON,		cmd_noop,
   "stou",	OP_CONN,		0,
   "appe",	OP_CONN,		0,
   "allo",	OP_CONN,		0,
   "rest",	OP_CONN,		0,
   "rmd",	OP_CONN,		0,
   "mkd",	OP_CONN,		0,
   "xpwd",	OP_CONN,		0,
   "syst",	OP_CONN,		0,
   "acct",	OP_CONN,		0,
   "smnt",	OP_CONN,		0,
   "quit",	OP_AOK,			cmd_quit,  
   "auth",	OP_AOK,			0, 
   "resp",	OP_AOK,			0,
   "rein",	OP_CONN,		0,
   "pasv",	OP_CONN,		0,
   "type",	OP_CONN,		0,
   "stru",	OP_CONN,		0,
   "mode",	OP_CONN,		0,
   "rnfr",	OP_CONN,		0,
   "rnto",	OP_CONN,		0,
   "abor",	OP_CONN,		cmd_abor,
   "stat",	OP_CONN,/* overload */	cmd_abor,
   "dele",	OP_CONN,		0,
   "xrmd",	OP_CONN,		0,
   "xmkd",	OP_CONN,		0, 
   "xcdup",	OP_CONN,		0,  
   "xcwd",	OP_CONN,		0,
   /* compatibility with DEC version */
   "passerve",	OP_WCON,		cmd_passthru,
   /* alias the connect command */
   "connect",	OP_WCON,/* overload */	cmd_passthru,
   "conn",	OP_WCON,/* overload */	cmd_passthru,
   0,		0,			0
};                      
/*==========================================================================
 * main function
 *=========================================================================*/
main(int ac, char *argv[]) 
{  
#ifndef linux
   size_t    addrlen;
#else   
   socklen_t addrlen;
#endif
   unsigned short debugport = 9000; 	/* default debug port		*/  

   int		autologin	=  0;   /* Set = 1 for server autologin	*/ 
   char		*dbufptr;		/* Data buffer pointer	  	*/
   int		ntries 		=  4;	/* number of tries for quote site*/
   int		runuid 		= -1;
   int		rungid 		= -1;    
   int		i;
   int		timeout; 
   int		x;       
   int		z; 
   long		tempport;
   short	port 		= FTPPORT; /* default port number */
   struct timeval	timo;
   fd_set		rdy; 
   char		*cp;    
   char		failedusers[81] = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
   char		lipaddr[20]; 		/* local IP address	*/ 
   char		ebuf[CBUFSIZ]; 
   char		obuf[CBUFSIZ];
   char		msgbuf[1024];
   char		*fakav[3];
   char		*passuser 	= (char *)0;	/* passed user as av 	*/
   char		savedcmd[100]; 		/* save cmds prior to USER	*/
   char		*token1;
   char		*token2; 
   char		*token3;
   char		tokensep[]   = "\t \n";
   struct sockaddr_in	la;
   struct sockaddr_in	ra;
   struct FTPROXY ftproxy;
   struct GWUSER  gwuser;
   struct hostent	*hp;
   struct sockaddr_in	sin;

   gwuptr   = &gwuser; 
   proxyptr = &ftproxy; 
   openlog("ftproxy",LOG_PID|LOG_NDELAY,LOG_DAEMON);
   z = sizeof(lipaddr);
   lastcmd[0] = '\0';  
   /*======================================================================== 
    * Initialize wall clock and cpu clock timings. If CPU timer isn't working
    * set flag.  Noted Solaris 2.6 CPU timer will overflow if system has not
    * been re-booted for 248.55 days.  Yes this does happen.
    *=======================================================================*/
   clktck = 100; 		/* Initialize clock ticks per second */  
   time(&starttime); 
   if( times(&tmsstart) < 0 )
   {
      syslog(LOG_ERR,"Error: CPU timer returned negative number to times()"
		     " function.  CPU timer may have overflowed."); 
       clktck = 0;	/* set to zero to stop cpu timing.	*/
   } 
   if( gethostname(lhostname,sizeof(lhostname)) )
   {
      syslog(LOG_ERR,"Error: gethostname failed: %s.",sys_errlist[errno]);
   }
   authuser[0] = '\0';
   strcpy(autheduser,"unauth"); 
   /*=============================================
    * Read the ftproxy configuration file and get 
    *    ftgroupid, ftuserid, ftdirectory, ...
    *============================================*/  
    if( ftproxconf(proxyptr) < 0) return(-1);
    /*===================================================================
    *	If Debug is specified this it will bind the port and listen  
    *	directly (circumventing inetd) so you can run the program under
    *	a debugger
    *===================================================================*/
   if( ac > 2)
   {
      if( strcmp(argv[2],"-D") == 0)
      {  
	 /* check for debug port number  */
         if( ac > 3 )
         {
	    if( (strlen(argv[3]) < 6)  && isalldigits(argv[3]) )
            {
               if( (tempport = atoi(argv[3])) > 64000)
               {
                  printf("\ntnproxy: portnumber > 64000. Please try again.\n");
	          exit(1);
               }
               debugport = tempport;
            }
            else
            {
               printf("\nftproxy: invalid portnumber (%s), must be a positive "
		      "integer less than 64000.\n"
		      "          Please try again.\n", argv[3]);
               exit(1); 
            }   
         }
         printf("\n ftproxy: Debug mode specified. Use port %d.\n",
                 debugport);
         debugbind(debugport); 
      }
   }   
   signal(SIGURG,trap_sigurg);
   /*========================================================================= 
    * Get the hostname, IP address, secureIP, and privateIP  data for 
    * the client.	
    *=======================================================================*/    
   if( peerinfo(0,proxyptr) ) 
   {
      syslog(LOG_ERR,"Error: cannot get peer name");
      exit(1);
   } 
   /*=====================================================
    * set socket options	
    *=====================================================*/
   x = 1;
   (void)setsockopt(0,SOL_SOCKET,SO_KEEPALIVE,(char *)&x,sizeof(x));  
   /*======================================================================== 
    * Get local IP address of socket and convert it to ASCII string in dot
    * decimal format. 
    *=======================================================================*/
    
   addrlen = sizeof(la);
   if(getsockname(0,(struct sockaddr *)&la,(socklen_t *)&addrlen) < 0) 
   {
      sprintf(msgbuf,"521 PORT getsockname: %s",sys_errlist[errno]);
      syslog(LOG_ERR,"Error: getsockname failed: %s.",sys_errlist[errno]);
      return(say(0,msgbuf));
   }
   strncpy(lipaddr,inet_ntoa(la.sin_addr),z);
   lipaddr[z-1] = '\0'; 
   /*========================================================================
    * Update the private connect status
    *=======================================================================*/ 
   if (portprivate(lipaddr) == 0)
      proxyptr->privateconnect |= LOCALPORT_IS_PRIVATE;
   /*========================================================================
    * Check if host with a secure source IP address is connected via a secure
    * port. If not issue a Security Alert and drop the connection.   
    *=======================================================================*/ 
   if( (proxyptr->srcIPsecure == SECURED) && (portsecure(lipaddr) != 0) ) 
   {    
      syslog(LOG_CRIT,"Security Alert: ftp attempt to unsecured port %s "
                      "using secure source IP address %s aka %s.",
		lipaddr,proxyptr->sourceIP,proxyptr->srcname); 
      sprintf(msgbuf,"500 System is not authorized to use FTP proxy. Bye."); 
      say(0,msgbuf);  
      exit(1);
   } 
#if !defined(__sun)
   if (getpeername(0,(struct sockaddr *)&ra,(socklen_t *)&z) < 0)
   {
	syslog(LOG_ERR,"Error: getpeername failed for fd 0. errno=%d",errno);
	exit(1);
   }
   chk_spoof("ftproxy",la.sin_addr,la.sin_port,
		ra.sin_addr,ra.sin_port,proxyptr->srcIPsecure);
#endif
   /*========================================================================
    * If not private connection and
    * external ftp users are NOT allowed and the ftp users source 
    * IP address is not secure then  disconnect.  
    *=======================================================================*/ 
  if( (proxyptr->privateconnect != PRIVATE_CONNECT) && 
      (proxyptr->external == NOEXFTP) && (proxyptr->srcIPsecure != SECURED) )
   {
      sprintf(msgbuf,"500 %s (%s) is not authorized to use FTP proxy. Bye.",
		 proxyptr->srcname,proxyptr->sourceIP);
      say(0,msgbuf); 
      syslog(LOG_CRIT,"Security Alert: unauthorized ftp attempt to %s from %s"
      		      " aka %s.",
		      lipaddr,proxyptr->sourceIP,proxyptr->srcname);  
      exit(1);
   }     
   /*========================================================================
    * Acquire data buffer.
    *=======================================================================*/
   if(( dbufptr = malloc(proxyptr->dbuffersize)) == NULL)
   {
      syslog(LOG_ERR,"Error: malloc(%d) failed for data buffer. Session"
       		     " terminated.",proxyptr->dbuffersize);
      say(0,"Temporary resource shortage. Try again later.");
      exit(1);      		      
		      
    }
   /*========================================================================
    * Display the Message Of The Day
    *=======================================================================*/
   if( sayfile(0,"/etc/motd",220) )
   {
      syslog(LOG_ERR,"Error: Can Not display MOTD from %s to %s (%s).",
		lipaddr,proxyptr->sourceIP,proxyptr->srcname);  
      exit(1);
   }   
   if (proxyptr->srcIPsecure == SECURED)
   {
      sprintf(ebuf,"220 %s FTP proxy %s ready.", lhostname, "V 1.0");
   }
   else
   {
      sprintf(ebuf,"220 %s FTP proxy ready.", lhostname);
   } 
   if( say(0,ebuf) )
   {
      syslog(LOG_ERR,"Error: Can Not display FTP Proxy msg from %s to %s (%s).",
		lipaddr,proxyptr->sourceIP,proxyptr->srcname);  
      exit(1);
   }
   /*=======================================================================
    * If authorization is required or source host is not secure or if
    * this is a private connection, then
    * authenticate the user.  Otherwise automatically log the user in.
    *=======================================================================*/ 
   if( (proxyptr->auth == AUTHREQ) || ( proxyptr->srcIPsecure != SECURED) ||
       (proxyptr->privateconnect == PRIVATE_CONNECT) )
   { 
      if( authenticate(gwuptr, proxyptr, failedusers, savedcmd)
          != 0 ) 
      {
         syslog(LOG_NOTICE,"Authentication failure: source host = %s (%s) "
 			    "user(s) = %s", 
			   proxyptr->srcname, proxyptr->sourceIP, failedusers);
         exit(1);
      }    
   }     
   else
   {   
      /*======================================================================
       * Set up auto login and get default user attributes from the default
       * group.
       *=====================================================================*/                               
      if( (autologin = noauth(ebuf,CBUFSIZ-1,obuf,gwuptr,proxyptr)) < 0 )
      {
         syslog(LOG_ERR,"Error: noauth rc = %d, source host = %s (%s)",
 		 autologin, proxyptr->srcname, proxyptr->sourceIP);
         exit(1);
      }  
   }
   strcpy(proxyptr->username,gwuptr->username);       
   strcpy(proxyptr->groupname,gwuptr->groupname);       
   strcpy(autheduser,gwuptr->username);
   strcpy(authuser,gwuptr->username); 
   authenticated++;
   syslog(LOG_INFO,"authenticate user = %s.",gwuptr->username);
#if !defined(__sun)
   chk_spoof("ftproxy",la.sin_addr,la.sin_port,
		ra.sin_addr,ra.sin_port,proxyptr->srcIPsecure);
#endif
   /*==================================================================
    * Check for private connection and use local IP as destination for
    * now.
    *=================================================================*/ 
   if (proxyptr->privateconnect == PRIVATE_CONNECT)
   {
      autologin = 1;
      strncpy(proxyptr->destname,lipaddr,sizeof(proxyptr->destname)-1);
   }
   /*==================================================================
    * Check for userid anonymous and specificatiion in conf file.
    *=================================================================*/ 
   else if( (strcmp(proxyptr->username,"anonymous") == 0)  && 
            (strlen(proxyptr->anonymousftp) > 0) ) 
   {
      autologin = 1;
   }   
   
   if( autologin )
   {
      token2 = (char *) &proxyptr->destname; 
      goto skiptries;  
   }
   /*======================================================================
    * Get destination address from user 
    *    site destination             200 -> 230
    *======================================================================*/
   sprintf(ebuf,"230 Specify Remote Destination with: quote site hostname");
   say(0,ebuf);
   while(ntries--)
   {     
      port = FTPPORT;   	/* Re-initialize default for each try */
      token2 = NULL;
      if( getline(0,(unsigned char *)ebuf,CBUFSIZ - 1) < 0 )
      {
          syslog(LOG_ERR,"Error: unable to get quote site dest"
                         " user = %s source = %s (%s).",
                          authuser, proxyptr->srcname, proxyptr->sourceIP);
          exit(1);       
      }  
      if( proxyptr->debug )
      {
         syslog(LOG_NOTICE,"command: %s",ebuf); 
      }
 
      if( (token1 = strtok(ebuf,tokensep)) == NULL) 
      {
          syslog(LOG_ERR,"Error: NULL response, expected: 'quote site dest'"
                         " user = %s source = %s (%s).",
                          authuser, proxyptr->srcname, proxyptr->sourceIP);
          say(0,"200 Specify Remote Destination with: quote site hostname");
          continue;       
      } 
      if( strcasecmp(token1,"quit") == 0)
      {
         syslog(LOG_ERR,"User QUIT. source = %s (%s)",
			 proxyptr->srcname, proxyptr->sourceIP); 
         say(0,"221 Goodbye.");
         exit(1);
      }
      /* added to support OS/2 Warp! */
      if( strcasecmp(token1,"ACCT") == 0)
      {
         say(0,"502 ACCT command not implemented.");
         ntries++;      	/* give them one more try	*/
         continue;	
      }   
            /* added to support OS/2 Warp! */
      if( strcasecmp(token1,"NOOP") == 0)
      {
         say(0,"200 NOOP command successful.");
         ntries++;      	/* give them one more try	*/
         continue;	
      }  
      /* added to support OS/2 Warp! */
      if( strcasecmp(token1,"PASS") == 0)
      {
         say(0,"230 User logged in enter quote site command.");
         ntries++;      	/* give them one more try	*/
         continue;	
      }  
      /* added to support OS/2 Warp! */
      if( strcasecmp(token1,"PWD") == 0)
      {
         say(0,"257 / Command not applicable on firewall.");
         ntries++;      	/* give them one more try	*/
         continue;	
      } 
      if( strcasecmp(token1,"SYST") == 0)
      {
         say(0,"215 UNIX");
         ntries++;      	/* give them one more try	*/
         continue;	
      } 
      if( strcasecmp(token1,"stru") == 0)
      {                 
         token3 = strtok(NULL,tokensep); 
	 sprintf(obuf,"220 %s %s ok.", token1, token3);
         if( say(0,obuf) )
         {
            syslog(LOG_ERR,"Error: Can Not display stru x msg to %s (%s).",
		proxyptr->sourceIP,proxyptr->srcname);  
            exit(1);
         }
         
         ntries++;      	/* give them one more try	*/
         continue;	
      }
      if( strcasecmp(token1,"site") == 0)
      {      
         if( (token2 = strtok(NULL,tokensep)) == NULL) 
         {
            syslog(LOG_ERR,"Error: NULL destination specified after site "
                              "keyword.");
            say(0,"200 Specify Remote Destination with: quote site hostname");
            continue;        
         } else if( strlen(token2) > MAXHOSTLN)
	 {
	    syslog(LOG_ERR,"Error: destination host name exceeds maximum"
                              " length of %d. '%.40s...'",
			   MAXHOSTLN,token2);
            say(0,"200 Remote Destination following quote site is too long.");
            continue;
	 } else
         {     
            /* Check for destination port number */
            if( (token3 = strtok(NULL,tokensep)) != NULL)
            {        
               if(isalldigits(token3)) 
               { 
                  if( (i = atoi(token3)) < 65536)
                  {
                     port = i;
                     break;
                  }
                  else 
                  {
                     syslog(LOG_ERR,"Error: Invalid destination port '%s' "
				    "specified after hostname.",
                                    token3);
                     say(0,"200 Invalid portnumber. Specify Remote Destination "
 		           "with: quote site hostname");
                     continue;
                  }        
               }
               else
               {
                  struct servent	*sp;
 		  sp = getservbyname(token3,"tcp");
	          if(sp != (struct servent *)0)
	             port = ntohs(sp->s_port);
	          else
                  {  
                     syslog(LOG_ERR,"Error: Unknown service '%s' "
				    "specified after quote site hostname.",
                                    token3);
                     say(0,"200 Unknown service: Specify Remote Destination "
			   "with: quote site hostname");
                     continue;
	          }
               }
               break; 
            }
            else
               break;	/* destination received so get out of loop	*/  
         }
      } 
      say(0,"200 Specify Remote Destination with: quote site hostname");
      syslog(LOG_ERR,"Error: unexpected command '%s'. expected site hostname. "
                     "user = %s source %s (%s).",
		     token1, authuser, proxyptr->srcname, proxyptr->sourceIP);
      
   } /* end of while loop */ 

   if( token2 == NULL)
   {
      say(0,"421 no destination specified. Goodbye.");
      syslog(LOG_ERR,"Error: No Destination specified. user = %s source = "
                     "%s (%s)",
		     authuser, proxyptr->srcname, proxyptr->sourceIP);
      exit(1);
   }

skiptries:	/* autologin skips over prompt for destination */
   strncpy(dest,token2,MAXHOSTLN);
   dest[MAXHOSTLN] = '\0';
   /*====================================================================
    * If destination address is in ASCII dot decimal format use it else
    * convert it from hostname to ASCII dot decimal format. 
    *=====================================================================*/ 
   cp = (char *) &dest;
   while(*cp != '\0' && (*cp == '.' || isdigit(*cp)))
		cp++; 
   if( *cp == '\0' ) 
   {
       strncpy(proxyptr->destIP,dest,20); 
   }
   else
   {   
      /*==================================================================
       * First try the external DNS server, if that fails try the internal
       * DNS.
       *================================================================*/
      if( (hp = gethostbyname(dest)) == (struct hostent *)0) 
      {  
         if((hp = Pgethostbyname(dest)) == (struct hostent *)0)
         {
            syslog(LOG_ERR,"Error: gethostbyname(%s) failed, %s.",
	                   dest, HostErrMsg()); 
            sprintf(ebuf,"521 Error hostname (%s) is unknown.",dest);
            say(0,ebuf);
            return(0);         /* host not found 	*/
         } 
      }
      /*=====================================================
       * copy h_addr to sin_addr and convert to ASCII string 
       * in Internet Address dot format	
       *====================================================*/
      bcopy(hp->h_addr,&sin.sin_addr,hp->h_length);
      cp = (inet_ntoa(sin.sin_addr));
      strncpy(proxyptr->destIP,cp,20);
   }  
   /*=======================================================================
    * Determine if the user is permitted to connect.
    * If not permitted issue message:
    *      " 500 user * at * (*) is not authorized to use the FTP proxy"
    *=======================================================================*/ 
   if( ftrules(proxyptr) != 0 )
   {
        sprintf(ebuf,"500 user %s at %s (%s) is not permitted to access %s.",
                     authuser,proxyptr->sourceIP,proxyptr->srcname,dest);
        say(0,ebuf);
	return(1);
   }
   /*=======================================================================
    * If private connection, ftrules() just updated the destIP member with
    * the redirect IP address so we copy it for use locally.
    *=======================================================================*/ 
   if (proxyptr->privateconnect == PRIVATE_CONNECT)
   {
      strcpy(proxyptr->destname,proxyptr->destIP);
      strcpy(dest,proxyptr->destIP);
   }
   syslog(LOG_NOTICE,"permit user = %s source = %s (%s) connect to %s (%s)",
		     authuser, proxyptr->srcname, proxyptr->sourceIP, 
		     dest, proxyptr->destIP);  
   /*======================================================================
    * Use the destIP address and not dest to save second DNS lookup.
    *=====================================================================*/
/*   port = FTPPORT; */
   if((rfd = connectserver(proxyptr->destIP,port,0,0)) < 0) 
   {
      char	ebuf[512];
      if( rfd == -1)
         sprintf(ebuf,"521 Error hostname (%s) is unknown.",dest);          
      else if( rfd == -2) 
         sprintf(ebuf,"521 Error hostname (%s) is unparasable.",dest); 
      else if( rfd == -3)
         sprintf(ebuf,"521 Error socket error %s for host (%s).",
		 sys_errlist[errno],dest); 
      else if( rfd == -4)
         sprintf(ebuf,"521 Error can not connect to hostname (%s).",dest);        
    
      return(say(0,ebuf));
      
   }  
   secureftp(proxyptr);	/* batten down the hatches	*/  
   if(proxyptr->srcIPsecure != SECURED)
      sprintf(ebuf,"    Firewall connected to %s.",dest);
   else
      sprintf(ebuf,"    Firewall connected to %s (%s).",dest,proxyptr->destIP);      
   saveline(ebuf);	/* save line to be sent to client later	*/
   x = getresp(rfd,ebuf,512,1);
   
   if(x / 100 != COMPLETE) 
   {
      sendsaved(0,-1);
      return( say(0,ebuf) );
   } 
   saveline(ebuf);	/* save line to be send to client later	*/
   /*========================================================================
    * If client specified autologin with user@hostname try it.
    *=======================================================================*/ 
   if( autologin)
   {
      sprintf(obuf,"USER %s",proxyptr->autologname);
      if( say(rfd,obuf) )
         return(1);
      x = getresp(rfd,ebuf,sizeof(ebuf),1); 
            if( sendsaved(0,x) )
         return(1); 
      if( say(0,ebuf) )
         return(1);   
   }
   else
   {
      if( sendsaved(0,x) )
         return(1); 
      if( say(0,"220 login with: user name") ); 
   }
   /*==============================================================
    * The main loop - aka the Livermore Loop 
    * 	Initialize fd list
    * 	Reset timeout
    *	Look for: user commands, peer replies, callbacks, & copies 
    *
    *=============================================================*/
   while(1) 
   {
      FD_ZERO(&rdy);
      FD_SET(0,&rdy);
      if(rfd != -1)
         FD_SET(rfd,&rdy);
      if(boundport != -1)
         FD_SET(boundport,&rdy);
      if(outgoing != -1)
         FD_SET(outgoing,&rdy);
      if(incoming != -1)
         FD_SET(incoming,&rdy);
      /* set timeout value	*/
      timo.tv_sec = proxyptr->timeout;
      timo.tv_usec = 0; 
      /*  select next available input            */ 
#ifdef __hppa
      if((x = select(32,(int *)&rdy,0,0,&timo)) < 0) 
#else
      if((x = select(32,&rdy,(fd_set *)0,(fd_set *)0,&timo)) < 0) 
#endif
      {
         syslog(LOG_ERR,"Error: select: %m");
	 exit(1);
      }
      if(x == 0)
         break;
      /* process user commands	*/
      if(FD_ISSET(0,&rdy))
      { 
         if( usercmd() )
            break;
      }
      /* process replies to user commands	*/
      if(rfd != -1 && FD_ISSET(rfd,&rdy))
         if( peerreply() )
            break;

      if( boundport != -1 && FD_ISSET(boundport,&rdy) )
         if( call_back() )
	    break;

      if( outgoing != -1 && FD_ISSET(outgoing,&rdy) )
         if( copyout(dbufptr,proxyptr->dbuffersize) )
            break;

      if(incoming != -1 && FD_ISSET(incoming,&rdy))
         if( copyin(dbufptr,proxyptr->dbuffersize) )
            break;
   } 
   /*=====================================  
    * gather and log statistics  
    *====================================*/
   time(&offtime); 
   if( times(&tmsend) < 0)
   {
      syslog(LOG_ERR,"Error: times(0 error. cpu timing stopped."); 
      clktck = 0;
   }
   if( clktck > 1)
   {
      cpu = ( tmsend.tms_utime   + tmsend.tms_stime 
	  -tmsstart.tms_utime - tmsstart.tms_stime)/(1.0*clktck);
   }  
   syslog(LOG_NOTICE,"exit user = %s source = %s (%s) dest = %s (%s) cmds = %d"
                     " in = %.0f out = %.0f duration = %d sec cpu = %.2f",
                     autheduser, proxyptr->srcname, proxyptr->sourceIP, 
                     dest, proxyptr->destIP, cmdcnt, inbytcnt, outbytcnt, 
	             offtime - starttime, cpu);

   exit(0);
}
/*===========================================================================
 * trap_sigurg
 * function: Trap urgent signals present on socket 
 *===========================================================================*/
static void trap_sigurg(int sig)
{
   int	atmark;
   char	buf[SMBUFSIZE];

   signal(SIGURG,trap_sigurg);
   while(1) 
   {
      if(ioctl(0,SIOCATMARK,(char *)&atmark) < 0)
         return;
      if(atmark)
         break;
      read(0,buf,sizeof(buf));
   }
}

/*============================================================================
 * 
 * inputs:
 *	argument count
 *	av[0] = 
 *	av[1] = user@hostname
 *
 *	cbuf  = "user internal"
 * 
 *==========================================================================*/
static int cmd_user(int ac, char *av[], char *cbuf)
{
   static char	narg[] = "501 Missing or extra username";
   static char	noad[] = "501 Use user@site to connect via proxy";
   char		buf[MINDBUF];
   char 	mbuf[SMBUFSIZE];
   char		*p;
   char		*dest;
   char		*user;
   int		x;
   int		msg_int;
   short	port = FTPPORT;
   /* log function entry!!!! */
   syslog(LOG_NOTICE,"Notice: cmd_user entered!");
   if((p = rindex(av[1],'@')) != (char *)0) 
   {
      *p++ = '\0';
      dest = p;
      user = av[1];
   } 
   else 
   {
      if((p = index(av[1],'!')) != (char *)0) 
      {
         *p++ = '\0';
	 user = p;
	 dest = av[1];
      } 
      else
         return(sayn(0,noad,sizeof(noad)));
   }

   if(*dest == '\0')
      dest = "localhost";

   syslog(LOG_NOTICE,"permit host = %s (%s) connect to %s",
		     proxyptr->srcname,proxyptr->sourceIP,dest);

   if((rfd = connectserver(dest,port,0,0)) < 0) 
   {
      char	ebuf[512];
            if( rfd == -1)
         sprintf(buf,"521 Error hostname (%s) is unknown.",av[1]);          
      else if( rfd == -2) 
         sprintf(buf,"521 Error hostname (%s) is unparasable.",av[1]); 
      else if( rfd == -3)
         sprintf(buf,"521 Error socket error %s for host (%s).",
		 sys_errlist[errno],av[1]); 
      else if( rfd == -4)
         sprintf(buf,"521 Error can not connect to hostname (%s).",av[1]);        

      strcpy(ebuf,buf);
      sprintf(buf,"%s: %s",av[1],ebuf);
      return(say(0,buf));
      
   }
   sprintf(buf," ---- Firewall connected to %s ----",dest);
   saveline(buf);

   /* we are now connected and need to try the autologin thing */
   x = getresp(rfd,buf,sizeof(buf),1);
   if(x / 100 != COMPLETE) 
   {
      sendsaved(0,-1);
      return(say(0,buf));
   }
	saveline(buf);

	sprintf(buf,"USER %s",user);
	if(say(rfd,buf))
		return(1);
	x = getresp(rfd,buf,sizeof(buf),1);
	if(sendsaved(0,x))
		return(1);
	return(say(0,buf));
}  

/*==========================================================================
 * baddest
 * inputs:
 *		fd file descriptor
 *		ptr to destination
 * function:
 *	If a bad destination was chosen this function logs the attempt
 * 	in the system log and notifies the user.  
 *==========================================================================*/
int baddest(int fd, char *dest)  
{ 
   char	buf[DBUFSIZ];
   sprintf(buf,"501 Not permitted to connect to %s",dest);
   syslog(LOG_NOTICE,"deny host=%s/%s connect to %s",
		     proxyptr->srcname,proxyptr->sourceIP,dest);
   return(say(fd,buf));
} 
/*=========================================================================
 *                                        
 * inputs:
 *
 *	av[1] = destination host  
 *      av[2] = port number
 *
 *=========================================================================*/
static	int cmd_passthru(int ac, char *av[], char *cbuf) 
{
   static char	narg[] = "501 Missing destination name";
   int		port = FTPPORT;
   char		buf[MINDBUF];
   char		mbuf[SMBUFSIZE];
   int		msg_int =1;
   int		x;

   if(ac < 2)
      return(sayn(0,narg,sizeof(narg)));


   if(ac > 2 && (port = atoi(av[2])) <= 0) 
   {
      sprintf(buf,"501 Bad port number: \"%s\"",av[2]);
      return(say(0,buf));
   }
   /*==============================
    * Check for valid destination  - add later 
    *==============================*/

   syslog(LOG_NOTICE,"permit host = %s (%s) connect to %s",
		     proxyptr->srcname,proxyptr->sourceIP,av[1]);

   /* Extended permissions processing goes in here for destination */
   if(extendperm) 
   { 
      if(msg_int == 1) 
      {
         sprintf(mbuf,"Permission denied for user %s to connect to %s",authuser,av[1]);
	 say(0,mbuf);
	 return(1);
      }
      else 
      {
         if(msg_int == -1) 
         {
	    sprintf(mbuf,"No match in netperm-table for %s to ftp to %s",
			authuser,av[1]);
	    say(0,mbuf);
	    return(1);
	 }	
      }
   }

   if((rfd = connectserver(av[1],port,0,0)) < 0) 
   {
      char	ebuf[512];
      if( rfd == -1)
         sprintf(buf,"521 Error hostname (%s) is unknown.",av[1]);          
      else if( rfd == -2) 
         sprintf(buf,"521 Error hostname (%s) is unparasable.",av[1]); 
      else if( rfd == -3)
         sprintf(buf,"521 Error socket error %s for host (%s).",
		 sys_errlist[errno],av[1]); 
      else if( rfd == -4)
         sprintf(buf,"521 Error can not connect to hostname (%s).",av[1]);        

      strcpy(ebuf,buf);
      sprintf(buf,"%s: %s",av[1],ebuf);
      return(say(0,buf));
   }

   sprintf(buf,"----GATEWAY CONNECTED TO %s----",av[1]);
   saveline(buf);

   x = getresp(rfd,buf,sizeof(buf),1);
   if(x / 100 != COMPLETE) 
   {
		sendsaved(0,-1);
		return(say(0,buf));
	}
	if(sendsaved(0,x))
		return(1);
	return(say(0,buf));
}
/*============================================================================
 * Process the PORT command issued by the client. ( on behalf of GET & PUT)
 *===========================================================================*/
static	int cmd_port( int ac, char *av[], char *cbuf) 
{
   struct sockaddr_in	r;
   struct sockaddr_in	n;
   int			x;
   unsigned char		*k;
   unsigned char		*l;
   static char		narg[] = "500 no port specified";
   static char		nadr[] = "500 cannot decode port specified";
   static char		nprn[] = "500 cannot get peername";
   char			buf[512];

   if(ac < 2)
      return(sayn(0,narg,sizeof(narg)));

   /* save port address for callback later */
   if( port_to_addr(av[1],&clntport) )
      return(sayn(0,nadr,sizeof(nadr)));


   /*=================================================================== 
    * For the paranoid : check that we are really PORTing to the client 
    *==================================================================*/
   x = sizeof(r);
   if(getpeername(0,(struct sockaddr *)&r,(socklen_t *)&x) < 0)
      return(sayn(0,nprn,sizeof(nprn)));
   if(bcmp((char *)&clntport.sin_addr,(char *)&r.sin_addr,sizeof(r.sin_addr))) 
   {
      char	xaf[128];

      strcpy(xaf,inet_ntoa(clntport.sin_addr));
      sprintf(buf,"521 PORT %s mismatch %sn",
   			inet_ntoa(r.sin_addr),xaf);  
      syslog(LOG_ALERT,"Security Alert PORT %s mismatch %sn",
                        inet_ntoa(r.sin_addr),xaf);  
      return(say(0,buf));
   }
   /*========================================
    * Build and bind a socket 
    *======================================*/
   if(boundport != -1)
      close(boundport);
   if((boundport = socket(AF_INET,SOCK_STREAM,0)) < 0) 
   {
      sprintf(buf,"521 PORT socket: %s",sys_errlist[errno]);
      return(say(0,buf));
   }
   r.sin_family = AF_INET;
   bzero((char *)&r.sin_addr,sizeof(r.sin_addr));
   r.sin_port = 0;
   if(bind(boundport,(struct sockaddr *)&r,sizeof(r))) 
   {
      sprintf(buf,"521 PORT bind: %s",sys_errlist[errno]);
      return(say(0,buf));
   }
   if(listen(boundport,1) < 0) 
   {
      sprintf(buf,"521 PORT listen: %s",sys_errlist[errno]);
      return(say(0,buf));
   }
   /*==================================================
    * Learn enough about the socket to send the PORT 
    *=================================================*/
   x = sizeof(n);
   if(getsockname(rfd,(struct sockaddr *)&n,(socklen_t *)&x) < 0) 
   {
      sprintf(buf,"521 PORT getsockname: %s",sys_errlist[errno]);
      return(say(0,buf));
   }
   bcopy((char *)&n.sin_addr,(char *)&r.sin_addr,sizeof(n.sin_addr));
   x = sizeof(n);
   if(getsockname(boundport,(struct sockaddr *)&n,(socklen_t *)&x) < 0) 
   {
      sprintf(buf,"521 PORT getsockname: %s",sys_errlist[errno]);
      return(say(0,buf));
   }
   r.sin_port = n.sin_port;

   /*=======================================================
    * Encode and send over our PORT to the remote server. 
    *======================================================*/
   k = (unsigned char *)&(r.sin_addr);
   l = (unsigned char *)&(r.sin_port);
#define UC(c)   (((int)c) & 0xff)
   sprintf(buf,"PORT %d,%d,%d,%d,%d,%d\r\n",UC(k[0]),UC(k[1]),UC(k[2]),
		UC(k[3]),UC(l[0]),UC(l[1]));             
   /* write PORT command to the server and return	*/ 
    return( dicta(rfd,buf,strlen(buf)) );
}  
/*==========================================================================
 * Dummy up the abort signalling per FTP 
 *    ( came from BSD net2 ) 
 *==========================================================================*/
static	int cmd_abor(int ac, char *av[], char *cbuf)  
{
   unsigned char	kbuf[4];

   kbuf[0] = IAC;
   kbuf[1] = IP;
   kbuf[2] = IAC;
   if(send(rfd,(char *)kbuf,3,MSG_OOB) != 3)
      return(1);
   kbuf[0] = DM;
   if(write(rfd,(char *)kbuf,1) != 1)
      return(1);
   return(say(rfd,cbuf));	/* cbuf, we can handle STAT or ABOR */
}  
/*========================================================================== 
 * Mediate the QUIT command to capture statistics and write them to the 
 * syslog.  
 *==========================================================================*/
static int cmd_quit(int ac, char *av[], char *cbuf) 
{
   char	buf[1024];
   int	x;
   /*=====================================  
    * gather and log statistics  
    *====================================*/
   time(&offtime); 
      if( times(&tmsend) < 0)
   {
      syslog(LOG_ERR,"Error: CPU timer returned negative number to times()"
		     " function.  CPU timer may have overflowed.");  
      clktck = 0;
   }
   if( clktck > 1)
   {
      cpu = ( tmsend.tms_utime   + tmsend.tms_stime 
	  -tmsstart.tms_utime - tmsstart.tms_stime)/(1.0*clktck);
   }

   syslog(LOG_NOTICE,"exit user = %s source = %s (%s) dest = %s (%s) cmds = %d"
                     " in = %.0f out = %.0f duration = %d sec  cpu = %.2f",
	             autheduser, proxyptr->srcname, proxyptr->sourceIP, 
                     dest, proxyptr->destIP, cmdcnt, inbytcnt,
	             outbytcnt, offtime - starttime, cpu);
   if(rfd != -1) 
   {
      if(sayn(rfd,"QUIT",4))
         exit(0);
      x = getresp(rfd,buf,sizeof(buf),1);
      sendsaved(0,x);
      if(say(0,buf))
         exit(0);
   }
   exit(0);
}
/*==========================================================================
 * Process the HELP sub command
 *=========================================================================*/ 
static	int cmd_help(int ac, char *av[], char *cbuf)  
{ 
   return(sayn(0,"214 no help available",21));
} 
/*===========================================================================
 * Process the NOOP sub command 
 *==========================================================================*/
static	int cmd_noop( int ac, char *av[], char *cbuf)
{
   return(sayn(0,"200 NOOP from proxy successful",30));
} 
/*===========================================================================
 * call back to the client on the address they gave as PORT 
 *=========================================================================*/
int call_back()
{
   /* if we haven't gotten a valid PORT scrub the connection */
   if((outgoing = accept(boundport,(struct sockaddr *)0,(addrlen_t *)0)) < 0 || 
       clntport.sin_port == 0)
      goto Abend;

   if((incoming = socket(AF_INET,SOCK_STREAM,0)) < 0)
      goto Abend;

   if(connect(incoming,(struct sockaddr *)&clntport,sizeof(clntport)) < 0)
      goto Abend;

   /* invalidate the port */
   clntport.sin_port = 0;
   return(0);

Abend:		/* Abnornal end */
   clntport.sin_port = 0;
   close(boundport);
   boundport = -1;
   if(outgoing != -1)
      close(outgoing);
   outgoing = -1;
   if(incoming != -1)
      close(incoming);
   incoming = -1;
   return(0);
}
/*============================================================================
 * Read Server reply and write it to the client. If the read fails inform
 * the client and close the server connection.  
 * Log replies for certain user commands.  
 *===========================================================================*/
int peerreply()
{
   char	buf[CBUFSIZ];                
    
   int	x;
   static char	pclos[] = "530 Peer has closed connection";

   if((x = read(rfd,buf,sizeof(buf))) <= 0) 
   {
      if(sayn(0,pclos,sizeof(pclos)))
         return(1);
      close(rfd);
      rfd = -1;
   } 
   if(write(0,buf,x) != x)
      	return(1);
   if( strncasecmp(lastcmd,"PWD",3) == 0)
   {  
      strtok(&buf[4]," ");
      syslog(LOG_NOTICE,"PWD %s from %s (%s) user = %s at %s (%s).",
 		        &buf[4], dest, proxyptr->destIP,proxyptr->username,
			proxyptr->srcname, proxyptr->sourceIP); 
      lastcmd[0] = '\0';
   }   
   if( strncasecmp(lastcmd,"XPWD",4) == 0)
   {  
      strtok(&buf[4]," ");
      syslog(LOG_NOTICE,"XPWD %s from %s (%s) user = %s at %s (%s).",
 		        &buf[4], dest, proxyptr->destIP,proxyptr->username,
			proxyptr->srcname, proxyptr->sourceIP); 
      lastcmd[0] = '\0';
   }   
   return(0);
}
/*============================================================================
 * Usercmd is called from the main loop when input is received from the client.  
 *
 * inputs:
 *	read input from ftp client (socket 0)
 *                                                                        
 * outputs:
 *	return 1 on error -> will break main loop and halt program
 *=========================================================================*/
int usercmd()
{
   FtpOp		*op;
   static char	badcmd[]   = "500 command not understood";
   static char	beconn[]   = "500 must be connected to remote server";
   static char	denied[]   = "500 command not permitted through gateway";
   static char	gottauth[] = "500 command requires user authentication"; 
   static char  badfile[]  = "500 transfer of file blocked"; 
   static char  usernot[]  = "530 must use anonymous";
   char		buf[CBUFSIZ];
   char 	*cp;
   char		tokbuf[CBUFSIZ];
   char		mbuf[512];
   char		*tokav[56];
   int		cmdlogging = 1;		/* 1 -> log commands in syslog	*/
   int		tokac;
   int		x;
   int		msg_int;
   /*================================================================
    * Get user command and build argument list for command processor. 
    *===============================================================*/
   if((x = getline(0,(unsigned char *)buf,sizeof(buf) - 1)) < 0)
      return(1);
   if(buf[0] == '\0')
      return(sayn(0,badcmd,sizeof(badcmd)));
   cmdcnt++;

   tokac = enargv(buf,tokav,56,tokbuf,sizeof(tokbuf));
   if(tokac <= 0)
      return(sayn(0,badcmd,sizeof(badcmd)));  
   /*================================================================ 
    * If "anonymous" ftp server is not set up for anonymous user ID
    * do NOT let them switch to another user ID. 
    *===============================================================*/ 
   if( (strcmp(proxyptr->username,"anonymous") == 0) &&
       (strcasecmp(tokav[0],"user")  == 0)           &&
       (strcmp(tokav[1],"anonymous") != 0)             )
   {
      sayn(0,usernot,sizeof(usernot)); 
      syslog(LOG_ERR,"Error: anonymous ftp failed. User at %s (%s) tried "
	     " alternate user ID '%s' which was denied by ftproxy.",
	                   proxyptr->srcname,proxyptr->sourceIP,tokav[1]);
      return(1);
   }     
   /*====================================================================
    * Search FTP ops table for user command. If the command is found then
    * check its permissions.  
    *===================================================================*/
   for(op = ops; op->name != (char *)0; op++) 
   {
      if(!strcasecmp(tokav[0],op->name)) 
      { 
	 /*===============================================
          * Check to see if operation should be logged	
          *==============================================*/
         if(op->flg & OP_LOG)
	    syslog(LOG_NOTICE,"%s/%s: %s",
		              proxyptr->srcname,proxyptr->sourceIP,buf);
         /* If not connected and the operation requires connection send msg.*/
	 if(rfd == -1 && (op->flg & OP_CONN))
	    return(sayn(0,beconn,sizeof(beconn)));
         /* Check to see if operation is denied		*/
	 if(op->flg & OP_DENY) 
         {
	    syslog(LOG_NOTICE,"deny host = %s (%s) operation %s",
			proxyptr->srcname,proxyptr->sourceIP,buf);
	    return(sayn(0,denied,sizeof(denied)));
	 }

         /* Check to see if operation requires user to be authenticated */
	 if((op->flg & OP_AUTH)) 
         {
            if(!authenticated) 
            {               
	       syslog(LOG_NOTICE,"deny host = %s (%s) operation %s - "
				 "not authenticated",
			         proxyptr->srcname,proxyptr->sourceIP,buf);
	       return(sayn(0,gottauth,sizeof(gottauth)));
	    }
         }
         /*================================================================= 
	  * If the command is not to be processed by ftproxy ( op == 0) or
	  * ( connection is not broken and connection is required) then 
	  * pass the command to the server. Else call local routine.
	  *================================================================*/
	 if( op->op == 0 ||
	     (rfd != -1 && (op->flg & OP_WCON))) 
         {   
	    /*==========================================================
             * check for logging of commands executed by remote server
	     *=========================================================*/           
	    if( cmdlogging)
            {    
               if( strncasecmp(buf,"CWD",3) == 0)
               {
                  syslog(LOG_NOTICE,"CD %s from %s (%s) user = %s at %s (%s).",
			            &buf[3], dest, proxyptr->destIP,
                                    proxyptr->username,
			            proxyptr->srcname, proxyptr->sourceIP);
               } 
               if( strncasecmp(buf,"DELE",4) == 0)
               {   
                  if( !(gwuptr->ftpaccess & DEL_FTP)  )
                  {
             	     syslog(LOG_ALERT,"Security Alert: user %s denied DEL "
					"from %s (%s).  operation - %s",
		                      gwuptr->username, proxyptr->srcname,
				      proxyptr->sourceIP,buf);
	             return(sayn(0,gottauth,sizeof(gottauth)));
                  } 
                  syslog(LOG_NOTICE,"DEL %s from %s (%s) user = %s at %s (%s).",
			            &buf[4], dest, proxyptr->destIP,
                                    proxyptr->username,
			            proxyptr->srcname, proxyptr->sourceIP);
               }    
               if( strncasecmp(buf,"MKD",3) == 0)
               {
                  syslog(LOG_NOTICE,"MKDIR %s from %s (%s) user = %s at %s "
		  		    "(%s).",
			            &buf[3], dest, proxyptr->destIP,
				    proxyptr->username,
			  	    proxyptr->srcname, proxyptr->sourceIP);
               } 
               if( strncasecmp(buf,"PWD",3) == 0)
               {  
                  strcpy(lastcmd,"PWD ");     
               } 
               if( strncasecmp(buf,"XPWD",4) == 0)
               {  
                  strcpy(lastcmd,"XPWD ");     
               } 
               /*=========================================================== 
                * Check permissions for GET and log 
		*==========================================================*/
               if( strncasecmp(buf,"RETR",4) == 0)
               {   
                  if( proxyptr->srcIPsecure == SECURED) 
                  { 
                    if( !(gwuptr->ftpaccess & GET_FTP)  )
                    {
             	       syslog(LOG_ALERT,"Security Alert: user %s denied GET "
					"from %s (%s).  operation - %s",
			                gwuptr->username, proxyptr->srcname,
					proxyptr->sourceIP,buf);
	               return(sayn(0,gottauth,sizeof(gottauth)));
                    } 
                  }
                  else
                  {
                     if( !(gwuptr->ftpaccess & PUT_FTP)  )
                     {
             	        syslog(LOG_ALERT,"Security Alert: GET denied "
			  		 "host = %s (%s) operation %s - "
				         "not authenticated",
			         proxyptr->srcname,proxyptr->sourceIP,buf);
	                return(sayn(0,gottauth,sizeof(gottauth)));
                     } 
                  }
                  /*==========================================================
                   * Block transfer of files with names beginning with pipe.
                   *=========================================================*/
                  cp = &buf[4];
		  while( isspace(*cp) ) cp++;
                  if( *cp == '|')
                  {
             	     syslog(LOG_ALERT,"Security Alert: GET %s denied "
			  		 "host = %s (%s) dangerous filename "
				         "blocked",
			               &buf[4],proxyptr->srcname,
				       proxyptr->sourceIP,buf);
	                return(sayn(0,badfile,sizeof(badfile)));
                  } 
                  syslog(LOG_NOTICE,"GET %s from %s (%s) user = %s at %s (%s).",
			            &buf[4], dest, proxyptr->destIP,
				    proxyptr->username,
			  	    proxyptr->srcname, proxyptr->sourceIP);
               }     

               if( strncasecmp(buf,"RMD",3) == 0)
               {
                  syslog(LOG_NOTICE,"RMDIR %s from %s (%s) user = %s at %s "
		  		    "(%s).",
			  	    &buf[3], dest, proxyptr->destIP,
				    proxyptr->username,
			            proxyptr->srcname, proxyptr->sourceIP);
               }  
               /*=========================================================== 
                * Check permissions for PUT and log 
		*==========================================================*/
               if( strncasecmp(buf,"STOR",4) == 0)
               {      
                  if( proxyptr->srcIPsecure == SECURED) 
                  { 
                    if( !(gwuptr->ftpaccess & PUT_FTP)  )
                    {
             	       syslog(LOG_ALERT,"Security Alert: user %s denied PUT "
					"from %s (%s).  operation - %s",
			                gwuptr->username, proxyptr->srcname,
					proxyptr->sourceIP,buf);
	               return(sayn(0,gottauth,sizeof(gottauth)));
                    } 
                  }
                  else
                  {
                     if( !(gwuptr->ftpaccess & GET_FTP)  )
                     {
             	        syslog(LOG_ALERT,"Security Alert: PUT denied "
			  		 "host = %s (%s) operation %s - "
				         "not authenticated",
			         proxyptr->srcname,proxyptr->sourceIP,buf);
	                return(sayn(0,gottauth,sizeof(gottauth)));
                     } 
                  }  
                  /*==========================================================
                   * Block transfer of files with names beginning with pipe.
                   *=========================================================*/
                  cp = &buf[4];
		  while( isspace(*cp) ) cp++;
                  if( *cp == '|')
                  {
             	     syslog(LOG_ALERT,"Security Alert: PUT %s denied "
			  		 "host = %s (%s) dangerous filename "
				         "blocked",
			               &buf[4],proxyptr->srcname,
				       proxyptr->sourceIP,buf);
	                return(sayn(0,badfile,sizeof(badfile)));
                  } 
                  syslog(LOG_NOTICE,"PUT %s to %s (%s) user = %s at %s (%s).",
			            &buf[4], dest, proxyptr->destIP, 
				    proxyptr->username,
			            proxyptr->srcname, proxyptr->sourceIP);
               }
            }
	    return(sayn(rfd,buf,x));          /* send cmd to server 	*/
         }
	 return((*op->op)(tokac,tokav,buf));  /* call local routine 	*/
      }
   }
   return(sayn(0,badcmd,sizeof(badcmd)));
}
/*=============================================================================
 *  Read data from incomming port and write to outgoing port.
 *===========================================================================*/
copyin(char *buf,int buffersize)
{   
   int	x;

   if(blockoutput)
      goto Abend;                                              
   x = read(incoming,buf,buffersize);
   if(x <= 0)
      goto Abend;
   if(write(outgoing,buf,x) != x)
      goto Abend;
   outbytcnt += x;
   return(0);

Abend:		/* Abnormal end	*/
   close(incoming);
   incoming = -1;
   if(outgoing != -1) 
   {
      close(outgoing);
      outgoing = -1;
   }
   return(0);
}

/*=============================================================================
 * Read data from outgoing port and write to incomming port.
 *===========================================================================*/
copyout(char *buf,int buffersize)
{  
   int	x;

   if(blockinput)
      goto Abend;
   x = read(outgoing,buf,buffersize);
   if(x <= 0)
      goto Abend;
   if(write(incoming,buf,x) != x)
      goto Abend;
   inbytcnt += x;
   return(0);

Abend:		/* Abnormal end	*/
   close(outgoing);
   outgoing = -1;
   if(incoming != -1) 
   {
      close(incoming);
      incoming = -1;
   }
   return(0);
}

/*============================================================================ 
 * function: getline
 * inputs:
 *     	file descriptor 
 *	pointer to input buffer 
 *	size of buffer
 *                    
 * outputs:
 *	updated buffer
 *	return: 	number of characters read if successfull
 *	                -1 on error
 *
 * The getline function handles odd cases by processing telnet options and
 * THROWING THEM AWAY.  This allows us to process the proxy to process commands
 * suchs as ABORT as normal commands so we can trap them and pass then to 
 * the remote host with our own options processing, thus avoiding the complexity
 * of handling OOB stuff ourselves.
 *============================================================================*/
int getline(int fd, unsigned char *buf, int siz)
{
  int	x = 0;

   while(1) 
   {
      if(read(fd,(char *)&buf[x],1) != 1)
         return(-1);

      /* get \r\n - read a char and throw it away */
      if(buf[x] == '\r') 
      {
         if( read(fd,(char *)&buf[x],1) != 1 )
            return(-1);
         buf[x] = '\0';
	 return(x);
      }

      if(buf[x] == '\n') 
      {
         buf[x] = '\0';
	 return(x);
      }

      if(buf[x] == IAC) 
      {
         unsigned char	j;
	 unsigned char	jbuf[4];

	 if(read(fd,&j,1) != 1)
	    return(-1);

	 switch(j) 
         {
	    case WILL:
	    case WONT:
	    		if(read(fd,(char *)&j,1) != 1)
		 	   return(-1);
			jbuf[0] = IAC;
			jbuf[1] = DONT;
			jbuf[2] = j;
			if(write(fd,(char *)jbuf,3) != 3)
			return(-1);
			continue;
            case DO:
	    case DONT:
	    		if(read(fd,(char *)&j,1) != 1)
			   return(-1);
			jbuf[0] = IAC;
			jbuf[1] = WONT;
			jbuf[2] = j;
			if(write(fd,(char *)jbuf,3) != 3)
			   return(-1);
			continue;
	    case IAC:
			x = 0;
			continue;
            case IP:
	    		if(read(fd,(char *)&j,1) != 1)
			   return(-1);
			if(j == DM)
			x = 0;
			continue;
         }
      }

      if(++x >= siz) 
      {
         syslog(LOG_ERR,"Error: getline: buffer overrun");
	 return(-1);
      }
   }
}  
/*========================================================================
 * save lines from remote server for possible later use 
 *======================================================================*/
static void  saveline( char *s) 
{
   if(saveresp == (char **)0)
      saveresp = (char **)malloc(sizeof(char *));
   else
      saveresp = (char **)realloc(saveresp,(saveresps + 1) * sizeof(char *));
   if(saveresp == (char **)0)
      return;
   saveresp[saveresps] = (char *) malloc(strlen(s) + 1);
   if(saveresp[saveresps] == (char *)0)
      return;
   strcpy(saveresp[saveresps],s);
   saveresps++;
} 
/*=========================================================================
 *
 *=========================================================================*/
static void flushsaved()
{
   int	x;

   for(x = 0; x < saveresps - 1; x++)
      free(saveresp[x]);
   saveresps = 0;
   if(saveresp != (char **)0) 
   {
      (void)free(saveresp);
      saveresp = (char **)0;
   }
} 
/*======================================================================== 
 * flush saved lines prefixing them with 'code'
 *========================================================================*/
sendsaved(int fd, int code)  
{
   int	l;
   int	x;

   for(x = 0; x < saveresps; x++) 
   {
      if(code != -1) 
      {
         char	sbuf[5];
	 sbuf[0] = (code / 100) + '0';
	 sbuf[1] = ((code / 10) % 10) + '0';
	 sbuf[2] = (code % 10) + '0';
	 sbuf[3] = '-';
	 sbuf[4] = '(';
	 if(write(fd,sbuf,5) != 5)
 	    return(-1);
      }
      l = strlen(saveresp[x]);
      if(write(fd,saveresp[x],l) != l)
         return(-1);
      if(code != -1 && write(fd,")",1) != 1)
         return(-1);
      if(write(fd,"\r\n",2) != 2)
         return(-1);
   }
   flushsaved();
   return(0);
}
/*============================================================================
 * 
 * outputs:
 *	If the line starts with a three digit number return the integer value.
 *===========================================================================*/
getresp(int fd, char *b, int siz, int save) 
{
   while(1) 
   {
      if(getline(fd,(unsigned char *)b,siz) < 0)
         return(-1);
      if(isdigit(b[0]) && isdigit(b[1]) && isdigit(b[2]) && b[3] == ' ') 
      {
         return(((int)(b[0] - '0') * 100) +
	 	 ((int)(b[1] - '0') * 10) +
		  (int)(b[2] - '0'));
      }
      if(save)
         saveline(b);
   }
}
/*==========================================================================
 *  function say
 * inputs:	file descriptor
 *		s 
 * return:	0 if ok
 *==========================================================================*/ 
int say(int fd, char *s)  
{   
   return(sayn(fd,s,strlen(s)));
}
/*========================================================================
 * function sayn 
 * 		Writes a character string of length n terminated by CRLF 
 * inputs:	file descriptor
 *		ptr to character string
 *		length of string
 * return:	0 if write is ok
 *========================================================================*/ 
int sayn(int fd, char *s, int n)
{
   if(write(fd,s,n) != n)
      return(1);
   return(write(fd,"\r\n",2) != 2);
} 
/*========================================================================
 * function dicta 
 * 		Writes a character string of length n terminated by CRLF 
 * inputs:	file descriptor
 *		ptr to character string. The string must be terminated with
 *					 "\r\n". 
 *		length of string
 * return:	0 if write is ok  
 *              1 if write failed.
 *========================================================================*/ 
int dicta(int fd, char *s, int n)
{
   if(write(fd,s,n) == n)
      return(0);
   return(1); 
}
/*=======================================================================
 * function:	sayfile
 * inputs:	output file descriptor 
 *		ptr to the file name 
 *              message code number
 * outputs:	return 0 if ok
 *		return 1 on error 
 *=======================================================================*/
int sayfile(int fd, char *filename,int code) 
{
   FILE	*f;
   char	buf[CBUFSIZ];		/* input buffer		*/
   char	obuf[CBUFSIZ];          /* output buffer	*/
   char	*c;
   int	x;

   if((f = fopen(filename,"r")) == (FILE *)0) 
   {
      syslog(LOG_ERR,"Error: unable to open file %s.",filename);
      return(1);
   }
   while(fgets(buf,sizeof(buf),f) != (char *)0) 
   {
      if( (c = index(buf,'\n')) != (char *)0 )
         *c = '\0';
      x = fgetc(f);
      if(feof(f)) 
      {
         sprintf(obuf,"%3.3d-%s",code,buf);  
      } 
      else 
      {
         sprintf(obuf,"%3.3d-%s",code,buf);
	 ungetc(x,f);
      }
      if(say(fd,obuf)) 
      {
         fclose(f);
         syslog(LOG_ERR,"Error: unable to write message file to user. "
			"fd = %d.",
		        fd);
	 return(1);
      }
   }
   fclose(f);
   return(0);
}
/*==========================================================================
 *
 *=========================================================================*/
int port_to_addr(char *s, struct sockaddr_in *a) 
{
   unsigned char	*c;
   char		*x;
   static char	d[] = ",";

   bzero((char *)a,sizeof(struct sockaddr_in));

   /* strip out host bits */
   c = (unsigned char *)(&(a->sin_addr));
   if((x = strtok(s,d)) == (char *)0)
     return(1);
   c[0] = atoi(x);
   if((x = strtok((char *)0,d)) == (char *)0)
      return(1);
   c[1] = atoi(x);
   if((x = strtok((char *)0,d)) == (char *)0)
      return(1);
   c[2] = atoi(x);
   if((x = strtok((char *)0,d)) == (char *)0)
      return(1);
   c[3] = atoi(x);

   /* now strip out port bits */
   c = (unsigned char *)(&(a->sin_port));
   if((x = strtok((char *)0,d)) == (char *)0)
      return(1);
   c[0] = atoi(x);
   if((x = strtok((char *)0,d)) == (char *)0)
      return(1);
   c[1] = atoi(x);
   a->sin_family = AF_INET;
   return(0);
} 
/*=========================================================================
 * secureftp
 * function: 
 *	secure the file transfer proxy server by: changing to the designated
 * 	directory chrooting to that directory and changing the group id and
 * 	user id. 
 *
 *========================================================================*/
void secureftp(struct FTPROXY *proxyptr )
{ 
   chdir("/");
   if( chdir(proxyptr->ftproxpath) ) 
   {
         syslog(LOG_ERR,"Error: chdir %s failed: %m",proxyptr->ftproxpath);
	 exit(1);
   }
   if( chroot(proxyptr->ftproxpath) ) 
   {
      syslog(LOG_ERR,"Error: chroot %s failed: %m",proxyptr->ftproxpath);
      exit(1);
   }
   chdir("/"); 
   if( proxyptr->ftgroupid != -1 && setgid(proxyptr->ftgroupid) ) 
   {
      syslog(LOG_ERR,"Error: cannot setgid %d: %m",proxyptr->ftgroupid);
      exit(1);
   }

   if(proxyptr->ftuserid != -1 && setuid(proxyptr->ftuserid)) 
   {
      syslog(LOG_ERR,"Error: cannot setuid %d: %m",proxyptr->ftuserid);
      exit(1);
   } 
   if(proxyptr->debug)
   {
      syslog(LOG_NOTICE,"ftp secured: ftproxpath = '%s', ftuserid = %d", 
			proxyptr->ftproxpath, proxyptr->ftuserid);			     
   } 
   return; 
}
/*===========================================================================
 * debugbind
 * input:	debug port number
 *==========================================================================*/
void debugbind(unsigned short debugport)
{
   struct	sockaddr_in	mya;
   int	x;
   int	nread;

   if((x = socket(AF_INET,SOCK_STREAM,0)) < 0) 
   {
      perror("socket");
      exit(1);
   }
   memset(&mya, 0, sizeof(mya));
   mya.sin_family = AF_INET;
   mya.sin_port = htons(debugport);

   if(bind(x,(struct sockaddr *)&mya,sizeof(mya))) 
   {
      perror("bind");
      exit(1);
   }
   if(listen(x,1) < 0)
   {
      perror("listen");
      exit(1);
   }
   if((nread = accept(x,0,0)) < 0) 
   {
      perror("accept");
      exit(1);
   }
   close(0);
   dup(nread);
   close(1);
   dup(nread);
}

