/*============================================================================
 * filename:		../ftproxy/noauth.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * written by:		R. James Livermore 
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  
 * All rights reserved.  
 *
 * Date written:	July	  27, 1995 
 *			December  17, 1997 - added SYST cmd for AS/400
 *                      September  7, 1999 - added Linux support
 * Last modified:	February   8, 2000 - added LPL
 *                     
 *
 * function:		Handle USER username when auth = no is coded in	
 *                      ftproxy.conf file. 
 *
 *	                If user name has the form user@host.domain setup  
 *	                automated login to remote system.
 *
 *
 *============================================================================*/

static	char	cprght[] = 
  "(C) COPYRIGHT Freemont Avenue Software, Inc. 1995-2000, V 1.0 00/01/21";  
#include	<stdio.h>
#include	<ctype.h>
#include	<syslog.h>   
#include	<sys/ioctl.h>
#include	<sys/errno.h>
#include	<sys/signal.h>
#include	<arpa/ftp.h>
#include	<arpa/telnet.h>
#include	<sys/time.h> 
#include	<sys/times.h>		/* cpu timings			*/
#include	<sys/types.h> 
#ifndef __hppa
#include 	<sys/select.h>		/* to support fd_set 		  */
#endif  
#include	<string.h>
#include	<sys/socket.h>
#include	<netinet/in.h> 
#include	<netdb.h>     		/* includes h_errno		  */ 
#include	"firewall.h" 
#include	"gwuser.h"
#include	"ftproxy.h"  

extern	int	h_errno; 
/*
extern	char	*rindex();
extern	char	*index(); 
*/
extern	int	errno;
#ifndef linux
extern	char	*sys_errlist[];
#else
extern const char *const sys_errlist[];
#endif
extern	char	*strtok();

/*==========================================================================
 * function prototypes
 *=========================================================================*/

       



             
/*=========================================================================
 * noauth
 * inputs:
 *	ptr to input buffer 
 *      buffer size
 *      ptr to output buffer
 *      ptr to GWUSER record
 *	ptr to FTPROXY record
 * outputs:
 *	returns 0 if OK.
 * 	returns 1 for autologin
 *	exits on error.                
 *      updated GWUSER record:
 *		user name in GWUSER or IP address of remote client
 *              default ftp options from default GWGROUP record 
 *========================================================================*/
int noauth(char *inbuf, int bufsiz, char *obuf, struct GWUSER *gwuptr,
           struct FTPROXY *proxyptr) 
{  

   int		ntries = 2;		/* number of tries name */
   int		x;       
   int		z; 
   long		tempport;
   short	port; 
   struct timeval	timo;
   fd_set		rdy; 
   char		*cp;    
   char		savedcmd[100]; 		/* save cmds prior to USER	*/
   char		*token1;
   char		*token2; 
   char		*token3;
   char		tokensep[]   = "\t \n";   

   struct GWGROUP group;  
   struct GWCONF  conf;
   /*========================================================================= 
    * Read gwuser.conf file to get name of default group.
    * Read default GWGROUP record and copy ftp options to GWUSER record.
    *========================================================================*/
   if( get_gwuserconf(&conf) != 0)
   {
      syslog(LOG_ERR,"Error: noauth unable to read gwuser.conf file");
      exit(1); 
   }
   if( get_gwgroup((char *)&conf.groupname,&group) != 0)
   {
      syslog(LOG_ERR,"Error: noauth unable to read group \"%s\".",
		conf.groupname);
      exit(1);
   }      
   gwuptr->ftpaccess = group.ftpaccess;
   /*======================================================================
    *  The FTP client prompts the user for their name and sends 
    * 'USER name" to the proxy.  Most ftp clients send USER name first.
    * However, DEC sends STRU first. So we give the client two tries.
    *=====================================================================*/ 
   while(ntries--)
   {  
      if( getline(0,(unsigned char *)inbuf,bufsiz) < 0 ) 
      {
         syslog(LOG_NOTICE,"Error: Can Not read USER from %s (%s).",
		 proxyptr->sourceIP,proxyptr->srcname);  
         exit(1); 
      } 
      if( proxyptr->debug)
      {
         syslog(LOG_NOTICE,"noauth.command: %s",inbuf); 
      }
      if( (token1 = strtok(inbuf,tokensep)) == NULL) 
      {
         syslog(LOG_NOTICE,"Error: Null user name from %s (%s).",
		 proxyptr->sourceIP,proxyptr->srcname);  
         exit(1); 
      }
      if( strcasecmp(token1,"QUIT") == 0 )
      {
         syslog(LOG_ERR,"User QUIT. source = %s (%s)",
			 proxyptr->srcname, proxyptr->sourceIP); 
         say(0,"221 Goodbye.");
         exit(0);   
      } 
      /* Added to support AS/400	*/
      if( strcasecmp(token1,"SYST") == 0)
      {
         say(0,"215 UNIX");
         ntries++;      	/* give them one more try	*/
         continue;	
      } 
      if( strcasecmp(token1,"STRU") == 0 )
      {
         token3 = strtok(NULL,tokensep); 
	 sprintf(obuf,"200 %s %s ok.", token1, token3);
         if( say(0,obuf) )
         {
            syslog(LOG_NOTICE,"Error: Can Not display stru x msg to %s (%s).",
		proxyptr->sourceIP,proxyptr->srcname);  
            exit(1);
         }
	 strncpy(savedcmd,token1,5); 
         strcat(savedcmd," ");
         strcat(savedcmd,token3);  
         syslog(LOG_NOTICE,"%s",savedcmd); 
	 goto tryagain;
      } 
      if( strcasecmp(token1,"USER") == 0 )
      {
         if( (token2 = strtok(NULL,tokensep)) == NULL)
         {
            syslog(LOG_ERR,"Error: no user name specified after USER keyword."
			   " source = %s (%s)",
	         	   proxyptr->srcname, proxyptr->sourceIP); 
	    say(0,"501 no user name specified after USER keyword. Goodbye.");
            exit(1);  
         }
	 /*=================================================================
          * Check for auto login "username@host.domain"
          *================================================================*/
         if( strchr(token2,'@') !=  NULL)
         {                                   
            token2 = strtok(token2,"@"); 
            if( strlen(token2) > UNMSIZ)
	    {                             
	       sprintf(obuf,"501 Error: user name '%.16s...' length (%d) > %d. Goodbye.",
			    token2, strlen(token2), UNMSIZ);
               say(0,obuf);
               exit(1);  
	    }
            strcpy(proxyptr->autologname,token2);  
            token2 = strtok(NULL,tokensep);
            strncpy(proxyptr->destname,token2,256); 
            strncpy(gwuptr->username,proxyptr->sourceIP,UNMSIZ); 
	    return(1);
	 }
         /* added for OS/2 Warp */
	 sprintf(obuf,"230- user %s logged in.", token2);
         if( say(0,obuf) )
         {
            syslog(LOG_NOTICE,"Error: Can Not display user logged in msg to %s (%s).",
		proxyptr->sourceIP,proxyptr->srcname);  
            exit(1);
         }  
         strncpy(gwuptr->username,token2,UNMSIZ);  
         return(0);
      }  /* end of USER processing */

tryagain:
      continue;   		
   }
   /* If USER not identified use IP address */
   strncpy(gwuptr->username,proxyptr->sourceIP,UNMSIZ); 
   return(0);  
 
}
