/*============================================================================
 * filename:	fwmon/spoofmon.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * (C) COPYRIGHT Freemont Avenue Softwarem, Incorporated 1996-2000.  All rights
 * reserved.    
 *
 * Date written:	May	   9, 1996
 * Last modified:	February   8, 2000
 *
 * function:		 	
 *              Turn the process into a daemon and then start tcpdump on the
 *              external network interface of the firewall and writes the
 *		source IP, source port, destination IP, destination port of
 *		all supicious ftp and telnet open requests to a shared memory
 *		segment.  Supicious requests are ones that come through the
 *		external network interface trying to connect to the internal
 *		ip address.
 *
 *		This function does not return but exits directly.  It is
 *		assumed tha the caller spawned a child to call this function.
 *
 *============================================================================*/
static  char	ident[] = "@(#) spoofmon, V 1.0, 00/02/14"
 			  " (C) Freemont Avenue Software, Inc."
			  " 1996-2000";
#ifdef __sun
main(){}
#else

#include	<limits.h>
#include	<sys/signal.h>
#include	<errno.h>
#include	<sys/ioctl.h>
#include	<sys/types.h>
#include	<sys/ipc.h>
#include	<sys/ipc.h>
#include	<sys/sem.h>
#include	<sys/shm.h>
#include	<sys/time.h>
#include	<stdio.h>
#include	<sys/socket.h>
#include	<net/if.h>
#ifndef _AIX
#include	<netinet/in_systm.h>
#endif
#include	<netinet/in.h>
#include	<netinet/tcp.h>
#include	<netinet/ip.h>
#ifndef linux
#include	<netinet/ip_var.h>
#include	<netinet/tcpip.h>
#else
#include	<netinet/ip.h>
#include	<netinet/tcp.h>
#endif
#include	<arpa/inet.h>
#include	<syslog.h>  
#include	<unistd.h>  
#include	<string.h>  
#include	<stdlib.h>  
#include	"firewall.h"
#include	"spoofmon.h"
#include	"fwmon.h"

static pid_t		pmonpid;
#define		__MAINFILE
#include	"chkpoint.h"
#define		MAXPORTNAME     16

#ifndef TNPORT
#define         TNPORT          "23"
#endif
#ifndef FTPPORT
#define         FTPPORT         "21"
#endif

#ifdef IFF_LOOPBACK
#define ISLOOPBACK(p) ((p)->ifr_flags & IFF_LOOPBACK)
#else
#define ISLOOPBACK(p) (strcmp((p)->ifr_name, "lo0") == 0)
#endif

int getlocal(in_addr_t **local_ip,char **portname,long *nlips);
static int		semid=-1;
static int		shmid;
static struct conn_entry    *shtop;

#ifndef linux
extern char *sys_errlist[];
#else
extern const char *const sys_errlist[];
#endif

/*
 * This is extracted and modified from the libpcap package.
 * Each packet in the dump file is prepended with this generic header.
 * This gets around the problem of different headers for different
 * packet interfaces.
 */
   struct pcap_pkthdr
   {
	struct	timeval ts;	/* time stamp */
	long	caplen;		/* length of portion present */
	long	len;		/* length this packet (off wire) */
   };

int addpid(char *name);

trace_exit()
{
   closelog();
   exit(1);
}

/*=======================================================================
 * exit handling
 *======================================================================*/
void pmexit() {
    kill(pmonpid, SIGUSR2);
    return;
}

/*=======================================================================
 * Spawn a process to monitor the network interface given in ifname.
 * The process spawns its own child to run tcpdump which pipes the output
 * back for the process to record.
 * ifname is the name of the network interface to trace.
 * Ports contains an expression to be passed to tcpdump to select packets
 * by destination address.
 *======================================================================*/
void trace_port(char *ifname,char *ports)
{
   FILE			*pipe_in,*pipe_out;
   int			pid,pipefds[2];
   int			rc;
   struct conn_entry	*shp;
   char			addrstr[LINE_MAX],addrstr2[LINE_MAX];
   char			buf[LINE_MAX],*cp,*cp2;
   char			portaddr[MAXPORTS];
   static struct sembuf op_lock[2] =
   {
        0,0,0,                          /* Wait for sem#0 to become 0 */
        0,1,SEM_UNDO                    /* then increment sem#0 by 1  */
   };
   static struct sembuf op_unlock[1] =
   {
        0,-1,(IPC_NOWAIT|SEM_UNDO)      /* decrement sem#0 by 1 (sets to 0) */
   };

   INIT_CHKPOINTS();

   /*=======================================================================
    * Fork a process and use the child to do the trace.
    * The parent returns to the caller.
    *======================================================================*/

   if ((pid=fork()) < 0)
   {
        syslog(LOG_ERR,"Error: Fork failed, errno=%d\n",errno);
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	closelog();
        exit(1);
   }

   CHKPOINT();
   if (pid != 0)
	return;

   atexit(pmexit);
   CHKPOINT();
   /*=======================================================================
    * Create the pipe
    *======================================================================*/
   if (pipe(pipefds) < 0)
   {
        syslog(LOG_ERR,"Error: Pipe create failed, errno=%d\n",errno);
	closelog();
        exit(1);
   }

   CHKPOINT();
   /*=======================================================================
    * fork a child to run tcpdump
    *======================================================================*/
   if ((pid=fork()) < 0)
   {
        syslog(LOG_ERR,"Error: Fork failed, errno=%d\n",errno);
	closelog();
        exit(1);
   }

   CHKPOINT();
   if (pid == 0)
   {
	CHKPOINT();
        /*===============================================================*
         * Child is executing here.....
	 * Add current pid to the fwmon.pids file.
	 *===============================================================*/
	addpid(FWMONPIDS);

	CHKPOINT();
        /*===============================================================*
         * Make the write side of the pipe the child's stdout.
         * Also make stderr the same as stdout.
         *===============================================================*/
        close(1);
        dup(pipefds[1]);
	close(2);
        dup(pipefds[1]);
        close(pipefds[1]);
        /* Close the read side - we are not expecting anything */
        close(pipefds[0]);

	CHKPOINT();
        /* Exec tcpdump */
#ifdef __hppa
	execl("/usr/local/etc/tcpdump","/usr/local/etc/tcpdump","-n","-l",
#else
#ifdef linux
	execl("/usr/sbin/tcpdump","/usr/sbin/tcpdump","-n","-l",
#else
	execl("/usr/sbin/tcpdump","/usr/sbin/tcpdump","-n","-I","-l",
#endif
#endif
	"-i",ifname,
	/* "dst","port",TNPORT,"or",FTPPORT,"and", */
	ports,"and",
	"tcp[13]","&","0xff","=","0x02",
	(char *)0);

	syslog(LOG_ERR,"Error: Could not exec tcpdump, errno = %d\n",errno);
	closelog();
	exit(1);
   }
   /*=======================================================================
    * The parent
    *======================================================================*/

   CHKPOINT();
   /*=======================================================================
    * Add current pid to the fwmon.pids file.
    *======================================================================*/
   addpid(FWMONPIDS);

   /*=======================================================================
    * Close the write side of the pipe since we don't need it.
    *======================================================================*/
   close(pipefds[1]);

   /* Convert the read side of the pipe to stdio. */
   pipe_in = fdopen(pipefds[0],"r");

   CHKPOINT();
   /*=======================================================================
    * The parent listens on the pipe and records relevent connections
    *======================================================================*/

   while (1)
   {
	int i;
	char *tp;
	CHKPOINT();
	/*====================================================================
	 * Read in the next tcpdump output line
	 *===================================================================*/
#ifndef linux
	if ((rc=(int)fgets(buf,sizeof(buf),pipe_in)) <= 0) {
	    syslog(LOG_ERR, "Error: Failed reading tcpdump output, "
				"size read = %d,errno = %d\n", rc,errno);
	    trace_exit();
	}
#else
	/*====================================================================
	 * For some reason, fgets on linux does not seem to work with
	 * pipes.
	 *===================================================================*/
	for (i = 0; i < sizeof(buf) - 1; i++) {
	    if ((rc = read(pipefds[0], &buf[i], 1)) <=0) {
		syslog(LOG_ERR, "Error: Failed reading tcpdump output, "
				"size read = %d,errno = %d\n", i,errno);
		trace_exit();
	    }
	    /*===============================================================
	     * Stop at EOL
	     *==============================================================*/
	    if (buf[i] == '\n') {
		buf[i+1] = '\0';
		break;
	    }
	}
#endif

	CHKPOINT();
	/*====================================================================
	 * We do expect the first line from tcpdump to be like:
	 * tcpdump: listening on .....
	 * so ignore it and continue.
	 *===================================================================*/
	if (strstr(buf,"tcpdump: listening on") != 0)
	    continue;

	CHKPOINT();
	/*====================================================================
	 * If the 1st character is not a digit or if there is no '.' in the
	 * line, this is not a 'hit'.  Log it just in case it is something
	 * suspicious.
	 *===================================================================*/

	if (!isdigit(buf[0]) || (strchr(buf,'.') == NULL))
	{
	    syslog(LOG_NOTICE,"Unexpected tcpdump output: %s",buf);
	    continue;
	}

	CHKPOINT();
	strtok(buf," \t");	/* Get rid of time stamp */
	if ((tp = strtok(NULL, " \t")) == NULL)
	    continue;
	if (strcmp(tp, "<") == 0) {
	    tp = strtok(NULL, " \t");
	    if (tp == NULL)
		continue;
	}
	strcpy(addrstr,tp);
	cp = strrchr(addrstr,'.');	/* Locate where the address ends */
	*cp++ = '\0';		/* Terminate address and inc to point to port */
	CHKPOINT();
	/*====================================================================
	 * If the 2nd token is not in the form of an IP address then
	 * this is not a 'hit'.
	 *===================================================================*/
	if (strspn(addrstr,"0123456789.") != strlen(addrstr) ||
		strchr(addrstr,'.') == NULL)
	    continue;

	CHKPOINT();
	if ((tp = strtok(NULL," >:\t")) == NULL)
	    continue;
	strcpy(addrstr2, tp);
	cp2 = strrchr(addrstr2,'.');	/* Locate where the address ends */
	*cp2++ = '\0';		/* Terminate address and inc to point to port */
	/*====================================================================
	 * If the token is not in the form of an IP address then
	 * this is not a 'hit'.
	 *===================================================================*/
	if (strspn(addrstr2,"0123456789.") != strlen(addrstr2) ||
		strchr(addrstr2,'.') == NULL)
	    continue;
	CHKPOINT();
	syslog(LOG_ALERT,"Security Alert: Attempt to connect to a secure port from outside the firewall or attempt to connect to the firewall using a local firewall IP address. Src (address=%s,port=%s), dst (address=%s,port=%s).\n",addrstr,cp,addrstr2,cp2);

	CHKPOINT();
	/*====================================================================
	 * Obtain a lock on the shared memory segment and then write the new
	 * spoof connection entry to it
	 *===================================================================*/
	if (semop(semid,&op_lock[0],2) < 0)
	{
	    syslog(LOG_ERR,"Error: semop lock error\n");
	    trace_exit();
	}

	CHKPOINT();
	shp = (struct conn_entry *)((char *)shtop + SHMTOP) + SHMINDEX;

        shp->src = inet_addr(addrstr);
	shp->sport = htons(atoi(cp));
        shp->dst = inet_addr(addrstr2);
	shp->dport = htons(atoi(cp2));
	if (SHMINDEX++ >= SHMNENT)
   		SHMINDEX = 0;
	CHKPOINT();
	if (semop(semid,&op_unlock[0],1) < 0)
	{
	    syslog(LOG_ERR,"Error: semop unlock error\n");
	    trace_exit();
	}
   }
   CHKPOINT();
   trace_exit();	/* Shouldn't get here anyway */

}

/*=======================================================================
 * spoofmon is called by fwmon to begin monitoring for spoofed IP
 * addresses.
 * spoof_mon indicates whether the monitor should be activated or disabled.
 *======================================================================*/
#ifdef linux
int main( int argc, char *argv[])
#else
void main( int argc, char *argv[])
#endif
{   
   int		fd;
   int		portlen;
   int		pindex;
   int		count=0;
   int		i,n;
   int		nintf=0;
   long		nlips=0;
   char		*secportfile = SECUREPORTFILE;
   char		portaddr[LINE_MAX];
   char		ports[3*32*MAXPORTS];
   in_addr_t	*ipp,*local_ip;
   struct in_addr lip;
   char		*intf;
   char		*portname;
   char		ifname[IFNAMSIZ];
   FILE         *spfp;
   pid_t	pid;
   struct pmonconf conf;

   SETUP_CHKPOINT_HANDLERS();
   INIT_CHKPOINTS();

   openlog("spoofmon",LOG_PID|LOG_NDELAY,LOG_NOTICE);

   pmonpid = getppid();

   CHKPOINT();
   /*====================================================================
    * Create a shared memory segment to store the trace output for the
    * proxies to read.
    *===================================================================*/
   if ((shmid = shmget(SHMKEY,SHMSIZE,IPC_CREAT | 0600)) < 0)
   {
	syslog(LOG_ERR,"Error: shmget failed, errno = %d\n",errno);
	closelog();
	exit(1);
   }
   CHKPOINT();
   if ((shtop = (struct conn_entry *)shmat(shmid,(char *)0,0)) == (struct conn_entry *)-1)
   {
	syslog(LOG_ERR,"Error: shmat failed, errno = %d\n",errno);
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	closelog();
	exit(1);
   }

   CHKPOINT();
   /*=======================================================================
    * Create the semaphore lock
    *======================================================================*/
   if ((semid=semget(SHMKEY,1,0600|IPC_CREAT)) < 0)
   {
	syslog(LOG_ERR,"Error: semget error\n");
	closelog();
	exit(1);
   }
   CHKPOINT();
   /*====================================================================
    * Initialize the shared memory segment
    *===================================================================*/
   memset(shtop,0,SHMSIZE);

   CHKPOINT();
   /*=======================================================================
    * If spoofmon is disabled by the fwmon.conf file,
    * just return (leaving the shared memory segment at zero so the proxies
    * know that no monitor is active.
    *======================================================================*/
   if (pmconf(&conf) < 0)
	exit(1);
   if (!conf.spoofmon)
   {
	syslog(LOG_NOTICE,"spoofmon is disabled as requested by %s."
			,PMONCONFFILE);
	exit(0);
   }
   CHKPOINT();

   SHMTOP = sizeof(shm_hdr);

   (void) signal(SIGHUP,SIG_IGN);
   (void) signal(SIGTTIN,SIG_IGN);
   (void) signal(SIGTTOU,SIG_IGN);
   (void) signal(SIGTSTP,SIG_IGN);
   (void) signal(SIGCLD,SIG_IGN); 

   CHKPOINT();
   /*=======================================================================
    * Dissociate from controlling terminal
    *======================================================================*/

#ifdef __hppa
   if (setpgid(0, 0) == -1)
#else
   if (setpgrp() == -1)
#endif
	syslog(LOG_NOTICE,"Cannot change process group, errno = %d\n",errno);

   chdir("/");

   syslog(LOG_NOTICE,"spoofmon daemon started");

   CHKPOINT();
   /*=======================================================================
    * First open the secureports file to get the ip address(es) of the
    * internal network interface(s).
    *======================================================================*/

   if (!(spfp = fopen(secportfile, "r")))
   {

	syslog(LOG_ERR,"Error: open failed for %s: %m",secportfile);
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	closelog();
	exit(1);               /* open failed all addresses are unsecured */
   }

   CHKPOINT();
   /*=======================================================================
    * Get all ip addresses specified in secureports
    *======================================================================*/
   if ((ipp = malloc(sizeof(in_addr_t))) == NULL)
   {
	syslog(LOG_ERR,"Error: malloc failed for ipaddr.  %s",
					sys_errlist[errno]);
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	fclose(spfp);
	closelog();
	exit(1);
   }
   pindex = 0;
   strcpy(ports,"dst host ");
   CHKPOINT();
   while(fgets(portaddr, LINE_MAX, spfp) != NULL)
   {
	CHKPOINT();
	if (portaddr[0] == '#' || strtok(portaddr," \t\n") == '\0')
	    continue;
	portlen = strlen(portaddr) - 1;           /* drop off new line char  */
	if (portaddr[portlen] == '\n')
	    portaddr[portlen] = '\0';
	/*====================================================================
	 * Get rid of blanks on the line.  Since this is either an in-place
	 * move or a left move (i.e. it can never be a right move), this
	 * strcpy should be OK.
	 *===================================================================*/
	strcpy(portaddr,strtok(portaddr," "));

	if ((ipp[pindex] = inet_addr(portaddr)) != 0)
	{
	    if (pindex > 0)
		strcat(ports," or ");
	    strcat(ports,portaddr);
	    pindex++;
	}
	CHKPOINT();
	/*====================================================================
	 * Get an additional chunk of memory for the next ipaddr
	 *===================================================================*/
	if ((ipp = realloc(ipp, (pindex + 1) * sizeof(in_addr_t))) == NULL)
	{
	    syslog(LOG_ERR,"Error: realloc failed for ipaddr.  %s",
				sys_errlist[errno]);
	    shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	    semctl(semid,IPC_RMID,0);
	    fclose(spfp);
	    closelog();
	    exit(1);
	}
   }
   CHKPOINT();
   if (!feof(spfp))
   {
	syslog(LOG_ERR,"Error: Failed reading secureports files, errno=%d\n",
		errno);
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	fclose(spfp);
	closelog();
	exit(1);
   }
   fclose(spfp);

   ipp[pindex++] = 0x7f000001;		/* Loopback address */

   CHKPOINT();
   /*=======================================================================
    * Each configured ip address that is not 127.0.0.1 and that's
    * not specified in secureports is assumed to be an external address
    * that needs to be monitored
    *======================================================================*/
   if (getlocal(&local_ip,&portname,&nlips))
   {
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	exit(1);
   }
   CHKPOINT();

   for (n=0; n<nlips; n++)
   {
	char *cp;
	CHKPOINT();
#if defined(linux) || defined(__sun)
	/*===================================================================
	 * Strip off anything at ':' so the "eth1:1" looks like "eth1"
	 *==================================================================*/
	if ((cp = strchr(portname + (n * IFNAMSIZ), ':')) != NULL)
	    *cp = '\0';
#endif

	CHKPOINT();
	for (i=0; i<pindex; i++)
	    if (local_ip[n] == ipp[i])
		break;

	CHKPOINT();
	if (i >=pindex)
	{
	    int j;

	    count++;
	    for (j = 0; j < nintf; j++) {
		if (strcmp(intf + (j * IFNAMSIZ), portname + (n * IFNAMSIZ))
							== 0)
		    break;
	    }

	    if (j >= nintf) {
		trace_port(portname + (n * IFNAMSIZ), ports);

		/*===========================================================
		 * Remember the interfaces we have worked on so we don't repeat
		 *==========================================================*/
		if (nintf == 0) {
		    if ((intf = malloc(IFNAMSIZ)) == NULL)
		    {
			syslog(LOG_ERR,"Error: malloc failed for interface "
					"name.  %s",sys_errlist[errno]);
			shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
			semctl(semid,IPC_RMID,0);
			exit(1);
		    }
		}
		else {
		    if ((intf = realloc(intf, (nintf + 1) * IFNAMSIZ)) == NULL)
		    {
			syslog(LOG_ERR,"Error: realloc failed for interface "
				"name.  %s",
				sys_errlist[errno]);
			shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
			semctl(semid,IPC_RMID,0);
			exit(1);
		    }
		}
		strcpy(intf + (nintf++ * IFNAMSIZ), portname + (n * IFNAMSIZ));
	    }
	}
   }
   CHKPOINT();
   if (count == 0)
   {
	syslog(LOG_ERR,"Error: No external network interface found on firewall.  Most likely a configuration mistake.\n");
	shmctl(shmid,IPC_RMID,(struct shmid_ds *)0);
	semctl(semid,IPC_RMID,0);
	closelog();
	exit(1);
   }

   closelog();
   exit(0);
}
#endif /* __sun */
