/*============================================================================
 * filename:	../fwmon/synmonkx.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * (C) COPYRIGHT Freemont Avenue Softwarem, Incorporated 1996-2000.  All rights
 * reserved.    
 *
 * Date written:	October   15, 1996
 * Last modified:	February   8, 2000
 *
 * function:		 	
 *		kernel extension for synmon
 *
 *============================================================================*/
static  char	ident[] = "@(#) synmonkx, V 1.0, 00/01/21"
 			  " (C) Freemont Avenue Software, Inc."
			  " 1996-2000";
#ifdef _AIX
#include <net/spl.h>
#include <sys/machine.h>
#include <sys/time.h>
#if !defined(_AIX) || defined(_AIX41)
#include <netinet/if_fddi.h>
#endif /* !defined(_AIX) || defined(_AIX41) */
#include <sys/ndd.h>
#include <sys/pin.h>
#include <sys/malloc.h>
#else
#include <malloc.h>
#endif /* _AIX */
#include <sys/param.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/socket.h>
#ifdef __hppa
#include <sys/spinlock.h>
#include <net/if_arp.h>
#endif
#if defined(_AIX32) && !defined(_AIX41)
#include <sys/intr.h>
#endif /* defined(_AIX32) && !defined(_AIX41) */
#include <syslog.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/ip_var.h>
#include <netinet/tcpip.h>
#include <netinet/tcp_var.h>
#define TCPSTATES
#include <netinet/tcp_fsm.h>
#include <net/route.h>
#include <netinet/in_pcb.h>
#include <sys/socketvar.h>
#include <stdio.h>
#include "fwmon.h"

#define NSAFE 3
#define EXPIRET 1
#define SOPCB	((struct inpcb *)(sock->so_pcb))
#define SOTCPCB	((struct tcpcb *)(SOPCB->inp_ppcb))
#define INPSO	((struct socket *)(pcb->inp_socket))
#define INTCPCB	((struct tcpcb *)(pcb->inp_ppcb))

/*====================================================================
 * Determnines if an ip address is on the list ips.
 *
 * 	The list ips consists of struct tip entries.
 *	The first 4 bytes is an ip address
 *	The second 4 bytes is a mask that describes which bits in the ip
 *	should be used for matching.
 *
 * Input:
 *      unsigned long ip        - IP to check
 *	unsigned long nips	- number of struct tip entries in list
 *	struct tip *ips		_ points to list of entries
 *
 * Output:
 *      0 = ip not on list
 *      1 = ip on list
 *===================================================================*/
int isonlist(unsigned long ip, unsigned long nips, struct tip *ips)
{
   int i;

   for (i=0; i< nips; i++)
   {
	if ((ip & (ips+i)->mask) == (ips+i)->ip)
	    return(1);
   }
   return(0);
}


#ifdef _AIX
/*====================================================================
 * Expire sockets in a socket queue
 *
 * Input:
 *      struct synparms *synparms - pointer to synmon parms
 *	unsigned char *warned	- Array of indicators for alerts
 *	struct inpcb *tcbp	- AIX 3.2 only - pointer to tcb
 *	struct tip *tipsp	- pointer to list of trusted ips.
 *	unsigned long ntips	- number of trusted ips.
 *	struct tip *utipsp	- pointer to list of untrusted ips.
 *	unsigned long nutips	- number of untrusted ips.
 *
 * Output:
 *      >=0  = number of sockets expired
 *      <0   = error
 *===================================================================*/
int synchk(struct synparms *synparms, unsigned char *warned,
#ifndef _AIX41
		struct inpcb *tcbp,
#endif
		struct tip *tipsp, unsigned long ntips,
		struct tip *utipsp, unsigned long nutips)
{
   struct socket *sock;
   struct inpcb *pcb;
   struct synparms ksynparms;
   short ndel;
   short total;
   struct tip *ktipsp;
   struct tip *kutipsp;
   struct tip *csp;
   struct synport *kportparm=NULL;
#if defined(_AIX32) && !defined(_AIX41)
   int current_int;	/* current interrupt level */
#endif /* defined(_AIX32) && !defined(_AIX41) */

   /*=================================================================
    * Allocate memory for the tips and utips arrays.
    *================================================================*/
   ktipsp = xmalloc(ntips*sizeof(struct tip),3,kernel_heap);
   if (ktipsp == NULL)
	return(SYN_CANT_XMT);

   kutipsp = xmalloc(nutips*sizeof(struct tip),3,kernel_heap);
   if (kutipsp == NULL)
   {
	xmfree(ktipsp,kernel_heap);
	return(SYN_CANT_XMU);
   }


   /*=================================================================
    * Copy structs from user space
    *================================================================*/
   if (copyin(tipsp,ktipsp,ntips*sizeof(struct tip)) != 0)
   {
	xmfree(kutipsp,kernel_heap);
	xmfree(ktipsp,kernel_heap);
	return(SYN_CANT_CPT);
   }

   if (copyin(utipsp,kutipsp,nutips*sizeof(struct tip)) != 0)
   {
	xmfree(kutipsp,kernel_heap);
	xmfree(ktipsp,kernel_heap);
	return(SYN_CANT_CPU);
   }

   if (copyin(synparms,&ksynparms,sizeof(ksynparms)) !=0)
   {
	xmfree(kutipsp,kernel_heap);
	xmfree(ktipsp,kernel_heap);
	return(SYN_CANT_CPS);
   }

   /*=================================================================
    * If we have portparms, malloc for it and copy it in
    *================================================================*/
   if (ksynparms.plistsz)
   {
	kportparm = xmalloc(ksynparms.plistsz,3,kernel_heap);
	if (kportparm == NULL)
	    return(SYN_CANT_XMP);

	if (copyin(ksynparms.plist,kportparm,ksynparms.plistsz) !=0)
	{
	    xmfree(kportparm,kernel_heap);
	    xmfree(kutipsp,kernel_heap);
	    xmfree(ktipsp,kernel_heap);
	    return(SYN_CANT_CPP);
	}
   }

   /*=================================================================
    * Get the head of the inpcb chain
    *================================================================*/
#ifdef _AIX41
   pcb = &tcb;
#else
   pcb = tcbp;
#endif

   do
   {
	u_long n=0;
	struct synport *portparm;
	unsigned short qlen;
	unsigned short himark;
	unsigned short lomark;


	/*===============================================================
	 * Walk the chain in reverse because all the LISTEN sockets are
	 * at the back of the queue.
	 *==============================================================*/
	pcb = pcb->inp_prev;

	/*===============================================================
	 * As soon as we see a TCPS_SYN_RECEIVED, it means we have looked
	 * at all the LISTENs.
	 *==============================================================*/
	if (INTCPCB->t_state == TCPS_SYN_RECEIVED)
	    break;

	if (INPSO->so_type != SOCK_STREAM)
	    continue;

	/*===============================================================
	 * Look for Listening sockets only
	 *==============================================================*/
	if ((INPSO->so_options & SO_ACCEPTCONN) == 0)
	    continue;

	/*===========================================================
	 * Decide whether there were port specific parameters to be
	 * used for this port.
	 *==========================================================*/
	qlen = ksynparms.qlen;
	himark = ksynparms.himark;
	lomark = ksynparms.lomark;
	portparm = kportparm;
	while (portparm && portparm->port)
	{
	    if (portparm->port == pcb->inp_lport)
	    {
		qlen = portparm->qlen;
		himark = portparm->himark;
		lomark = portparm->lomark;
		break;
	    }
	    portparm++;
	}

	/*===========================================================
	 * Set so_qlimit with qlen
	 *==========================================================*/
	INPSO->so_qlimit = qlen;

	/*===========================================================
	 * Check to see if we need to clean up so_q0 for this socket
	 *==========================================================*/
	if (INPSO->so_q0len <= himark)
	    continue;

	/*===========================================================
	 * Check to see if we need to issue an alert
	 *==========================================================*/
	if (fubyte(&warned[pcb->inp_lport]) == 0)
	{
	    subyte(&warned[pcb->inp_lport],1);
	    bsdlog(LOG_ALERT,"Security Alert: Suspected SYN flood attack "
				"to port %d detected, adjust fwmon.conf "
				"parameters to repel attack.",
				pcb->inp_lport);
	}

	/*=================================================================
	 * pin the data areas so we can disable interrupts
	 *================================================================*/
	if (pin(ktipsp,ntips*sizeof(struct tip)))
	{
	    xmfree(kportparm,kernel_heap);
	    xmfree(kutipsp,kernel_heap);
	    xmfree(ktipsp,kernel_heap);
	    return(SYN_CANT_PTI);
	}
	if (pin(kutipsp,nutips*sizeof(struct tip)))
	{
	    unpin(ktipsp,ntips*sizeof(struct tip));
	    xmfree(kportparm,kernel_heap);
	    xmfree(kutipsp,kernel_heap);
	    xmfree(ktipsp,kernel_heap);
	    return(SYN_CANT_PUT);
	}

	/*=================================================================
	 * pin this module so we can disable interrupts
	 *================================================================*/
	if (pincode(synchk))
	{
	    unpin(kutipsp,nutips*sizeof(struct tip));
	    unpin(ktipsp,ntips*sizeof(struct tip));
	    xmfree(kportparm,kernel_heap);
	    xmfree(kutipsp,kernel_heap);
	    xmfree(ktipsp,kernel_heap);
	    return(SYN_CANT_PIN);
	}
#ifdef _AIX41
	SOCKET_LOCK(pcb->inp_socket);
#else
	current_int = i_disable(PL_IMP);
#endif /* _AIX41 */

	sock = pcb->inp_socket;
	total = sock->so_q0len;
	ndel = sock->so_q0len - lomark;

	if (ndel < 1)
	{
	    unpin(kutipsp,nutips*sizeof(struct tip));
	    unpin(ktipsp,ntips*sizeof(struct tip));
	    unpincode(synchk);
	    xmfree(kportparm,kernel_heap);
	    xmfree(kutipsp,kernel_heap);
	    xmfree(ktipsp,kernel_heap);
	    continue;
	}

	/*=================================================================
	 * Walk thru the entire so_q0
	 *================================================================*/
	while ((sock = sock->so_q0) && (n < total))
	{
	    /*================================================================
	     * Delete the socket if the foreign address is not on the trusted
	     * list.
	     * If the IP is trusted, don't delete.
	     * Otherwise, delete if low water mark has not been reached.
	     * Else (low water mark reached), delete only if on untrusted list.
	     * This implies that the trusted list has the highest precedence.
	     * I.e. a request from an IP on the trusted list will never be
	     * deleted
	     * If an IP is on both the trusted and untrusted list, it will be
	     * trusted.
	     *===============================================================*/
	    if (!isonlist(SOPCB->inp_faddr.s_addr,ntips,ktipsp) &&
			( n < ndel ||
			  isonlist(SOPCB->inp_faddr.s_addr,nutips,kutipsp) ) )
	    {
		/*============================================================
		 * As an additional safeguard, we make sure the state of the
		 * tcpcb is TCPS_SYN_RECEIVED before we write to the timer.
		 *===========================================================*/
#ifdef _AIX41
		SOCKET_LOCK(sock);
#endif /* _AIX41 */
		if (SOTCPCB->t_state != TCPS_SYN_RECEIVED)
		{
#ifdef _AIX41
		    SOCKET_UNLOCK(sock);
#endif /* _AIX41 */
		    sock = pcb->inp_socket;
		    continue;
		}
		/*============================================================
		 * If the timer value is greater than NSAFE, we write a 1 to the
		 * timer so the socket will expire in the next 500ms.
		 *===========================================================*/
		if (SOTCPCB->t_timer[TCPT_KEEP] > NSAFE)
		{
		    SOTCPCB->t_timer[TCPT_KEEP] = EXPIRET;
		    n++;
		}
#ifdef _AIX41
		SOCKET_UNLOCK(sock);
#endif /* _AIX41 */
	    }
	}
#ifdef _AIX41
	SOCKET_UNLOCK(pcb->inp_socket);
#else
	i_enable(current_int);
#endif /* _AIX41 */

	if (ksynparms.verbose)
	    bsdlog(LOG_NOTICE,"Deleted %d of %d entries from so_q0 for port %d",
			n,total,pcb->inp_lport);
	
	unpin(kutipsp,nutips*sizeof(struct tip));
	unpin(ktipsp,ntips*sizeof(struct tip));
	unpincode(synchk);
   }
   while (pcb->inp_prev != pcb->inp_head);

   xmfree(kportparm,kernel_heap);
   xmfree(kutipsp,kernel_heap);
   xmfree(ktipsp,kernel_heap);
   return(0);

}
#endif /* _AIX */
