/*============================================================================
 * filename:		PFrame.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class PFrame extends Frame implements ActionListener {
    fwwin fw;
    MyMenuItem miopen;
    Menu bufsize;
    String[] tzs = TimeZone.getAvailableIDs();

    PFrame() {
	super("T.Rex");
	newf();
    }

    PFrame(String t) {
	super(t);
	newf();
    }

    void newf() {
	int i;
	setBackground(SystemColor.control);
	setForeground(SystemColor.controlText);

	// T.Rex Menu
	Menu p = new Menu("T.Rex");
	miopen = new MyMenuItem("New T.Rex Window","open",this);
	p.add(miopen);
	p.add(new MyMenuItem("Close Current Window","close",this));
	MenuBar mb = new MenuBar();
	mb.add(p);

	// Options Menu
	Menu o = new Menu("Options");

	// Font size menuitem
	Menu fs = new Menu("Font Size");
	o.add(fs);
	fs.add(new MyMenuItem("8","8",this));
	fs.add(new MyMenuItem("10","10",this));
	fs.add(new MyMenuItem("12","12",this));
	fs.add(new MyMenuItem("14","14",this));
	fs.add(new MyMenuItem("16","16",this));
	fs.add(new MyMenuItem("18","18",this));
	fs.add(new MyMenuItem("20","20",this));

	// Edit mode menuitem
	Menu em = new Menu("Edit Mode");
	o.add(em);
	em.add(new MyMenuItem("yes","emyes",this));
	em.add(new MyMenuItem("no","emno",this));

	bufsize = new Menu("Buffer Size");
	o.add(bufsize);
	bufsize.add(new MyMenuItem("30","30",this));
	bufsize.add(new MyMenuItem("60","60",this));
	bufsize.add(new MyMenuItem("100","100",this));

	// Timezone menuitem
	Menu tz = new Menu("TimeZone");
	o.add(tz);
	for (i = 0; i < tzs.length; i++)
	    tz.add(new MyMenuItem(tzs[i], "TZ" + tzs[i], this));

	// Save menuitem
	o.addSeparator();
	o.add(new MyMenuItem("Save options","save",this));

	// Add options to the menu bar
	mb.add(o);

	setMenuBar(mb);

	enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	pack();

    }

    public void disable_open() {
	miopen.setEnabled(false);
	return;
    }

    public void enable_open() {
	miopen.setEnabled(true);
	return;
    }

    /*======================================================================
     * Build a new frame so a new window pops up for multitasking
     * b should have been constructed with a null fwwin
     * e.g. new mainmenu((fwwin)null);
     * Not that tmpframe.fw is the fwwin() instance of the new window
     * frame while fw is the instance in the "old" window frame where
     * the callback request was initiated.
     *=====================================================================*/
    void fwframe(Base b) {
	PFrame tmpframe;
	if (b instanceof login)
	    tmpframe = new PFrame();
	else
	    tmpframe = new PFrame(getTitle());
	tmpframe.setVisible(false);
	tmpframe.fw = new fwwin(false,tmpframe);
	b.setRootwin(tmpframe.fw);
	if (b instanceof login)
	    tmpframe.disable_open();
	tmpframe.fw.add(b);
	tmpframe.fw.inittop(b);
	tmpframe.addWindowListener( new WindowAdapter() {
		public void windowClosing(WindowEvent we) {
		    fw.newpanel(null);
		};
	} );
	pktinfo pktrc = tmpframe.fw.c.opencb(fw.c.fd,
			fw.c.passed_auth,
			fw.c.ckeyschedp,
			fw.c.dkeyschedp);
	if (pktrc.rc < 0) {
	    tmpframe.fw.c.closefd();
	    tmpframe.dispose();
	    if (pktrc.rc != cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}
	tmpframe.add(tmpframe.fw);
	tmpframe.pack();
	tmpframe.setVisible(true);
	fwmain.inc_refcnt();
    }

    void saveopts() {
	File outfile;
	FileOutputStream out;
	DataOutputStream dout;
	String fn;
	String tmp;

	if (System.getProperty("file.separator").equals("\\"))
	    fn = new String(fwmain.dosdir + "hoplite.con");
	else
	    fn = new String("/etc/firewall/hoplite.conf");

	outfile = new File(fn);
	try {
	    out = new FileOutputStream(outfile);
	    dout = new DataOutputStream(out);
	} catch (IOException e) {
	    fw.msgline.setText("Cannot open output file");
	    return;
	}

	// fontsize statement
	try {
	    dout.writeBytes("fontsize = " + fwmain.fontsize + "\n");
	} catch (IOException e) {
	    fw.msgline.setText("Write error on config output file");
	    return;
	}

	// bufsize statement
	try {
	    dout.writeBytes("bufsize = " + fwmain.bufsize + "\n");
	} catch (IOException e) {
	    fw.msgline.setText("Write error on config output file");
	    return;
	}

	// editmode statement
	try {
	    if (fwmain.editmode)
		dout.writeBytes("editmode = yes\n");
	    else
		dout.writeBytes("editmode = no\n");
	} catch (IOException e) {
	    fw.msgline.setText("Write error on config output file");
	    return;
	}

	// timezone statement
	try {
	    dout.writeBytes("timezone = " + fwmain.timezone + "\n");
	} catch (IOException e) {
	    fw.msgline.setText("Write error on config output file");
	    return;
	}
	return;
    }

    /*======================================================================
     * Note the use of fw and tmpframe.fw here.  fw is the
     * fwwin() instance in the parent while tmpframe.fw is the
     * fwwin() instance in the child frame which is being opened.
     *=====================================================================*/
    public void actionPerformed(ActionEvent e) {
	int i;
	if (e.getActionCommand().equals("open")) {
	    fwframe(new mainmenu((fwwin)null));
	    return;
	}
	if (e.getActionCommand().equals("close")) {
	    fw.newpanel(null);
	    return;
	}
	if (e.getActionCommand().equals("8")) {
	    fwmain.fontsize = 8;
	    return;
	}
	if (e.getActionCommand().equals("10")) {
	    fwmain.fontsize = 10;
	    return;
	}
	if (e.getActionCommand().equals("12")) {
	    fwmain.fontsize = 12;
	    return;
	}
	if (e.getActionCommand().equals("14")) {
	    fwmain.fontsize = 14;
	    return;
	}
	if (e.getActionCommand().equals("16")) {
	    fwmain.fontsize = 16;
	    return;
	}
	if (e.getActionCommand().equals("18")) {
	    fwmain.fontsize = 18;
	    return;
	}
	if (e.getActionCommand().equals("20")) {
	    fwmain.fontsize = 20;
	    return;
	}
	if (e.getActionCommand().equals("emyes")) {
	    fwmain.editmode = true;
	    return;
	}
	if (e.getActionCommand().equals("emno")) {
	    fwmain.editmode = false;
	    return;
	}
	if (e.getActionCommand().equals("30")) {
	    fwmain.bufsize = 30;
	    return;
	}
	if (e.getActionCommand().equals("60")) {
	    fwmain.bufsize = 60;
	    return;
	}
	if (e.getActionCommand().equals("100")) {
	    fwmain.bufsize = 100;
	    return;
	}
	for (i = 0; i < tzs.length; i++) {
	    if (e.getActionCommand().equals("TZ" + tzs[i])) {
		fwmain.timezone = tzs[i];
		return;
	    }
	}
	if (e.getActionCommand().equals("save")) {
	    saveopts();
	    return;
	}
    }
}
