/*============================================================================
 * filename:		apache.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

public class apache extends Base {
    Choice	lookup_f;
    int	lookup;
    TextField	servername_f;
    String	servername;
    TextField	serverroot_f;
    String	serverroot;
    TextField	port_f;
    String	port;
    TextField	user_f;
    String	user;
    TextField	group_f;
    String	group;
    TextField	accesslog_f;
    String	accesslog;
    TextField	errorlog_f;
    String	errorlog;
    TextField	pidfile_f;
    String	pidfile;
    TextField	startserver_f;
    String	startserver;
    TextField	minspare_f;
    String	minspare;
    TextField	maxspare_f;
    String	maxspare;
    TextField	maxclient_f;
    String	maxclient;
    TextField	maxreqperchild_f;
    String	maxreqperchild;
    TextField	allowconnect_f;
    String	allowconnect;
    TextField	receivebufsize_f;
    String	receivebufsize;
    TextField	cacheroot_f;
    String	cacheroot;
    TextField	cachesize_f;
    String	cachesize;
    TextField	cachegcint_f;
    String	cachegcint;
    TextField	nocache_f;
    String	nocache;
    JTextArea	proxyblock_f;
    JTextArea	listen_f;
    JTextArea	dir_f;
    JTextArea	priv_f;
    pktinfo pktrc;
    String capname;
    File tmpfile;

    apache(Base p) {
	super(p,"APACHE","");
	addBody();
    }

    void addBody() {
	int rc;

	component = fw.c.APACHE;
	capname = new String("APACHE");
	lowname = new String("apache");

	// Initialize the entry fields

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	// Get the config file over here to a temp file
	pktrc = download();
	tmpfn = pktrc.str;

	if (pktrc.rc != fw.c.OK) {
	    complete = false;
	    return;
	}

	// Construct the TextAreas now so they can collect lines
	// while we read the config file
	dir_f = new JTextArea(5,48);
	dir_f.setFont(new Font("TimesRoman",Font.PLAIN,fwmain.fontsize));
	listen_f = new JTextArea(5,48);
	listen_f.setFont(new Font("TimesRoman",Font.PLAIN,fwmain.fontsize));
	proxyblock_f = new JTextArea(5,48);
	proxyblock_f.setFont(new Font("TimesRoman",Font.PLAIN,fwmain.fontsize));
	priv_f = new JTextArea(5,48);
	priv_f.setFont(new Font("TimesRoman",Font.PLAIN,fwmain.fontsize));

	// Read in the temp file
	if ((rc = readconf()) == fw.c.FAILED) {
	    fw.c.closefd();
	    fw.newpanel(fw.getTop());
	}

	if (rc < 0)
	    return;

	gbc.anchor = GridBagConstraints.WEST;
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button edit_b = new Button("Edit");
	edit_b.addActionListener(this);
	gbl.setConstraints(edit_b,gbc);
	body.add(edit_b);

	// ServerName
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label servername_l = new Label("Proxy hostname");
	gbl.setConstraints(servername_l,gbc);
	body.add(servername_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	servername_f = new TextField(servername,20);
	gbl.setConstraints(servername_f,gbc);
	body.add(servername_f);
	servername_f.addFocusListener(this);

	// ServerRoot
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label serverroot_l = new Label("Proxy home directory");
	gbl.setConstraints(serverroot_l,gbc);
	body.add(serverroot_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	serverroot_f = new TextField(serverroot,20);
	gbl.setConstraints(serverroot_f,gbc);
	body.add(serverroot_f);
	serverroot_f.addFocusListener(this);

	// port
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label port_l = new Label("Port number");
	gbl.setConstraints(port_l,gbc);
	body.add(port_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	port_f = new TextField(port,5);
	gbl.setConstraints(port_f,gbc);
	body.add(port_f);
	port_f.addFocusListener(this);

	// user
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label user_l = new Label("User name");
	gbl.setConstraints(user_l,gbc);
	body.add(user_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	user_f = new TextField(user,8);
	gbl.setConstraints(user_f,gbc);
	body.add(user_f);
	user_f.addFocusListener(this);

	// group
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label group_l = new Label("Group Name");
	gbl.setConstraints(group_l,gbc);
	body.add(group_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	group_f = new TextField(group,8);
	gbl.setConstraints(group_f,gbc);
	body.add(group_f);
	group_f.addFocusListener(this);

	// AccessLog
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label accesslog_l = new Label("Access Log filename");
	gbl.setConstraints(accesslog_l,gbc);
	body.add(accesslog_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	accesslog_f = new TextField(accesslog,20);
	gbl.setConstraints(accesslog_f,gbc);
	body.add(accesslog_f);
	accesslog_f.addFocusListener(this);

	// ErrorLog
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label errorlog_l = new Label("Error Log filename");
	gbl.setConstraints(errorlog_l,gbc);
	body.add(errorlog_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	errorlog_f = new TextField(errorlog,20);
	gbl.setConstraints(errorlog_f,gbc);
	body.add(errorlog_f);
	errorlog_f.addFocusListener(this);

	// PidFile
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label pidfile_l = new Label("File to contain PID number");
	gbl.setConstraints(pidfile_l,gbc);
	body.add(pidfile_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	pidfile_f = new TextField(pidfile,20);
	gbl.setConstraints(pidfile_f,gbc);
	body.add(pidfile_f);
	pidfile_f.addFocusListener(this);

	// Lookups
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label lookup_l = new Label("Hostname lookup");
	gbl.setConstraints(lookup_l,gbc);
	body.add(lookup_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	lookup_f = new Choice();
	lookup_f.addItem("On");
	lookup_f.addItem("Off");
	lookup_f.addItem("Double");
	lookup_f.select(lookup);
	gbl.setConstraints(lookup_f,gbc);
	body.add(lookup_f);
	lookup_f.addFocusListener(this);

	// n processes
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label startserver_l = new Label("Number of processes on startup");
	gbl.setConstraints(startserver_l,gbc);
	body.add(startserver_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	startserver_f = new TextField(startserver,4);
	gbl.setConstraints(startserver_f,gbc);
	body.add(startserver_f);
	startserver_f.addFocusListener(this);

	// minspare
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label minspare_l = new Label("Minimum number of idle processes");
	gbl.setConstraints(minspare_l,gbc);
	body.add(minspare_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	minspare_f = new TextField(minspare,4);
	gbl.setConstraints(minspare_f,gbc);
	body.add(minspare_f);
	minspare_f.addFocusListener(this);

	// maxspare
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxspare_l = new Label("Maximum number of idle processes");
	gbl.setConstraints(maxspare_l,gbc);
	body.add(maxspare_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxspare_f = new TextField(maxspare,4);
	gbl.setConstraints(maxspare_f,gbc);
	body.add(maxspare_f);
	maxspare_f.addFocusListener(this);

	// maxclient
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxclient_l = new Label("Maximum number of processes");
	gbl.setConstraints(maxclient_l,gbc);
	body.add(maxclient_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxclient_f = new TextField(maxclient,4);
	gbl.setConstraints(maxclient_f,gbc);
	body.add(maxclient_f);
	maxclient_f.addFocusListener(this);

	// maxreqperchild
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxreqperchild_l = new Label("Maximum re-use per process");
	gbl.setConstraints(maxreqperchild_l,gbc);
	body.add(maxreqperchild_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxreqperchild_f = new TextField(maxreqperchild,4);
	gbl.setConstraints(maxreqperchild_f,gbc);
	body.add(maxreqperchild_f);
	maxreqperchild_f.addFocusListener(this);

	// allowconnect
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label allowconnect_l = new Label("Port numbers to allow SSL tunneling");
	gbl.setConstraints(allowconnect_l,gbc);
	body.add(allowconnect_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	allowconnect_f = new TextField(allowconnect,10);
	gbl.setConstraints(allowconnect_f,gbc);
	body.add(allowconnect_f);
	allowconnect_f.addFocusListener(this);

	// receivebufsize
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label receivebufsize_l = new Label("Proxy receive buffer size");
	gbl.setConstraints(receivebufsize_l,gbc);
	body.add(receivebufsize_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	receivebufsize_f = new TextField(receivebufsize,5);
	gbl.setConstraints(receivebufsize_f,gbc);
	body.add(receivebufsize_f);
	receivebufsize_f.addFocusListener(this);

	// CacheRoot
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label cacheroot_l = new Label("Cache directory");
	gbl.setConstraints(cacheroot_l,gbc);
	body.add(cacheroot_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	cacheroot_f = new TextField(cacheroot,20);
	gbl.setConstraints(cacheroot_f,gbc);
	body.add(cacheroot_f);
	cacheroot_f.addFocusListener(this);

	// CacheSize
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label cachesize_l = new Label("Cache size in kilobytes");
	gbl.setConstraints(cachesize_l,gbc);
	body.add(cachesize_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	cachesize_f = new TextField(cachesize,4);
	gbl.setConstraints(cachesize_f,gbc);
	body.add(cachesize_f);
	cachesize_f.addFocusListener(this);

	// CacheGCInterval
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label cachegcint_l = new Label("Cache garbage collect interval (hours)");
	gbl.setConstraints(cachegcint_l,gbc);
	body.add(cachegcint_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	cachegcint_f = new TextField(cachegcint,4);
	gbl.setConstraints(cachegcint_f,gbc);
	body.add(cachegcint_f);
	cachegcint_f.addFocusListener(this);

	// nocache
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label nocache_l = new Label("Sites that should not be cached");
	gbl.setConstraints(nocache_l,gbc);
	body.add(nocache_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	nocache_f = new TextField(nocache,20);
	gbl.setConstraints(nocache_f,gbc);
	body.add(nocache_f);
	nocache_f.addFocusListener(this);

	// ProxyBlockContent/ProxyPermitContent
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Label proxyblock_l = new Label("Active contents blocking");
	gbl.setConstraints(proxyblock_l,gbc);
	body.add(proxyblock_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	JScrollPane proxyblock_sp = new JScrollPane(proxyblock_f);
	gbl.setConstraints(proxyblock_sp,gbc);
	body.add(proxyblock_sp);
	proxyblock_f.addFocusListener(this);

	// <Directory> or <DirectoryMatch>
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Label dir_l = new Label("Access permission");
	gbl.setConstraints(dir_l,gbc);
	body.add(dir_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	JScrollPane dir_sp = new JScrollPane(dir_f);
	gbl.setConstraints(dir_sp,gbc);
	body.add(dir_sp);
	dir_f.addFocusListener(this);

	// Listens
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Label listen_l = new Label("Listen IP:port");
	gbl.setConstraints(listen_l,gbc);
	body.add(listen_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	JScrollPane listen_sp = new JScrollPane(listen_f);
	gbl.setConstraints(listen_sp,gbc);
	body.add(listen_sp);
	listen_f.addFocusListener(this);

	// PrivClients
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Label priv_l = new Label("ProxyPrivClient IP address");
	gbl.setConstraints(priv_l,gbc);
	body.add(priv_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	JScrollPane priv_sp = new JScrollPane(priv_f);
	gbl.setConstraints(priv_sp,gbc);
	body.add(priv_sp);
	priv_f.addFocusListener(this);

	sp.add(body);
    }

    /*=======================================================================
     * Reads the temp file in and interpret it
     *
     * Returns 0 if successful
     *		-1 if failed
     *		NONFATAL if connection need not be closed
     *
     *======================================================================*/
    int readconf() {
	int fd;
	if (tmpfn.equals("")) {
	    fw.msgline.setText("Internal error: " + lowname + " config " +
			"file has not been downloaded yet");
	    return(fw.c.NONFATAL);
	}
	tmpfile = new File(tmpfn);
	if (!tmpfile.exists() || !tmpfile.isFile()) {
	    fw.msgline.setText("Internal error: the downloaded " +
			lowname + " conf file cannot be found");
	    return(fw.c.NONFATAL);
	}

	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	while ( true ) {
	    String tmp;
	    String statement;

	    pktrc = fw.c.cbcreadLine(fd);
	    if (pktrc.rc != cglue.OK) {
		if (pktrc.rc == cglue.CLOSED)
		    break;
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(pktrc.rc);
	    }

	    // Exit loop at EOF
	    if (pktrc.str == null)
		break;

	    lineno++;

	    // Get rid of comment lines (first character is #) and empty lines
	    if (pktrc.str.trim().length() == 0 ||
			pktrc.str.trim().substring(0,1).equals("#"))
		continue;

	    StringTokenizer st = new StringTokenizer(pktrc.str.trim()," \t=:");

	    // Get the statement type
	    try {
		statement = st.nextToken();
	    } catch (NoSuchElementException e) {
		continue;
	    }

	    // Get the next token into tmp - ignore error with no token found
	    // We do this here so we don't have to do a "try" for every
	    // statement type
	    try {
		tmp = st.nextToken();
	    } catch (NoSuchElementException e) {
		tmp = new String();
	    }

	    if (statement.equalsIgnoreCase("ServerName")) {
		servername = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("ServerRoot")) {
		serverroot = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("Port")) {
		port = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("User")) {
		user = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("Group")) {
		group = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("TransferLog")) {
		accesslog = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("ErrorLog")) {
		errorlog = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("PidFile")) {
		pidfile = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("HostnameLookups")) {
		if (tmp.equalsIgnoreCase("On"))
		    lookup = 0;
		else if (tmp.equalsIgnoreCase("Double"))
		    lookup = 2;
		else
		    lookup = 1;
		continue;
	    }

	    if (statement.equalsIgnoreCase("StartServers")) {
		startserver = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("MinSpareServers")) {
		minspare = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("MaxSpareServers")) {
		maxspare = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("MaxClients")) {
		maxclient = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("MaxRequestsPerChild")) {
		maxreqperchild = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("AllowConnect")) {
		allowconnect = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("ProxyReceiveBufferSize")) {
		receivebufsize = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("CacheRoot")) {
		cacheroot = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("CacheSize")) {
		cachesize = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("CacheGCInterval")) {
		cachegcint = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("NoCache")) {
		nocache = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("Listen")) {
		if (listen_f.getText().length() != 0)
		    listen_f.append("\n");
		listen_f.append(pktrc.str);
		continue;
	    }

	    if (statement.equalsIgnoreCase("<Directory") ||
			statement.equalsIgnoreCase("<DirectoryMatch")) {
		if (dir_f.getText().length() != 0)
		    dir_f.append("\n");
		dir_f.append(pktrc.str);

		while (true) {
		    pktrc = fw.c.cbcreadLine(fd);
		    if (pktrc.rc != cglue.OK) {
			if (pktrc.rc == cglue.CLOSED)
			    break;
			fw.msgline.setText(pktrc.errmsg);
			fw.c.closefile(fd);
			return(pktrc.rc);
		    }

		    // Exit loop at EOF
		    if (pktrc.str == null)
			break;
	
		    lineno++;

		    // Get rid of comment lines (first character is #) and
		    // empty lines
		    if (pktrc.str.trim().length() == 0 ||
				pktrc.str.trim().substring(0,1).equals("#"))
			continue;

		    // Add the line to the TextArea
		    dir_f.append("\n" + pktrc.str);

		    // Do until "</Directory*" is found
		    if (pktrc.str.length() > 10 &&
			pktrc.str.substring(0,11).equalsIgnoreCase
							("</Directory"))
			break;
		}
		continue;
	    }

	    if (statement.equalsIgnoreCase("CacheRoot")) {
		cacheroot = tmp;
		continue;
	    }

	    if (statement.equalsIgnoreCase("CacheSize")) {
		cachesize = tmp;
		continue;
	    }

	    // ProxyBlockContent/ProxyPermitContent
	    if (statement.equalsIgnoreCase("ProxyBlockContent") ||
		statement.equalsIgnoreCase("ProxyPermitContent")) {
		if (proxyblock_f.getText().length() != 0)
		    proxyblock_f.append("\n");
		proxyblock_f.append(pktrc.str);
		continue;
	    }

	    // ProxyPrivClient
	    if (statement.equalsIgnoreCase("ProxyPrivClient")) {
		if (priv_f.getText().length() != 0)
		    priv_f.append("\n");
		priv_f.append(pktrc.str);
		continue;
	    }

	    // No invalid statements
	}

	// Delete the temp file since we no longer need it
	fw.c.closefile(fd);
	tmpfile.delete();
	return (0);
    }

    public void handleOK() {

	if (saveconf() < 0)
	    return;

	pktrc = upload();
	if (pktrc.rc < 0)
	    return;

	fw.msgline.setText("New " + lowname + " config file " +
		"successfully created");
	fw.newpanel(parent_panel);
    }

    /*=======================================================================
     * Given a string, this method splits it into lines (separated by '\n')
     * and sends each line individually to cbcwriteLine().
     * If comp is a String, this function makes sure each line starts with
     * that string.  If comp is null, no comparison is made.
     * Returns	0 if succcessful
     *		-1 if failed
     *		-3 if A line does not begin with the String comp
     *======================================================================*/
    private int split_line(int fd, String s, String comp) {
	String line;
	StringTokenizer st = new StringTokenizer(s,"\n");

	while (true) {
	    // Get one statement
	    try {
		line = st.nextToken();
	    } catch (NoSuchElementException e) {
		break;
	    }
	    if (comp != null) {
		if (!line.trim().toLowerCase().startsWith(comp.toLowerCase())) {
		    return(fw.c.NONFATAL);
		}
	    }
	    pktrc = fw.c.cbcwriteLine(fd, line + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		return(-1);
	    }
	}
	return(0);
    }

    /*=======================================================================
     * This saveconf() is different from other saveconf() in that it has
     * to re-get the conf file from the server so that it can use it to
     * emit all the statements not supported by T.Rex.
     *======================================================================*/
    public int saveconf() {
	int rc;
	int fd;
	File outfile;
	File infile;
	String tmp;
	String tmpoutfn;
	String unknown_statements = new String();
	StringTokenizer st;
	String statement;
	int end_of_dirname;

	// Re-get the config file over here to a temp file
	pktrc = fw.c.getconf(component);
	tmpfn = pktrc.str;

	// Form the temp output filename
	end_of_dirname = tmpfn.lastIndexOf('/');
	if (end_of_dirname < 0)
	    end_of_dirname = tmpfn.lastIndexOf('\\');
	if (end_of_dirname < 0)
	    tmpoutfn = new String("_padmhtt.pd");
	else {
	    tmpoutfn = tmpfn.substring(0,end_of_dirname+1);
	    tmpoutfn = tmpoutfn.concat("_padmhtt.pd");
	}
	outfile = new File(tmpoutfn);

	infile = new File(tmpfn);

	if (pktrc.rc == fw.c.OK) {
	    if (!infile.exists() || !infile.isFile()) {
		fw.msgline.setText("Temp httpd.conf file cannot be found");
		return(-1);
	    }

	    pktrc = fw.c.opencbcfile(tmpfn, 0);
	    if (pktrc.rc < 0) {
		fw.msgline.setText(pktrc.errmsg);
		return(pktrc.rc);
	    }

	    fd = pktrc.rc;

	    // Process each line in the input file, get rid of all comment lines
	    // and all the statements that are 'managed' by the gui.  I.e.
	    // write out all the statements not known to the gui.
	    while ( true ) {
		pktrc = fw.c.cbcreadLine(fd);
		if (pktrc.rc != cglue.OK) {
		    if (pktrc.rc == cglue.CLOSED)
			break;
		    fw.msgline.setText(pktrc.errmsg);
		    fw.c.closefile(fd);
		    return(pktrc.rc);
		}

		// Exit loop at EOF
		if (pktrc.str == null)
		    break;

		lineno++;

		// Get rid of comment lines (first character is #) and empty
		// line
		if (pktrc.str.trim().length() == 0 ||
			pktrc.str.trim().substring(0,1).equals("#"))
		    continue;

		st = new StringTokenizer(pktrc.str.trim()," \t=:");

		// Get the statement type
		try {
		    statement = st.nextToken().toLowerCase();
		} catch (NoSuchElementException e) {
		    continue;
		}

		if (statement.equals("servername")	||
		    statement.equals("serverroot")	||
		    statement.equals("hostnamelookups")	||
		    statement.equals("port")	||
		    statement.equals("user")	||
		    statement.equals("group")	||
		    statement.equals("transferlog")	||
		    statement.equals("errorlog")	||
		    statement.equals("pidfile")	||
		    statement.equals("startservers")	||
		    statement.equals("listen")	||
		    statement.equals("minspareservers")	||
		    statement.equals("maxspareservers")	||
		    statement.equals("maxclients")	||
		    statement.equals("maxrequestsperchild")	||
		    statement.equals("allowconnect")	||
		    statement.equals("proxyreceivebuffersize")	||
		    statement.equals("cacheroot")	||
		    statement.equals("cachesize")	||
		    statement.equals("cachegcinterval")	||
		    statement.equals("nocache")	||
		    statement.equals("proxyprivclient")	||
		    statement.equals("proxyblockcontent")	||
		    statement.equals("proxypermitcontent"))
		    continue;

		// Get rid of the "<Directory" statement group
		if (statement.equals("<directory") ||
			statement.equals("<directorymatch")) {
		    while ( true ) {
			pktrc = fw.c.cbcreadLine(fd);
			if (pktrc.rc != cglue.OK) {
			    if (pktrc.rc == cglue.CLOSED)
				break;
			    fw.msgline.setText(pktrc.errmsg);
			    fw.c.closefile(fd);
			    return(pktrc.rc);
			}
			// Exit loop at EOF
			if (pktrc.str == null)
			    break;

			// Get rid of comment lines (first character is #) and
			// empty lines
			if (pktrc.str.trim().length() == 0 ||
				pktrc.str.trim().substring(0,1).equals("#"))
			    continue;

			// Do until </Directory is found
			if (pktrc.str.substring(0,11).equalsIgnoreCase
							("</Directory"))
			    break;
		    }
		    continue;
		}

		// OK, this is not a comment line and the statement type is not
		// recognized, save it.
		unknown_statements = unknown_statements.concat(pktrc.str+"\n");
	    }

	    // Close/delete the input file and open the output file
	    fw.c.closefile(fd);

	    infile.delete();
	}

	pktrc = fw.c.opencbcfile(tmpoutfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	// servername statement
	tmp = servername_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"ServerName " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	// ServerRoot statement
	tmp = serverroot_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"ServerRoot " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Must specify ServerRoot");
	    serverroot_f.requestFocus();
	    fw.c.closefile(fd);
	    return(-1);
	}

	// Port statement
	tmp = port_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"Port " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Must specify port number");
	    port_f.requestFocus();
	    fw.c.closefile(fd);
	    return(-1);
	}

	// User statement
	tmp = user_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"User " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Must specify user");
	    user_f.requestFocus();
	    fw.c.closefile(fd);
	    return(-1);
	}

	// Group statement
	tmp = group_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"Group " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Must specify group");
	    group_f.requestFocus();
	    fw.c.closefile(fd);
	    return(-1);
	}

	// AccessLog statement
	tmp = accesslog_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"TransferLog " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// ErrorLog statement
	tmp = errorlog_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"ErrorLog " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// PidFile statement
	tmp = pidfile_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"PidFile " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// HostnameLookups statement
	pktrc = fw.c.cbcwriteLine(fd,"HostnameLookups " +
			lookup_f.getSelectedItem() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// StartServers statement
	tmp = startserver_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"StartServers " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// MinSpareServers statement
	tmp = minspare_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"MinSpareServers " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// MaxSpareServers statement
	tmp = maxspare_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"MaxSpareServers " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// MaxClients statement
	tmp = maxclient_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"MaxClients " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// MaxRequestsPerChild statement
	tmp = maxreqperchild_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"MaxRequestsPerChild " + tmp +
						"\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// AllowConnect statement
	tmp = allowconnect_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"AllowConnect " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// ProxyReceiveBufferSize statement
	tmp = receivebufsize_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"ProxyReceiveBufferSize " + tmp +
						"\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// CacheRoot statement
	tmp = cacheroot_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"CacheRoot " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// CacheSize statement
	tmp = cachesize_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"CacheSize " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// CacheGCInterval statement
	tmp = cachegcint_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"CacheGCInterval " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// NoCache statement
	tmp = nocache_f.getText();
	if (tmp.length() > 0) {
	    pktrc = fw.c.cbcwriteLine(fd,"NoCache " + tmp + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// ProxyBlockContent/ProxyPermitContent
	tmp = proxyblock_f.getText();
	if (tmp.length() > 0) {
	    if ((rc = split_line(fd, tmp, "Proxy")) < 0) {
		if (rc == fw.c.NONFATAL) {
		    fw.msgline.setText("Encountered invalid keyword in " +
				"\"Active contents blocking\" area.");
		}
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// <Directory statements
	tmp = dir_f.getText();
	if (tmp.length() > 0) {
	    if (split_line(fd, tmp, null) < 0) {
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Must specify Access Permissions");
	    dir_f.requestFocus();
	    fw.c.closefile(fd);
	    return(-1);
	}

	// Listen statements
	tmp = listen_f.getText();
	if (tmp.length() > 0) {
	    if ((rc = split_line(fd, tmp, "Listen")) < 0) {
		if (rc == fw.c.NONFATAL) {
		    fw.msgline.setText("Encountered invalid keyword in " +
				"\"Listen\" area.");
		}
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// ProxyPrivClient statements
	tmp = priv_f.getText();
	if (tmp.length() > 0) {
	    if ((rc = split_line(fd, tmp, "ProxyPrivClient")) < 0) {
		if (rc == fw.c.NONFATAL) {
		    fw.msgline.setText("Encountered invalid keyword in " +
				"\"ProxyPrivClient\" area.");
		}
		fw.c.closefile(fd);
		return(-1);
	    }
	}

	// All the unknown statements
	if (unknown_statements.length() > 0) {
	    if (split_line(fd, unknown_statements, null) < 0) {
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	
	fw.c.closefile(fd);

	// Rename the outfile to tmpfn
	outfile.renameTo(infile);
	return(0);
    }

    // Add processing code for the edit button
    protected boolean moreAction(String s) {
	if ("Edit".equals(s)) {
	    if (saveconf() < 0)
		return(true);
	    lineno = 0;		// Don't want edit to highlight any lines
	    fw.newpanel(new edit(this,parent_panel,"EDIT " + capname));
	    return(true);
	}
	return(false);
    }
}
