/*============================================================================
 * filename:		backup.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.lang.reflect.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class backup extends Base {
    CheckboxGroup group;
    Checkbox typical;
    Checkbox customized;
    TextField filename_f;
    Dir dir;
    int i;
    int ver;
    int flag = 0;
    public static final int TYPICAL = 1;
    public static final int CUSTOM = 2;

    backup(Base p) {
	super(p,"T.Rex Backup","Select the desired backup list(s) and then " +
				"clicked on \"Continue\"");
	addBody();
	okbutton.setLabel("Continue");
	canbutton.setLabel("Return");
    }

    void addBody() {
	String fn;
	String tfn;

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(10,10,10,10);

	gbc.gridwidth = GridBagConstraints.REMAINDER;

	typical = new Checkbox("Typical Backup",true);
	gbl.setConstraints(typical,gbc);
	body.add(typical);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	body.add(new Label("          "));
	Label fwfiles_l = new Label("T.Rex/Padmin files");
	gbl.setConstraints(fwfiles_l,gbc);
	body.add(fwfiles_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button fwfiles_b = new Button("Browse/Edit");
	fwfiles_b.addActionListener(this);
	fwfiles_b.setActionCommand("fwfiles");
	gbl.setConstraints(fwfiles_b,gbc);
	body.add(fwfiles_b);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	body.add(new Label("          "));
	Label apachefiles_l = new Label("Apache files");
	gbl.setConstraints(apachefiles_l,gbc);
	body.add(apachefiles_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button apachefiles_b = new Button("Browse/Edit");
	apachefiles_b.addActionListener(this);
	apachefiles_b.setActionCommand("apachefiles");
	gbl.setConstraints(apachefiles_b,gbc);
	body.add(apachefiles_b);

//	gbc.gridwidth = GridBagConstraints.RELATIVE;
//	body.add(new Label("          "));
//	Label padminfiles_l = new Label("Padmin files");
//	gbl.setConstraints(padminfiles_l,gbc);
//	body.add(padminfiles_l);

//	gbc.gridwidth = GridBagConstraints.REMAINDER;
//	Button padminfiles_b = new Button("Browse/Edit");
//	padminfiles_b.addActionListener(this);
//	padminfiles_b.setActionCommand("padminfiles");
//	gbl.setConstraints(padminfiles_b,gbc);
//	body.add(padminfiles_b);

//	gbc.gridwidth = GridBagConstraints.RELATIVE;
//	body.add(new Label("          "));
//	Label socksfiles_l = new Label("Socks files");
//	gbl.setConstraints(socksfiles_l,gbc);
//	body.add(socksfiles_l);

//	gbc.gridwidth = GridBagConstraints.REMAINDER;
//	Button socksfiles_b = new Button("Browse/Edit");
//	socksfiles_b.addActionListener(this);
//	socksfiles_b.setActionCommand("socksfiles");
//	gbl.setConstraints(socksfiles_b,gbc);
//	body.add(socksfiles_b);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	body.add(new Label("          "));
	Label systemfiles_l = new Label("Selected system files");
	gbl.setConstraints(systemfiles_l,gbc);
	body.add(systemfiles_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button systemfiles_b = new Button("Browse/Edit");
	systemfiles_b.addActionListener(this);
	systemfiles_b.setActionCommand("systemfiles");
	gbl.setConstraints(systemfiles_b,gbc);
	body.add(systemfiles_b);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	customized = new Checkbox("Customized Backup",false);
	gbl.setConstraints(customized,gbc);
	body.add(customized);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	body.add(new Label("          "));
	Label customfiles_l = new Label("User selected files");
	gbl.setConstraints(customfiles_l,gbc);
	body.add(customfiles_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button customfiles_b = new Button("Browse/Edit");
	customfiles_b.addActionListener(this);
	customfiles_b.setActionCommand("customfiles");
	gbl.setConstraints(customfiles_b,gbc);
	body.add(customfiles_b);

	// Open the archive directory
	try {
	    dir = new Dir(fw.c.getvar("HOME").str +
		System.getProperty("file.separator") + "fw_archive");
	}
	    catch (IllegalArgumentException e) {
	    fw.msgline.setText("Archive directory error: " +
							e.getMessage());
	}

	// Get the host name or address from the frame title
	// The name or address is the last "word" in the title
	fn = fw.getFrame().getTitle().trim();
	while ((i = fn.indexOf(' ')) >= 0)
	    fn = fn.substring(i + 1);

	// Come up with a default archive file name
	ver = 0;
	while (true) {
	    boolean unique = true;
	    tfn = fn.concat("_" + String.valueOf(++ver));
	    for (i = 0; i < dir.count; i++) {
		if (tfn.equals(dir.filenames[i])) {
		    unique = false;
		    break;
		}
	    }
	    if (unique)
		break;
	}

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label filename_l = new Label("Backup to file");
	gbl.setConstraints(filename_l,gbc);
	body.add(filename_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	filename_f = new TextField(tfn);
	filename_f.addActionListener(this);
	gbl.setConstraints(filename_f,gbc);
	body.add(filename_f);

	sp.add(body);
    }

    /*=======================================================================
     * Override handleOK()
     * The OK button on this panel requests the server to start backing up
     *======================================================================*/
    public void handleOK() {
	pktinfo pktrc;
	
	if (typical.getState())
	    flag |= TYPICAL;
	if (customized.getState())
	    flag |= CUSTOM;

	if (flag == 0) {
	    fw.msgline.setText("Must select at least one backup type");
	    return;
	}

	if (filename_f.getText().length() == 0) {
	    fw.msgline.setText("Must specified backup filename");
	    return;
	}

	dotar();

	return;
    }

    /*=======================================================================
     * Process the input from the panel and make request to the server to
     * tar the backup files.
     *======================================================================*/
    private void dotar() {
	int i;
	String fn;
	File efile;
	pktinfo pktrc;

	fn = filename_f.getText();
	/*===================================================================
	 * Check to see if specified file already exists
	 *==================================================================*/
	efile = new File(dir.getPath(), fn);
	if (efile.exists()) {
	    /*===========================================================
	     * Put up a dialog to ask if OK to overwrite existing file
	     *==========================================================*/
	    Button filecont = new Button("Overwrite");
	    Button filecan = new Button("Cancel");
	    dldisp = new String("");
	    Panel p = new Panel();

	    // Put the "Continue" and "Cancel" buttons in the panel p
	    p.setLayout(new GridLayout(1,5));
	    p.add(new Label(""));
	    filecont.setActionCommand("FILECONT");
	    filecont.addActionListener(this);
	    p.add(filecont);
	    p.add(new Label(""));
	    filecan.setActionCommand("FILECAN");
	    filecan.addActionListener(this);
	    p.add(filecan);
	    p.add(new Label(""));

	    dldialog = new MyDialog(fw.getFrame(),
			paneltitle.getText(),
			true,
			new Label("File " + fn + " already exists and " +
				"was last written " +
				Dir.datetime(efile.lastModified())),
			new Label("Select \"Overwrite\" or \"Cancel\""), p);
	    dldialog.setVisible(true);

	    // Just returned from the event handler, continue based on
	    // whether the "Continue" button or the "Cancel" button was
	    // pressed
	    if (dldisp.equals("FILECAN"))
		return;
	    else {
		File tmpfile = new File(dir.getPath(), fn);
		tmpfile.delete();
	    }
	}

	/*===================================================================
	 * Now we have the filename to backup to, send request to server to
	 * start the tar
	 *==================================================================*/
	fn = efile.toString();
	pktrc = fw.c.downloadtar(fn, flag);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}
	fw.msgline.setText("Backup file " + fn + " written successfully");
	return;
    }

    // Add processing code for the edit/browse buttons
    protected boolean moreAction(String s) {
	if ("fwfiles".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    fw.newpanel(new editcomponent(this,fw.c.TREXLIST,
				"T.Rex Files List "));
	    return(true);
	}
	if ("apachefiles".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    component = fw.c.APACHELIST;
	    fw.newpanel(new editcomponent(this,fw.c.APACHELIST,
				"Apache Files List "));
	    return(true);
	}
	if ("systemfiles".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    component = fw.c.SYSTEMLIST;
	    fw.newpanel(new editcomponent(this,fw.c.SYSTEMLIST,
				"Selected System Files List "));
	    return(true);
	}
	if ("customfiles".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    component = fw.c.CUSTOMLIST;
	    fw.newpanel(new editcomponent(this,fw.c.CUSTOMLIST,
				"User selected Files List "));
	    return(true);
	}

	return(false);
    }
}
