/*============================================================================
 * filename:		cglue.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
class cglue {
    public native pktinfo openfd(String ip);
    public native pktinfo opencb(int fd, int auth, int ck, int dk);
    public native void closefd();
    public native void flush();
    public native void wsacleanup();
    public native pktinfo sendpkt(int Component, int Command, String s,
				int restart);
    public native pktinfo recvpkt(int restart);
    public native pktinfo getconf(int Component);
    public native pktinfo putconf(int Component, String fn);
    public native pktinfo setkey(String username, String pidname);
    public native pktinfo getgwuser(int action, gwrecord rec);
    public native pktinfo getgwdefault(int action, gwrecord rec);
    public native pktinfo putgwuser(int action, gwrecord rec);
    public native pktinfo opencbcfile(String fn, int bin);
    public native void closefile(int fd);
    public native pktinfo cbcreadLine(int fd);
    public native pktinfo cbcreadFile(int fd);
    public native pktinfo cbcwriteLine(int fd, String line);
    public native pktinfo getvar(String name);
    public native pktinfo downloadtar(String fn, int flag);
    public native pktinfo uploadtar(String fn, String args);
    public native tarinfo readtar(String fn);
    public int fd = -1;
    public int passed_auth = AUTHDEF; /* 0 = use default encrypt key
					usually means user not auth'ed yet
				   1 = use gwuser's encreypt key
					usually means user logged in
				   2 = use gwuser's encreypt key normally
					but use default key for local files
					usually means local login	*/
    public String localfn;
    public int cbcblkp;		/* int because java does not support ptr */
    public int ckeyschedp;	/* int because java does not support ptr */
    public int dkeyschedp;	/* int because java does not support ptr */
    public int Errno;		/* used to pass errno to java		*/
    public int Eintr;		/* The constant EINTR			*/
    public static String EOFMSG = new String("Remote host disconnected");

// passed_auth values
    public static final int AUTHDEF = 0; /* 0 = use default encrypt key
					usually means user not auth'ed yet */
    public static final int AUTHGWU = 1; /* use gwuser's encreypt key
					usually means user logged in */
    public static final int AUTHLCL = 2; /* use gwuser's encreypt key normally
					but use default key for local files
					usually means local login	*/

// Some T.Rex constants
    public static final int GRPSIZ = 17;

// See cs.h for comments on these constants
// Components
    public static final int ALL=	0;
    public static final int APACHE=	1;
    public static final int APACHEERR=	2;
    public static final int FTPROXY=	3;
    public static final int FWPULSE=	4;
    public static final int FWPULSED=	5;
    public static final int APROXY=	6;
    public static final int GWUSER=	7;
    public static final int GWGROUP=	8;
    public static final int HTTPD=	9;
    public static final int INETD=	10;
    public static final int LOGIN=	11;
    public static final int PADMIN=	12;
    public static final int FWMON=	13;
    public static final int PS=		14;
    public static final int RAPROXY=	15;
    public static final int RPCPROXY=	16;
    public static final int SMALIASES=	17;
    public static final int SMWRAP=	18;
    public static final int SMWRAPD=	19;
    public static final int TNKEY=	20;
    public static final int TNPROXY=	21;
    public static final int SECNETS=	22;
    public static final int SECPORTS=	23;
    public static final int SOCKD=	24;
    public static final int SYSLOG=	25;
    public static final int TIMER=	26;
    public static final int VMSTAT=	27;
    public static final int WEBGATE=	28;
    public static final int TREXLIST=	29;
    public static final int APACHELIST=	30;
    public static final int SYSTEMLIST=	31;
    public static final int CUSTOMLIST=	32;

// Commands
    public static final int GETCONF=	1;
    public static final int PUTCONF=	2;
    public static final int STOPCOMP=	3;
    public static final int STARTCOMP=	4;
    public static final int GETGWUSER=	5;
    public static final int ADDGWUSER=	6;
    public static final int MODGWUSER=	7;
    public static final int RUN=	8;
    public static final int CHALLENGE=	9;
    public static final int AUTH=	10;
    public static final int CANCEL=	11;
    public static final int KEEPALIVE=	12;
    public static final int CALLBACK=	13;
    public static final int PROXY=	14;
    public static final int TAILLOG=	15;
    public static final int PAUSE=	16;
    public static final int RESUME=	17;
    public static final int GETDEFGWUSER=18;
    public static final int DELGWUSER=	19;
    public static final int REFCOMP=	20;
    public static final int GETLIST=	21;
    public static final int BACKUP=	22;
    public static final int RESTORE=	23;
    public static final int GETIFLIST=	24;

// Return codes
    public static final int LOCALFILE=	2;
    public static final int CONTINUE=	1;
    public static final int OK=		0;
    public static final int FAILED=	-1;
    public static final int CLOSED=	-2;
    public static final int NONFATAL=	-3;

    static {
	try {
	    System.loadLibrary("glue");
	} catch (UnsatisfiedLinkError e) {
	    System.out.println("Cannont find library " + e.getMessage());
	    System.exit(-1);
	}
    }
}
