/*============================================================================
 * filename:		configmenu.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.awt.*;
import java.awt.event.*;

public class configmenu extends Base {

    configmenu(Base p) {
	super(p,"T.Rex Configuration Menu","Click on the desired action");
	addBody();
	okbutton.setLabel("Continue");
	canbutton.setLabel("Return");
    }

    void addBody() {
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	/*===============================================================
	 * Query the server to get the components that are present
	 *==============================================================*/
	long comps = getcomps();
	if (comps < 0) {
	    complete = false;
	    if (comps != (long)cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    return;
	}

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(10,10,10,10);

	gbc.gridwidth = GridBagConstraints.REMAINDER;

	if ((comps & (1 << (fw.c.APACHE - 1))) != 0) {
	    Button apache_b = new Button("Configure Apache Proxy");
	    apache_b.setActionCommand("apache");
	    apache_b.addActionListener(this);
	    gbl.setConstraints(apache_b,gbc);
	    body.add(apache_b);

	    Button webblock_b = new Button("Configure Apache WebBlock");
	    webblock_b.setActionCommand("webblock");
	    webblock_b.addActionListener(this);
	    gbl.setConstraints(webblock_b,gbc);
	    body.add(webblock_b);
	}

	if ((comps & (1 << (fw.c.FTPROXY - 1))) != 0) {
	    Button ftproxy_b = new Button("Configure FTPROXY");
	    ftproxy_b.setActionCommand("ftproxy");
	    ftproxy_b.addActionListener(this);
	    gbl.setConstraints(ftproxy_b,gbc);
	    body.add(ftproxy_b);
	}

	if ((comps & (1 << (fw.c.FWPULSE - 1))) != 0) {
	    Button fwpulse_b = new Button("Configure FWPULSE");
	    fwpulse_b.setActionCommand("fwpulse");
	    fwpulse_b.addActionListener(this);
	    gbl.setConstraints(fwpulse_b,gbc);
	    body.add(fwpulse_b);
	}

	if ((comps & (1 << (fw.c.APROXY - 1))) != 0) {
	    Button aproxy_b = new Button("Configure APROXY");
	    aproxy_b.setActionCommand("aproxy");
	    aproxy_b.addActionListener(this);
	    gbl.setConstraints(aproxy_b,gbc);
	    body.add(aproxy_b);
	}

	if ((comps & (1 << (fw.c.GWUSER - 1))) != 0) {
	    Button gwuser_b = new Button("Configure GWUSER");
	    gwuser_b.setActionCommand("gwuser");
	    gwuser_b.addActionListener(this);
	    gbl.setConstraints(gwuser_b,gbc);
	    body.add(gwuser_b);
	}

	Button inetd_b = new Button("Configure INETD");
	inetd_b.setActionCommand("inetd");
	inetd_b.addActionListener(this);
	gbl.setConstraints(inetd_b,gbc);
	body.add(inetd_b);

	Button padmin_b = new Button("Configure PADMIN");
	padmin_b.setActionCommand("padmin");
	padmin_b.addActionListener(this);
	gbl.setConstraints(padmin_b,gbc);
	body.add(padmin_b);

	if ((comps & (1 << (fw.c.FWMON - 1))) != 0) {
	    Button fwmon_b = new Button("Configure FWMON");
	    fwmon_b.setActionCommand("fwmon");
	    fwmon_b.addActionListener(this);
	    gbl.setConstraints(fwmon_b,gbc);
	    body.add(fwmon_b);
	}

	if ((comps & (1 << (fw.c.RAPROXY - 1))) != 0) {
	    Button raproxy_b = new Button("Configure RAPROXY");
	    raproxy_b.setActionCommand("raproxy");
	    raproxy_b.addActionListener(this);
	    gbl.setConstraints(raproxy_b,gbc);
	    body.add(raproxy_b);
	}

	if ((comps & (1 << (fw.c.RPCPROXY - 1))) != 0) {
	    Button rpcproxy_b = new Button("Configure RPCPROXY");
	    rpcproxy_b.setActionCommand("rpcproxy");
	    rpcproxy_b.addActionListener(this);
	    gbl.setConstraints(rpcproxy_b,gbc);
	    body.add(rpcproxy_b);
	}

	if ((comps & (1 << (fw.c.SMWRAP - 1))) != 0) {
	    Button smwrap_b = new Button("Configure SMWRAP");
	    smwrap_b.setActionCommand("smwrap");
	    smwrap_b.addActionListener(this);
	    gbl.setConstraints(smwrap_b,gbc);
	    body.add(smwrap_b);

	    Button smaliases_b = new Button("Configure SMWRAP Aliases");
	    smaliases_b.setActionCommand("smaliases");
	    smaliases_b.addActionListener(this);
	    gbl.setConstraints(smaliases_b,gbc);
	    body.add(smaliases_b);
	}

	if ((comps & (1 << (fw.c.SOCKD - 1))) != 0) {
	    Button sockd_b = new Button("Configure SOCKD");
	    sockd_b.setActionCommand("sockd");
	    sockd_b.addActionListener(this);
	    gbl.setConstraints(sockd_b,gbc);
	    body.add(sockd_b);
	}

	Button syslog_b = new Button("Configure SYSLOG");
	syslog_b.setActionCommand("syslog");
	syslog_b.addActionListener(this);
	gbl.setConstraints(syslog_b,gbc);
	body.add(syslog_b);

	if ((comps & (1 << (fw.c.TNPROXY - 1))) != 0) {
	    Button tnproxy_b = new Button("Configure TNPROXY");
	    tnproxy_b.setActionCommand("tnproxy");
	    tnproxy_b.addActionListener(this);
	    gbl.setConstraints(tnproxy_b,gbc);
	    body.add(tnproxy_b);
	}

	if ((comps & (1 << (fw.c.WEBGATE - 1))) != 0) {
	    Button webgate_b = new Button("Configure WEBGATE");
	    webgate_b.setActionCommand("webgate");
	    webgate_b.addActionListener(this);
	    gbl.setConstraints(webgate_b,gbc);
	    body.add(webgate_b);
	}

	Button secnets_b = new Button("Configure Secure Networks");
	secnets_b.setActionCommand("secnets");
	secnets_b.addActionListener(this);
	gbl.setConstraints(secnets_b,gbc);
	body.add(secnets_b);

	Button secports_b = new Button("Configure Secure Ports");
	secports_b.setActionCommand("secports");
	secports_b.addActionListener(this);
	gbl.setConstraints(secports_b,gbc);
	body.add(secports_b);

	sp.add(body);
    }

    /*======================================================================
     * Override since we don't want an OK button here
     *=====================================================================*/
    void addOK() {
    }

    public void menubuttons(String s) {

	if ("apache".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.APACHE,
			"APACHE"));
	    else
		fw.newpanel(new apache(this));
	    return;
	}

	if ("ftproxy".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.FTPROXY,
			"FTPROXY"));
	    else
		fw.newpanel(new tnproxy(this,tnproxy.FTP));
	    return;
	}

	if ("fwpulse".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.FWPULSE,
			"FWPULSE"));
	    else
		fw.newpanel(new fwpulse(this));
	    return;
	}

	if ("aproxy".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.APROXY,
			"GENPROXY"));
	    else
		fw.newpanel(new aproxy(this,aproxy.GEN));
	    return;
	}

	if ("gwuser".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.GWUSER,
			"GWUSER"));
	    else
		fw.newpanel(new gwuserconf(this));
	    return;
	}

	if ("inetd".equals(s)) {
	    fw.newpanel(new editcomponent(this, fw.c.INETD, "INETD"));
	    return;
	}

	if ("padmin".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.PADMIN,
			"PADMIN"));
	    else
		fw.newpanel(new padmin(this));
	    return;
	}

	if ("fwmon".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.FWMON,
			"FWMON"));
	    else
		fw.newpanel(new fwmon(this));
	    return;
	}

	if ("raproxy".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.RAPROXY,
			"RAPROXY"));
	    else
		fw.newpanel(new raproxy(this));
	    return;
	}

	if ("rpcproxy".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.RPCPROXY,
			"RPCPROXY"));
	    else
		fw.newpanel(new rpcproxy(this));
	    return;
	}

	if ("smaliases".equals(s)) {
	    fw.newpanel(new editcomponent(this, fw.c.SMALIASES,
			"SMWRAP Aliases"));
	    return;
	}

	if ("smwrap".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.SMWRAP,
			"SMWRAP"));
	    else
		fw.newpanel(new smwrap(this));
	    return;
	}

	if ("secnets".equals(s)) {
	    fw.newpanel(new editcomponent(this, fw.c.SECNETS,
			"Secure Nets"));
	    return;
	}

	if ("secports".equals(s)) {
	    fw.newpanel(new editcomponent(this, fw.c.SECPORTS,
			"Secure Ports"));
	    return;
	}

	if ("sockd".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.SOCKD,
			"SOCKD"));
	    else
		fw.newpanel(new sockd(this));
	    return;
	}

	if ("syslog".equals(s)) {
	    fw.newpanel(new editcomponent(this, fw.c.SYSLOG,
			"SYSLOG"));
	    return;
	}

	if ("tnproxy".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.TNPROXY,
			"TNPROXY"));
	    else
		fw.newpanel(new tnproxy(this,tnproxy.TN));
	    return;
	}

	if ("webblock".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.APACHE,
			"WEBBLOCK/APACHE"));
	    else
		fw.newpanel(new webblock(this));
	    return;
	}

	if ("webgate".equals(s)) {
	    if (fwmain.editmode)
		fw.newpanel(new editcomponent(this, fw.c.WEBGATE,
			"WEBGATE"));
	    else
		fw.newpanel(new aproxy(this,aproxy.WEB));
	    return;
	}
    }
}
