/*============================================================================
 * filename:		edit.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//					    Windows limitation
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

public class edit extends Base {
    protected JTextArea edit_a;
    Base return_to_panel;
    boolean editable;
    pktinfo pktrc;
    mouse m;

    edit(Base parent, Base return_to_panel, String title) {
	super(parent,title,"");
	this.return_to_panel = return_to_panel;
	this.editable = true;
	addBody();
    }

    edit(Base parent, Base return_to_panel, String title, boolean editable) {
	super(parent,title,"");
	this.return_to_panel = return_to_panel;
	this.editable = editable;
	addBody();
    }

    void addBody() {
	int fd;
	pktinfo pktrc;

	File tmpfile = new File(parent_panel.tmpfn);

	// Download the config file if temp file doesn't exist
	if (!tmpfile.exists()) {
	    pktrc = parent_panel.download();
	    if (pktrc.rc < 0) {
		complete = false;
		return;
	    }
	    // Reset tmpfile to the new temp file name
	    tmpfile = new File(parent_panel.tmpfn);
	}

	if (parent_panel.tmpfn.equals("")) {
	    fw.msgline.setText("Internal error: config file " +
			"has not been downloaded yet");
	    complete = false;
	    return;
	}
	if (!tmpfile.exists() || !tmpfile.isFile()) {
	    fw.msgline.setText("Internal error: the downloaded " +
			"config file cannot be found");
	    complete = false;
	    return;
	}

	pktrc = fw.c.opencbcfile(parent_panel.tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    complete = false;
	    return;
	}

	fd = pktrc.rc;
	// Read the whole file all at once.  This permits bigger files (> 100K)
	// to come up in seconds rather than minutes.
	pktrc = fw.c.cbcreadFile(fd);
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    complete = false;
	    return;
	}
	edit_a = new JTextArea(pktrc.str);

	if (!editable)
	    edit_a.setEditable(false);

	// If parent panel has its lineno set, go through the text string
	// so we can highlight the correct line
	if (parent_panel.lineno != 0) {
	    int start = 0;
	    int end = 0;
	    lineno = 0;
	    while (true) {
		end = pktrc.str.indexOf('\n', start);
		if (end == -1) {
		    end = pktrc.str.length();
		    if (lineno <= parent_panel.lineno) {
			start = 0;
			end = 0;
			break;
		    }
		}
		if (++lineno == parent_panel.lineno)
		    break;
		start = end + 1;
	    }
	    edit_a.setCaretPosition(start);
	    edit_a.select(start, end);
	}
	else
	    edit_a.setCaretPosition(0);

	// Delete the temp file since we no longer need it
	fw.c.closefile(fd);
	tmpfile.delete();

	remove(sp);
	edit_a.setBackground(SystemColor.control);
	edit_a.setForeground(SystemColor.controlText);
	edit_a.setFont(new Font("TimesRoman",Font.PLAIN,fwmain.fontsize));
	add(new JScrollPane(edit_a));

	edit_a.requestFocus();

	m = new mouse();
	edit_a.addMouseListener(m);
    }

    public void handleCan() {
	fw.newpanel(return_to_panel);
    }

    /*=======================================================================
     * Given a string, this method splits it into lines (separated by '\n')
     * and sends each line individually to cbcwriteLine().
     * Returns	0 if succcessful
     *		-1 if failed
     *======================================================================*/
    private int split_line(int fd, String s) {
	String line;
	StringTokenizer st = new StringTokenizer(s,"\n");

	while (true) {
	    // Get one statement
	    try {
		line = st.nextToken();
	    } catch (NoSuchElementException e) {
		break;
	    }
	    pktrc = fw.c.cbcwriteLine(fd, line + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		return(-1);
	    }
	}
	return(0);
    }

    public void handleOK() {
	int fd;
	File outfile;

	outfile = new File(parent_panel.tmpfn);

	pktrc = fw.c.opencbcfile(parent_panel.tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	fd = pktrc.rc;

	if (split_line(fd, edit_a.getText()) < 0) {
	    fw.c.closefile(fd);
	    return;
	}
	
	fw.c.closefile(fd);
	pktrc = parent_panel.upload();
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}
	fw.msgline.setText("New config file successfully created");
	fw.newpanel(return_to_panel);
	return;
    }

    /*=======================================================================
     * This class is defined solely to put the key focus in the
     * JTextArea in this panel.  It will call requestFocus() once and then
     * removes itself so it is not done again.
     *======================================================================*/
    class mouse extends MouseAdapter {
	public void mouseEntered(MouseEvent e) {
	    edit_a.requestFocus();
	    edit_a.removeMouseListener(m);
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseClicked(MouseEvent e) {
	}
    }
}
