/*============================================================================
 * filename:		gwuser.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//public class gwuser extends Base {
public class gwuser extends Base implements ItemListener {
    Button	showgroup_b;
    String	name;
    String	origpw;
    TextField	name_f;
    TextField	realname_f;
    TextField	phone_f;
    TextField	group_f;
    TextField	password_f;
    TextField	password2_f;
    Choice	tokentype_f;
    TextField	key_f;
    Checkbox	protn_f;
    Checkbox	protnsa_f;
    Checkbox	unprotn_f;
    Checkbox	admtn_f;
    Checkbox	proftp_f;
    Checkbox	unproftp_f;
    Checkbox	getftp_f;
    Checkbox	putftp_f;
    Checkbox	delftp_f;
    TextField	startdate_f;
    TextField	stopdate_f;
    Choice	locked_f;
    times	times_f;
    int		action;
    boolean	isgwuser;
    gwrecord	rec;
    public final static int ADDUSER = 0;
    public final static int CLONEUSER = 1;
    public final static int MODUSER = 2;
    public final static int ADDGROUP = 3;
    public final static int CLONEGROUP = 4;
    public final static int MODGROUP = 5;

    gwuser(Base p, int action, String name) {
	super(p,"GWUSER","");
	this.action = action;

	rec = new gwrecord();
	if (name.length() == 0 &&
		(action == CLONEUSER || action == MODUSER ||
		action == CLONEGROUP || action == MODGROUP)) {
	    switch (action) {
		case CLONEUSER:
		    fw.msgline.setText("Must specify username to clone " +
				"user");
		    break;
		case MODUSER:
		    fw.msgline.setText("Must specify username to modify " +
				"user");
		    break;
		case CLONEGROUP:
		    fw.msgline.setText("Must specify groupname to clone " +
				"group");
		    break;
		case MODGROUP:
		    fw.msgline.setText("Must specify groupname to modify " +
				"group");
		    break;
	    }
	    complete = false;
	    return;
	}
	else
	    rec.name = name;

	if (action == ADDUSER || action == CLONEUSER || action == MODUSER) {
	    lowname = new String("gwuser");
	    isgwuser = true;
	}
	else {
	    lowname = new String("gwgroup");
	    paneltitle.setText("GWGROUP");
	    isgwuser = false;
	}
	
	addBody();
    }

    void addBody() {
	int rc;
	Label name_l;
	Label realname_l;
	pktinfo pktrc;
	Date sdate;

	// Initialize the values for this panel
	rec.realname = new String("");
	rec.phone = new String("");
	rec.group = new String("");
	rec.password = new String("");
	rec.tokentype = 0;
	rec.key = new String("");
	rec.tnaccess = 0;
	rec.ftpaccess = 0;
	rec.locked = false;

	if (action == ADDUSER || action == ADDGROUP)
	    pktrc = fw.c.getgwdefault(action, rec);
	else
	    pktrc = fw.c.getgwuser(action, rec);

	if (pktrc.rc < 0) {
	    complete = false;
	    if (pktrc.rc != fw.c.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	if (action == ADDUSER) {
	    rec.startdate = 0;	// Default to NOW
	    rec.stopdate = 0;	// Default to NEVER
	}

	if (action == MODUSER)
	    origpw = rec.password;
	else
	    origpw = new String();

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	gbc.anchor = GridBagConstraints.NORTHWEST;

	// User/Group name
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	if (isgwuser)
	    name_l = new Label("Username");
	else
	    name_l = new Label("Groupname");
	gbl.setConstraints(name_l,gbc);
	body.add(name_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	name_f = new TextField(rec.name,16);
	gbl.setConstraints(name_f,gbc);
	body.add(name_f);
	name_f.addFocusListener(this);
	if (action == MODUSER || action == MODGROUP)
	    name_f.setEditable(false);

	// Real name
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	if (isgwuser)
	    realname_l = new Label("User's Real Name");
	else
	    realname_l = new Label("Group's Real Name");
	gbl.setConstraints(realname_l,gbc);
	body.add(realname_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	realname_f = new TextField(rec.realname,20);
	gbl.setConstraints(realname_f,gbc);
	body.add(realname_f);
	realname_f.addFocusListener(this);

	if (isgwuser) {

	    // Phone number
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label phone_l = new Label("Phone Number");
	    gbl.setConstraints(phone_l,gbc);
	    body.add(phone_l);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    phone_f = new TextField(rec.phone,10);
	    gbl.setConstraints(phone_f,gbc);
	    body.add(phone_f);
	    phone_f.addFocusListener(this);

	    // Group name that the user belongs to
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label group_l = new Label("Group Name");
	    gbl.setConstraints(group_l,gbc);
	    body.add(group_l);

	    Panel group_p = new Panel();
	    group_p.setLayout(new GridLayout(1,2));

	    group_f = new TextField(rec.group,16);
	    group_p.add(group_f);
	    group_f.addFocusListener(this);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    showgroup_b = new Button("Show Group");
	    showgroup_b.setActionCommand("showgroup");
	    group_p.add(showgroup_b);
	    showgroup_b.addActionListener(this);
	    showgroup_b.addFocusListener(this);

	    gbl.setConstraints(group_p,gbc);
	    body.add(group_p);

	    // Password
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label password_l = new Label("Password");
	    gbl.setConstraints(password_l,gbc);
	    body.add(password_l);

	    // Do not directly display the password
	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    // If cloning a user, do not clone the password by default
	    if (action == CLONEUSER)
		rec.password = new String();
	    password_f = new TextField(rec.password,10);
	    password_f.setEchoChar('*');
	    gbl.setConstraints(password_f,gbc);
	    body.add(password_f);
	}

	// Token type
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label tokentype_l = new Label("Token Type");
	gbl.setConstraints(tokentype_l,gbc);
	body.add(tokentype_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	tokentype_f = new Choice();
	tokentype_f.addItem("None");
	tokentype_f.addItem("CRYPTO");
	tokentype_f.addItem("SNK");
	tokentype_f.select(rec.tokentype);
	gbl.setConstraints(tokentype_f,gbc);
	body.add(tokentype_f);
	tokentype_f.addFocusListener(this);

	if (isgwuser) {
	    // Token key
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label key_l = new Label("Token Key");
	    gbl.setConstraints(key_l,gbc);
	    body.add(key_l);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    key_f = new TextField(rec.key,32);
	    gbl.setConstraints(key_f,gbc);
	    body.add(key_f);
	    key_f.addFocusListener(this);

	    // Start date
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label startdate_l = new Label("Start Date (mm/dd/yyyy)");
	    gbl.setConstraints(startdate_l,gbc);
	    body.add(startdate_l);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    if (rec.startdate == 0)
		startdate_f = new TextField("NOW",12);
	    else {
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(2);
		Calendar calendar = Calendar.getInstance();	/* today */
		calendar.setTime(new
			Date(new Integer(rec.startdate).longValue() * 1000));
		String s = nf.format(calendar.get(Calendar.MONTH) + 1);
		s = s.concat("/");
		s = s.concat(nf.format(calendar.get(Calendar.DAY_OF_MONTH)));
		s = s.concat("/");
		s = s.concat(Integer.toString(calendar.get(Calendar.YEAR)));
		startdate_f = new TextField(s,12);
	    }
	    gbl.setConstraints(startdate_f,gbc);
	    body.add(startdate_f);
	    startdate_f.addFocusListener(this);

	    // Stop date
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label stopdate_l = new Label("Stop Date (mm/dd/yyyy)");
	    gbl.setConstraints(stopdate_l,gbc);
	    body.add(stopdate_l);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    if (rec.stopdate == 0)
		stopdate_f = new TextField("NEVER",12);
	    else {
		NumberFormat nf = NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(2);
		Calendar calendar = Calendar.getInstance();	/* today */
		calendar.setTime(new
			Date(new Integer(rec.stopdate).longValue() * 1000));
		String s = nf.format(calendar.get(Calendar.MONTH) + 1);
		s = s.concat("/");
		s = s.concat(nf.format(calendar.get(Calendar.DAY_OF_MONTH)));
		s = s.concat("/");
		s = s.concat(Integer.toString(calendar.get(Calendar.YEAR)));
		stopdate_f = new TextField(s,12);
	    }
	    gbl.setConstraints(stopdate_f,gbc);
	    body.add(stopdate_f);
	    stopdate_f.addFocusListener(this);

	    // Lock status
	    gbc.gridwidth = GridBagConstraints.RELATIVE;
	    Label locked_l = new Label("User Locked?");
	    gbl.setConstraints(locked_l,gbc);
	    body.add(locked_l);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    locked_f = new Choice();
	    locked_f.addItem("yes");
	    locked_f.addItem("no");
	    gbl.setConstraints(locked_f,gbc);
	    body.add(locked_f);
	    locked_f.addFocusListener(this);
	    if (rec.locked)
		locked_f.select("yes");
	    else
		locked_f.select("no");
	}

	// Telnet access
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label tnaccess_l = new Label("Telnet Access");
	gbl.setConstraints(tnaccess_l,gbc);
	body.add(tnaccess_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Panel tnaccess_p = new Panel();
	tnaccess_p.setLayout(new GridLayout(2,3,0,0));

	// PRO_TN
	protn_f = new Checkbox("PRO_TN");
	if ((rec.tnaccess & gwrecord.PRO_TN) != 0)
	    protn_f.setState(true);
	tnaccess_p.add(protn_f);
	protn_f.addItemListener(this);

	// PRO_TNSA
	protnsa_f = new Checkbox("PRO_TNSA");
	if ((rec.tnaccess & gwrecord.PRO_TNSA) != 0)
	    protnsa_f.setState(true);
	tnaccess_p.add(protnsa_f);
	protnsa_f.addItemListener(this);

	// UNPRO_TN
	unprotn_f = new Checkbox("UNPRO_TN");
	if ((rec.tnaccess & gwrecord.UNPRO_TN) != 0)
	    unprotn_f.setState(true);
	tnaccess_p.add(new Label());
	tnaccess_p.add(unprotn_f);
	unprotn_f.addItemListener(this);

	// ADM_TN
	admtn_f = new Checkbox("ADM_TN");
	if ((rec.tnaccess & gwrecord.ADM_TN) != 0)
	    admtn_f.setState(true);
	tnaccess_p.add(admtn_f);
	admtn_f.addItemListener(this);
	gbl.setConstraints(tnaccess_p,gbc);
	body.add(tnaccess_p);

	// FTP access
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label ftpaccess_l = new Label("FTP Access");
	gbl.setConstraints(ftpaccess_l,gbc);
	body.add(ftpaccess_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Panel ftpaccess_p = new Panel();
	ftpaccess_p.setLayout(new GridLayout(2,3,0,0));

	// PRO_FTP
	proftp_f = new Checkbox("PRO_FTP");
	if ((rec.ftpaccess & gwrecord.PRO_FTP) != 0)
	    proftp_f.setState(true);
	ftpaccess_p.add(proftp_f);
	proftp_f.addItemListener(this);

	// UNPRO_FTP
	unproftp_f = new Checkbox("UNPRO_FTP");
	if ((rec.ftpaccess & gwrecord.UNPRO_FTP) != 0)
	    unproftp_f.setState(true);
	ftpaccess_p.add(unproftp_f);
	unproftp_f.addItemListener(this);

	ftpaccess_p.add(new Label());

	// GET_FTP
	getftp_f = new Checkbox("GET_FTP");
	if ((rec.ftpaccess & gwrecord.GET_FTP) != 0)
	    getftp_f.setState(true);
	ftpaccess_p.add(getftp_f);
	getftp_f.addItemListener(this);

	// PUT_FTP
	putftp_f = new Checkbox("PUT_FTP");
	if ((rec.ftpaccess & gwrecord.PUT_FTP) != 0)
	    putftp_f.setState(true);
	ftpaccess_p.add(putftp_f);
	putftp_f.addItemListener(this);

	// DEL_FTP
	delftp_f = new Checkbox("DEL_FTP");
	if ((rec.ftpaccess & gwrecord.DEL_FTP) != 0)
	    delftp_f.setState(true);
	ftpaccess_p.add(delftp_f);
	delftp_f.addItemListener(this);

	gbl.setConstraints(ftpaccess_p,gbc);
	body.add(ftpaccess_p);

	// Access times
	Panel times_p = new Panel();

	times_p.setLayout(new GridLayout(2,1));
	Label times_l = new Label("Access Times");
	times_p.add(times_l);
	times_p.add(new legends());

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	gbl.setConstraints(times_p,gbc);
	body.add(times_p);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	times_f = new times(rec.accesstimes, fw);
	gbl.setConstraints(times_f,gbc);
	body.add(times_f);
	times_f.addFocusListener(this);

	sp.add(body);
    }

    // Add processing code for the showgroup button
    protected boolean moreAction(String s) {
	if ("showgroup".equals(s)) {
	    fw.newpanel(new gwuser(this,MODGROUP,group_f.getText()));
	    return(true);
	}
	return(false);
    }

    public void itemStateChanged(ItemEvent e) {
	fw.msgline.setText("");
	if (e.getStateChange() == ItemEvent.SELECTED) {
	    if (e.getItem().equals("PRO_TN")) {
		if (admtn_f.getState()) {
		    fw.msgline.setText("ADM_TN is currently selected, it " +
			"requires PRO_TNSA and does not work with PRO_TN");
		    protn_f.setState(false);
		}
		else if (protnsa_f.getState()) {
		    fw.msgline.setText("PRO_TN and PRO_TNSA are mutually " +
			"exclusive, deselecting PRO_TNSA");
		    protnsa_f.setState(false);
		}
	    }
	    if (e.getItem().equals("PRO_TNSA")) {
		if (protn_f.getState()) {
		    fw.msgline.setText("PRO_TN and PRO_TNSA are mutually " +
			"exclusive, deselecting PRO_TN");
		    protn_f.setState(false);
		}
	    }
	    if (e.getItem().equals("ADM_TN")) {
		if (protn_f.getState()) {
		    fw.msgline.setText("ADM_TN requires PRO_TNSA, PRO_TN " +
			"selection automatically changed to PRO_TNSA");
		    protn_f.setState(false);
		    protnsa_f.setState(true);
		}
	    }
	}
    }

    /*=======================================================================
     * Read in the input from the screen.  The input values are put into
     * the gwrecord class instance rec.
     * Returns 0 if successful
     *		-1 if failed
     *======================================================================*/
    int readInput() {
	rec.name = name_f.getText();
	rec.realname = realname_f.getText();
	rec.tokentype = (byte)tokentype_f.getSelectedIndex();
	rec.tnaccess = 0;
	if (protn_f.getState())
	    rec.tnaccess |= gwrecord.PRO_TN;
	if (unprotn_f.getState())
	    rec.tnaccess |= gwrecord.UNPRO_TN;
	if (protnsa_f.getState())
	    rec.tnaccess |= gwrecord.PRO_TNSA;
	if (admtn_f.getState())
	    rec.tnaccess |= gwrecord.ADM_TN;
	rec.ftpaccess = 0;
	if (proftp_f.getState())
	    rec.ftpaccess |= gwrecord.PRO_FTP;
	if (unproftp_f.getState())
	    rec.ftpaccess |= gwrecord.UNPRO_FTP;
	if (getftp_f.getState())
	    rec.ftpaccess |= gwrecord.GET_FTP;
	if (putftp_f.getState())
	    rec.ftpaccess |= gwrecord.PUT_FTP;
	if (delftp_f.getState())
	    rec.ftpaccess |= gwrecord.DEL_FTP;
	if (isgwuser) {
	    String sdate;
	    rec.phone = phone_f.getText();
	    rec.group = group_f.getText();
	    rec.key = key_f.getText();
	    rec.password = password_f.getText();
	    if (action == MODUSER && rec.password.equals(origpw))
		rec.password = new String();

	    // startdate
	    sdate = startdate_f.getText();
	    if (sdate.length() == 0 || sdate.equalsIgnoreCase("NOW"))
		rec.startdate = 0;
	    else {
		int month, day, year;
		if (sdate.length() != 10) {
		    focus_prompt = new String("Start date must be in " +
				"mm/dd/yyyy format");
		    startdate_f.requestFocus();
		    return(-1);
		}
		try {
		    month =
			Integer.valueOf(sdate.substring(0,2)).intValue() - 1;
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Start date must be in " +
				"mm/dd/yyyy format");
		    startdate_f.requestFocus();
		    return(-1);
		}
		try {
		    day =
			Integer.valueOf(sdate.substring(3,5)).intValue();
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Start date must be in " +
				"mm/dd/yyyy format");
		    startdate_f.requestFocus();
		    return(-1);
		}
		try {
		    year =
			Integer.valueOf(sdate.substring(6)).intValue();
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Start date must be in " +
				"mm/dd/yyyy format");
		    startdate_f.requestFocus();
		    return(-1);
		}
		Calendar calendar = Calendar.getInstance();	/* today */
		calendar.clear(Calendar.YEAR);
		calendar.clear(Calendar.MONTH);
		calendar.clear(Calendar.DAY_OF_YEAR);
		calendar.set(year,month,day);
		// Pretty ugly....
		// The first getTime() is in Calendar class and it returns a
		// Date class object
		// The second getTime() is in Date class and it returns a
		// long representing the number of milliseconds since the epoch.
		// The divide by 1000 turns it into seconds
		// intValue converts the number into an int.
		rec.startdate =
			new Long(calendar.getTime().getTime()/1000).intValue();
	    }

	    // stopdate
	    sdate = stopdate_f.getText();
	    if (sdate.length() == 0 || sdate.equalsIgnoreCase("NEVER"))
		rec.stopdate = 0;
	    else {
		int month, day, year;
		if (sdate.length() != 10) {
		    focus_prompt = new String("Stop date must be in " +
				"mm/dd/yyyy format");
		    stopdate_f.requestFocus();
		    return(-1);
		}
		try {
		    month =
			Integer.valueOf(sdate.substring(0,2)).intValue() - 1;
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Stop date must be in " +
				"mm/dd/yyyy format");
		    stopdate_f.requestFocus();
		    return(-1);
		}
		try {
		    day =
			Integer.valueOf(sdate.substring(3,5)).intValue();
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Stop date must be in " +
				"mm/dd/yyyy format");
		    stopdate_f.requestFocus();
		    return(-1);
		}
		try {
		    year =
			Integer.valueOf(sdate.substring(6)).intValue();
		} catch (NumberFormatException e) {
		    focus_prompt = new String("Stop date must be in " +
				"mm/dd/yyyy format");
		    stopdate_f.requestFocus();
		    return(-1);
		}
		Calendar calendar = Calendar.getInstance();	/* today */
		calendar.clear(Calendar.YEAR);
		calendar.clear(Calendar.MONTH);
		calendar.clear(Calendar.DAY_OF_MONTH);
		calendar.set(year,month,day);
		// Pretty ugly....
		// The first getTime() is in Calendar class and it returns a
		// Date class object
		// The second getTime() is in Date class and it returns a
		// long representing the number of milliseconds since the epoch.
		// The divide by 1000 turns it into seconds
		// intValue converts the number into an int.
		rec.stopdate =
			new Long(calendar.getTime().getTime()/1000).intValue();
	    }

	    rec.locked =  locked_f.getSelectedItem().equalsIgnoreCase("yes");
	}

	return(0);
    }

    public void handleOK() {
	pktinfo pktrc;

	if (readInput() < 0)
	    return;

	pktrc = fw.c.putgwuser(action, rec);

	if (pktrc.rc < 0) {
	    if (pktrc.rc != fw.c.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	fw.newpanel(parent_panel);
	fw.msgline.setText(pktrc.str);
    }
}
