/*============================================================================
 * filename:		gwuserconf.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//public class gwuser extends Base {
public class gwuserconf extends Base implements ItemListener {
    TextField	group_f;
    String	group;
    Choice	tokentype_f;
    int		tokentype;
    Checkbox	protn_f;
    Checkbox	protnsa_f;
    Checkbox	unprotn_f;
    Checkbox	admtn_f;
    int		tnaccess;
    Checkbox	proftp_f;
    Checkbox	unproftp_f;
    Checkbox	getftp_f;
    Checkbox	putftp_f;
    Checkbox	delftp_f;
    int		ftpaccess;
    times	times_f;

    TextField	pw_min_len_f;
    String	pw_min_len;
    TextField	pw_min_alpha_f;
    String	pw_min_alpha;
    TextField	pw_min_other_f;
    String	pw_min_other;
    TextField	pw_max_age_f;
    String	pw_max_age;
    TextField	n_unique_f;
    String	n_unique;
    TextField	n_login_f;
    String	n_login;
    gwrecord	rec;

    gwuserconf(Base p) {
	super(p,"GWUSER","");
	addBody();
    }

    void addBody() {
	int rc;
	pktinfo pktrc;

	component = fw.c.GWUSER;
	rec = new gwrecord();
	// Initialize the values for this panel
	pw_min_len = new String("6");
	pw_min_alpha = new String("3");
	pw_min_other = new String("1");
	pw_max_age = new String("90");
	n_unique = new String("4");
	n_login = new String("3");

	// Get the default group values.  This duplicates some
	// effort later on but making this call let us avoid having to
	// convert the access times from a string to a bit array.
	pktrc = fw.c.getgwdefault(gwuser.ADDGROUP, rec);

	if (pktrc.rc < 0) {
	    complete = false;
	    if (pktrc.rc != fw.c.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	// Get the config file over here to a temp file
	pktrc = download();
	tmpfn = pktrc.str;

	if (pktrc.rc != fw.c.OK) {
	    complete = false;
	    return;
	}

	// Read in the temp file
	if ((rc = readconf()) == fw.c.FAILED) {
	    fw.c.closefd();
	    fw.newpanel(fw.getTop());
	}

	if (rc < 0)
	    return;

	gbc.anchor = GridBagConstraints.NORTHWEST;
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button edit_b = new Button("Edit");
	edit_b.addActionListener(this);
	gbl.setConstraints(edit_b,gbc);
	body.add(edit_b);

	// Default group
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label group_l = new Label("Default group for new user");
	gbl.setConstraints(group_l,gbc);
	body.add(group_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	group_f = new TextField(group,16);
	gbl.setConstraints(group_f,gbc);
	body.add(group_f);
	group_f.addFocusListener(this);

	// Default Token type
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label tokentype_l = new Label("Default TokenType for new group");
	gbl.setConstraints(tokentype_l,gbc);
	body.add(tokentype_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	tokentype_f = new Choice();
	tokentype_f.addItem("None");
	tokentype_f.addItem("CRYPTO");
	tokentype_f.addItem("SNK");
	tokentype_f.select(rec.tokentype);
	gbl.setConstraints(tokentype_f,gbc);
	body.add(tokentype_f);
	tokentype_f.addFocusListener(this);

	// Telnet access
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label tnaccess_l = new Label("Default telnet access for new group");
	gbl.setConstraints(tnaccess_l,gbc);
	body.add(tnaccess_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Panel tnaccess_p = new Panel();
	tnaccess_p.setLayout(new GridLayout(2,3,0,0));

	// PRO_TN
	protn_f = new Checkbox("PRO_TN");
	if ((rec.tnaccess & gwrecord.PRO_TN) != 0)
	    protn_f.setState(true);
	tnaccess_p.add(protn_f);
	protn_f.addItemListener(this);

	// PRO_TNSA
	protnsa_f = new Checkbox("PRO_TNSA");
	if ((rec.tnaccess & gwrecord.PRO_TNSA) != 0)
	    protnsa_f.setState(true);
	tnaccess_p.add(protnsa_f);
	protnsa_f.addItemListener(this);

	// UNPRO_TN
	unprotn_f = new Checkbox("UNPRO_TN");
	if ((rec.tnaccess & gwrecord.UNPRO_TN) != 0)
	    unprotn_f.setState(true);
	tnaccess_p.add(new Label());
	tnaccess_p.add(unprotn_f);
	unprotn_f.addItemListener(this);

	// ADM_TN
	admtn_f = new Checkbox("ADM_TN");
	if ((rec.tnaccess & gwrecord.ADM_TN) != 0)
	    admtn_f.setState(true);
	tnaccess_p.add(admtn_f);
	admtn_f.addItemListener(this);
	gbl.setConstraints(tnaccess_p,gbc);
	body.add(tnaccess_p);

	// FTP access
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label ftpaccess_l = new Label("Default FTP access for new group");
	gbl.setConstraints(ftpaccess_l,gbc);
	body.add(ftpaccess_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Panel ftpaccess_p = new Panel();
	ftpaccess_p.setLayout(new GridLayout(2,3,0,0));

	// PRO_FTP
	proftp_f = new Checkbox("PRO_FTP");
	if ((rec.ftpaccess & gwrecord.PRO_FTP) != 0)
	    proftp_f.setState(true);
	ftpaccess_p.add(proftp_f);
	proftp_f.addItemListener(this);

	// UNPRO_FTP
	unproftp_f = new Checkbox("UNPRO_FTP");
	if ((rec.ftpaccess & gwrecord.UNPRO_FTP) != 0)
	    unproftp_f.setState(true);
	ftpaccess_p.add(unproftp_f);
	unproftp_f.addItemListener(this);

	ftpaccess_p.add(new Label());

	// GET_FTP
	getftp_f = new Checkbox("GET_FTP");
	if ((rec.ftpaccess & gwrecord.GET_FTP) != 0)
	    getftp_f.setState(true);
	ftpaccess_p.add(getftp_f);
	getftp_f.addItemListener(this);

	// PUT_FTP
	putftp_f = new Checkbox("PUT_FTP");
	if ((rec.ftpaccess & gwrecord.PUT_FTP) != 0)
	    putftp_f.setState(true);
	ftpaccess_p.add(putftp_f);
	putftp_f.addItemListener(this);

	// DEL_FTP
	delftp_f = new Checkbox("DEL_FTP");
	if ((rec.ftpaccess & gwrecord.DEL_FTP) != 0)
	    delftp_f.setState(true);
	ftpaccess_p.add(delftp_f);
	delftp_f.addItemListener(this);

	gbl.setConstraints(ftpaccess_p,gbc);
	body.add(ftpaccess_p);

	// Access times
	Panel times_p = new Panel();

	times_p.setLayout(new GridLayout(2,1));
	Label times_l = new Label("Default access times for new group");
	times_p.add(times_l);
	times_p.add(new legends());

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	gbl.setConstraints(times_p,gbc);
	body.add(times_p);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	times_f = new times(rec.accesstimes, fw);
	gbl.setConstraints(times_f,gbc);
	body.add(times_f);
	times_f.addFocusListener(this);

	// password_min_length
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label pw_min_len_l = new Label("Password minimum length");
	gbl.setConstraints(pw_min_len_l,gbc);
	body.add(pw_min_len_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	pw_min_len_f = new TextField(pw_min_len,4);
	gbl.setConstraints(pw_min_len_f,gbc);
	body.add(pw_min_len_f);
	pw_min_len_f.addFocusListener(this);

	// password_min_alpha
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label pw_min_alpha_l = new Label("Password minimum alpha characters");
	gbl.setConstraints(pw_min_alpha_l,gbc);
	body.add(pw_min_alpha_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	pw_min_alpha_f = new TextField(pw_min_alpha,4);
	gbl.setConstraints(pw_min_alpha_f,gbc);
	body.add(pw_min_alpha_f);
	pw_min_alpha_f.addFocusListener(this);

	// password_min_other
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label pw_min_other_l = new Label("Password minimum other characters");
	gbl.setConstraints(pw_min_other_l,gbc);
	body.add(pw_min_other_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	pw_min_other_f = new TextField(pw_min_other,4);
	gbl.setConstraints(pw_min_other_f,gbc);
	body.add(pw_min_other_f);
	pw_min_other_f.addFocusListener(this);

	// password_max_age
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label pw_max_age_l = new Label("Password maximum change interval " +
			"in days");
	gbl.setConstraints(pw_max_age_l,gbc);
	body.add(pw_max_age_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	pw_max_age_f = new TextField(pw_max_age,4);
	gbl.setConstraints(pw_max_age_f,gbc);
	body.add(pw_max_age_f);
	pw_max_age_f.addFocusListener(this);

	// no_unique_passwords
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label n_unique_l = new Label("Number of unique passwords before reuse");
	gbl.setConstraints(n_unique_l,gbc);
	body.add(n_unique_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	n_unique_f = new TextField(n_unique,4);
	gbl.setConstraints(n_unique_f,gbc);
	body.add(n_unique_f);
	n_unique_f.addFocusListener(this);

	// no_login_attempts
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label n_login_l = new Label("Number of failed logins before locking " +
			"user");
	gbl.setConstraints(n_login_l,gbc);
	body.add(n_login_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	n_login_f = new TextField(n_login,4);
	gbl.setConstraints(n_login_f,gbc);
	body.add(n_login_f);
	n_login_f.addFocusListener(this);

	sp.add(body);
    }

    class legends extends Panel {
	legends() {
	    super();
	}

	public void paint(Graphics g) {
	    Color c;
	    c = g.getColor();
	    g.setColor(SystemColor.controlText);
	    g.draw3DRect(0,0,times.wt,times.ht,false);
	    g.setColor(SystemColor.control);
	    g.draw3DRect(0,times.ht + times.ht,times.wt,times.ht,true);
	    g.setColor(c);
	    setFont(new Font("TimesRoman",Font.PLAIN,times.pts));
	    g.drawString("= Allowed",times.wt + 10, times.ht - 2);
	    g.drawString("= Not Allowed",times.wt + 10,
				times.ht + times.ht + times.ht - 2);
	}
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED) {
	    if (e.getItem().equals("PRO_TN")) {
		if (admtn_f.getState()) {
		    fw.msgline.setText("ADM_TN is currently selected, it " +
			"requires PRO_TNSA and does not work with PRO_TN");
		    protn_f.setState(false);
		}
		else if (protnsa_f.getState()) {
		    fw.msgline.setText("PRO_TN and PRO_TNSA are mutually " +
			"exclusive, deselecting PRO_TNSA");
		    protnsa_f.setState(false);
		}
	    }
	    if (e.getItem().equals("PRO_TNSA")) {
		if (protn_f.getState()) {
		    fw.msgline.setText("PRO_TN and PRO_TNSA are mutually " +
			"exclusive, deselecting PRO_TN");
		    protn_f.setState(false);
		}
	    }
	    if (e.getItem().equals("ADM_TN")) {
		if (protn_f.getState()) {
		    fw.msgline.setText("ADM_TN requires PRO_TNSA, PRO_TN " +
			"selection automatically changed to PRO_TNSA");
		    protn_f.setState(false);
		    protnsa_f.setState(true);
		}
	    }
	}
	else
	    fw.msgline.setText("");
    }

    /*=======================================================================
     * Reads the temp file in and interpret it
     *
     * Returns 0 if successful
     *		-1 if failed
     *		NONFATAL if connection need not be closed
     *
     *======================================================================*/
    int readconf() {
	int fd;
	pktinfo pktrc; 

	if (tmpfn.equals("")) {
	    fw.msgline.setText("Internal error: gwuser config " +
			"file has not been downloaded yet");
	    return(fw.c.NONFATAL);
	}
	File tmpfile = new File(tmpfn);
	if (!tmpfile.exists() || !tmpfile.isFile()) {
	    fw.msgline.setText("Internal error: the downloaded gwuser " +
			"conf file cannot be found");
	    return(fw.c.NONFATAL);
	}

	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	while ( true ) {
	    String tmp;
	    String statement;

	    pktrc = fw.c.cbcreadLine(fd);
	    if (pktrc.rc != cglue.OK) {
		if (pktrc.rc == cglue.CLOSED)
		    break;
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(pktrc.rc);
	    }

	    // Exit loop at EOF
	    if (pktrc.str == null)
		break;

	    lineno++;

	    // Get rid of comment lines (first character is #)
	    if (pktrc.str.trim().length() == 0 ||
			pktrc.str.trim().substring(0,1).equals("#"))
		continue;

	    StringTokenizer st = new StringTokenizer(pktrc.str.trim()," \t=:");

	    // Get the statement type
	    try {
		statement = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		continue;
	    }

	    // Get the next token into tmp - ignore error with no token found
	    // We do this here so we don't have to do a "try" for every
	    // statement type
	    try {
		tmp = st.nextToken();
	    } catch (NoSuchElementException e) {
		complete = false;
		fw.c.closefile(fd);
		tmpfile.delete();
		fw.newpanel(new edit(this,parent_panel,"EDIT GWUSER"));
		fw.msgline.setText("Highlighted line contains an " +
			"invalid statement, please correct and retry");
		return(fw.c.NONFATAL);
	    }

	    // Ignore these statements which we already have values for from
	    // the getgwdefault() call
	    if (statement.equals("default_group")) {
		group = tmp;
		continue;
	    }

	    if (statement.equals("default_token")) {
		continue;
	    }

	    if (statement.equals("default_telnet")) {
		continue;
	    }

	    if (statement.equals("default_ftp")) {
		continue;
	    }

	    if (statement.equals("default_times")) {
		continue;
	    }

	    if (statement.equals("password_min_length")) {
		pw_min_len = tmp;
		continue;
	    }

	    if (statement.equals("password_min_alpha")) {
		pw_min_alpha = tmp;
		continue;
	    }

	    if (statement.equals("password_min_other")) {
		pw_min_other = tmp;
		continue;
	    }

	    if (statement.equals("password_max_age")) {
		pw_max_age = tmp;
		continue;
	    }

	    if (statement.equals("no_unique_passwords")) {
		n_unique = tmp;
		continue;
	    }

	    if (statement.equals("no_login_attempts")) {
		n_login = tmp;
		continue;
	    }

	    // Invalid statement
	    complete = false;
	    fw.c.closefile(fd);
	    fw.newpanel(new edit(this,parent_panel,"EDIT GWUSER"));
	    fw.msgline.setText("Highlighted line contains an invalid " +
		"statement, please correct and retry");
	    return(fw.c.NONFATAL);
	}

	// Delete the temp file since we no longer need it
	fw.c.closefile(fd);
	tmpfile.delete();
	return (0);
    }

    public void handleOK() {
	pktinfo pktrc;

	if (saveconf() < 0)
	    return;

	pktrc = upload();
	if (pktrc.rc < 0)
	    return;

	fw.msgline.setText("New gwuser config file successfully created");
	fw.newpanel(parent_panel);
    }

    public int saveconf() {
	int fd;
	File outfile;
	String tmp;
	int tmpint;
	int pwminlen;
	int pwminalpha;
	int pwminother;
	pktinfo pktrc; 

	outfile = new File(tmpfn);

	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	// default_group statement
	if (group_f.getText().length() > fw.c.GRPSIZ - 1) {
	    focus_prompt = new String("Default group " + group_f.getText() +
		" exceeds maximum length of " + (fw.c.GRPSIZ - 1) +
		" characters");
	    fw.c.closefile(fd);
	    group_f.requestFocus();
	    return(-1);
	}
	pktrc = fw.c.cbcwriteLine(fd, "default_group = " +
					group_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// default_token statement
	tmp = tokentype_f.getSelectedItem();
	pktrc = fw.c.cbcwriteLine(fd, "default_token = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// default_telnet statement
	tmp = new String();
	if (protn_f.getState())
	    tmp = tmp.concat(" PRO_TN");
	if (protnsa_f.getState())
	    tmp = tmp.concat(" PRO_TNSA");
	if (unprotn_f.getState())
	    tmp = tmp.concat(" UNPRO_TN");
	if (admtn_f.getState())
	    tmp = tmp.concat(" ADM_TN");
	if (tmp.length() == 0)
	    tmp = new String(" NO_TN");
	pktrc = fw.c.cbcwriteLine(fd, "default_telnet = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// default_telnet statement
	tmp = new String();
	if (proftp_f.getState())
	    tmp = tmp.concat(" PRO_FTP");
	if (unproftp_f.getState())
	    tmp = tmp.concat(" UNPRO_FTP");
	if (getftp_f.getState())
	    tmp = tmp.concat(" GET_FTP");
	if (putftp_f.getState())
	    tmp = tmp.concat(" PUT_FTP");
	if (delftp_f.getState())
	    tmp = tmp.concat(" DEL_FTP");
	if (tmp.length() == 0)
	    tmp = new String(" NO_FTP");
	pktrc = fw.c.cbcwriteLine(fd, "default_ftp = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// default access time statement
	pktrc = fw.c.cbcwriteLine(fd, "default_times = " + argstring() +
						"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// password_min_length statement
	tmp = pw_min_len_f.getText();
	try {
	    pwminlen = Integer.parseInt(tmp);
	}
	catch (NumberFormatException e) {
	    focus_prompt = new String("Password min length must be a number");
	    pw_min_len_f.requestFocus();
	    return(-1);
	}
	if (pwminlen < 4 || pwminlen > 16) {
	    focus_prompt = new String("Password min length must be between" +
			"4 and 16");
	    pw_min_len_f.requestFocus();
	    return(-1);
	}
	pktrc = fw.c.cbcwriteLine(fd, "password_min_length = " + tmp +
								"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// password_min_alpha statement
	tmp = pw_min_alpha_f.getText();
	try {
	    pwminalpha = Integer.parseInt(tmp);
	}
	catch (NumberFormatException e) {
	    focus_prompt = new String("Password min alpha value must be a " +
			"number");
	    pw_min_alpha_f.requestFocus();
	    return(-1);
	}
	if (pwminalpha > pwminlen) {
	    focus_prompt = new String("Password min alpha value must not be" +
			"greater than password min length");
	    pw_min_alpha_f.requestFocus();
	    return(-1);
	}
	pktrc = fw.c.cbcwriteLine(fd, "password_min_alpha = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// password_min_other statement
	tmp = pw_min_other_f.getText();
	try {
	    pwminother = Integer.parseInt(tmp);
	}
	catch (NumberFormatException e) {
	    focus_prompt = new String("Password min other value must be a " +
			"number");
	    pw_min_other_f.requestFocus();
	    return(-1);
	}
	if (pwminother > pwminlen) {
	    focus_prompt = new String("Password min other value must not be" +
			"greater than password min length");
	    pw_min_other_f.requestFocus();
	    return(-1);
	}
	pktrc = fw.c.cbcwriteLine(fd, "password_min_other = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	if ((pwminother + pwminalpha) > pwminlen) {
	    focus_prompt = new String("Minimum password alpha plus " +
			"non-alpha exceeds minimum password length");
	    fw.c.closefile(fd);
	    pw_min_len_f.requestFocus();
	    return(-1);
	}

	// password_max_age statement
	tmp = pw_max_age_f.getText();
	if (!tmp.equalsIgnoreCase("UNLIMITED")) {
	    try {
		tmpint = Integer.parseInt(tmp);
	    } catch (NumberFormatException e) {
		focus_prompt = new String("Password max age value must be a " +
			"number or \"UNLIMITED\"");
		pw_max_age_f.requestFocus();
		return(-1);
	    }
	    if (tmpint  < 1 || tmpint > 365) {
		focus_prompt = new String("Password max age value must be" +
			"between 1 and 365 ot \"UNLIMITED\"");
		pw_max_age_f.requestFocus();
		return(-1);
	    }
	}
	pktrc = fw.c.cbcwriteLine(fd, "password_max_age = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// no_unique_passwords statement
	tmp = n_unique_f.getText();
	if (!tmp.equalsIgnoreCase("NONE")) {
	    try {
		tmpint = Integer.parseInt(tmp);
	    } catch (NumberFormatException e) {
		focus_prompt = new String("Number of unique passwords must " +
			"be a number or \"NONE\"");
		n_unique_f.requestFocus();
		return(-1);
	    }
	    if (tmpint < 1 || tmpint > 12) {
		focus_prompt = new String("Number of unique passwords must " +
			"be between 1 and 12 or \"NONE\"");
		n_unique_f.requestFocus();
		return(-1);
	    }
	}
	pktrc = fw.c.cbcwriteLine(fd, "no_unique_passwords = " + tmp +
								"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// no_login_attempts statement
	tmp = n_login_f.getText();
	if (!tmp.equalsIgnoreCase("UNLIMITED")) {
	    try {
		tmpint = Integer.parseInt(tmp);
	    } catch (NumberFormatException e) {
		focus_prompt = new String("Number of failed logins must be a " +
			"number or \"UNLIMITED\"");
		n_login_f.requestFocus();
		return(-1);
	    }
	    if (tmpint < 1 || tmpint > 12) {
		focus_prompt = new String("Number of failed logins must be " +
			"between 1 and 12 or \"UNLIMITED\"");
		n_login_f.requestFocus();
		return(-1);
	    }
	}
	pktrc = fw.c.cbcwriteLine(fd, "no_login_attempts = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}
	fw.c.closefile(fd);

	return(0);
    }

    // Convert accesstimes from byte array to command line arguments
    private String argstring() {
	int fullword;
	int onbits;
	int i,j;
	String args = new String();
	// The bits in accesstimes are unfortunately not in the most intuitive
	// order, i.e. they are not in the same order as the hours they
	// represent.  Ths order of the bits are as follows:
	// byte 0 bit 0 = 0 hour
	// byte 0 bit 1 = 100 hour
	// .
	// .
	// byte 0 bit 7 = 700 hour
	// byte 1 bit 0 = 800 hour
	// .
	// .
	// .
	//
	// where bit 0 = lsb = least significant bit = rightmost bit
	// Since bit 0 is the lsb, the bits representing 700 hour and 800 hour
	// are not adjacent to each other!  This may make this code a little
	// less intuitive than it should be.
	//
	final int [] b = {	0x010000, 0x020000, 0x040000, 0x080000,
				0x100000, 0x200000, 0x400000, 0x800000,
				0x000100, 0x000200, 0x000400, 0x000800,
				0x001000, 0x002000, 0x004000, 0x008000,
				0x000001, 0x000002, 0x000004, 0x000008,
				0x000010, 0x000020, 0x000040, 0x000080	};
	final String [] day = {"Su", "M", "Tu", "W", "Th", "F", "Sa"};

	// The strategy is to go one day at a time, look for consecutive
	// "on" hours.  Then repeatedly look in the next day to see if the same
	// hours are on also, stopping at the first day that doesn't present
	// the same "on" hours.
	// This may not produce the optimal (shortest) output all the time but
	// it works pretty good for the common cases (where the "on" hours are
	// in one or more distinct rectangles).
	for (i = 0; i < times.days; i++) {
	    int fsthr;
	    int lsthr;
	    int fstday;
	    int lstday;
	    fullword = 0;
	    // Convert the 24 hour bits into a fullword
	    // the "& 0x00ff0000" is necessary because hte accesstimes byte
	    // array has its sign bit replicated when being promoted to an
	    // integer.
	    fullword =	((rec.accesstimes[i+i+i] << 16) & 0x00ff0000) |
			((rec.accesstimes[i+i+i+1] << 8) & 0x0000ff00) |
			(rec.accesstimes[i+i+i+2] & 0x000000ff);
	    onbits = 0;
	    fsthr = -1;
	    lsthr = -1;
	    fstday = -1;
	    lstday = -1;
	    // Look at one hour at a time
	    for (j = 0; j < times.hrs; j++) {
		if (fsthr < 0) {
		    if ((fullword & b[j]) != 0) {
			fsthr = j;
			lsthr = j;
			fstday = i;
			lstday = i;
			onbits |= b[j];
		    }
		}
		else {
		    if ((fullword & b[j]) != 0) {
			lsthr = j;
			onbits |= b[j];
		    }
		    else {
			int fw;
			int k;
			for (k = i+1; k < times.days; k++) {
	    		    fw = ((rec.accesstimes[k+k+k] << 16) & 0x00ff0000) |
				((rec.accesstimes[k+k+k+1] << 8) & 0x0000ff00) |
				(rec.accesstimes[k+k+k+2] & 0x000000ff);
			    if ((fw & onbits) == onbits) {
				lstday = k;
				// Turn off the bits so we don't revisit them
				rec.accesstimes[k+k+k] &= ~(onbits >> 16);
				rec.accesstimes[k+k+k+1] &=
						~((onbits & 0x0000ff00) >> 8);
				rec.accesstimes[k+k+k+2] &=
						~(onbits & 0x000000ff);
			    }
			    else
				break;
			}
			// Output an arg string representing the
			// "on" hrs that we have found
			if (args.length() != 0)
			    args = args.concat(" ");
			args = args.concat(day[fstday]);
			if (fstday != lstday) {
			    args = args.concat("-");
			    args = args.concat(day[lstday]);
			}
			args = args.concat(" ");
			args = args.concat(String.valueOf(fsthr));
			args = args.concat("-");
			args = args.concat(String.valueOf(lsthr+1));
			onbits = 0;
			fsthr = -1;
			lsthr = -1;
			fstday = -1;
			lstday = -1;
		    }
		}
	    }
	}
	if (args.length() == 0)
	    args = new String("NONE");
	return(args);
    }

    // Add processing code for the edit button
    protected boolean moreAction(String s) {
	if ("Edit".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    saveconf();
	    fw.newpanel(new edit(this,parent_panel,"EDIT GWUSER"));
	    return(true);
	}
	return(false);
    }
}
