/*============================================================================
 * filename:		gwusermenu.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;

public class gwusermenu extends Base {
    TextField name_f;
    String name;

    gwusermenu(Base p) {
	super(p,"T.Rex GWUSER/GWGROUP Menu","Enter a user or group name and " +
		"then Click on the desired action");
	newmm();
    }

    void newmm() {
	addBody();
	okbutton.setLabel("Continue");
	canbutton.setLabel("Return");
    }

    void addBody() {
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(0,10,0,10);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label user_l = new Label("User or Group Name");
	gbl.setConstraints(user_l,gbc);
	body.add(user_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	name_f = new TextField(16);
	gbl.setConstraints(name_f,gbc);
	body.add(name_f);
	name_f.addFocusListener(this);

	Label filler0 = new Label("");
	gbl.setConstraints(filler0,gbc);
	body.add(filler0);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Button adduser_f = new Button("Add User");
	adduser_f.setActionCommand("adduser");
	adduser_f.addActionListener(this);
	gbl.setConstraints(adduser_f,gbc);
	body.add(adduser_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button addgroup_f = new Button("Add Group");
	addgroup_f.setActionCommand("addgroup");
	addgroup_f.addActionListener(this);
	gbl.setConstraints(addgroup_f,gbc);
	body.add(addgroup_f);

	Label filler1 = new Label("");
	gbl.setConstraints(filler1,gbc);
	body.add(filler1);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Button cloneuser_f = new Button("Clone User");
	cloneuser_f.setActionCommand("cloneuser");
	cloneuser_f.addActionListener(this);
	gbl.setConstraints(cloneuser_f,gbc);
	body.add(cloneuser_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button clonegroup_f = new Button("Clone Group");
	clonegroup_f.setActionCommand("clonegroup");
	clonegroup_f.addActionListener(this);
	gbl.setConstraints(clonegroup_f,gbc);
	body.add(clonegroup_f);

	Label filler2 = new Label("");
	gbl.setConstraints(filler2,gbc);
	body.add(filler2);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Button moduser_f = new Button("Modify User");
	moduser_f.setActionCommand("moduser");
	moduser_f.addActionListener(this);
	gbl.setConstraints(moduser_f,gbc);
	body.add(moduser_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button modgroup_f = new Button("Modify Group");
	modgroup_f.setActionCommand("modgroup");
	modgroup_f.addActionListener(this);
	gbl.setConstraints(modgroup_f,gbc);
	body.add(modgroup_f);

	Label filler3 = new Label("");
	gbl.setConstraints(filler3,gbc);
	body.add(filler3);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Button deluser_f = new Button("Delete User");
	deluser_f.setActionCommand("deluser");
	deluser_f.addActionListener(this);
	gbl.setConstraints(deluser_f,gbc);
	body.add(deluser_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button delgroup_f = new Button("Delete Group");
	delgroup_f.setActionCommand("delgroup");
	delgroup_f.addActionListener(this);
	gbl.setConstraints(delgroup_f,gbc);
	body.add(delgroup_f);

	Label filler4 = new Label("");
	gbl.setConstraints(filler4,gbc);
	body.add(filler4);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button tnkey_f = new Button("Generate tnkey");
	tnkey_f.setActionCommand("tnkey");
	tnkey_f.addActionListener(this);
	gbl.setConstraints(tnkey_f,gbc);
	body.add(tnkey_f);

	Label filler5 = new Label("");
	gbl.setConstraints(filler5,gbc);
	body.add(filler5);

	Label filler6 = new Label("");
	gbl.setConstraints(filler6,gbc);
	body.add(filler6);

	Label filler7 = new Label("");
	gbl.setConstraints(filler7,gbc);
	body.add(filler7);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Button listuser_f = new Button("List Users");
	listuser_f.setActionCommand("listuser");
	listuser_f.addActionListener(this);
	gbl.setConstraints(listuser_f,gbc);
	body.add(listuser_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button listgroup_f = new Button("List Groups");
	listgroup_f.setActionCommand("listgroup");
	listgroup_f.addActionListener(this);
	gbl.setConstraints(listgroup_f,gbc);
	body.add(listgroup_f);

	sp.add(body);
    }

    /*=======================================================================
     * No OK button for this panel
     *======================================================================*/
    void addOK() {
	return;
    }

    public void menubuttons(String s) {

	if ("adduser".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.ADDUSER,name_f.getText()));
	    return;
	}

	if ("cloneuser".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.CLONEUSER,name_f.getText()));
	    return;
	}

	if ("moduser".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.MODUSER,name_f.getText()));
	    return;
	}

	if ("deluser".equals(s) || "delgroup".equals(s)) {
	    pktinfo pktrc;
	    boolean isgwuser = "deluser".equals(s);
	    String name = name_f.getText();
	    if (name.length() == 0) {
		if (isgwuser)
		    fw.msgline.setText("Must specify a username for " +
				"delete");
		else
		    fw.msgline.setText("Must specify a groupname for " +
				"delete");
		return;
	    }
	    if (isgwuser)
		pktrc = fw.c.sendpkt(fw.c.GWUSER, fw.c.DELGWUSER,
					name, 1);
	    else
		pktrc = fw.c.sendpkt(fw.c.GWGROUP, fw.c.DELGWUSER,
					name, 1);
	    if (pktrc.rc < 0) {
		if (pktrc.rc != cglue.NONFATAL) {
		    fw.c.closefd();
		    fw.newpanel(fw.getTop());
		}
		fw.msgline.setText(pktrc.errmsg);
		return;
	    }

	    pktrc = fw.c.recvpkt(1);
	    if (pktrc.rc < 0) {
		if (pktrc.rc != cglue.NONFATAL) {
		    fw.c.closefd();
		    fw.newpanel(fw.getTop());
		}
		fw.msgline.setText(pktrc.errmsg);
		return;
	    }

	    fw.msgline.setText(pktrc.str);

	    return;
	}

	if ("tnkey".equals(s)) {
	    pktinfo pktrc;
	    String name = name_f.getText();
	    if (name.length() == 0) {
		fw.msgline.setText("Must specify a username for tnkey");
		return;
	    }
	    pktrc = fw.c.sendpkt(fw.c.TNKEY, fw.c.TAILLOG, name, 1);

	    if (pktrc.rc < 0) {
		if (pktrc.rc != cglue.NONFATAL) {
		    fw.c.closefd();
		    fw.newpanel(fw.getTop());
		}
		fw.msgline.setText(pktrc.errmsg);
		return;
	    }

	    pktrc = fw.c.recvpkt(1);
	    if (pktrc.rc != fw.c.OK) {
		if (pktrc.rc != cglue.NONFATAL) {
		    fw.c.closefd();
		    fw.newpanel(fw.getTop());
		}
		fw.msgline.setText(pktrc.errmsg);
		return;
	    }

	    monitor m = new monitor(this,fw.c.TNKEY, "TNKEY", 0);
	    fw.newpanel(m);
	    m.activeThread.start();
	    return;
	}

	if ("addgroup".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.ADDGROUP,name_f.getText()));
	    return;
	}

	if ("clonegroup".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.CLONEGROUP,name_f.getText()));
	    return;
	}

	if ("modgroup".equals(s)) {
	    fw.newpanel(new gwuser(this,gwuser.MODGROUP,name_f.getText()));
	    return;
	}

	if ("listuser".equals(s)) {
	    fw.newpanel(new mgwuser(this,fw.c.GWUSER));
	    return;
	}

	if ("listgroup".equals(s)) {
	    fw.newpanel(new mgwuser(this,fw.c.GWGROUP));
	    return;
	}
    }
}
