/*============================================================================
 * filename:		login.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.awt.*;
import java.awt.event.*;

public class login extends Base {

    TextField host_f;
    TextField username_f;
    TextField challenge_f;
    TextField response_f;
    mouse m;

    login(Base p) {
	super(p, "Remote T.Rex Login","Enter remote host and username " +
		"then click 'Login'");
	addBody();
	okbutton.setLabel("Login");
	canbutton.setLabel("Return");
    }

    login(fwwin fwtop) {
	super(fwtop, "T.Rex Login","Enter remote host and username " +
		"then click 'Login'");
	addBody();
	okbutton.setLabel("Login");
	canbutton.setLabel("Exit");
    }

    void addBody() {
	pktinfo pktrc;

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(10,10,10,10);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label host_l = new Label("Remote Host:");
	gbl.setConstraints(host_l,gbc);
	body.add(host_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	host_f = new TextField(16);
	gbl.setConstraints(host_f,gbc);
	body.add(host_f);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label username_l = new Label("Username:");
	gbl.setConstraints(username_l,gbc);
	body.add(username_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	username_f = new TextField(16);
	gbl.setConstraints(username_f,gbc);
	body.add(username_f);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label challenge_l = new Label("Challenge:");
	gbl.setConstraints(challenge_l,gbc);
	body.add(challenge_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	challenge_f = new TextField(8);
	challenge_f.setEditable(false);
	gbl.setConstraints(challenge_f,gbc);
	body.add(challenge_f);
	challenge_f.setEnabled(false);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label response_l = new Label("Response:");
	gbl.setConstraints(response_l,gbc);
	body.add(response_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	response_f = new TextField(8);
	response_f.setEditable(false);
	gbl.setConstraints(response_f,gbc);
	body.add(response_f);
	response_f.setEnabled(false);

	sp.add(body);

	m = new mouse();
	body.addMouseListener(m);
    }

    /*=======================================================================
     * Reset this panel so it starts fresh
     *======================================================================*/
    void reset() {
	host_f.setEditable(true);
	username_f.setEditable(true);
	challenge_f.setText("");
	challenge_f.setEditable(false);
	challenge_f.setEnabled(false);
	response_f.setText("");
	response_f.setEditable(false);
	response_f.setEnabled(false);
    }

    public void handleOK() {
	int rc;
	pktinfo pktrc;

	// If the response field is not editable, it means that we are in
	// the state where we are collecting the IP address and username
	// If it is editable, then we already have the IP and username and
	// are looking for the response to the challenge.
	if (response_f.isEditable() == false) {

	    if (host_f.getText().length() == 0) {
		fw.msgline.setText("Specify remote host");
		return;
	    }

	    // Open a socket to the remote host
	    pktrc = fw.c.openfd(host_f.getText());
	    if (pktrc.rc < 0) {
		if (fw.isMain())
		    fw.c.closefd();
		fw.msgline.setText(pktrc.errmsg);
		return;
	    }

	   // Send the login packet
	    pktrc = fw.c.sendpkt(cglue.LOGIN,cglue.CHALLENGE,
				username_f.getText(),1);
	    if (pktrc.rc < 0) {
		fw.msgline.setText(pktrc.errmsg);
		if (fw.isMain())
		    fw.c.closefd();
		return;
	    }

	    // Get the response
	    pktrc = fw.c.recvpkt(1);
	    if (pktrc.rc == fw.c.OK) {
		fw.c.passed_auth = cglue.AUTHLCL;
		fw.getFrame().setTitle("T.Rex Server " + host_f.getText());
		pktrc = fw.c.setkey(new String(), pktrc.str);
		if (pktrc.rc < 0) {
		    fw.c.closefd();
		    fw.msgline.setText(pktrc.errmsg);
		    return;
		}
		fw.newpanel(new mainmenu(this));
		return;
	    }
	    if (pktrc.rc == fw.c.CLOSED) {
		fw.msgline.setText(fw.c.EOFMSG);
		if (fw.isMain()) {
		    fw.c.closefd();
		    reset();
		}
		return;
	    }
	    if (pktrc.rc != fw.c.CONTINUE) {
		fw.msgline.setText(pktrc.errmsg);
		if (fw.isMain())
		    fw.c.closefd();
		return;
	    }

	    // Put the challenge on the panel and make the response field
	    // editable
	    host_f.setEditable(false);
	    username_f.setEditable(false);
	    challenge_f.setText(pktrc.str);
	    challenge_f.setEnabled(true);
	    response_f.setEditable(true);
	    response_f.setEnabled(true);
	    response_f.requestFocus();
	    return;
	}
	// Now we are looking for a response to the challenge
	else {
	    pktrc = fw.c.sendpkt(cglue.LOGIN,cglue.AUTH,
			response_f.getText(),1);
	    if (pktrc.rc < 0) {
		fw.msgline.setText(pktrc.errmsg);
		if (fw.isMain())
		    fw.c.closefd();
		reset();
		return;
	    }
	    pktrc = fw.c.recvpkt(1);
	    if (pktrc.rc == fw.c.OK) {
		fw.c.passed_auth = cglue.AUTHGWU;
		fw.getFrame().setTitle("T.Rex server " + host_f.getText());
		pktrc = fw.c.setkey(username_f.getText(), new String());
		if (pktrc.rc < 0) {
		    fw.msgline.setText(pktrc.errmsg);
		    return;
		}
		fw.newpanel(new mainmenu(this));
		reset();
		return;
	    }
	    if (pktrc.rc == fw.c.CLOSED) {
		fw.msgline.setText("Remote host disconnected");
		if (fw.isMain())
		    fw.c.closefd();
		reset();
		return;
	    }
	    if (pktrc.rc != fw.c.OK) {
		fw.msgline.setText(pktrc.errmsg);
		if (fw.isMain())
		    fw.c.closefd();
		reset();
		return;
	    }
	}
    }


    /*=======================================================================
     * Thois class is defined solely to put the key focus in the first
     * textfield in this panel.  It will call requestFocus() once and then
     * removes itself so it is not done again.
     *======================================================================*/
    class mouse extends MouseAdapter {
	public void mouseEntered(MouseEvent e) {
	    host_f.requestFocus();
	    body.removeMouseListener(m);
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void mouseClicked(MouseEvent e) {
	}
    }
}
