/*============================================================================
 * filename:		mgwuser.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;

public class mgwuser extends Base {
    CheckboxGroup group;
    Checkbox listshort_f;
    Checkbox listlong_f;
    TextField name_f;

    mgwuser(Base p, int component) {
	super(p,"T.Rex List GWUSER/GWGROUP Menu","Click on the desired action");
	this.component = component;
	newmm();
    }

    void newmm() {
	addBody();
	okbutton.setLabel("Continue");
	canbutton.setLabel("Return");
    }

    void addBody() {
	String ug;
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(10,10,10,10);

	if (component == fw.c.GWUSER)
	   ug = new String("users");
	else if (component == fw.c.GWGROUP)
	   ug = new String("groups");
	else {
	    fw.msgline.setText("List function with invalid component");
	    complete = false;
	    return;
	}

	gbc.gridwidth = GridBagConstraints.REMAINDER;

	group = new CheckboxGroup();

	listshort_f = new Checkbox("List " + ug,group,true);
	gbl.setConstraints(listshort_f,gbc);
	body.add(listshort_f);

	Label filler0 = new Label("");
	gbl.setConstraints(filler0,gbc);
	body.add(filler0);

	listlong_f = new Checkbox("List detailed " + ug,group,false);
	gbl.setConstraints(listlong_f,gbc);
	body.add(listlong_f);

	Label filler1 = new Label("");
	gbl.setConstraints(filler1,gbc);
	body.add(filler1);

	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label name_l = new Label("Optional " + ug + " name pattern");
	gbl.setConstraints(name_l,gbc);
	body.add(name_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	name_f = new TextField(10);
	gbl.setConstraints(name_f,gbc);
	body.add(name_f);

	Label filler2 = new Label("");
	gbl.setConstraints(filler2,gbc);
	body.add(filler2);

	sp.add(body);
    }

    void startmon(String args) {
	pktinfo pktrc;

	pktrc = fw.c.sendpkt(component, fw.c.TAILLOG, args, 1);
	if (pktrc.rc != fw.c.OK) {
	    if (pktrc.rc != cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	pktrc = fw.c.recvpkt(1);
	if (pktrc.rc != fw.c.OK) {
	    if (pktrc.rc != cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	monitor m = new monitor(this,component,"List GWUSER/GWGROUP",0);
	m.canbutton.setEnabled(false);
	fw.newpanel(m);
	m.activeThread.start();
    }

    /*=======================================================================
     * Override handleOK()
     *======================================================================*/
    public void handleOK() {
	String args;
	Checkbox cb = group.getSelectedCheckbox();

	args = new String("\"");
	args = args.concat(name_f.getText());
	args = args.concat("\"");

	// If name_f is empty then replace "" with \*
	if (args.length() == 2)
	    args = new String("\\*");

	if (cb == listshort_f) {
	    startmon(args);
	    return;
	}
	if (cb == listlong_f) {
	    startmon(args + " -a");
	    return;
	}
    }
}
