/*============================================================================
 * filename:		rpcproxyrules.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.io.*;

public class rpcproxyrules extends Rules {
    int pd;		// Holds index of the selected List object
    String fromaddr;
    String frommask;
    String fromport;
    String toaddr;
    String toport;
    String hiport;
    String destaddr;
    String destport;
    String useaddr;
    String useport;
    boolean priv;
    Choice pd_f;
    TextField fromaddr_f;
    TextField frommask_f;
    TextField fromport_f;
    TextField toaddr_f;
    TextField toport_f;
    TextField hiport_f;
    TextField destaddr_f;
    TextField destport_f;
    TextField useaddr_f;
    TextField useport_f;
    Choice priv_f;

    rpcproxyrules(fwwin p) {
	super(p);
	body.addActionListener(this);
    }

    public void addEditline() {
	GridLayout gl = new GridLayout(8,4);
	editline.setLayout(gl);

	pd_f = new Choice();
	fromaddr_f = new TextField();
	frommask_f = new TextField();
	fromport_f = new TextField();
	toaddr_f = new TextField();
	toport_f = new TextField();
	hiport_f = new TextField();
	destaddr_f = new TextField();
	destport_f = new TextField();
	useaddr_f = new TextField();
	useport_f = new TextField();
	priv_f = new Choice();

	pd_f.addItem("permit udp");
	pd_f.addItem("permit tcp");
	pd_f.addItem("permit udprpc");
	pd_f.addItem("permit tcprpc");
	pd_f.addItem("permit tftp");

	editline.add(new Label("Permit"));
	editline.add(new Label("From Address"));
	editline.add(new Label("From Address Mask"));
	editline.add(new Label("From Port"));
	editline.add(pd_f);
	editline.add(fromaddr_f);
	editline.add(frommask_f);
	editline.add(fromport_f);

	editline.add(new Label());
	editline.add(new Label("To Address"));
	editline.add(new Label("To Port"));
	editline.add(new Label("High Port (Opt)"));
	editline.add(new Label());
	editline.add(toaddr_f);
	editline.add(toport_f);
	editline.add(hiport_f);

	editline.add(new Label());
	editline.add(new Label("Dest Address"));
	editline.add(new Label("Dest Port"));
	editline.add(new Label());
	editline.add(new Label());
	editline.add(destaddr_f);
	editline.add(destport_f);
	editline.add(new Label());

	editline.add(new Label());
	editline.add(new Label("Local Address (Opt)"));
	editline.add(new Label("Local Port"));
	editline.add(new Label("Use Privilege Port"));
	editline.add(new Label());
	editline.add(useaddr_f);
	editline.add(useport_f);
	priv_f.addItem("yes");
	priv_f.addItem("no");
	priv_f.select("no");
	editline.add(priv_f);

	pd_f.addFocusListener(this);
	fromaddr_f.addFocusListener(this);
	frommask_f.addFocusListener(this);
	fromport_f.addFocusListener(this);
	toaddr_f.addFocusListener(this);
	toport_f.addFocusListener(this);
	hiport_f.addFocusListener(this);
	destaddr_f.addFocusListener(this);
	destport_f.addFocusListener(this);
	useaddr_f.addFocusListener(this);
	useport_f.addFocusListener(this);

	add("North",editline);
    }

    /*======================================================================
     * Read all the input fields on the editline and insert a new permit/deny
     * line at the selected position in the body object
     * returns the new permit/deny line read from editline
     * returns null if failed
     *=====================================================================*/
    String readEditline() {
	String newrule;
	String tmp;

	newrule = pd_f.getSelectedItem();

	newrule = newrule.concat(" from ");
	// From IP
	tmp = fromaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify from address");
	    fromaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	// Optional From Mask
	tmp = frommask_f.getText();
	if (tmp.length() > 0) {
	    newrule = newrule.concat(" mask ");
	    newrule = newrule.concat(tmp);
	}

	newrule = newrule.concat(" ");

	// From Port
	tmp = fromport_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify from port");
	    fromport_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	newrule = newrule.concat(" to ");
	// To IP
	tmp = toaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify to address");
	    toaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat(" ");

	// To Port
	tmp = toport_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify to port");
	    toport_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	// Optional High To Port
	tmp = hiport_f.getText();
	if (tmp.length() > 0) {
	    newrule = newrule.concat("-");
	    newrule = newrule.concat(tmp);
	}

	newrule = newrule.concat(" redirect ");
	// Dest IP
	tmp = destaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify destination address");
	    destaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat(" ");

	// Dest Port
	tmp = destport_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify destination port");
	    destport_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	// Optional Using IP
	tmp = useaddr_f.getText();
	if (tmp.length() > 0) {
	    newrule = newrule.concat(" using ");
	    newrule = newrule.concat(tmp);
	}

	newrule = newrule.concat(" ");
	// Using Port
	tmp = useport_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify local using port");
	    useport_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	// Optional priv flag
	tmp = priv_f.getSelectedItem();
	if (tmp.toLowerCase().equals("yes")) {
	    newrule = newrule.concat(" priv");
	}

	return(newrule);
    }

    /*======================================================================
     * Parse a permit line
     * returns 0 if successful (parsed values in the instance variables)
     * returns -1 if failed, caller should not use values in instance variables
     *=====================================================================*/
    public int readRule(String line) {
	int i;
	String tmp1,tmp2;
	StringTokenizer st = new StringTokenizer(line.trim()," \t=:");

	// Get the statement type
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Line is empty");
	    return(-1);
	}
	try {
	    tmp2 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing protocol parameter after permit");
	    return(-1);
	}

	// pd is set to the index of the selected List object
	if (tmp1.equals("permit")) {
	    if (tmp2.equals("udp"))
		pd = 0;
	    else if (tmp2.equals("tcp"))
		pd = 1;
	    else if (tmp2.equals("udprpc"))
		pd = 2;
	    else if (tmp2.equals("tcprpc"))
		pd = 3;
	    else if (tmp2.equals("tftp"))
		pd = 4;
	    else {
		fw.msgline.setText("Invalid protocol parameter after " +
			"permit");
		return(-1);
	    }
	}
	else {
	    fw.msgline.setText("Invalid statement type");
	    return(-1);
	}

	// Get the next token which is "from"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing \"from\" keyword");
	    return(-1);
	}
	if (!tmp1.equals("from")) {
	    fw.msgline.setText("Missing \"from\" keyword");
	    return(-1);
	}

	// Get the next token which is fromaddr
	try {
	    fromaddr = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing from address");
	    return(-1);
	}

	// Get the next token which can be fromport or "mask"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing from port");
	    return(-1);
	}

	// Get the from mask if "mask" is specified
	if (tmp1.equals("mask")) {
	    try {
		frommask = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing parameter for \"mask\"");
		return(-1);
	    }
	    // Now read in fromport
	    try {
		tmp1 = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing from port");
		return(-1);
	    }
	}

	fromport = tmp1;

	// Get the next token which is "to"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing \"to\" keyword");
	    return(-1);
	}

	if (!tmp1.equals("to")) {
	    fw.msgline.setText("Missing \"to\" keyword");
	    return(-1);
	}

	// Get the next token which is toaddr
	try {
	    toaddr = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing to address");
	    return(-1);
	}

	// Get the next token which is toport
	try {
	    toport = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing to port");
	    return(-1);
	}

	// If '-' is in the token, make toport and hiport out of it
	if ((i = toport.indexOf('-')) != -1) {
	    hiport = toport.substring(i+1);
	    toport = toport.substring(0,i);
	}

	// Get the next token which can be '-' or "redirect"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing \"redirect\" keyword");
	    return(-1);
	}

	if (tmp1.equals("-")) {
	    try {
		hiport = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing high port number following " +
			"\"-\"");
        	return(-1);
	    }
	    try {
		tmp1 = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing \"redirect\" keyword");
        	return(-1);
	    }
	}
	else
	    hiport = new String("");

	if (!tmp1.equals("redirect")) {
	    fw.msgline.setText("Missing \"redirect\" keyword");
	    return(-1);
	}

	// Get the next token which is destaddr
	try {
	    destaddr = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing destination address");
	    return(-1);
	}

	// Get the next token which is destport
	try {
	    destport = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing destination port");
	    return(-1);
	}

	// Get the next token which can be or "using" or useport
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing port number");
	    return(-1);
	}

	if (tmp1.equalsIgnoreCase("using")) {
	    try {
		useaddr = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing address after \"using\"");
		return(-1);
	    }
	    try {
		tmp1 = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Missing port number after \"using\"");
		return(-1);
	    }
	}
	else
	    useaddr = new String("");

	useport = tmp1;

	// Get the next token which can be "priv"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    tmp1 = new String("");
	}

	priv_f.select("no");
	if (tmp1.length() > 0 && !tmp1.equalsIgnoreCase("priv")) {
	    fw.msgline.setText("Unrecognizable keyword " + tmp1);
	    return(-1);
	}
	else if (tmp1.equalsIgnoreCase("priv"))
	    priv_f.select("yes");

	pd_f.select(pd);
	fromaddr_f.setText(fromaddr);
	frommask_f.setText(frommask);
	fromport_f.setText(fromport);
	toaddr_f.setText(toaddr);
	toport_f.setText(toport);
	hiport_f.setText(hiport);
	destaddr_f.setText(destaddr);
	destport_f.setText(destport);
	useaddr_f.setText(useaddr);
	useport_f.setText(useport);

	return (0);
    }
}
