/*============================================================================
 * filename:		smwrap.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class smwrap extends Base {
    Choice	aliasreq_f;
    boolean	aliasreq;
    TextField	groupid_f;
    String	groupid;
    TextField	maxchildren_f;
    String	maxchildren;
    TextField	maxbytes_f;
    String	maxbytes;
    TextField	maxreceipts_f;
    String	maxreceipts;
    TextField	postoffice_f;
    String	postoffice;
    TextField	smtppath_f;
    String	smtppath;
    TextField	smwpdpath_f;
    String	smwpdpath;
    TextField	spoolpath_f;
    String	spoolpath;
    TextField	undelivpath_f;
    String	undelivpath;
    TextField	userid_f;
    String	userid;
    TextField	timeout_f;
    String	timeout;
    Choice	trace_f;
    boolean	trace;
    TextField	wakeup_f;
    String	wakeup;
    smwraprules	rules_f;
    pktinfo pktrc;
    String capname;

    smwrap(Base p) {
	super(p,"SMWRAP","");
	addBody();
    }

    void addBody() {
	int rc;

	component = fw.c.SMWRAP;
	capname = new String("SMWRAP");
	lowname = new String("smwrap");

	// Initialize the values for this panel
	aliasreq = false;
	groupid = new String("staff");
	maxchildren = new String("10");
	maxbytes = new String("1500000");
	maxreceipts = new String("100");
	postoffice = new String("");
	smtppath = new String("/usr/lib/sendmail");
	smwpdpath = new String("/usr/local/etc");
	spoolpath = new String("/home/hermes");
	undelivpath = new String("/home/hermes/sequestered");
	userid = new String("hermes");
	timeout = new String("600");
	trace = false;
	wakeup = new String("60");

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	// Get the config file over here to a temp file
	pktrc = download();
	tmpfn = pktrc.str;

	if (pktrc.rc != fw.c.OK) {
	    complete = false;
	    return;
	}

	// Construct the rules box now so it can collect permit/deny lines
	// while we read the config file
	rules_f = new smwraprules(fw);

	// Read in the temp file
	if ((rc = readconf()) == fw.c.FAILED) {
	    fw.c.closefd();
	    fw.newpanel(fw.getTop());
	}

	if (rc < 0)
	    return;

	gbc.anchor = GridBagConstraints.WEST;
	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button edit_b = new Button("Edit");
	edit_b.addActionListener(this);
	gbl.setConstraints(edit_b,gbc);
	body.add(edit_b);

	// User id
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label userid_l = new Label("User name to run smwrap and smwrapd under");
	gbl.setConstraints(userid_l,gbc);
	body.add(userid_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	userid_f = new TextField(userid,8);
	gbl.setConstraints(userid_f,gbc);
	body.add(userid_f);
	userid_f.addFocusListener(this);

	// Group id
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label groupid_l = new Label("Group name to run smwrap and smwrapd " +
		"under");
	gbl.setConstraints(groupid_l,gbc);
	body.add(groupid_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	groupid_f = new TextField(groupid,8);
	gbl.setConstraints(groupid_f,gbc);
	body.add(groupid_f);
	groupid_f.addFocusListener(this);

	// Max bytes
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxbytes_l = new Label("Maximum size in bytes for a single " +
		"piece of mail");
	gbl.setConstraints(maxbytes_l,gbc);
	body.add(maxbytes_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxbytes_f = new TextField(maxbytes,8);
	gbl.setConstraints(maxbytes_f,gbc);
	body.add(maxbytes_f);
	maxbytes_f.addFocusListener(this);

	// Max receipients
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxreceipts_l = new Label("Maximum number of recipients " +
		"allowed for a piece of mail");
	gbl.setConstraints(maxreceipts_l,gbc);
	body.add(maxreceipts_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxreceipts_f = new TextField(maxreceipts,8);
	gbl.setConstraints(maxreceipts_f,gbc);
	body.add(maxreceipts_f);
	maxreceipts_f.addFocusListener(this);

	// Max children
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label maxchildren_l = new Label("Maximum number of processes " +
		"for processing mail");
	gbl.setConstraints(maxchildren_l,gbc);
	body.add(maxchildren_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	maxchildren_f = new TextField(maxchildren,8);
	gbl.setConstraints(maxchildren_f,gbc);
	body.add(maxchildren_f);
	maxchildren_f.addFocusListener(this);

	// smwpdpath
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label smwpdpath_l = new Label("Fully qualified directory name for " +
		"the smwrapd daemon");
	gbl.setConstraints(smwpdpath_l,gbc);
	body.add(smwpdpath_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	smwpdpath_f = new TextField(smwpdpath,20);
	gbl.setConstraints(smwpdpath_f,gbc);
	body.add(smwpdpath_f);
	smwpdpath_f.addFocusListener(this);

	// spoolpath
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label spoolpath_l = new Label("Fully qualified directory name for " +
		"spooling mail files");
	gbl.setConstraints(spoolpath_l,gbc);
	body.add(spoolpath_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	spoolpath_f = new TextField(spoolpath,20);
	gbl.setConstraints(spoolpath_f,gbc);
	body.add(spoolpath_f);
	spoolpath_f.addFocusListener(this);

	// undelivpath
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label undelivpath_l = new Label("Fully qualified directory name for " +
		"sequestered files");
	gbl.setConstraints(undelivpath_l,gbc);
	body.add(undelivpath_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	undelivpath_f = new TextField(undelivpath,20);
	gbl.setConstraints(undelivpath_f,gbc);
	body.add(undelivpath_f);
	undelivpath_f.addFocusListener(this);

	// smtppath
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label smtppath_l = new Label("Fully qualified file name for the " +
		"sendmail program");
	gbl.setConstraints(smtppath_l,gbc);
	body.add(smtppath_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	smtppath_f = new TextField(smtppath,20);
	gbl.setConstraints(smtppath_f,gbc);
	body.add(smtppath_f);
	smtppath_f.addFocusListener(this);

	// timeout
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label timeout_l = new Label("Maximum seconds to wait for a message");
	gbl.setConstraints(timeout_l,gbc);
	body.add(timeout_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	timeout_f = new TextField(timeout,4);
	gbl.setConstraints(timeout_f,gbc);
	body.add(timeout_f);
	timeout_f.addFocusListener(this);

	// wakeup
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label wakeup_l = new Label("Interval in seconds for smwrapd " +
		"processing");
	gbl.setConstraints(wakeup_l,gbc);
	body.add(wakeup_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	wakeup_f = new TextField(wakeup,4);
	gbl.setConstraints(wakeup_f,gbc);
	body.add(wakeup_f);
	wakeup_f.addFocusListener(this);

	// aliasreq
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label aliasreq_l = new Label("Requires smwrap alias " +
		"to send outbound mail");
	gbl.setConstraints(aliasreq_l,gbc);
	body.add(aliasreq_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	aliasreq_f = new Choice();
	aliasreq_f.addItem("Yes");
	aliasreq_f.addItem("No");
	if (aliasreq)
	    aliasreq_f.select("Yes");
	else
	    aliasreq_f.select("No");
	gbl.setConstraints(aliasreq_f,gbc);
	body.add(aliasreq_f);
	aliasreq_f.addFocusListener(this);

	// trace
	gbc.gridwidth = GridBagConstraints.RELATIVE;
	Label trace_l = new Label("Turn trace on");
	gbl.setConstraints(trace_l,gbc);
	body.add(trace_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	trace_f = new Choice();
	trace_f.addItem("Yes");
	trace_f.addItem("No");
	if (trace)
	    trace_f.select("Yes");
	else
	    trace_f.select("No");
	gbl.setConstraints(trace_f,gbc);
	body.add(trace_f);
	trace_f.addFocusListener(this);

	gbl.setConstraints(rules_f,gbc);
	body.add(rules_f);

	sp.add(body);
    }

    /*=======================================================================
     * Reads the temp file in and interpret it
     *
     * Returns 0 if successful
     *		-1 if failed
     *		NONFATAL if connection need not be closed
     *
     *======================================================================*/
    int readconf() {
	int fd;
	if (tmpfn.equals("")) {
	    fw.msgline.setText("Internal error: " + lowname + " config " +
			"file has not been downloaded yet");
	    return(fw.c.NONFATAL);
	}
	File tmpfile = new File(tmpfn);
	if (!tmpfile.exists() || !tmpfile.isFile()) {
	    fw.msgline.setText("Internal error: the downloaded " +
			lowname + " conf file cannot be found");
	    return(fw.c.NONFATAL);
	}

	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	while ( true ) {
	    String tmp;
	    String statement;

	    pktrc = fw.c.cbcreadLine(fd);
	    if (pktrc.rc != cglue.OK) {
		if (pktrc.rc == cglue.CLOSED)
		    break;
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(pktrc.rc);
	    }

	    // Exit loop at EOF
	    if (pktrc.str == null)
		break;

	    lineno++;

	    // Get rid of comment lines (first character is #) and empty lines
	    if (pktrc.str.trim().length() == 0 ||
			pktrc.str.trim().substring(0,1).equals("#"))
		continue;

	    StringTokenizer st = new StringTokenizer(pktrc.str.trim()," \t=:");

	    // Get the statement type
	    try {
		statement = st.nextToken().toLowerCase();
	    } catch (NoSuchElementException e) {
		continue;
	    }

	    // Get the next token into tmp - ignore error with no token found
	    // We do this here so we don't have to do a "try" for every
	    // statement type
	    try {
		tmp = st.nextToken();
	    } catch (NoSuchElementException e) {
		complete = false;
		fw.c.closefile(fd);
		tmpfile.delete();
		fw.newpanel(new edit(this,parent_panel,"EDIT " + capname));
		fw.msgline.setText("Highlighted line contains an " +
			"invalid statement, please correct and retry");
		return(fw.c.NONFATAL);
	    }

	    if (statement.equals("aliasreq")) {
		if (tmp.toLowerCase().equals("yes"))
		    aliasreq = true;
		continue;
	    }

	    if (statement.equals("groupid")) {
		groupid = tmp;
		continue;
	    }

	    if (statement.equals("maxbytes")) {
		maxbytes = tmp;
		continue;
	    }

	    if (statement.equals("maxchildren")) {
		maxchildren = tmp;
		continue;
	    }

	    if (statement.equals("maxreceipts")) {
		maxreceipts = tmp;
		continue;
	    }

	    if (statement.equals("smtppath")) {
		smtppath = tmp;
		continue;
	    }

	    if (statement.equals("smwpdpath")) {
		smwpdpath = tmp;
		continue;
	    }

	    if (statement.equals("spoolpath")) {
		spoolpath = tmp;
		continue;
	    }

	    if (statement.equals("undelivpath")) {
		undelivpath = tmp;
		continue;
	    }

	    if (statement.equals("userid")) {
		userid = tmp;
		continue;
	    }

	    if (statement.equals("timeout")) {
		timeout = tmp;
		continue;
	    }

	    if (statement.equals("trace")) {
		if (tmp.toLowerCase().equals("yes"))
		    trace = true;
		continue;
	    }

	    if (statement.equals("wakeup")) {
		wakeup = tmp;
		continue;
	    }

	    if (statement.equals("permit") || statement.equals("deny")) {
		rules_f.body.addItem(pktrc.str);
		continue;
	    }

	    // Invalid statement
	    complete = false;
	    fw.c.closefile(fd);
	    fw.newpanel(new edit(this,parent_panel,"EDIT " + capname));
	    fw.msgline.setText("Highlighted line contains an invalid " +
		"statement, please correct and retry");
	    return(fw.c.NONFATAL);
	}

	// Add an end marker so the user can insert after the last real rule
	rules_f.body.addItem("[end marker]");

	// Delete the temp file since we no longer need it
	fw.c.closefile(fd);
	tmpfile.delete();
	return (0);
    }

    public void handleOK() {

	if (saveconf() < 0)
	    return;

	pktrc = upload();
	if (pktrc.rc < 0)
	    return;

	fw.msgline.setText("New " + lowname + " config file " +
		"successfully created");
	fw.newpanel(parent_panel);
    }

    public int saveconf() {
	int fd;
	File outfile;
	String tmp;

	outfile = new File(tmpfn);

	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    return(pktrc.rc);
	}

	fd = pktrc.rc;

	// aliasreq statement
	if (aliasreq_f.getSelectedItem().toLowerCase().equals("yes"))
	    tmp = new String("yes");
	else
	    tmp = new String("no");
	pktrc = fw.c.cbcwriteLine(fd, "aliasreq = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// groupid statement
	pktrc = fw.c.cbcwriteLine(fd, "groupid = " + groupid_f.getText() +
							"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// maxbytes statement
	pktrc = fw.c.cbcwriteLine(fd, "maxbytes = " + maxbytes_f.getText() +
							"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// maxchildren statement
	pktrc = fw.c.cbcwriteLine(fd, "maxchildren = " +
				maxchildren_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// maxreceipts statement
	pktrc = fw.c.cbcwriteLine(fd, "maxreceipts = " +
				maxreceipts_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// smtppath statement
	pktrc = fw.c.cbcwriteLine(fd, "smtppath = " +
				smtppath_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// smwpdpath statement
	pktrc = fw.c.cbcwriteLine(fd, "smwpdpath = " +
				smwpdpath_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// spoolpath statement
	pktrc = fw.c.cbcwriteLine(fd, "spoolpath = " +
				spoolpath_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// undelivpath statement
	pktrc = fw.c.cbcwriteLine(fd, "undelivpath = " +
				undelivpath_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// userid statement
	pktrc = fw.c.cbcwriteLine(fd, "userid = " +
				userid_f.getText() + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// timeout statement
	pktrc = fw.c.cbcwriteLine(fd, "timeout = " + timeout_f.getText() +
						"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	// trace statement
	if (trace_f.getSelectedItem().toLowerCase().equals("yes"))
	    tmp = new String("yes");
	else
	    tmp = new String("no");
	pktrc = fw.c.cbcwriteLine(fd, "trace = " + tmp + "\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}


	// wakeup statement
	pktrc = fw.c.cbcwriteLine(fd, "wakeup = " + wakeup_f.getText() +
						"\n");
	if (pktrc.rc != cglue.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(fd);
	    return(-1);
	}

	//permit/deny rules
	// Note that we only process n - 1 lines, the last one is the
	// end marker
	for (int i = 0; i < rules_f.body.getItemCount() - 1; i++) {
	    pktrc = fw.c.cbcwriteLine(fd, rules_f.body.getItem(i) + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(fd);
		return(-1);
	    }
	}
	fw.c.closefile(fd);

	return(0);
    }

    // Add processing code for the edit button
    protected boolean moreAction(String s) {
	if ("Edit".equals(s)) {
	    lineno = 0;		// Don't want edit to highlight any lines
	    saveconf();
	    fw.newpanel(new edit(this,parent_panel,"EDIT " + capname));
	    return(true);
	}
	return(false);
    }
}
