/*============================================================================
 * filename:		smwraprules.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

// deny from src_addr to rcpt_addr [block|forward|sequester]
// permit from src_addr to rcpt_addr

public class smwraprules extends Rules implements ItemListener {
    Choice	pd_f;
    int		pd;
    TextField	fromaddr_f;
    String	fromaddr;
    TextField	toaddr_f;
    String	toaddr;
    Choice	disp_f;
    int		disp;
    TextField	forwaddr_f;
    String	forwaddr;

    smwraprules(fwwin p) {
	super(p);
	body.addActionListener(this);
    }

    public void addEditline() {
	GridLayout gl = new GridLayout(2,5);
	editline.setLayout(gl);

	editline.add(new Label("Permit/Deny"));
	editline.add(new Label("From Address"));
	editline.add(new Label("To Address"));
	editline.add(new Label("Disposition"));
	editline.add(new Label("Forward Address"));

	pd_f = new Choice();
	fromaddr_f = new TextField();
	toaddr_f = new TextField();
	disp_f = new Choice();
	forwaddr_f = new TextField();

	pd_f.addItem("permit");
	pd_f.addItem("deny");
	pd_f.select("deny");
	editline.add(pd_f);
	editline.add(fromaddr_f);
	editline.add(toaddr_f);
	disp_f.addItem("block");
	disp_f.addItem("sequester");
	disp_f.addItem("forward");
	disp_f.select("block");
	editline.add(disp_f);
	editline.add(forwaddr_f);

	pd_f.addItemListener(this);
	pd_f.addFocusListener(this);
	fromaddr_f.addFocusListener(this);
	toaddr_f.addFocusListener(this);
	disp_f.addItemListener(this);
	disp_f.addFocusListener(this);
	forwaddr_f.addFocusListener(this);

	add("North",editline);
    }

    /*======================================================================
     * Read all the input fields on the editline and insert a new permit/deny
     * line at the selected position in the body object
     * returns the new permit/deny line read from editline
     * returns null if failed
     *=====================================================================*/
    String readEditline() {
	String newrule;
	String tmp;
	String pd;

	pd = pd_f.getSelectedItem();
	newrule = pd;

	newrule = newrule.concat(" from ");
	tmp = fromaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify from address");
	    fromaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	newrule = newrule.concat(" to ");
	tmp = toaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify to address");
	    toaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);

	if (pd.equals("deny")) {
	    tmp = disp_f.getSelectedItem();
	    newrule = newrule.concat(" ");
	    newrule = newrule.concat(tmp);

	    if (tmp.equals("forward")) {
		tmp = forwaddr_f.getText();
		if (tmp.length() == 0) {
		    focus_prompt = new String("No address specified " +
			"for forward mail"); 
		    forwaddr_f.requestFocus();
		    return(null);
		}
		newrule = newrule.concat(" ");
		newrule = newrule.concat(tmp);
	    }
	}

	return(newrule);
    }

    /*======================================================================
     * Parse a permit/deny line
     * returns 0 if successful (parsed values in the instance variables)
     * returns -1 if failed, caller should not use values in instance variables
     *=====================================================================*/
    public int readRule(String line) {
	String tmp1,tmp2;
	StringTokenizer st = new StringTokenizer(line.trim()," \t=:");

	// Get the statement type
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Line is empty");
	    return(-1);
	}

	// pd is set to the index of the selected List object
	if (tmp1.equals("permit"))
	    pd = 0;
	else if (tmp1.equals("deny"))
	    pd = 1;
	else {
	    fw.msgline.setText("Statement type not \"permit\" or \"deny\"");
	    return(-1);
	}

	// Get the next token which is "from"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing \"from\" keyword");
	    return(-1);
	}
	if (!tmp1.equals("from")) {
	    fw.msgline.setText("Missing \"from\" keyword");
	    return(-1);
	}

	// Get the next token which is fromaddr
	try {
	    fromaddr = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing from address");
	    return(-1);
	}

	// Get the next token which is "to"
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing \"to\" keyword");
	    return(-1);
	}
	if (!tmp1.equals("to")) {
	    fw.msgline.setText("Missing \"to\" keyword");
	    return(-1);
	}

	// Get the next token which is toaddr
	try {
	    toaddr = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Missing to address");
	    return(-1);
	}

	// Get the next optional token which is disposition
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    pd_f.select(pd);
	    fromaddr_f.setText(fromaddr);
	    toaddr_f.setText(toaddr);
	    disp_f.select(0);
	    forwaddr_f.setText(new String());
	    forwaddr_f.setEnabled(false);
	    if (pd == 0) {
		disp_f.setEnabled(false);
	    }
	    else
		disp_f.setEnabled(true);
	    return(0);
	}

	// If permit, the presence of an optional argument is invalid
	if (pd == 0) {
	    fw.msgline.setText("\"block\", \"sequester\" and \"forward\" " +
			"are invalid on \"permit\" lines");
	    return(-1);
	}

	disp_f.setEnabled(true);

	if (tmp1.equals("block"))
	    disp = 0;
	else if (tmp1.equals("sequester"))
	    disp = 1;
	else if (tmp1.equals("forward"))
	    disp = 2;
	else {
	    fw.msgline.setText("Disposition parameter must be " +
			"\"block\", \"sequester\" or \"forward\"");
	    return(-1);
	}

	disp_f.select(disp);

	// Get the next optional token which is forward address
	try {
	    tmp1 = st.nextToken().toLowerCase();
	} catch (NoSuchElementException e) {
	    if (disp == 2) {
		fw.msgline.setText("Missing forward address following " +
			"\"forward\" keyword");
		return(-1);
	    }
	    else {
		pd_f.select(pd);
		fromaddr_f.setText(fromaddr);
		toaddr_f.setText(toaddr);
		disp_f.select(disp);
		forwaddr_f.setText(new String(""));
		forwaddr_f.setEnabled(false);
		return(0);
	    }
	}

	// If not "forward", optional forward address is invalid
	if (disp !=2) {
	    fw.msgline.setText("Forward address is not valid following " +
			"\"block\" and \"sequester\"");
	    return(-1);
	}

	forwaddr = tmp1;
	pd_f.select(pd);
	fromaddr_f.setText(fromaddr);
	toaddr_f.setText(toaddr);
	disp_f.select(disp);
	forwaddr_f.setText(forwaddr);
	forwaddr_f.setEnabled(true);

	return (0);
    }

    /*=================================================================
     * The listener catches state changes for permit/deny and
     * for block/sequester/forward so that it can enable/disable
     * appropriate fields on the editline.
     *================================================================*/
    public void itemStateChanged(ItemEvent e) {
	String s = (String) e.getItem();
	// If changed from permit to deny, enable the disposition field
	if (s.equals("deny")) {
	    disp_f.setEnabled(true);
	    // If disposition is "forward", enable the forward address field
	    if (disp_f.getSelectedItem().equals("forward"))
		forwaddr_f.setEnabled(true);
	}
	// If changed from deny to permit, disable both disposition and
	// forward address
	else if (s.equals("permit")) {
	    disp_f.setEnabled(false);
	    if (forwaddr_f.isEnabled())
		forwaddr_f.setEnabled(false);
	}
	// If disposition changed to "forward", enable forward address
	else if (s.equals("forward"))
	    forwaddr_f.setEnabled(true);
	// If dispositon changed to anything other than "forward", disable
	// forward address
	else if (s.equals("block") || s.equals("sequester"))
	    forwaddr_f.setEnabled(false);
    }
}
