/*============================================================================
 * filename:		sockdcrules.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	January   30, 2000
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.io.*;

public class sockdrules extends Rules {
    int		pd;		// Holds index of the selected List object
    boolean client;
    final static int CLIENT = 0;
    final static int SERVER = 1;
    String	fromaddr;
    String	frommask;
    String	destaddr;
    String	destmask;
    int		op;
    String	port;
    String	command;

    Choice	pd_c;
    TextField	fromaddr_f;
    TextField	frommask_f;
    TextField	destaddr_f;
    TextField	destmask_f;
    Choice	op_c;;
    TextField	port_f;
    Checkbox	logerror_cb;
    Checkbox	logconn_cb;
    Checkbox	logdisconn_cb;
    Checkbox	logdata_cb;
    Checkbox	logio_cb;
    Checkbox	cmdbind_cb;
    Checkbox	cmdbindreply_cb;
    Checkbox	cmdconnect_cb;
    Checkbox	cmdudpassoc_cb;
    Checkbox	cmdudpreply_cb;
    Checkbox	protcp_cb;
    Checkbox	proudp_cb;
    Choice	prox_c;
    GridBagLayout gbl;
    Label	destaddr_l;
    Label	destmask_l;

    sockdrules(fwwin p, int cs) {
	super(p);
	if (cs != CLIENT) {
	    client = false;
	    addServer();
	}
	else
	    client = true;
	body.addActionListener(this);
    }

    public void addEditline() {

	GridBagLayout gbl = new GridBagLayout();
	this.gbl = gbl;		// Save for addServer()
	GridBagConstraints gbc = new GridBagConstraints();
	editline.setLayout(gbl);
	gbc.anchor = GridBagConstraints.WEST;

	pd_c = new Choice();
	fromaddr_f = new TextField(12);
	frommask_f = new TextField(12);
	destaddr_f = new TextField(12);
	destmask_f = new TextField(12);
	op_c = new Choice();
	port_f = new TextField(9);
	logerror_cb = new Checkbox("error");
	logconn_cb = new Checkbox("connect");
	logdisconn_cb = new Checkbox("disconnect");
	logdata_cb = new Checkbox("data");
	logio_cb = new Checkbox("iooperation");
	cmdbind_cb = new Checkbox("bind");
	cmdbindreply_cb = new Checkbox("bindreply");
	cmdconnect_cb = new Checkbox("connect");
	cmdudpassoc_cb = new Checkbox("udpassociate");
	cmdudpreply_cb = new Checkbox("udpreply");
	protcp_cb = new Checkbox("tcp");
	proudp_cb = new Checkbox("udp");
	prox_c = new Choice();

	pd_c.addItem("permit");
	pd_c.addItem("deny");
	pd_c.select(1);

	gbc.gridwidth = 1;
	Label pd_l = new Label("Permit/Deny");
	gbl.setConstraints(pd_l,gbc);
	editline.add(pd_l);

	gbc.gridwidth = 1;
	Label fromaddr_l = new Label("From Address");
	gbl.setConstraints(fromaddr_l,gbc);
	editline.add(fromaddr_l);

	gbc.gridwidth = 1;
	Label frommask_l = new Label("From Addr Mask");
	gbl.setConstraints(frommask_l,gbc);
	editline.add(frommask_l);

	gbc.gridwidth = 1;
	destaddr_l = new Label("Local Address");
	gbl.setConstraints(destaddr_l,gbc);
	editline.add(destaddr_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	destmask_l = new Label("Local Addr Mask");
	gbl.setConstraints(destmask_l,gbc);
	editline.add(destmask_l);

	gbc.gridwidth = 1;
	gbl.setConstraints(pd_c,gbc);
	editline.add(pd_c);

	gbc.gridwidth = 1;
	gbl.setConstraints(fromaddr_f,gbc);
	editline.add(fromaddr_f);

	gbc.gridwidth = 1;
	gbl.setConstraints(frommask_f,gbc);
	editline.add(frommask_f);

	gbc.gridwidth = 1;
	gbl.setConstraints(destaddr_f,gbc);
	editline.add(destaddr_f);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(destmask_f,gbc);
	editline.add(destmask_f);

	gbc.gridwidth = 1;
	Label l5 = new Label();
	gbl.setConstraints(l5,gbc);
	editline.add(l5);

	gbc.gridwidth = 1;
	Label op_l = new Label("Port op");
	gbl.setConstraints(op_l,gbc);
	editline.add(op_l);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Label port_l = new Label("Port Number");
	gbl.setConstraints(port_l,gbc);
	editline.add(port_l);

	gbc.gridwidth = 1;
	Label l6 = new Label();
	gbl.setConstraints(l6,gbc);
	editline.add(l6);

	gbc.gridwidth = 1;
	gbl.setConstraints(op_c,gbc);
	editline.add(op_c);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(port_f,gbc);
	editline.add(port_f);

	op_c.addItem("None");
	op_c.addItem("=");
	op_c.addItem("!=");
	op_c.addItem("<");
	op_c.addItem(">");
	op_c.addItem("<=");
	op_c.addItem(">=");
	op_c.select(0);

	gbc.gridwidth = 1;
	Label l7 = new Label();
	gbl.setConstraints(l7,gbc);
	editline.add(l7);

	Panel log_p = new Panel();
	log_p.setLayout(gbl);
	Label log_l = new Label("Log:");
	log_p.add(log_l);

	log_p.add(logerror_cb);
	log_p.add(logconn_cb);
	log_p.add(logdisconn_cb);
	log_p.add(logdata_cb);
	log_p.add(logio_cb);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(log_p,gbc);
	editline.add(log_p);

	pd_c.addFocusListener(this);
	fromaddr_f.addFocusListener(this);
	frommask_f.addFocusListener(this);
	destaddr_f.addFocusListener(this);
	destmask_f.addFocusListener(this);
	op_c.addFocusListener(this);
	port_f.addFocusListener(this);
	logerror_cb.addFocusListener(this);
	logconn_cb.addFocusListener(this);
	logdisconn_cb.addFocusListener(this);
	logdata_cb.addFocusListener(this);
	logio_cb.addFocusListener(this);
	cmdbind_cb.addFocusListener(this);
	cmdbindreply_cb.addFocusListener(this);
	cmdconnect_cb.addFocusListener(this);
	cmdudpassoc_cb.addFocusListener(this);
	cmdudpreply_cb.addFocusListener(this);
	protcp_cb.addFocusListener(this);
	proudp_cb.addFocusListener(this);
	prox_c.addFocusListener(this);

	add("North",editline);
    }

    void addServer() {
	GridBagConstraints gbc = new GridBagConstraints();
	gbc.anchor = GridBagConstraints.WEST;

	gbc.gridwidth = 1;
	Label l8 = new Label();
	gbl.setConstraints(l8,gbc);
	editline.add(l8);

	Panel cmd_p = new Panel();
	cmd_p.setLayout(gbl);
	Label cmd_l = new Label("Command:");
	cmd_p.add(cmd_l);

	cmd_p.add(cmdbind_cb);
	cmd_p.add(cmdbindreply_cb);
	cmd_p.add(cmdconnect_cb);
	cmd_p.add(cmdudpassoc_cb);
	cmd_p.add(cmdudpreply_cb);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(cmd_p,gbc);
	editline.add(cmd_p);

	gbc.gridwidth = 1;
	Label l9 = new Label();
	gbl.setConstraints(l9,gbc);
	editline.add(l9);

	Panel pro_p = new Panel();
	pro_p.setLayout(gbl);
	Label pro_l = new Label("Protocol:");
	pro_p.add(pro_l);

	pro_p.add(protcp_cb);
	pro_p.add(proudp_cb);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(pro_p,gbc);
	editline.add(pro_p);

	gbc.gridwidth = 1;
	Label l10 = new Label();
	gbl.setConstraints(l10,gbc);
	editline.add(l10);

	Panel prox_p = new Panel();
	prox_p.setLayout(gbl);
	Label prox_l = new Label("Proxy:");
	prox_p.add(prox_l);

	prox_c.addItem("socks_v4");
	prox_c.addItem("socks_v5");
	prox_p.add(prox_c);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	gbl.setConstraints(prox_p,gbc);
	editline.add(prox_p);

	destaddr_l.setText("Dest Address");
	destmask_l.setText("Dest Addr Mask");

	editline.invalidate();
    }

    /*======================================================================
     * Read all the input fields on the editline and insert a new permit/deny
     * line at the selected position in the body object
     * returns the new permit/deny line read from editline
     * returns null if failed
     *=====================================================================*/
    String readEditline() {
	String newrule;
	String tmp;
	boolean portop = false;
	int tmpint;

	if (client)
	    newrule = new String("client ");
	else
	    newrule = new String();
	tmp = pd_c.getSelectedItem();
	if (tmp.equals("permit"))
	    newrule = newrule.concat("pass { ");
	else
	    newrule = newrule.concat("block { ");

	// From IP
	newrule = newrule.concat("from: ");
	tmp = fromaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify from address");
	    fromaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat("/");

	// From Mask
	tmp = frommask_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify from mask");
	    frommask_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat(" ");

	// Dest IP
	newrule = newrule.concat("to: ");
	tmp = destaddr_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify dest address");
	    destaddr_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat("/");

	// Dest Mask
	tmp = destmask_f.getText();
	if (tmp.length() == 0) {
	    focus_prompt = new String("Must specify dest mask");
	    destmask_f.requestFocus();
	    return(null);
	}
	newrule = newrule.concat(tmp);
	newrule = newrule.concat(" ");

	// Port op
	tmpint = op_c.getSelectedIndex();
	if (tmpint > 0) {
	    portop = true;
	    tmp = op_c.getSelectedItem();
	    newrule = newrule.concat("port ");
	    newrule = newrule.concat(op_c.getSelectedItem());
	    newrule = newrule.concat(" ");
	}

	// Port
	tmp = port_f.getText();
	if (tmpint > 0) {
	    if (!portop)
		newrule = newrule.concat("port ");
	    newrule = newrule.concat(tmp);
	    newrule = newrule.concat(" ");
	}
	else if (portop) {
	    focus_prompt = new String("Must specify a port number when a " +
				"port comparison is selected");
	    port_f.requestFocus();
	    return(null);
	}

	// log:
	String logops = new String();
	if (logerror_cb.getState()) {
	    logops = logops.concat(logerror_cb.getLabel());
	    logops = logops.concat(" ");
	}
	if (logconn_cb.getState()) {
	    logops = logops.concat(logconn_cb.getLabel());
	    logops = logops.concat(" ");
	}
	if (logdisconn_cb.getState()) {
	    logops = logops.concat(logdisconn_cb.getLabel());
	    logops = logops.concat(" ");
	}
	if (logdata_cb.getState()) {
	    logops = logops.concat(logdata_cb.getLabel());
	    logops = logops.concat(" ");
	}
	if (logio_cb.getState()) {
	    logops = logops.concat(logio_cb.getLabel());
	    logops = logops.concat(" ");
	}
	if (logops.length() > 0) {
	    newrule = newrule.concat("log: ");
	    newrule = newrule.concat(logops);
	}

	if (!client) {
	    // command:
	    String cmdops = new String();
	    if (cmdbind_cb.getState()) {
		cmdops = cmdops.concat(cmdbind_cb.getLabel());
		cmdops = cmdops.concat(" ");
	    }
	    if (cmdbindreply_cb.getState()) {
		cmdops = cmdops.concat(cmdbindreply_cb.getLabel());
		cmdops = cmdops.concat(" ");
	    }
	    if (cmdconnect_cb.getState()) {
		cmdops = cmdops.concat(cmdconnect_cb.getLabel());
		cmdops = cmdops.concat(" ");
	    }
	    if (cmdudpassoc_cb.getState()) {
		cmdops = cmdops.concat(cmdudpassoc_cb.getLabel());
		cmdops = cmdops.concat(" ");
	    }
	    if (cmdudpreply_cb.getState()) {
		cmdops = cmdops.concat(cmdudpreply_cb.getLabel());
		cmdops = cmdops.concat(" ");
	    }
	    if (cmdops.length() > 0) {
		newrule = newrule.concat("command: ");
		newrule = newrule.concat(cmdops);
	    }

	    // protocol:
	    String proops = new String();
	    if (protcp_cb.getState()) {
		proops = proops.concat(protcp_cb.getLabel());
		proops = proops.concat(" ");
	    }
	    if (proudp_cb.getState()) {
		proops = proops.concat(proudp_cb.getLabel());
		proops = proops.concat(" ");
	    }
	    if (proops.length() > 0) {
		newrule = newrule.concat("protocol: ");
		newrule = newrule.concat(proops);
	    }

	    // proxyprotocol:
	    newrule = newrule.concat("proxyprotocol: ");
	    newrule = newrule.concat(prox_c.getSelectedItem());
	    newrule = newrule.concat(" ");
	}

	newrule = newrule.concat("}");

	return(newrule);
    }

    /*======================================================================
     * Parse a permit line
     * returns 0 if successful (parsed values in the instance variables)
     * returns -1 if failed, caller should not use values in instance variables
     *=====================================================================*/
    public int readRule(String line) {
	int i;
	boolean logerror, logconn, logdisconn, logdata, logio;
	boolean cmdbind, cmdbindreply, cmdconnect, cmdudpassoc, cmdudpreply;
	boolean protcp, proudp;
	int prox;
	String tmp1,tmp2;
	StringTokenizer st = new StringTokenizer(line.trim()," \t{}");

	// initialize the optional fields first
	destaddr_f.setText("");
	destmask_f.setText("");
	op_c.select(0);
	port_f.setText("");
	logerror = false;
	logerror_cb.setState(false);
	logconn = false;
	logconn_cb.setState(false);
	logdisconn = false;
	logdisconn_cb.setState(false);
	logdata = false;
	logdata_cb.setState(false);
	logio = false;
	logio_cb.setState(false);
	cmdbind = false;
	cmdbind_cb.setState(false);
	cmdbindreply = false;
	cmdbindreply_cb.setState(false);
	cmdconnect = false;
	cmdconnect_cb.setState(false);
	cmdudpassoc = false;
	cmdudpassoc_cb.setState(false);
	cmdudpreply = false;
	cmdudpreply_cb.setState(false);
	protcp = false;
	protcp_cb.setState(false);
	proudp = false;
	proudp_cb.setState(false);
	prox = 0;
	if (!client)
	    prox_c.select(0);

	// Get the statement type
	try {
	    tmp1 = st.nextToken().toLowerCase();	// "client"
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("Encountered an empty line");
	    return(-1);
	}

	if (!tmp1.equals("client") && !tmp1.equals("pass") &&
		!tmp1.equals("block")) {
	    fw.msgline.setText("Invalid statement type " + tmp1);
	    return(-1);
	}
	if (tmp1.equals("client")) {
	    try {
		tmp2 = st.nextToken().toLowerCase();	// "pass" or "block"
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("Encountered an incomplete line");
		return(-1);
	    }
	}
	else
	    tmp2 = tmp1;	// Make tmp2 "pass" or "block"

	// pd is set to the index of the selected List object
	if (tmp2.equals("pass"))
	    pd = 0;
	else if (tmp2.equals("block"))
	    pd = 1;
	else {
	    fw.msgline.setText("Invalid statement type \"" + tmp2 + "\"");
	    return(-1);
	}

	// Get the next 2 tokens
	try {
	    tmp1 = st.nextToken();
	    tmp2 = st.nextToken();
	} catch (NoSuchElementException e) {
	    fw.msgline.setText("client statement is missing arguments");
	    return(-1);
	}

	while (true) {
	    boolean logstatement;
	    boolean cmdstatement;
	    boolean prostatement;
	    logstatement = false;
	    cmdstatement = false;
	    prostatement = false;
	    // If next token is "from:"
	    if (tmp1.equals("from:")) {
		int itmp = tmp2.indexOf('/');
		if (itmp != -1) {
		    fromaddr = tmp2.substring(0,itmp);
		    frommask = tmp2.substring(itmp + 1);
		}
		else {
		    fw.msgline.setText("From address/mask not complete");
		    return(-1);
		}
	    }
	    // If token is "to:"
	    else if (tmp1.equals("to:")) {
		int itmp = tmp2.indexOf('/');
		if (itmp != -1) {
		    destaddr = tmp2.substring(0,itmp);
		    destmask = tmp2.substring(itmp + 1);
		}
		else {
		    fw.msgline.setText("Dest address/mask not complete");
		    return(-1);
		}
	    }
	    // If next token is "port"
	    else if (tmp1.length() >= 4 && tmp1.substring(0,4).equals("port")) {
		int oplen;
		String tmpport;
		String tmpop;
		if (tmp1.length() > 4) {
		    oplen = 0;
		    tmpop = tmp1.substring(4);
		    if (tmpop.substring(0,1).equals("=")) {
			oplen = 1;
			op = 1;
		    }
		    else if (tmpop.substring(0,1).equals("<")) {
			oplen = 1;
			op = 3;
		    }
		    else if (tmpop.substring(0,1).equals(">")) {
			oplen = 1;
			op = 4;
		    }
		    else if (tmpop.length() > 1 &&
				tmpop.substring(0,2).equals("!=")) {
			oplen = 2;
			op = 2;
		    }
		    else if (tmpop.length() > 1 &&
				tmpop.substring(0,2).equals("<=")) {
			oplen = 2;
			op = 5;
		    }
		    else if (tmpop.length() > 1 &&
				tmpop.substring(0,2).equals(">=")) {
			oplen = 2;
			op = 6;
		    }
		    else {
			fw.msgline.setText("Invalid \"port\" argument");
			return(-1);
		    }
		    // If there are more in this string, assume they are the
		    // port number.  Otherwise, get the next token to be
		    // the port number.
		    if (tmpop.length() > oplen)
			port = tmpop.substring(oplen);
		    else {
			try {
			    port = st.nextToken();
			} catch (NoSuchElementException e) {
			    fw.msgline.setText("Missing port number");
			    return(-1);
			}
		    }
		}
		// The comparison operator and/or the port number are in
		// a separate token
		else {
		    int tmp2len;
		    String tmp2c1;
		    String tmp2c2;
		    oplen = 0;
		    tmp2len = tmp2.length();
		    tmp2c1 = tmp2.substring(0,1);
		    if (tmp2len > 1)
			tmp2c2 = tmp2.substring(0,2);
		    else
			tmp2c2 = new String();

		    if (tmp2c1.equals("=")) {
			oplen = 1;
			op = 1;
		    }
		    else if (tmp2c1.equals("<")) {
			oplen = 1;
			op = 3;
		    }
		    else if (tmp2c1.equals(">")) {
			oplen = 1;
			op = 4;
		    }
		    else if (tmp2c2.equalsIgnoreCase("eq")) {
			oplen = 2;
			op = 1;
		    }
		    else if (tmp2c2.equalsIgnoreCase("ne") ||
				tmp2c2.equals("!=")) {
			oplen = 2;
			op = 2;
		    }
		    else if (tmp2c2.equalsIgnoreCase("lt")) {
			oplen = 2;
			op = 3;
		    }
		    else if (tmp2c2.equalsIgnoreCase("gt")) {
			oplen = 2;
			op = 4;
		    }
		    else if (tmp2c2.equalsIgnoreCase("le") ||
				tmp2c2.equals("<=")) {
			oplen = 2;
			op = 5;
		    }
		    else if (tmp2c2.equalsIgnoreCase("ge") ||
				tmp2c2.equals(">=")) {
			oplen = 2;
			op = 6;
		    }
		    // If we have totally consumed the token in tmp2, get
		    // another one, otherwise, use tmp2 or its substring
		    // as our next token.
		    if (tmp2len == oplen) {
			try {
			    tmp2 = st.nextToken();
			} catch (NoSuchElementException e) {
			    fw.msgline.setText("Missing port number");
			    return(-1);
			}
		    }
		    else if (tmp2len > oplen)
			tmp2 = tmp2.substring(oplen);
		    else {
			// No comparison operator
			op = 0;
		    }
		    port = tmp2;
		}
	    }
	    // If next token is "log:"
	    else if (tmp1.equals("log:")) {
		logstatement = true;
		if (tmp2.equalsIgnoreCase("error"))
		    logerror = true;
		else if (tmp2.equalsIgnoreCase("connect"))
		    logconn = true;
		else if (tmp2.equalsIgnoreCase("disconnect"))
		    logdisconn = true;
		else if (tmp2.equalsIgnoreCase("data"))
		    logdata = true;
		else if (tmp2.equalsIgnoreCase("iooperation"))
		    logio = true;
		else {
		    fw.msgline.setText("Invalid log value");
		    return(-1);
		}
	    }
	    // If next token is "Command:"
	    else if (!client && tmp1.equals("command:")) {
		cmdstatement = true;
		if (tmp2.equalsIgnoreCase("bind"))
		    cmdbind = true;
		else if (tmp2.equalsIgnoreCase("bindreply"))
		    cmdbindreply = true;
		else if (tmp2.equalsIgnoreCase("connect"))
		    cmdconnect = true;
		else if (tmp2.equalsIgnoreCase("udpassociate"))
		    cmdudpassoc = true;
		else if (tmp2.equalsIgnoreCase("udpreply"))
		    cmdudpreply = true;
		else {
		    fw.msgline.setText("Invalid command value");
		    return(-1);
		}
	    }
	    // If next token is "Protocol:"
	    else if (!client && tmp1.equals("protocol:")) {
		prostatement = true;
		if (tmp2.equalsIgnoreCase("tcp"))
		    protcp = true;
		else if (tmp2.equalsIgnoreCase("udp"))
		    proudp = true;
		else {
		    fw.msgline.setText("Invalid protocol value");
		    return(-1);
		}
	    }
	    // If next token is "ProxyProtocol:"
	    else if (!client && tmp1.equals("proxyprotocol:")) {
		if (tmp2.equalsIgnoreCase("socks_v4"))
		    prox = 0;
		else if (tmp2.equalsIgnoreCase("socks_v5"))
		    prox = 1;
		else {
		    fw.msgline.setText("Invalid proxyprotocol value");
		    return(-1);
		}
	    }

	    // Get the next tokens to prepare for the neext iteration
	    try {
		tmp1 = st.nextToken();
	    } catch (NoSuchElementException e) {
		break;
	    }
	    // Handle special case of log:/command:/protocol: statements
	    // which may have more than one argument and we won't know when
	    // to stop until we see the next keyword
	    if (logstatement) {
		while (tmp1.equalsIgnoreCase("error") ||
			tmp1.equalsIgnoreCase("connect") ||
			tmp1.equalsIgnoreCase("disconnect") ||
			tmp1.equalsIgnoreCase("data") ||
			tmp1.equalsIgnoreCase("iooperation")) {
		    if (tmp1.equalsIgnoreCase("error"))
			logerror = true;
		    else if (tmp1.equalsIgnoreCase("connect"))
			logconn = true;
		    else if (tmp1.equalsIgnoreCase("disconnect"))
			logdisconn = true;
		    else if (tmp1.equalsIgnoreCase("data"))
			logdata = true;
		    else if (tmp1.equalsIgnoreCase("iooperation"))
			logio = true;
		    try {
			tmp1 = st.nextToken();
		    } catch (NoSuchElementException e) {
			tmp1 = null;
			break;
		    }
		}
	    }
	    if (cmdstatement) {
		while (tmp1.equalsIgnoreCase("bind") ||
			tmp1.equalsIgnoreCase("bindreply") ||
			tmp1.equalsIgnoreCase("connect") ||
			tmp1.equalsIgnoreCase("udpassociate") ||
			tmp1.equalsIgnoreCase("udpreply")) {
		    if (tmp1.equalsIgnoreCase("bind"))
			cmdbind = true;
		    else if (tmp1.equalsIgnoreCase("bindreply"))
			cmdbindreply = true;
		    else if (tmp1.equalsIgnoreCase("connect"))
			cmdconnect = true;
		    else if (tmp1.equalsIgnoreCase("udpassociate"))
			cmdudpassoc = true;
		    else if (tmp1.equalsIgnoreCase("udpreply"))
			cmdudpreply = true;
		    try {
			tmp1 = st.nextToken();
		    } catch (NoSuchElementException e) {
			tmp1 = null;
			break;
		    }
		}
	    }
	    if (prostatement && (tmp1.equalsIgnoreCase("tcp") ||
			tmp1.equalsIgnoreCase("udp"))) {
		if (tmp1.equalsIgnoreCase("tcp"))
		    protcp = true;
		else if (tmp1.equalsIgnoreCase("udp"))
		    proudp = true;
		try {
		    tmp1 = st.nextToken();
		} catch (NoSuchElementException e) {
		    tmp1 = null;
		    break;
		}
	    }
	    if (tmp1 == null)
		break;
	    try {
		tmp2 = st.nextToken();
	    } catch (NoSuchElementException e) {
		fw.msgline.setText("statement is missing arguments");
		return(-1);
	    }
	}
	// Put the values into the rules fields
	pd_c.select(pd);
	fromaddr_f.setText(fromaddr);
	frommask_f.setText(frommask);
	destaddr_f.setText(destaddr);
	destmask_f.setText(destmask);
	op_c.select(op);
	port_f.setText(port);
	logerror_cb.setState(logerror);
	logconn_cb.setState(logconn);
	logdisconn_cb.setState(logdisconn);
	logdata_cb.setState(logdata);
	logio_cb.setState(logio);
	if (!client) {
	    cmdbind_cb.setState(cmdbind);
	    cmdbindreply_cb.setState(cmdbindreply);
	    cmdconnect_cb.setState(cmdconnect);
	    cmdudpassoc_cb.setState(cmdudpassoc);
	    cmdudpreply_cb.setState(cmdudpreply);
	    protcp_cb.setState(protcp);
	    proudp_cb.setState(proudp);
	    prox_c.select(prox);
	}
	return (0);
    }
}
