/*============================================================================
 * filename:		ssmenu.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.awt.*;
import java.awt.event.*;

public class ssmenu extends Base {

    ssmenu(Base p) {
	super(p,"T.Rex Start/Stop Services Menu",
			"Click on the desired action");
	addBody();
	okbutton.setLabel("Continue");
	canbutton.setLabel("Return");
    }

    void addBody() {
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	/*===============================================================
	 * Query the server to get the components that are present
	 *==============================================================*/
	long comps = getcomps();
	if (comps < 0) {
	    complete = false;
	    if (comps != (long)cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    return;
	}

	gbc.anchor = GridBagConstraints.WEST;
	gbc.insets = new Insets(10,10,10,10);

	if ((comps & (1 << (fw.c.APACHE - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label apache_l = new Label("APACHE");
	    gbl.setConstraints(apache_l,gbc);
	    body.add(apache_l);

	    Button startapache = new Button("Start");
	    startapache.setActionCommand("startapache");
	    startapache.addActionListener(this);
	    gbl.setConstraints(startapache,gbc);
	    body.add(startapache);

	    Button stopapache = new Button("Stop");
	    stopapache.setActionCommand("stopapache");
	    stopapache.addActionListener(this);
	    gbl.setConstraints(stopapache,gbc);
	    body.add(stopapache);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refapache = new Button("Refresh");
	    refapache.setActionCommand("refapache");
	    refapache.addActionListener(this);
	    gbl.setConstraints(refapache,gbc);
	    body.add(refapache);
	}

	if ((comps & (1 << (fw.c.APROXY - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label aproxy_l = new Label("APROXY");
	    gbl.setConstraints(aproxy_l,gbc);
	    body.add(aproxy_l);

	    Button startaproxy = new Button("Start");
	    startaproxy.setActionCommand("startaproxy");
	    startaproxy.addActionListener(this);
	    gbl.setConstraints(startaproxy,gbc);
	    body.add(startaproxy);

	    Button stopaproxy = new Button("Stop");
	    stopaproxy.setActionCommand("stopaproxy");
	    stopaproxy.addActionListener(this);
	    gbl.setConstraints(stopaproxy,gbc);
	    body.add(stopaproxy);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refaproxy = new Button("Refresh");
	    refaproxy.setActionCommand("refaproxy");
	    refaproxy.addActionListener(this);
	    gbl.setConstraints(refaproxy,gbc);
	    body.add(refaproxy);
	}

	if ((comps & (1 << (fw.c.FWPULSE - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label fwpulse_l = new Label("FWPULSE");
	    gbl.setConstraints(fwpulse_l,gbc);
	    body.add(fwpulse_l);

	    Button startfwpulse = new Button("Start");
	    startfwpulse.setActionCommand("startfwpulse");
	    startfwpulse.addActionListener(this);
	    gbl.setConstraints(startfwpulse,gbc);
	    body.add(startfwpulse);

	    Button stopfwpulse = new Button("Stop");
	    stopfwpulse.setActionCommand("stopfwpulse");
	    stopfwpulse.addActionListener(this);
	    gbl.setConstraints(stopfwpulse,gbc);
	    body.add(stopfwpulse);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button reffwpulse = new Button("Refresh");
	    reffwpulse.setActionCommand("reffwpulse");
	    reffwpulse.addActionListener(this);
	    gbl.setConstraints(reffwpulse,gbc);
	    body.add(reffwpulse);
	}

	if ((comps & (1 << (fw.c.FWPULSED - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label fwpulsed_l = new Label("FWPULSED");
	    gbl.setConstraints(fwpulsed_l,gbc);
	    body.add(fwpulsed_l);

	    Button startfwpulsed = new Button("Start");
	    startfwpulsed.setActionCommand("startfwpulsed");
	    startfwpulsed.addActionListener(this);
	    gbl.setConstraints(startfwpulsed,gbc);
	    body.add(startfwpulsed);

	    Button stopfwpulsed = new Button("Stop");
	    stopfwpulsed.setActionCommand("stopfwpulsed");
	    stopfwpulsed.addActionListener(this);
	    gbl.setConstraints(stopfwpulsed,gbc);
	    body.add(stopfwpulsed);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button reffwpulsed = new Button("Refresh");
	    reffwpulsed.setActionCommand("reffwpulsed");
	    reffwpulsed.addActionListener(this);
	    gbl.setConstraints(reffwpulsed,gbc);
	    body.add(reffwpulsed);
	}

	gbc.gridwidth = 1;
	Label inetd_l = new Label("INETD");
	gbl.setConstraints(inetd_l,gbc);
	body.add(inetd_l);

	Button startinetd = new Button("Start");
	startinetd.setActionCommand("startinetd");
	startinetd.addActionListener(this);
	gbl.setConstraints(startinetd,gbc);
	body.add(startinetd);
	startinetd.setEnabled(false);

	Button stopinetd = new Button("Stop");
	stopinetd.setActionCommand("stopinetd");
	stopinetd.addActionListener(this);
	gbl.setConstraints(stopinetd,gbc);
	body.add(stopinetd);
	stopinetd.setEnabled(false);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button refinetd = new Button("Refresh");
	refinetd.setActionCommand("refinetd");
	refinetd.addActionListener(this);
	gbl.setConstraints(refinetd,gbc);
	body.add(refinetd);

	gbc.gridwidth = 1;
	Label padmin_l = new Label("PADMIN");
	gbl.setConstraints(padmin_l,gbc);
	body.add(padmin_l);

	Button startpadmin = new Button("Start");
	startpadmin.setActionCommand("startpadmin");
	startpadmin.addActionListener(this);
	gbl.setConstraints(startpadmin,gbc);
	body.add(startpadmin);
	startpadmin.setEnabled(false);

	Button stoppadmin = new Button("Stop");
	stoppadmin.setActionCommand("stoppadmin");
	stoppadmin.addActionListener(this);
	gbl.setConstraints(stoppadmin,gbc);
	body.add(stoppadmin);
	stoppadmin.setEnabled(false);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button refpadmin = new Button("Refresh");
	refpadmin.setActionCommand("refpadmin");
	refpadmin.addActionListener(this);
	gbl.setConstraints(refpadmin,gbc);
	body.add(refpadmin);

	if ((comps & (1 << (fw.c.FWMON - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label fwmon_l = new Label("FWMON");
	    gbl.setConstraints(fwmon_l,gbc);
	    body.add(fwmon_l);

	    Button startfwon = new Button("Start");
	    startfwon.setActionCommand("startfwon");
	    startfwon.addActionListener(this);
	    gbl.setConstraints(startfwon,gbc);
	    body.add(startfwon);

	    Button stopfwon = new Button("Stop");
	    stopfwon.setActionCommand("stopfwon");
	    stopfwon.addActionListener(this);
	    gbl.setConstraints(stopfwon,gbc);
	    body.add(stopfwon);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button reffwon = new Button("Refresh");
	    reffwon.setActionCommand("reffwon");
	    reffwon.addActionListener(this);
	    gbl.setConstraints(reffwon,gbc);
	    body.add(reffwon);
	}

	if ((comps & (1 << (fw.c.RPCPROXY - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label rpcproxy_l = new Label("RPCPROXY");
	    gbl.setConstraints(rpcproxy_l,gbc);
	    body.add(rpcproxy_l);

	    Button startrpcproxy = new Button("Start");
	    startrpcproxy.setActionCommand("startrpcproxy");
	    startrpcproxy.addActionListener(this);
	    gbl.setConstraints(startrpcproxy,gbc);
	    body.add(startrpcproxy);

	    Button stoprpcproxy = new Button("Stop");
	    stoprpcproxy.setActionCommand("stoprpcproxy");
	    stoprpcproxy.addActionListener(this);
	    gbl.setConstraints(stoprpcproxy,gbc);
	    body.add(stoprpcproxy);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refrpcproxy = new Button("Refresh");
	    refrpcproxy.setActionCommand("refrpcproxy");
	    refrpcproxy.addActionListener(this);
	    gbl.setConstraints(refrpcproxy,gbc);
	    body.add(refrpcproxy);
	    refrpcproxy.setEnabled(false);
	}

	if ((comps & (1 << (fw.c.SOCKD - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label sockd_l = new Label("SOCKD");
	    gbl.setConstraints(sockd_l,gbc);
	    body.add(sockd_l);

	    Button startsockd = new Button("Start");
	    startsockd.setActionCommand("startsockd");
	    startsockd.addActionListener(this);
	    gbl.setConstraints(startsockd,gbc);
	    body.add(startsockd);

	    Button stopsockd = new Button("Stop");
	    stopsockd.setActionCommand("stopsockd");
	    stopsockd.addActionListener(this);
	    gbl.setConstraints(stopsockd,gbc);
	    body.add(stopsockd);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refsockd = new Button("Refresh");
	    refsockd.setActionCommand("refsockd");
	    refsockd.addActionListener(this);
	    gbl.setConstraints(refsockd,gbc);
	    body.add(refsockd);
	}

	if ((comps & (1 << (fw.c.SMWRAP - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label smwrapd_l = new Label("SMWRAPD");
	    gbl.setConstraints(smwrapd_l,gbc);
	    body.add(smwrapd_l);

	    Button startsmwrapd = new Button("Start");
	    startsmwrapd.setActionCommand("startsmwrapd");
	    startsmwrapd.addActionListener(this);
	    gbl.setConstraints(startsmwrapd,gbc);
	    body.add(startsmwrapd);

	    Button stopsmwrapd = new Button("Stop");
	    stopsmwrapd.setActionCommand("stopsmwrapd");
	    stopsmwrapd.addActionListener(this);
	    gbl.setConstraints(stopsmwrapd,gbc);
	    body.add(stopsmwrapd);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refsmwrapd = new Button("Refresh");
	    refsmwrapd.setActionCommand("refsmwrapd");
	    refsmwrapd.addActionListener(this);
	    gbl.setConstraints(refsmwrapd,gbc);
	    body.add(refsmwrapd);

	    gbc.gridwidth = 1;
	    Label aliases_l = new Label("SMWRAP Aliases");
	    gbl.setConstraints(aliases_l,gbc);
	    body.add(aliases_l);

	    Button startaliases = new Button("Start");
	    startaliases.setActionCommand("aliases");
	    startaliases.addActionListener(this);
	    gbl.setConstraints(startaliases,gbc);
	    body.add(startaliases);
	    startaliases.setEnabled(false);

	    Button stopaliases = new Button("Stop");
	    stopaliases.setActionCommand("stopaliases");
	    stopaliases.addActionListener(this);
	    gbl.setConstraints(stopaliases,gbc);
	    body.add(stopaliases);
	    stopaliases.setEnabled(false);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refaliases = new Button("Refresh");
	    refaliases.setActionCommand("refaliases");
	    refaliases.addActionListener(this);
	    gbl.setConstraints(refaliases,gbc);
	    body.add(refaliases);
	}

	gbc.gridwidth = 1;
	Label syslogd_l = new Label("SYSLOGD");
	gbl.setConstraints(syslogd_l,gbc);
	body.add(syslogd_l);

	Button startsyslogd = new Button("Start");
	startsyslogd.setActionCommand("startsyslogd");
	startsyslogd.addActionListener(this);
	gbl.setConstraints(startsyslogd,gbc);
	body.add(startsyslogd);

	Button stopsyslogd = new Button("Stop");
	stopsyslogd.setActionCommand("stopsyslogd");
	stopsyslogd.addActionListener(this);
	gbl.setConstraints(stopsyslogd,gbc);
	body.add(stopsyslogd);

	gbc.gridwidth = GridBagConstraints.REMAINDER;
	Button refsyslogd = new Button("Refresh");
	refsyslogd.setActionCommand("refsyslogd");
	refsyslogd.addActionListener(this);
	gbl.setConstraints(refsyslogd,gbc);
	body.add(refsyslogd);

	if ((comps & (1 << (fw.c.WEBGATE - 1))) != 0) {
	    gbc.gridwidth = 1;
	    Label webgate_l = new Label("WEBGATE");
	    gbl.setConstraints(webgate_l,gbc);
	    body.add(webgate_l);

	    Button startwebgate = new Button("Start");
	    startwebgate.setActionCommand("startwebgate");
	    startwebgate.addActionListener(this);
	    gbl.setConstraints(startwebgate,gbc);
	    body.add(startwebgate);

	    Button stopwebgate = new Button("Stop");
	    stopwebgate.setActionCommand("stopwebgate");
	    stopwebgate.addActionListener(this);
	    gbl.setConstraints(stopwebgate,gbc);
	    body.add(stopwebgate);

	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    Button refwebgate = new Button("Refresh");
	    refwebgate.setActionCommand("refwebgate");
	    refwebgate.addActionListener(this);
	    gbl.setConstraints(refwebgate,gbc);
	    body.add(refwebgate);
	}

	sp.add(body);
    }

    /*======================================================================
     * Override since we don't want an OK button here
     *=====================================================================*/
    void addOK() {
    }

    void request(int component, int cmd) {
	pktinfo pktrc;
	pktrc = fw.c.sendpkt(component, cmd, "", 1);

	if (pktrc.rc < 0) {
	    if (pktrc.rc != cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	pktrc = fw.c.recvpkt(1);

	if (pktrc.rc < 0) {
	    if (pktrc.rc != cglue.NONFATAL) {
		fw.c.closefd();
		fw.newpanel(fw.getTop());
	    }
	    fw.msgline.setText(pktrc.errmsg);
	    return;
	}

	fw.msgline.setText(pktrc.str);
	return;
    }

    public void menubuttons(String s) {

	if ("startapache".equals(s)) {
	    request(fw.c.APACHE, fw.c.STARTCOMP);
	    return;
	}

	if ("stopapache".equals(s)) {
	    request(fw.c.APACHE, fw.c.STOPCOMP);
	    return;
	}

	if ("refapache".equals(s)) {
	    request(fw.c.APACHE, fw.c.REFCOMP);
	    return;
	}

	if ("startfwpulse".equals(s)) {
	    request(fw.c.FWPULSE, fw.c.STARTCOMP);
	    return;
	}

	if ("startaproxy".equals(s)) {
	    request(fw.c.APROXY, fw.c.STARTCOMP);
	    return;
	}

	if ("stopaproxy".equals(s)) {
	    request(fw.c.APROXY, fw.c.STOPCOMP);
	    return;
	}

	if ("refaproxy".equals(s)) {
	    request(fw.c.APROXY, fw.c.REFCOMP);
	    return;
	}

	if ("stopfwpulse".equals(s)) {
	    request(fw.c.FWPULSE, fw.c.STOPCOMP);
	    return;
	}

	if ("reffwpulse".equals(s)) {
	    request(fw.c.FWPULSE, fw.c.REFCOMP);
	    return;
	}

	if ("startfwpulsed".equals(s)) {
	    request(fw.c.FWPULSED, fw.c.STARTCOMP);
	    return;
	}

	if ("stopfwpulsed".equals(s)) {
	    request(fw.c.FWPULSED, fw.c.STOPCOMP);
	    return;
	}

	if ("reffwpulsed".equals(s)) {
	    request(fw.c.FWPULSED, fw.c.REFCOMP);
	    return;
	}

	if ("startinetd".equals(s)) {
	    request(fw.c.INETD, fw.c.STARTCOMP);
	    return;
	}

	if ("stopinetd".equals(s)) {
	    request(fw.c.INETD, fw.c.STOPCOMP);
	    return;
	}

	if ("refinetd".equals(s)) {
	    request(fw.c.INETD, fw.c.REFCOMP);
	    return;
	}

	if ("startpadmin".equals(s)) {
	    request(fw.c.PADMIN, fw.c.STARTCOMP);
	    return;
	}

	if ("stoppadmin".equals(s)) {
	    request(fw.c.PADMIN, fw.c.STOPCOMP);
	    return;
	}

	if ("refpadmin".equals(s)) {
	    request(fw.c.PADMIN, fw.c.REFCOMP);
	    return;
	}

	if ("startfwmon".equals(s)) {
	    request(fw.c.FWMON, fw.c.STARTCOMP);
	    return;
	}

	if ("stopfwmon".equals(s)) {
	    request(fw.c.FWMON, fw.c.STOPCOMP);
	    return;
	}

	if ("reffwmon".equals(s)) {
	    request(fw.c.FWMON, fw.c.REFCOMP);
	    return;
	}

	if ("startrpcproxy".equals(s)) {
	    request(fw.c.RPCPROXY, fw.c.STARTCOMP);
	    return;
	}

	if ("stoprpcproxy".equals(s)) {
	    request(fw.c.RPCPROXY, fw.c.STOPCOMP);
	    return;
	}

	if ("refrpcproxy".equals(s)) {
	    request(fw.c.RPCPROXY, fw.c.REFCOMP);
	    return;
	}

	if ("startsockd".equals(s)) {
	    request(fw.c.SOCKD, fw.c.STARTCOMP);
	    return;
	}

	if ("stopsockd".equals(s)) {
	    request(fw.c.SOCKD, fw.c.STOPCOMP);
	    return;
	}

	if ("refsockd".equals(s)) {
	    request(fw.c.SOCKD, fw.c.REFCOMP);
	    return;
	}

	if ("startsmwrapd".equals(s)) {
	    request(fw.c.SMWRAPD, fw.c.STARTCOMP);
	    return;
	}

	if ("stopsmwrapd".equals(s)) {
	    request(fw.c.SMWRAPD, fw.c.STOPCOMP);
	    return;
	}

	if ("refsmwrapd".equals(s)) {
	    request(fw.c.SMWRAPD, fw.c.REFCOMP);
	    return;
	}

	if ("startaliases".equals(s)) {
	    request(fw.c.SMALIASES, fw.c.STARTCOMP);
	    return;
	}

	if ("stopaliases".equals(s)) {
	    request(fw.c.SMALIASES, fw.c.STOPCOMP);
	    return;
	}

	if ("refaliases".equals(s)) {
	    request(fw.c.SMALIASES, fw.c.REFCOMP);
	    return;
	}

	if ("startsyslogd".equals(s)) {
	    request(fw.c.SYSLOG, fw.c.STARTCOMP);
	    return;
	}

	if ("stopsyslogd".equals(s)) {
	    request(fw.c.SYSLOG, fw.c.STOPCOMP);
	    return;
	}

	if ("refsyslogd".equals(s)) {
	    request(fw.c.SYSLOG, fw.c.REFCOMP);
	    return;
	}

	if ("startwebgate".equals(s)) {
	    request(fw.c.WEBGATE, fw.c.STARTCOMP);
	    return;
	}

	if ("stopwebgate".equals(s)) {
	    request(fw.c.WEBGATE, fw.c.STOPCOMP);
	    return;
	}

	if ("refwebgate".equals(s)) {
	    request(fw.c.WEBGATE, fw.c.REFCOMP);
	    return;
	}
    }
}
