/*============================================================================
 * filename:		times.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class times extends Panel {
    public final static int days = 7;
    public final static int hrs = 24;
    public final static int wt = 7;
    public final static int ht = 7;
    public final static int gap = 2;
    public final static int pts = 8;
    public final static int titleht = pts + gap;
    public final static int titlewt = 3*pts + gap;
    public final static String [] weekday = {"Sun","Mon","Tue",
					"Wed","Thu","Fri","Sat"};
    Rectangle [][] dots;
    Point downPt;
    Point curPt;
    boolean turn_it_on;
    Rectangle bounds;
    byte [] accesstimes;
    fwwin fw;

    times(byte accesstimes[], fwwin fw) {
	int i,j;
	int rc;

	this.fw = fw;
	this.accesstimes = accesstimes;

	dots = new Rectangle[days][hrs];
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	setLayout(gbl);

	gbc.anchor = GridBagConstraints.NORTHWEST;
	setFont(new Font("TimesRoman",Font.PLAIN,pts));

	// Register dummy listeners so that processEvent()
	// will be called
	addMouseListener(new mouse());
	addMouseMotionListener(new mousemotion());

	for (i=0; i<days; i++) {
	    for(j=0; j<hrs; j++) {
		int idx1 = i + i + i + j / 8;
		int idx2 = 1 << (j & 0x7);
		dots[i][j] = new Rectangle(titlewt + j * (gap + wt),
				titleht + i * (gap + ht), wt, ht);
	    }
	}
	bounds = new Rectangle(dots[0][0].x, dots[0][0].y,
				dots[days-1][hrs-1].x - dots[0][0].x + wt,
				dots[days-1][hrs-1].y - dots[0][0].y + ht);
    }

    class mouse extends MouseAdapter {
	public void mouseEntered(MouseEvent e) {
	    setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
	}

	public void mouseExited(MouseEvent e) {
	    setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

	public void mousePressed(MouseEvent e) {
	    fw.msgline.setText("");
	    Point p = e.getPoint();
	    int mod = e.getModifiers();
	    if (!bounds.contains(p))
		return;
	    /*===========================================================
	     * Middle button is not used
	     *==========================================================*/
	    if ((mod & InputEvent.BUTTON2_MASK) != 0)
		return;
	    else if ((mod & InputEvent.BUTTON3_MASK) != 0)
		turn_it_on = false;
	    else
		turn_it_on = true;
	    downPt = p;
	}

	public void mouseReleased(MouseEvent e) {
	    int i,j;

	    if (downPt == null)
		return;
	    curPt = e.getPoint();
	    curPt = bound(curPt);
	    
	    /*===========================================================
	     * Only act if CurPt is NOT to the left of or above downPt
	     *==========================================================*/
	    if (curPt.x >= downPt.x && curPt.y >= downPt.y) {
		for (i = (downPt.y - dots[0][0].y) / (gap + ht);
			i <= (curPt.y - dots[0][0].y)/(gap+ht); i++) {
		    for (j = (downPt.x - dots[0][0].x) / (gap + wt);
			j <= (curPt.x - dots[0][0].x) / (gap + wt); j++) {
			int idx1 = i + i + i + j / 8;
			int idx2 = 1 << (j & 0x7);
			if (turn_it_on)
			    accesstimes[idx1] |= idx2;
			else
			    accesstimes[idx1] &= ~idx2;
		    }
		}
	    }
	    
	    downPt = null;
	    curPt = null;
	    e.getComponent().repaint();
	}

	public void mouseClicked(MouseEvent e) {
	    fw.msgline.setText("");
	    Point cur = e.getPoint();
	    int mod = e.getModifiers();
	    if (bounds.contains(cur)) {
		int i,j;
		if ((mod & InputEvent.BUTTON2_MASK) != 0)
		    return;
		else if ((mod & InputEvent.BUTTON3_MASK) != 0)
		    turn_it_on = false;
		else
		    turn_it_on = true;
		j = (cur.x-titlewt)/(gap+wt);
		i = (cur.y-titleht)/(gap+ht);
		int idx1 = i + i + i + j / 8;
		int idx2 = 1 << (j & 0x7);
		if (turn_it_on)
		    accesstimes[idx1] |= idx2;
		else
		    accesstimes[idx1] &= ~idx2;
		e.getComponent().repaint();
	    }
	}
    }

    class mousemotion extends MouseMotionAdapter {
	public void mouseDragged(MouseEvent e) {
	    curPt = e.getPoint();
	    curPt = bound(curPt);
	    e.getComponent().repaint();
	}
    }

    Point bound(Point p) {
	Point q = p;
	if (q.x < bounds.x)
	    q.x = bounds.x;
	if (q.y < bounds.y)
	    q.y = bounds.y;
	if (q.x > bounds.x + bounds.width)
	    q.x = bounds.x + bounds.width;
	if (q.y > bounds.y + bounds.height)
	    q.y = bounds.y + bounds.height;
	return(q);
    }

    public void paint(Graphics g) {
	int i,j;
	Color c;
	for (i=0; i<days; i++) {
	    for (j=0; j<hrs; j++) {
		boolean raised;

		if (i == 0)
		    g.drawString(String.valueOf(j),dots[i][j].x,pts);
		if (j == 0)
		    g.drawString(weekday[i],0,dots[i][j].y+pts);

		c = g.getColor();
		int idx1 = i + i + i + j / 8;
		int idx2 = 1 << (j & 0x7);
		if ((accesstimes[idx1] & idx2) != 0) {
		    g.setColor(SystemColor.controlText);
		    raised = false;
		}
		else {
		    g.setColor(SystemColor.control);
		    raised = true;
		}

		g.draw3DRect(dots[i][j].x,dots[i][j].y,wt,ht,raised);
		g.setColor(c);
	    }
	}
	if (downPt != null && curPt != null) {
	    /*===============================================================
	     * Only rubberband it if the cursor is to the right or below the
	     * drag start point
	     *==============================================================*/
	    if (curPt.x > downPt.x && curPt.y > downPt.y) {
		g.setColor(Color.black);
		g.drawRect(downPt.x, downPt.y,
			curPt.x - downPt.x, curPt.y - downPt.y);
	    }
	}
    }

    public Dimension getMinimumSize() {
	return(new Dimension(titlewt + hrs*(gap+wt),
				titleht + days*(gap+ht) + gap));
    }

    public Dimension getPreferredSize() {
	return(new Dimension(titlewt + hrs*(gap+wt),
				titleht + days*(gap+ht) + gap));
    }
}
