/*============================================================================
 * filename:		webblock.java
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
//============================================================================
//
// R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
// license to use, modify, and market this program using their tradename
// T.Rex.
//
//
// (C) COPYRIGHT R. James Livermore 1998-2000.  All rights reserved.
//
// (C) COPYRIGHT Freemont Avenue Software, Incorporated 1998-2000.
// All rights reserved.
//
// Date written:	June      24, 1998
// Last modified:	February   8, 2000
//
//===========================================================================*/
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class webblock extends Base {
    final int MAXDIRENT = 100;
    Checkbox  checkbox[]= new Checkbox[MAXDIRENT];
    TextField  timerange[]= new TextField[MAXDIRENT];
    TextField  textfield[]= new TextField[MAXDIRENT];
    String keyword="ProxyBlockList";
    FileInputStream in;
    BufferedReader din;
    String line;
    final String listdir="/etc/firewall/lists";
    int nfiles;
    pktinfo pktrc;

    webblock(Base p) {
	super(p,"WEBBLOCK","Select lists of sites to block");
	addBody();
    }

    void addBody() {
	int i = 0;
	int infd;
	File conf;
	int len;
	String filelist;

	component = fw.c.APACHE;

	/*==============================================================
	 * Title of this panel
	 *=============================================================*/
	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();
	body.setLayout(gbl);

	/*==============================================================
	 * Get the config file over here to a temp file
	 *=============================================================*/
	pktrc = download();
	tmpfn = pktrc.str;

	if (pktrc.rc != fw.c.OK) {
	    complete = false;
	    return;
	}

	/*==============================================================
	 * Column headings
	 *=============================================================*/
	gbc.anchor = GridBagConstraints.WEST;
	Label cb = new Label("Block Lists");
	gbc.gridwidth   = 1;
	gbl.setConstraints(cb,gbc);
	body.add(cb);
	Label tr = new Label("Optional time range");
	gbc.gridwidth   = 1;
	gbl.setConstraints(tr,gbc);
	body.add(tr);
	Label op = new Label("Optional URL to Remap Access");
	gbc.gridwidth   = GridBagConstraints.REMAINDER;
	gbl.setConstraints(op,gbc);
	body.add(op);

	/*==============================================================
	 * Get dir listing for /etc/firewall/lists
	 *=============================================================*/
	pktrc = fw.c.sendpkt(fw.c.APACHE, fw.c.GETLIST, "", 1);

	if (pktrc.rc != fw.c.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    complete = false;
	    return;
	}

	pktrc = fw.c.recvpkt(1);

	if (pktrc.rc != fw.c.OK) {
	    fw.msgline.setText(pktrc.errmsg);
	    complete = false;
	    return;
	}

	/*===============================================================
	 * Loop through each file found in the /etc/firewall/lists directory
	 * and set the label for their checkboxes
	 *==============================================================*/
	filelist = pktrc.str;
	while (filelist.length() > 0) {
	    String filename;
	    int end = filelist.indexOf(' ');
	    if (end < 0)
		filename = filelist;
	    else
	        filename = filelist.substring(0,end);

	    // Chop name down to 16 so long name don't mess up screen
	    // formatting.
	    if (filename.length() < 16)
		checkbox[i] = new Checkbox(filename);
	    else
		checkbox[i] = new Checkbox(filename.substring(0,16));

	    timerange[i] = new TextField(15);
	    textfield[i] = new TextField(30);

	    gbc.anchor = GridBagConstraints.WEST;
	    gbc.gridwidth = 1;
	    gbl.setConstraints(checkbox[i],gbc);
	    body.add(checkbox[i]);
	    gbc.gridwidth = 1;
	    gbl.setConstraints(timerange[i],gbc);
	    body.add(timerange[i]);
	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    gbl.setConstraints(textfield[i],gbc);
	    body.add(textfield[i]);

	    i++;
	    if (end < 0)
		break;
	    filelist = filelist.substring(end + 1);
	}
	nfiles = i;

	/*==============================================================
	 * Prepare the temp /etc/httpd.conf file for input
	 *=============================================================*/
	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    complete = false;
	    return;
	}
	infd = pktrc.rc;
	fw.msgline.setText("Reading and processing input file " + tmpfn);
	/*==============================================================
	 * Loop to read each line in the conf file and look for
	 * ProxyBlockList lines
	 *=============================================================*/
	while ( true ) {
	    int pound;

	    pktrc = fw.c.cbcreadLine(infd);
	    if (pktrc.rc != cglue.OK) {
		if (pktrc.rc == cglue.CLOSED)
		    break;
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(infd);
		complete = false;
		return;
	    }

	    // Exit loop at EOF
	    if (pktrc.str == null)
		break;

	    line = pktrc.str;

	    if (line.trim().length() == 0)
		continue;

	    /*=======================================================
	     * Parse line into tokens
	     *======================================================*/
	    StringTokenizer st =
			new StringTokenizer(line.trim()," \t=");

	    /*=======================================================
	     * Process only if keyword is "ProxyBlockList"
	     *======================================================*/
	    if (!st.nextToken().equalsIgnoreCase(keyword))
		continue;

	    if (!st.hasMoreTokens())
		continue;

	    String file = st.nextToken();
	    /*===================================================
	     * See if the list file is in /etc/firewall/lists
	     *==================================================*/
	    for (i=0; i < nfiles; i++) {
		if (file.indexOf(checkbox[i].getLabel()) != -1) {
		    String tmp;
		    checkbox[i].setState(true);
		    /*===========================================
		     * Get the next (optional) token and see if it
		     * is a time range or not
		     *==========================================*/
		    if (st.hasMoreTokens()) {
			int j;
			String timechars = "0123456789:apm-,";
			tmp = st.nextToken();
			for (j = 0; j < tmp.length(); j++) {
			    /*===============================================
			     * If one character in the token does not match
			     * the time range characters, assume it is not
			     * a time range.
			     *==============================================*/
			    if (timechars.indexOf(tmp.substring(j,j+1)) == -1)
				break;
			}
			if (j >= tmp.length()) {
			    timerange[i].setText(tmp);
			    /*==============================================
			     * Get the next (optional) token (remap url)
			     *=============================================*/
			    if (st.hasMoreTokens())
				textfield[i].setText(st.nextToken());
			}
			else
			    /*==============================================
			     * We decided that token in tmp is not a
			     * time range so it must be the remap url.
			     *=============================================*/
			    textfield[i].setText(tmp);
		    }
		    break;
		}
	    }
	}

	fw.c.closefile(infd);
	conf = new File(tmpfn);
	conf.delete();

	sp.add(body);
    }

    /*===================================================================
     * Handle the OK button
     *==================================================================*/
    public void handleOK() {

	fw.msgline.setText("");
	if (saveconf() < 0)
	    return;

	pktrc = upload();
	if (pktrc.rc < 0)
	    return;

	fw.msgline.setText("New webblock config file successfully " +
		"created");
	fw.newpanel(parent_panel);
    }

    /*==================================================================
     * The OK button has been pressed.  Process the input in this panel
     *=================================================================*/
    public int saveconf() {
	int i;
	int infd, outfd;
	int end_of_dirname;
	String tmpoutfn;
	File conf,newconf;

	// Re-get the config file over here to a temp file
	pktrc = download();
	tmpfn = pktrc.str;

	if (pktrc.rc != fw.c.OK) {
	    return(fw.c.NONFATAL);
	}

	// Form the temp output filename
	end_of_dirname = tmpfn.lastIndexOf('/');
	if (end_of_dirname < 0)
	    end_of_dirname = tmpfn.lastIndexOf('\\');
	if (end_of_dirname < 0)
	    tmpoutfn = new String("_padmhtt.pd");
	else {
	    tmpoutfn = tmpfn.substring(0,end_of_dirname+1);
	    tmpoutfn = tmpoutfn.concat("_padmhtt.pd");
	}

	/*==============================================================
	 * Open the input file
	 *=============================================================*/
	pktrc = fw.c.opencbcfile(tmpfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    conf = new File(tmpfn);
	    conf.delete();
	    return(pktrc.rc);
	}
	infd = pktrc.rc;

	/*==============================================================
	 * Open the output file
	 *=============================================================*/
	pktrc = fw.c.opencbcfile(tmpoutfn, 0);
	if (pktrc.rc < 0) {
	    fw.msgline.setText(pktrc.errmsg);
	    fw.c.closefile(infd);
	    conf = new File(tmpfn);
	    conf.delete();
	    conf = new File(tmpoutfn);
	    conf.delete();
	    return(pktrc.rc);
	}
	outfd = pktrc.rc;
	/*==============================================================
	 * Process each line
	 *=============================================================*/
	while ( true ) {
	    int bl;

	    pktrc = fw.c.cbcreadLine(infd);
	    if (pktrc.rc != cglue.OK) {
		if (pktrc.rc == cglue.CLOSED)
		    break;
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(infd);
		conf = new File(tmpfn);
		conf.delete();
		conf = new File(tmpoutfn);
		conf.delete();
		return(pktrc.rc);
	    }

	    // Exit loop at EOF
	    if (pktrc.str == null)
		break;

	    line = pktrc.str;

	    if (line == null)
		break;
	    if ((bl = line.indexOf(keyword)) != -1) {
		/*======================================================
		 * If found "ProxyBlockList" keyword then see if the file
		 * specified is one found in listdir.  If it is, we
		 * suppress the output of this line.  Note that we don't
		 * really care if the line is commented.
		 *=====================================================*/
		for (i=0; i < nfiles; i++) {
		    if (line.indexOf(checkbox[i].getLabel()) != -1) {
			break;
		    }
		}
		if (i != nfiles)
		    continue;
	    }
	    /*==========================================================
	     * Output the line read
	     *=========================================================*/
	    pktrc = fw.c.cbcwriteLine(outfd, line + "\n");
	    if (pktrc.rc != cglue.OK) {
		fw.msgline.setText(pktrc.errmsg);
		fw.c.closefile(infd);
		fw.c.closefile(outfd);
		conf = new File(tmpfn);
		conf.delete();
		conf = new File(tmpoutfn);
		conf.delete();
		return(-1);
	    }
	}

	/*=============================================================
	 * Now write out all the ProxyBlockList lines selected
	 *============================================================*/
	for (i=0; i < nfiles; i++) {
	    if (checkbox[i].getState()) {
		pktrc = fw.c.cbcwriteLine(outfd, keyword + " " +
				listdir + "/" + checkbox[i].getLabel() + " " +
				timerange[i].getText() + " " +
				textfield[i].getText() +"\n");
		if (pktrc.rc != cglue.OK) {
		    fw.msgline.setText(pktrc.errmsg);
		    fw.c.closefile(infd);
		    fw.c.closefile(outfd);
		    conf = new File(tmpfn);
		    conf.delete();
		    conf = new File(tmpoutfn);
		    conf.delete();
		    return(-1);
		}
	    }
	}

	fw.c.closefile(infd);
	fw.c.closefile(outfd);

	conf = new File(tmpfn);
	conf.delete();
	newconf = new File(tmpoutfn);
	if (!newconf.renameTo(conf)) {
	    fw.msgline.setText("Rename of temp file failed.");
	    return(-1);
	}

	return(0);
    }
}
