/*============================================================================
 * filename:		include/ftproxy.h					
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*============================================================================
 *                                          
 * written by:		R. James Livermore 
 *			1602 Mossy Stone
 *			Houston, TX 77077
 *
 * R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
 * license to use, modify, and market this program using their tradename
 * T.Rex.	
 *
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  All rights
 * reserved.  
 *		
 * Date written:	April	  10, 1995
 * Last modified:	February   8, 2000
 *	                         
 * function:
 *
 *  The ftproxy sctucture contains the information used control the 
 *  file transfer proxy server aka ftproxy.      
 *  
 *
 *===========================================================================*/
#ifndef SMBUFSIZE   
#define SMBUFSIZE 512
#endif
#define	DBUFSIZ	 4096			/* Default Data buffer size          */
#define CBUFSIZ	 2048			/* Command buffer size		     */
#define MINDBUF	 1024			/* minimum data buffer size          */
#define MAXDBUF  32768			/* maximum data buffer size	     */
   struct FTPROXY {     
   char		 username[UNMSIZ];	/* client user name 		     */
   unsigned long userid;		/* client user id 		     */ 
   char		 groupname[GRPSIZ];	/* client group name from gwuser     */
   unsigned long groupid;		/* group id from gwuser              */ 
					/* manditory commands		     */
   char		 auth;			/* authorization for internal access */  
   char 	 x4ward;		/* allow xforwarding	  	     */
   unsigned long ftuserid;		/* ftproxy user id from ftproxy.conf */
   unsigned long ftgroupid;		/* ftproxy group id from ftproxy.conf*/ 
   int 		timeout;		/* ftproxy timeout in seconds        */
   char 	ftproxpath[MAXPATHLN+1];/* ftproxy directory 		     */ 
   char 	sourceIP[IPSIZ];	/* source IP address		     */  
   char 	destIP[IPSIZ];		/* destination IP address	     */ 
   unsigned short destPort;		/* destination port	 	     */
   char		srcname[MAXHOSTLN+1];	/* source host name		     */
   char		destname[MAXHOSTLN+1];	/* destination host name	     */ 
   int		srcIPsecure;		/* Is source IP address secure	     */
   int		privateconnect;		/* Is private connection	     */
   char		autologname[UNMSIZ];	/* auto login name for ftp server    */
   int		debug;			/* set = 1 for debugging             */
   int		dbuffersize;		/* data buffer size		     */
   char		external;		/* Is external ftp allowed	     */
   char		anonymousftp[MAXHOSTLN+1];/* anonymous FTP server (IP|name)  */			
};  
/*============================================================================
 * Values for the privateconnect member.
 * If both SRCIP_IS_PRIVATE and LOCALPORT_IS_PRIVATE are set, the connection
 * is private.
 *===========================================================================*/
#define SRCIP_IS_PRIVATE	1
#define LOCALPORT_IS_PRIVATE	2
#define PRIVATE_CONNECT		(SRCIP_IS_PRIVATE|LOCALPORT_IS_PRIVATE)
