 * filename:		include/smg.h
/*============================================================================
 *										
 * written by:		Jim Livermore						
 *			Freemont Avenue Software, Incorporated
 *
 * (C) COPYRIGHT Freemont Avenue Software, Inc. 1995-2000.  All rights
 * reserved.
 *		
 * Date written:	December   5, 1995
 * Last modified:	February   8, 2000
 * 			
 *	                         
 * function:
 *
 *  The SMG structure contains the information used control the 
 *  Secure Mail Guard.      
 *  
 *
 *===========================================================================*/
struct SMG {
   unsigned long userid;	/* user id from passwd file     	*/
   unsigned long groupid;	/* group id                     	*/ 
   int	maxbytes;		/* maximum message size			*/
   int	maxreceipts;		/* max receipts per message     	*/
   int 	timeout;		/* smwrap timeout in seconds           	*/
   int	wakeup;			/* smwrapd sleep time between scans	*/
   int	maxpids;		/* maximum process ids (children)	*/
   int	traceflg;		/* trace flag				*/							  
   char spoolpath[256];		/* smwrap spool directory   		*/ 
   char smwpdpath[256];         /* smwrapd executable pathname 		*/
   char smtppath[256];		/* smtp (sendmail) executable path	*/ 
   char undelivpath[256];	/* undeliverable mail path              */ 
   char noaliases;		/* 0 -> uses aliases DB 1-> NOT 	*/ 
   char postoffice[128];	/* hostname of internal post office     */
};
/*============================================================================
 * SMG trace entry and trace header
 *===========================================================================*/  
struct	trace
{
   int		entryno; 
   char		sr;		/* S = send, R = Receive */
   char		entry[96];
}; 
struct  tracehdr
{
   int		recno;
   int		tindx;
   char		title[80];
#define	MAXTRACE 	32 
}; 
