/*============================================================================
 * filename:		include/webgate.h
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*============================================================================
 *
 * written by:		R. James Livermore 
 *			1602 Mossy Stone
 *			Houston, TX 77077
 *
 * R. James Livermore grants Freemont Avenue Software, Inc. a nonexclusive
 * license to use, modify, and market this program using their tradename
 * T.Rex.	
 *
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  All rights
 * reserved. 
 *
 *		
 * Date written:
 * Last modified:	February   8, 2000
 *	                         
 * function:
 *
 *  The webgate structure contains the information used control the 
 *  webgate program.       
 *  
 *
 *===========================================================================*/
#include <sys/time.h>
#include <signal.h>
#define PIDFILE FW_CFG_DIR "/webgate.pid"   
#define SHRCONF FW_CFG_DIR "/webgate.shr"   
#define PROCNAME "webgate"   
#define INBUFSIZE   	4096 
#define WGTRACESIZE 	1024  
#define ClientLast	0
#define ServerLast	1
#define CLFExt		1
#define WTMultiHomed	2 
#ifdef NOTTHERE
struct WEBPROX 
{
   unsigned long userid;	/* user id from passwd file     	*/
   unsigned long groupid;	/* group id                     	*/ 
   int 		timeout;	/* genproxy timeout in seconds         	*/
   char         GMTdelta[6];    /* locattime delta from GMT as char str */
   int		DNSflg;		/* DNS flag  				*/
   int		traceflg;	/* trace flag				*/	  
   char 	gproxpath[256];	/* genproxy spool directory   		*/ 
   char 	logname[LOGNMSIZ];/* log file name			*/ 
   char		srcHost[256];   /* Source|Client host name		*/
   char		srcIP[IPSIZ];  	/* Source/Client IP address		*/
   char		localIP[IPSIZ];	/* Firewall IP				*/
   int		localport;      /* Firewall port #			*/
   char		destIP[IPSIZ]; 	/* Destination IP address		*/
   int		destport; 	/* Destination port #			*/ 
   int		totalGETs;	/* total number of GETs			*/
   int		totalPOSTs;	/* total number of POSTs		*/
   int		totalreads;	/* total number of blocks read		*/
};
#endif
typedef	char	IPSTR[16];	/* IP string				*/

/*============================================================================
 * child info
 * The parent initializes all the members and calls a child.  From that point
 * on, the struct should only be readable and NOT writable by the parent,
 * until it is time to expire the child or until a SIGCHLD is received by the
 * handler (where the child might have died or exited for any reason).
 * The child updates status and nconn.
 * The parent updates pid when it starts a new child in this slot.
 * We need to maintain this exclusivity because we are not locking around
 * any updates to this struct.
 *===========================================================================*/
typedef struct CHILD CHILD;
struct CHILD
{
   pid_t	pid;		/* Child pid				*/
   int		nconn;		/* Number of connections handled by chld*/
   int		status;		/* Child status				*/
#define CHILD_NONE	0	/* Child process does not exist		*/
#define CHILD_IDLE	1	/* Child is ready for new connection	*/
#define CHILD_BUSY	2	/* Child is handling a connection	*/
#define CHILD_TERM	3	/* Child has been sent SIGUSR1 to exit	*/
#define CHILD_N_STAT	4	/* 1 plus highest status define		*/
};

struct RULE {
   int		op;		/* 0 = permit, 1 = deny			*/
   #define	PERMIT	0
   #define	DENY	1
   char		fromaddr[16];	/* from address				*/
   char		toaddr[16];	/* to address				*/
   char		toname[64];	/* to name for logging			*/
   unsigned short	toport;	/* to port				*/
   char		destaddr[16];	/* dest address				*/
   unsigned short	destport;/* dest port				*/
   char		oobauser[UNMSIZ];/* OOBA user name			*/
   unsigned short	oobaport;/* OOBA port number			*/
   int		roundrobin;	/* 0 = no roundrobin, >0 means n rrobin	*/
   struct timeval	lastused;/* time of last use of this rrobin rule*/
   unsigned short	vlog;	/* verbose logging			*/
};

typedef struct RULE RULE;

struct NS_WGCONF
{
   char		srcHost[256];   /* Source|Client host name		*/
   char		srcIP[IPSIZ];  	/* Source/Client IP address		*/
   char		localIP[IPSIZ];	/* Firewall IP				*/
   int		localport;      /* Firewall port #			*/
   char		destIP[IPSIZ]; 	/* Destination IP address		*/
   int		destport; 	/* Destination port #			*/ 
   int		totalGETs;	/* total number of GETs			*/
   int		totalHEADs;	/* total number of HEADs		*/
   int		totalPOSTs;	/* total number of POSTs		*/
   int		totalreads;	/* total number of blocks read		*/
   int		rule_index;	/* index to the selected permit rule	*/
};

typedef struct NS_WGCONF NS_WGCONF;

struct WGCONF 
{
   unsigned long userid;	/* user id from passwd file     	*/
   unsigned long groupid;	/* group id                     	*/ 
   int 		timeout;	/* genproxy timeout in seconds         	*/
   char         GMTdelta[6];    /* locattime delta from GMT as char str */
   int		DNSflg;		/* DNS flag  				*/
   int		traceflg;	/* trace flag				*/
   int		debugflg;	/* debug flag				*/
   char 	gproxpath[256];	/* genproxy spool directory   		*/ 
   char 	logname[LOGNMSIZ];/* log file name			*/ 
   int		logformat;      /* log format                           */
   NS_WGCONF	*ns;		/* points to non-share portion of WGCONF*/

#ifdef __sun
   volatile sig_atomic_t nprocs;/* Number of processes to spawn		*/
   volatile sig_atomic_t minspare;/* Min number of spare idle processes	*/
   volatile sig_atomic_t maxspare;/* Max number of spare idle processes	*/
#else
   sig_atomic_t	nprocs;		/* Number of processes to spawn         */
   sig_atomic_t minspare;	/* Min number of spare idle processes	*/
   sig_atomic_t maxspare;	/* Max number of spare idle processes	*/
#endif
   int		checkprocs;	/* Interval (secs) to check processes	*/
   int		maxprocs;	/* Max number of child processes	*/
   int		maxuse;		/* Max use for each child process	*/
   int		lockfd;		/* fd for flock file			*/
   int		rrfd;		/* fd for round robin flock file	*/
   CHILD	*child;		/* ptr to shm of child info table	*/
   int		nsnp;		/* Number of securenets entries		*/
   IPSTR	*snp;		/* ptr to shm for securenets entries	*/
   int		nspp;		/* Number of secureports entries	*/
   IPSTR	*spp;		/* ptr to shm for secureports entries	*/
   int		nfds;		/* Number of fd entries			*/
   struct pollfd *fdp;		/* ptr to array of pollfd's		*/
   int		nrules;		/* Number of rules to follow		*/
   RULE		rulep[1];	/* Variable length array of rules	*/
};
typedef struct WGCONF WGCONF;

/*============================================================================
 * webgate trace header
 *===========================================================================*/  

struct  tracehdr
{
   int		recno;
   int		src; 
   int          bytes; 
   int		pid;
   char		title[80];
   char		srcHost[256];    /* Source|Client host name		*/
   char		srcIP[20];  	/* Source/Client IP address		*/
   char		localIP[20];	/* Firewall IP				*/
   int		localport;      /* Firewall port #			*/
   char		destIP[20]; 	/* Destination IP address		*/
   int		destport; 	/* Destination port #			*/ 
   int		fd;		/* trace file descriptor		*/ 
#define	MAXTRACE 	80 
};        
/*============================================================================
 * HHTP Log Data
 *===========================================================================*/  
struct	HTTPLOG
{     
   int		state;          	/* empty, partial, complete	 */ 
   int		ServerCnt;		/* number of blocks after client */
   char		srcIP[32];		/* client host IP addr in dot-dec*/
   char         identd[16];             /* clients login name            */
   char         user[16];               /* user from auth                */
   char         CLFtime[32];		/* Common Log Format time        */
   char		request[8];		/* request type; GET, POST,	 */   
   char		data[256];		/* requested data	 	 */ 
   char         Status[8];              /* Status                        */
   char		version[16];
   char		HostRefer[128];
   char		Referer[128];
   char		User_Agent[128]; 
   char		Server[32]; 
   int		Client_Cmd_Length;
   char		Content_Type[16];
   int		Content_Length;
   int		TotalServerBytes;
   int		TotalClientBytes;
   
}; 

/*============================================================================
 * OOBA Version 2 message block
 *===========================================================================*/  
struct	OOBA2
{  
   unsigned char sync;
   unsigned char command;
   char		 msg[128];	
};
#define OOBAPROMPT	1 
#define	OOBASHOW	2

/*============================================================================
 * Keys for sem and shm tokens
 *===========================================================================*/
#define WGPATH		"/usr/local/etc/webgate"
#define WGSEMKEY	1
#define WGCLDKEY	2
#define WGSECKEY1	3
#define WGSECKEY2	4
#define WGCONKEY	5

/*=======================================================================
 * Example on calling the debug macro
 * DEBUG(1, wgconfp, (DBLOG, "Debug in function xxx, i = %d, j = %d", i, j));
 *
 * DBLOG is used so that if we decide later that debug info should be
 * at another log level, we can make that chnge in one place.
 *======================================================================*/
#define DBLOG	LOG_NOTICE
#define DEBUG(n, ptr, msg)	if (ptr->debugflg >= n) syslog msg
