/*============================================================================
 * filename:		netlib/Pgethostnamadr.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*============================================================================ 
 *
 * written by:		R. James Livermore
 * Last modified:	February 8, 2000 - added LPL
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  All rights
 * reserved.  
 *
 * This program is a modification of the BSD gethostnamadr.c program. 
 * This version looks at the /etc/firewall/resolv.inside.conf file to find the
 * Internal DNS.     
 *
 * Copyright (c) 1985, 1988 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
*===========================================================================*/
static char	cprght[] = 
 "(C) COPYRIGHT Freemont Avenue Software, Inc. 1995-2000 Pgethostnamadr, V 1.0 00/01/21"; 
#if defined(LIBC_SCCS) && !defined(lint)
static char sccsid[] = "@(#)gethostnamadr.c	6.48 (Berkeley) 1/10/93";
#endif /* LIBC_SCCS and not lint */

#include <sys/param.h> 
#include <sys/types.h>		/* added by Jim Livermore		*/
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <arpa/nameser.h>
#include <netdb.h>
/*#include <resolv.h> */      	/* commented out by Jim Livermore 	*/
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>
#include "presolv.h"    	/* use new resolve.h file		*/
#ifdef 	__hppa
#define	_PATH_HOSTS	"/etc/hosts"
#endif
#define	MAXALIASES	35
#define	MAXADDRS	35

static char *h_addr_ptrs[MAXADDRS + 1];

static struct hostent host;
static char *host_aliases[MAXALIASES];
static char hostbuf[BUFSIZ+1];
static struct in_addr host_addr;
static FILE *hostf = NULL;
static char hostaddr[MAXADDRS];
static char *host_addrs[2];
static int stayopen = 0;
#ifndef linux
char *strpbrk();
#endif

#if PACKETSZ > 1024
#define	MAXPACKET	PACKETSZ
#else
#define	MAXPACKET	1024
#endif

#ifdef linux
#define _getlong ___getlong
#define _getshort ___getshort
#define _putlong ___putlong
#define _putshort ___putshort
#define dn_expand __dn_expand
#define dn_comp __dn_comp
#endif

typedef union {
    HEADER hdr;
    u_char buf[MAXPACKET];
} querybuf;

typedef union {
    long al;
    char ac;
} align;

int h_errno;
/*========================================================
 * getanswer
 *========================================================*/
static struct hostent *
getanswer(querybuf *answer, int anslen, int iquery) 
{
   register HEADER *hp;
   register u_char *cp;
   register int n;
   u_char *eom;
   char *bp;
   char **ap;
   int type, class, buflen, ancount, qdcount;
   int haveanswer, getclass = C_ANY;
   char **hap;

   eom = answer->buf + anslen;
   /*========================================
    * find first satisfactory answer
    *=======================================*/
   hp = &answer->hdr;
   ancount = ntohs(hp->ancount);
   qdcount = ntohs(hp->qdcount);
   bp = hostbuf;
   buflen = sizeof(hostbuf);
   cp = answer->buf + sizeof(HEADER);
   if (qdcount) 
   {
      if (iquery) 
      {
         if ((n = dn_expand((u_char *)answer->buf,
			    (u_char *)eom, (u_char *)cp, (u_char *)bp,
			    buflen)) < 0) 
         {
	    h_errno = NO_RECOVERY;
	    return ((struct hostent *) NULL);
	 }
	 cp += n + QFIXEDSZ;
	 host.h_name = bp;
	 n = strlen(bp) + 1;
	 bp += n;
	 buflen -= n;
      } 
      else
         cp += __dn_skipname(cp, eom) + QFIXEDSZ;
      while (--qdcount > 0)
         cp += __dn_skipname(cp, eom) + QFIXEDSZ;
   } 
   else if (iquery) 
   {
      if (hp->aa)
         h_errno = HOST_NOT_FOUND;
      else
         h_errno = TRY_AGAIN;
      return ((struct hostent *) NULL);
   }
   ap = host_aliases;
   *ap = NULL;
   host.h_aliases = host_aliases;
   hap = h_addr_ptrs;
   *hap = NULL;
#if BSD >= 43 || defined(h_addr)	/* new-style hostent structure */
   host.h_addr_list = h_addr_ptrs;
#endif
   haveanswer = 0;
   while (--ancount >= 0 && cp < eom) 
   {
      if ((n = dn_expand((u_char *)answer->buf, (u_char *)eom,
		    (u_char *)cp, (u_char *)bp, buflen)) < 0)
         break;
      cp += n;
      type = _getshort(cp);
      cp  += sizeof(u_short);
      class = _getshort(cp);
      cp  += sizeof(u_short) + sizeof(u_long);
      n    = _getshort(cp);
      cp += sizeof(u_short);
      if (type == T_CNAME) 
      {
         cp += n;
	 if (ap >= &host_aliases[MAXALIASES-1])
	    continue;
	 *ap++ = bp;
	 n = strlen(bp) + 1;
	 bp += n;
	 buflen -= n;
	 continue;
      }
      if (iquery && type == T_PTR) 
      {
			if ((n = dn_expand((u_char *)answer->buf,
			    (u_char *)eom, (u_char *)cp, (u_char *)bp,
			    buflen)) < 0)
				break;
			cp += n;
			host.h_name = bp;
			return(&host);
		}
		if (iquery || type != T_A)  {
#ifdef DEBUG
			if (_res.options & RES_DEBUG)
				printf("unexpected answer type %d, size %d\n",
					type, n);
#endif
			cp += n;
			continue;
		}
		if (haveanswer) {
			if (n != host.h_length) {
				cp += n;
				continue;
			}
			if (class != getclass) {
				cp += n;
				continue;
			}
		} else {
			host.h_length = n;
			getclass = class;
			host.h_addrtype = (class == C_IN) ? AF_INET : AF_UNSPEC;
			if (!iquery) {
				host.h_name = bp;
				bp += strlen(bp) + 1;
			}
		}

		bp += sizeof(align) - ((u_long)bp % sizeof(align));

		if (bp + n >= &hostbuf[sizeof(hostbuf)]) {
#ifdef DEBUG
			if (_res.options & RES_DEBUG)
				printf("size (%d) too big\n", n);
#endif
			break;
		}
		bcopy(cp, *hap++ = bp, n);
		bp +=n;
		cp += n;
		haveanswer++;
	}
	if (haveanswer) {
		*ap = NULL;
#if BSD >= 43 || defined(h_addr)	/* new-style hostent structure */
		*hap = NULL;
#else
		host.h_addr = h_addr_ptrs[0];
#endif
		return (&host);
      } 
      else 
      {
         h_errno = TRY_AGAIN;
	 return ((struct hostent *) NULL);
      }
}
/*=============================================================================
 * Pgethostbyname
 * This function performs a gethostbyname using the Internal Domain Name
 * Servers pointed to by /etc/firewall/resolv.inside.conf file instead of the 
 * /etc/resolv.conf file.
 *===========================================================================*/
struct hostent *Pgethostbyname(const char *name) 
{
   querybuf buf;
   register const char *cp;
   int n;
   extern struct hostent *_gethtbyname();

   /*============================================================
    * disallow names consisting only of digits/dots, unless
    * they end in a dot.
    *==========================================================*/
   if (isdigit(name[0]))
      for (cp = name;; ++cp) 
      {
         if (!*cp) 
         {
	    if (*--cp == '.')
	       break;
	    /*========================================
	     * All-numeric, no dot at the end.
	     * Fake up a hostent as if we'd actually
	     * done a lookup.
	     *=======================================*/
	    if (!inet_aton(name, &host_addr)) 
            {
	       h_errno = HOST_NOT_FOUND;
	       return((struct hostent *) NULL);
	    }
	    host.h_name = (char *)name;
	    host.h_aliases = host_aliases;
	    host_aliases[0] = NULL;
	    host.h_addrtype = AF_INET;
	    host.h_length = sizeof(u_long);
	    h_addr_ptrs[0] = (char *)&host_addr;
	    h_addr_ptrs[1] = (char *)0;
#if BSD >= 43 || defined(h_addr)	/* new-style hostent structure */
	    host.h_addr_list = h_addr_ptrs;
#else
	    host.h_addr = h_addr_ptrs[0];
#endif
	    return (&host);
	 }
	 if (!isdigit(*cp) && *cp != '.') 
	    break;
      }

      if ((n = res_search(name, C_IN, T_A, buf.buf, sizeof(buf))) < 0) 
      {
#ifdef DEBUG
      if (_res.options & RES_DEBUG)
         printf("res_search failed\n");
#endif
      if (errno == ECONNREFUSED)
         return (_gethtbyname(name));
      else
         return ((struct hostent *) NULL);
   }
   return (getanswer(&buf, n, 0));
}
/*========================================================================== 
 *
 *==========================================================================*/
struct hostent *Pgethostbyaddr(const char *addr, int len, int type)
{
   int n;
   querybuf buf;
   register struct hostent *hp;
   char qbuf[MAXDNAME];
   extern struct hostent *_gethtbyaddr();
	
   if (type != AF_INET)
      return ((struct hostent *) NULL);
   (void)sprintf(qbuf, "%u.%u.%u.%u.in-addr.arpa",
		((unsigned)addr[3] & 0xff),
		((unsigned)addr[2] & 0xff),
		((unsigned)addr[1] & 0xff),
		((unsigned)addr[0] & 0xff));
   n = res_query(qbuf, C_IN, T_PTR, (char *)&buf, sizeof(buf));
   if (n < 0) 
   {
#ifdef DEBUG
      if (_res.options & RES_DEBUG)
			printf("res_query failed\n");
#endif
      if (errno == ECONNREFUSED)
			return (_gethtbyaddr(addr, len, type));
      return ((struct hostent *) NULL);
   }
   hp = getanswer(&buf, n, 1);
   if (hp == NULL)
      return ((struct hostent *) NULL);
   hp->h_addrtype = type;
   hp->h_length = len;
   h_addr_ptrs[0] = (char *)&host_addr;
   h_addr_ptrs[1] = (char *)0;
   host_addr = *(struct in_addr *)addr;
#if BSD < 43 && !defined(h_addr)	/* new-style hostent structure */
	hp->h_addr = h_addr_ptrs[0];
#endif
   return(hp);
}
/*=========================================================================
 *
 *========================================================================*/
_sethtent(int f)
{
   if (hostf == NULL)
      hostf = fopen(_PATH_HOSTS, "r" );
   else
      rewind(hostf);
   stayopen |= f;
}
/*==========================================================================
 *
 *=========================================================================*/
_endhtent()
{
   if (hostf && !stayopen) 
   {
      (void) fclose(hostf);
      hostf = NULL;
   }
}
/*=========================================================================== 
 *
 *=========================================================================*/
struct hostent *
_gethtent()
{
   char *p;
   register char *cp, **q;

   if (hostf == NULL && (hostf = fopen(_PATH_HOSTS, "r" )) == NULL)
      return (NULL);
again:
   if ((p = fgets(hostbuf, BUFSIZ, hostf)) == NULL)
      return (NULL);
   if (*p == '#')
      goto again;
   cp = strpbrk(p, "#\n");
   if (cp == NULL)
      goto again;
   *cp = '\0';
   cp = strpbrk(p, " \t");
   if (cp == NULL)
      goto again;
   *cp++ = '\0';
   /* THIS STUFF IS INTERNET SPECIFIC */
#if BSD >= 43 || defined(h_addr)	/* new-style hostent structure */
   host.h_addr_list = host_addrs;
#endif
   host.h_addr = hostaddr;
   *((u_long *)host.h_addr) = inet_addr(p);
   host.h_length = sizeof (u_long);
   host.h_addrtype = AF_INET;
   while (*cp == ' ' || *cp == '\t')
      cp++;
   host.h_name = cp;
   q = host.h_aliases = host_aliases;
   cp = strpbrk(cp, " \t");
   if (cp != NULL) 
     *cp++ = '\0';
   while (cp && *cp) 
   {
      if (*cp == ' ' || *cp == '\t') 
      {
         cp++;
	 continue;
      }
      if (q < &host_aliases[MAXALIASES - 1])
         *q++ = cp;
      cp = strpbrk(cp, " \t");
      if (cp != NULL)
         *cp++ = '\0';
   }
   *q = NULL;
   return (&host);
}
/*======================================================================
 *
 *=====================================================================*/
struct hostent *  _gethtbyname(char *name) 
{
   register struct hostent *p;
   register char **cp;
	
   _sethtent(0);
   while (p = _gethtent()) 
   {
      if (strcasecmp(p->h_name, name) == 0)
			break;
      for (cp = p->h_aliases; *cp != 0; cp++)
         if (strcasecmp(*cp, name) == 0)
				goto found;
   }
found:
   _endhtent();
   return (p);
}

struct hostent *
_gethtbyaddr(addr, len, type)
	const char *addr;
	int len, type;
{
	register struct hostent *p;

	_sethtent(0);
	while (p = _gethtent())
		if (p->h_addrtype == type && !bcmp(p->h_addr, addr, len))
			break;
	_endhtent();
	return (p);
}
