/*============================================================================
 * filename:		raproxy/raproxy.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*===========================================================================
 *
 * mods written by:	R. James Livermore 
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.  
 * All rights reserved.
 *   
 * Last modified:	February   8, 2000 - added LPL
 *              
 *
 * This code is based the RealAudio Firewall Proxy Kit version 3.0
 *   
 * THE REALAUDIO FIREWALL PROXY KIT 3.0 BETA 1 
 * This file: $Date: 1996/12/19 23:53:22 $ $Revision: 1.14 $ 
 *
 * 
 * Copyright (c) 1996 Progressive Networks, Inc.
 * 
 * By clicking on the "Accept" button or opening the package, you are
 * consenting to be bound by this Agreement.  If you do not agree to all of
 * the terms of this agreement, click the "Do Not Accept" button and, if
 * you received the Software by package, return the product to the place of
 * purchase for a full refund.
 * 
 * 1. GRANT OF LICENSE.
 * 
 *  
 * Progressive Networks, Inc. (PN) grants to Recipient a limited,
 * non-exclusive, royalty-free license to use, modify, or redistribute the
 * Software without a fee, subject to the conditions stated below.
 * 
 * All other rights are reserved to PN. 
 * 
 * 
 * 2.  CONDITIONS
 * The above grant of license is subject to the following conditions:
 * 
 *        A) The copyright notice ("Copyright (c) 1996 Progressive
 *           Networks, Inc. ")  and this license appear on all copies of the
 *           Software and/or any derivatives of the Software.
 * 
 *        B) Recipient uses the Software or any derivatives only to build a
 *           firewall proxy for use with RealAudio products from PN.
 * 
 *        C) Recipient acknowledges and agrees that PN is and shall be the
 *           exclusive owner of all right, title and interest, including
 *           copyright, in the Software.
 * 
 * 3. SOFTWARE  MAINTENANCE. 
 * 
 * PN is not obligated to provide maintenance or updates to Recipient for
 * the Software. However, any maintenance or updates provided by PN shall
 * be covered by this Agreement.
 * 
 * 4. DISCLAIMER OF WARRANTY.
 * 
 * Software is deemed accepted by Recipient.  Because PN is providing
 * Recipient the Software for free, the Software is provided to Recipient
 * AS IS, WITHOUT WARRANTY OF ANY KIND. TO THE MAXIMUM EXTENT PERMITTED
 * BYAPPLICABLE LAW, PROGRESSIVE NETWORKS FURTHER DISCLAIMS ALL
 * WARRANTIES,INCLUDING WITHOUT LIMITATION ANY IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NONINFRINGEMENT. THE ENTIRE RISK ARISING OUT OF THE USE OR PERFORMANCE
 * OF THE SOFTWARE REMAINS WITH RECIPIENT. TO THE MAXIMUM EXTENT PERMITTED
 * BY APPLICABLE LAW, IN NO EVENT SHALL PROGRESSIVE NETWORKS OR ITS
 * SUPPLIERS BE LIABLE FOR ANY CONSEQUENTIAL, INCIDENTAL, DIRECT, INDIRECT,
 * SPECIAL, PUNITIVE, OR OTHER DAMAGES WHATSOEVER (INCLUDING, WITHOUT
 * LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION,
 * LOSS OF BUSINESS INFORMATION, OR OTHER PECUNIARY LOSS) ARISING OUT OF
 * THIS AGREEMENT OR THE USE OF OR INABILITY TO USE THE SOFTWARE, EVEN IF
 * PROGRESSIVE NETWORKS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGES. BECAUSE SOME STATES/JURISDICTIONS DO NOT ALLOW THE EXCLUSION OR
 * LIMITATION OF LIABILITY FOR CONSEQUENTIAL OR INCIDENTAL DAMAGES, THE
 * ABOVE LIMITATION MAY NOT APPLY TO RECIPIENT.
 * 
 * 5. INDEMNIFICATION. 
 * 
 * Recipient hereby agrees to defend, indemnify, and hold PN, its
 * directors, officers, employees and agents, harmless from any and all
 * claims, damages, and expenses (including attorneys fees and costs) of
 * any nature arising out of the use, modification, or redistribution the
 * Software or any derivatives.
 * 
 * 6. U.S. GOVERNMENT RESTRICTED RIGHTS AND EXPORT RESTRICTIONS. 
 * 
 * The Software is provided with RESTRICTED RIGHTS. Use, duplication, or
 * disclosure by the Government is subject to restrictions as set forth in
 * subparagraph (c)(1)(ii) of The Rights in Technical Data and Computer
 * Software clause of DFARS 252.227-7013 or subparagraphs (c)(i) and (2) of
 * the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19,
 * as applicable. Manufacturer is Progressive Networks, 616 First Avenue,
 * Suite 701, Seattle, Washington 98104-2258. Recipient acknowledges that
 * none of the Software or underlying information or technology may be
 * downloaded or otherwise exported or re-exported (i) into (or to a
 * national or resident of) Cuba, Iraq, Libya, Yugoslavia, North Korea,
 * Iran, Syria or any other country to which the U.S. has embargoed goods;
 * or (ii) to anyone on the U.S. Treasury Department's list of Specially
 * Designated Nationals or the U.S. Commerce Department's Table of Denial
 * Orders.  By using the Software, you are agreeing to the foregoing and
 * you are representing and warranting that you are not located in, under
 * the control of, or a national or resident or resident of any such
 * country or on any such list.
 * 
 * 7. GOVERNING LAW; ATTORNEYS FEES. 
 * 
 * This agreement shall be governed by the laws of the State of Washington
 * and Recipient further consents to jurisdiction by the state and federal
 * courts sitting in the State of Washington. If either PN or Recipient
 * employs attorneys to enforce any rights arising out of or relating to
 * this Agreement, the prevailing party shall be entitled to recover
 * reasonable attorneys' fees.
 * 
 * 8. ENTIRE AGREEMENT. 
 * 
 * This agreement constitutes the complete and exclusive agreement between
 * PN and Recipient with respect to the subject matter hereof, and
 * supersedes all prior oral or written understandings, communications or
 * agreements not specifically incorporated herein.  This agreement may not
 * be modified except in a writing duly signed by an authorized
 * representative of PN and Recipient.
 *
 *===========================================================================
 *
 *  Usage Notes: 
 *  - we assume we're being called from inetd or in some way that
 *	the control connection is on fd 0.  
 *
 *  -  Go through the proxy dialog with the player and get "useful" info
 *  -  Setup control connection to the "real" server.
 *  -  For non tcp connections, setup UDP backchannel passthrough stream.
 *  -  Copy control data to/from player/server
 *  -  For udp, copy data stream from server to player.
 *==========================================================================*/


/* use tabstop=4 */
#include	<stdio.h>
#include	<ctype.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/times.h>
#include	<sys/socket.h>
#include	<unistd.h>
#include	<netdb.h>
#include	<netinet/in.h>
#include	<sys/signal.h>
#include	<syslog.h>
#include	"raproxy.h"
#include	"firewall.h"
#include	"rap.h"
#ifndef __hppa
#include <sys/select.h>
#endif

#define NO_UDP

#ifdef USE_SOCKS
#define connect Rconnect
#define accept  Raccept
#define getsockname Rgetsockname
#define bind Rbind
#define listen Rlisten
#endif  /* USE_SOCKS */

#ifdef SYSV
/* if you don't have bzero/bcopy, define SYSV. */
#define bcopy(src, dest, size) memcpy(dest, src, size)
#define bzero(buf,size) memset(buf, '\0', size);
#endif /* SYSV */

/* define the logging facility/level for the proxy */
#define LOG_FACILITY	LOG_DAEMON
#define LOG_LVL	LOG_NOTICE

#ifdef LOAD_LIMIT
#define LOAD_OK			0	/* load limit not reached */
#define LOAD_EXCEEDED		1	/* load limit exceeded */
#define LOAD_PROBLEM		2	/* locking/counting problems */
/*============================================================
 * flag to indicate whether max audio streams are being used 
 *============================================================*/
int load_limit_reached = LOAD_PROBLEM;
#endif /* LOAD_LIMIT */

/* socket to audio server */
int serverfd;

/* if client wants udpresends */
int clientudpresend = 0;
/* udp port to look for audio resends */
unsigned short clientresendport;
/* udp socket to listen for audio resends */
int clientresendfd = 0;
/* udp socket to send audio resends to server */
int svrresendfd;
/* server address for udp resend stream */
struct sockaddr_in serverinfo;


#ifndef NO_UDP
/* udp sockets for audio */
int serveraudiofd, playeraudiofd;
/* client/player address for udp stream */
struct sockaddr_in playerinfo;
#endif /* !NO_UDP */

struct RAPROXY *proxptr;
#ifndef linux
extern char *sys_errlist[];
#else
extern const char *const sys_errlist[];
#endif

void debugbind(unsigned short debugport);
int proxydialog(struct RAPROXY *proxptr);
int raprules(struct RAPROXY *proxptr);
int serverconnect(struct RAPROXY *proxyptr, char *hostname, unsigned short port);

/*=========================================================================================
 *
 *=======================================================================================*/
main( int argc, char **argv)
{
   static  char	ident[] = "@(#) raproxy, V 1.0, 00/01/21"
 			  " (C) Freemont Avenue Software, Inc."
			  " 1995-2000";

   fd_set	readfds, dummy;
   char		buf[2048];
   struct	timeval *timeout = (struct timeval *)0;
   int		use_tcp;
   int 		yes_resend = 0;
   int		firsttime = 1;
   extern	int errno;
   int		IPsecure = -1;
   static char	srchost[512];
   static char	srcIP[20];
   struct tms	tmsstart;
   struct tms	tmsend;
   clock_t	start;
   clock_t	end;
   static long	clock_ticks = 0;
   static char	locIP[20];
   struct	sockaddr_in la;
   unsigned short	debugport = 7777;
   int		portid = -1;
   char		*servnam;
   int		siz;
   long		tempport;
   struct RAPROXY	RAPprox;

#ifdef DEBUG
	/*========================================================== 
	 * define DEBUG if you want to run this via a debugger 
	 * SEE debugit() below.
	 *===========================================================*/
	debugit();
#endif /* DEBUG */


   if( (start = times(&tmsstart)) < 0)
   {
      syslog(LOG_ERR, "Error: times function failed.");
   }
   if( ( clock_ticks = sysconf(_SC_CLK_TCK)) < 0)
   {
      syslog(LOG_ERR, "Error: sysconf(_SC_CLK_TCK) function failed");
   }

/* Initialize RAPROXY structure */

   proxptr	= &RAPprox;
   memset(&RAPprox, 0, sizeof(struct RAPROXY));
   strcpy(proxptr->raproxpath,"/home/hermes");
   proxptr->locPort = -1;
   proxptr->destPort = -1;

   openlog("raproxy", LOG_PID|LOG_NDELAY, LOG_DAEMON);
   /*=======================================================================
    * If Debug is specified this will bind the port and listen directly
    * (circumventing inetd) so you can run the program under a debugger
    *======================================================================*/
   if( argc > 2)
   {
      if( strcmp(argv[2],"-D") == 0)
      {
         /* check for debug port number */
         if(argc > 3 )
         {
            if( (strlen(argv[3]) < 6) && isalldigits(argv[3]) )
            {
               if( (tempport = atoi(argv[3])) > 64000)
               {
                  printf("\ngenproxy: portnumber > 64000. Please try again.\n");
                  close(0);
                  exit(1);
               }
            debugport = tempport;
            }
            else
            {
               printf("\ngenproxy: invalid portnumber (%s), must be a positive "
	   	      "integer less than 64000."
		      "\n		Please try again.\n", 
                      argv[3]);
               close(0);
               exit(1);
            }
         }
         printf("\ngenproxy: Debug mode specified. Use port %d.\n", debugport);
         debugbind(debugport);
      }
   }

   /* If called with an argument, it is the connecting service name */
   if( argc > 1)
      servnam = argv[1];
   else
      servnam = argv[0];
   /*======================================================================
    * If the service name is all digits then convert from alpha to integer.
    * Else lookup the service by name from the etc/services file.
    *=====================================================================*/
   if(isalldigits(servnam))
      proxptr->locPort = atoi(servnam);
   else
   {
      struct servent	*sp;
      if((sp = getservbyname(servnam, "tcp")) != (struct servent *) 0)
         portid = ntohs(sp->s_port);
      else
      {
         syslog(LOG_ERR, "Error: unknown service '%s' can not decode to port."
			 " Check /etc/services file.",
                	 servnam);
         close(0);
         exit(1);
      }
   }


#ifdef USE_SOCKS
   SOCKSinit(argv[0]);
#endif /* USE_SOCKS */

#ifdef LOAD_LIMIT
   /* increment load count */
   load_limit_reached = raloadlimit(1);
#endif /* LOAD_LIMIT */

   /*========================================================
    * get remote hostname and IP addy in dot decimal format 
    *=======================================================*/
   if(peername(0, srchost, srcIP, sizeof(srchost)))
   {
      syslog(LOG_ERR, "Error: getpeername for client (%s) failed.",
		      srcIP);
      close(0);
      exit(1);
   }
   strncpy(proxptr->srcHost,srchost,sizeof(proxptr->srcHost));
   strncpy(proxptr->srcIP, srcIP, sizeof(proxptr->srcIP));

   siz = sizeof(la);
   if(getsockname(0,(struct sockaddr *)&la,(socklen_t *)&siz) < 0)
   {
      syslog(LOG_ERR, "Error: get sockname failed: %s.", sys_errlist[errno]);
      exit(1);
   }

   /* conver local ip address to ACSII string in dot decimal dormat */
   siz = sizeof(locIP);
   strncpy(locIP, inet_ntoa(la.sin_addr),siz);
   locIP[siz-1] = '\0';
   strncpy(proxptr->locIP,locIP,siz);
   /* ipsecure returns 0 if secure else -1 */
   IPsecure = ipsecure(locIP);

   /*======================================================================= 
    * do initial "proxy dialog" with client and connect to audio server
    *  (globally sets serverfd)
    *=====================================================================*/
   if ( (use_tcp = proxydialog(proxptr)) < 0 ) 
   {
      /*========================================================== 
       * some PC/MAC stacks disconnect immediately - we'll add a
       *  delay to make sure they get all messages.
       *=========================================================*/
      sleep(2);
      close(0);
      if ( serverfd )
         close(serverfd);
      ra_exit(1);
   }

#ifndef NO_UDP
   /*============================================================== 
    * For udp, then setup udp backchannel sockets/data etc
    * (globally sets, playeraudiofd, serveraudiofd and playerinfo)
    * If we have udp resends we also globally set
    *	clientresendfd, svrresendfd, serverinfo
    *============================================================*/
   if ( use_tcp == 0 ) 
   {
      if ( setupdialog() < 0 ) 
      {
	 sleep(2); /* for problem stacks - see above */
	 ra_exit(1);
      }
   }
#endif /* !NO_UDP */

   /*========================================================================== 
    * Main loop
    *  - we've done all the proxy setup
    *  - we have descriptors for sending/receiving control info
    *    to/from player/server 
    *	  - 0 is control socket to/from player (setup by inetd)
    *	  - serverfd is control socket to/from server (setup from proxydialog)
    *  - for udp connections we also have descriptors for 
    *    - sending/receiving audio info. (setup in udpaudiosetup)
    *	  - playeryaudiofd is socket for sending udp audio
    *	  - serveraudiofd is socket for receiving udp audio
    *    - playerinfo has address info for udp audio "write"
    *    - listening for udp resends from client
    *    - sending udp resends to server
    *    - serverinfo has address info for resends "write"
    *
    *  - Now just sit and wait for info and copy it to the
    *    appropriate place.
    *========================================================================*/

   FD_ZERO(&dummy);
   FD_SET(0, &dummy);
   FD_SET(serverfd, &dummy);
#ifndef NO_UDP
   if (use_tcp == 0 ) 
   {
      FD_SET(serveraudiofd, &dummy);
   }
#endif /* !NO_UDP */  
   /*====================================================================
    *
    *===================================================================*/
   while (1) 
   {
      struct 		sockaddr_in from;
      int 		fromlen = sizeof(from);
      int 		count;

      (void) bcopy( &dummy, &readfds, sizeof(fd_set) );
      if ( select(FD_SETSIZE, &readfds, (fd_set *)0, (fd_set *)0,timeout) <= 0) 
      {
         syslog(LOG_NOTICE,"select timeout, %d sec. client %s (%s)",
			    timeout,proxptr->srcHost,proxptr->srcIP);
         break;
      }
      /*  read/write control info (and sometimes audio) from server to player */
      if ( FD_ISSET(serverfd, &readfds) ) 
      {
         /* client wants resends, but need to see if server agrees */
	 if ( clientudpresend && firsttime) 
         {
	    firsttime = 0;
	    /* check server options to see if it will do udp resends */
	    if ( (yes_resend=udpresendsetup2()) < 0 ) 
            {
	       /* syslog error? */ 
               syslog(LOG_ERR,"Error: UDP Resend not supported.");
	       return(-1);
	    } 
				
	    if ( yes_resend )
	       FD_SET(clientresendfd, &dummy);
         }  
         if ( (count = read( serverfd, buf, sizeof(buf))) <= 0 )
            break;
	 proxptr->numreads++;
	 proxptr->bytesread = proxptr->bytesread + count;
         if ( write(0, buf, count) != count )
            break;
      }   
      /*==================================================  
       * read/write control info from player to server 
       *================================================*/
      if ( FD_ISSET(0, &readfds) ) 
      {
         if ( (count = read(0, buf, sizeof(buf)) ) <= 0 )
            break;
	 proxptr->numwrites++;
	 proxptr->byteswritten = proxptr->byteswritten + count;
         if ( write(serverfd, buf, count) != count )
            break;
      }
#ifndef NO_UDP
      if (use_tcp == 0 ) 
      {
         /* write audio data from server to player */
         if ( FD_ISSET(serveraudiofd, &readfds) ) 
         {
            /*========================================================= 
             * you may want to check the source/from address to see if
             * the stream is coming from the "right" place.  Given
             * this is udp it could be easily spoofed. (All
             * you would get is "garbage" in the audio stream).
             *========================================================*/
            if( (count = recvfrom(serveraudiofd, buf, sizeof(buf),
	 			0, (struct sockaddr *)&from, &fromlen) ) <= 0 ) 
            {
	       break;
	    }
	    if( sendto(playeraudiofd, buf, count, 0, 
		 (struct sockaddr *)&playerinfo, sizeof(playerinfo)) != count )
	       break;
         }
      }
#endif /* !NO_UDP */

      if ( yes_resend ) 
      {
         if ( FD_ISSET(clientresendfd, &readfds) ) 
         {
            if( (count = recvfrom(clientresendfd, buf, sizeof(buf),
	 			0, (struct sockaddr *)&from,
				(addrlen_t *)&fromlen) ) <= 0 ) 
            {
               break;
	    }
	    if( sendto(svrresendfd, buf, count, 0, 
		 (struct sockaddr *)&serverinfo, sizeof(serverinfo)) != count ) 
            {
	       break;
            }
         }
      }
   }
   ra_exit(0);
}
/*========================================================================================
 *
 *======================================================================================*/
ra_exit(int error)
{
#ifdef LOAD_LIMIT
   /* decrement load count */
   if ( load_limit_reached == LOAD_OK )
      raloadlimit(0);
#endif /* LOAD_LIMIT */
   syslog(LOG_NOTICE, "RealAudio player at %s (%s) disconnect from %s (%s) "
	"reads = %d, writes = %d, bytes read = %.0f "
	"bytes written = %.0f",
	proxptr->srcHost,	proxptr->srcIP,
	proxptr->destname,	proxptr->destIP,
	proxptr->numreads,	proxptr->numwrites,
	proxptr->bytesread,	proxptr->byteswritten);
	
   exit(error);
}

/* storage for "proxy info" from client - need by udpaudiosetup() */
static unsigned short backportoffset;

/*========================================================================================
 *  Send version info to player then wait for appropriate info
 *	to validate proxy dialog.
 *======================================================================================*/
int proxydialog(struct RAPROXY *proxyptr)
{
   unsigned char opcode;
   unsigned char version = RA_PROXYVERSION;
   unsigned char connecttype = 0;
   int gothostname = 0, gotserverport = 0, gotbackport = 0, gotconnecttype = 0;
   unsigned short serverport = 0;
   short msgbytes;
   int done;
   char *hostname;
   void timeoutexit(int), signalerror();
   extern int errno;


   /* setup a timeout in case proxy dialog doesn't finish */
   signal(SIGALRM, timeoutexit);
   signal(SIGPIPE, signalerror);
   alarm(RA_TIMEOUT);

	/* send our proxy version # */
	msgbytes = htons(2);
   if ( write(0, &msgbytes, 2) != 2 ) 
   {
	/* syslog error */
	syslog(LOG_ERR, "Error: sending version '%d'to client 1: %m",
			msgbytes);
	return(-1);
   }
   opcode = RA_VERSION;
   if ( write(0, &opcode, 1) != 1 ) 
   {  
	syslog(LOG_ERR, "Error: sending opcode '%s' to client 2: %m",
			opcode);
	return(-1);
   }
   if ( write(0, &version, 1) != 1 ) 
   {
	/* syslog error */
	syslog(LOG_ERR, "Error: sending version '%s' to client 3: %m",
			version);
	return(-1);
   }

   /*===================================================================== 
    * read proxy info from client 
    *  - procotol version comes first
    *  the following info can be in any order:
    *  - server hostname
    *  - server port number
    *  - offset of "backchannel data port" in subsequent control stream
    *  - is this a udp or tcp connection.
    *===================================================================*/

	
   /*========================================
    * check if first info is version # 
    *=======================================*/
   if ( getopcode(&msgbytes) != RA_VERSION ) 
   {
	/* syslog error? */
	syslog(LOG_LVL, "Warning: bad proxy protocol version '%d'. ",
			msgbytes);
	sendstatus(RA_BADCODE, 0);
	return(-1);
   }
   if ( gread( 0, &version, 1) != 1 ) 
   {
	syslog(LOG_ERR, "Error: reading version from client: %m");
	return(-1);
   }

   if ( version != RA_PROXYVERSION ) 
   {
	syslog(LOG_ERR, "Error: bad version from client: %m");
	sendstatus(RA_BADVERSION,0);
	/* return status error to player TBD */
	return(-1);
   }
   proxptr->numwrites++;
   proxptr->byteswritten++;
   done = 0;
   /*============================================================================
    *
    *==========================================================================*/
   while ( !done ) 
   {

      switch(getopcode(&msgbytes))
      {
      	case RA_HOSTNAME:
		if ( (hostname = (char *)malloc(msgbytes + 1)) == (char *) NULL ) 
                {
	           syslog(LOG_ERR, "Error: malloc()failed, out of memory.");
		   return(-1);
		}
					
		if ( gread( 0, hostname, msgbytes) != msgbytes ) 
                {
	           syslog(LOG_ERR, "Error: reading hostname from client: %m");
		   return(-1);
		}
		hostname[msgbytes] = '\0';
		strcpy(proxptr->destname,hostname);
		gothostname = 1;
		proxptr->numwrites++;
		proxptr->byteswritten =+ msgbytes;
		break;
	case RA_SERVERPORT:
		if ( gread( 0, &serverport, msgbytes) != msgbytes ) 
                { 
		   syslog(LOG_ERR, "Error: reading server port from client: %m");
		   return(-1);
		}
		serverport = ntohs(serverport);
		gotserverport = 1;
		proxptr->numwrites++;
		proxptr->byteswritten =+ msgbytes;
		break;
	case RA_BACKPORTOFFSET:
		/* we need to read this, but don't use it anymore */
		if ( gread( 0, &backportoffset, msgbytes) != msgbytes ) 
                { 
		   syslog(LOG_ERR, "Error: reading backport offset from "
		   		   "client: %m");
		   return(-1);
		}
		backportoffset = ntohs(backportoffset);
		gotbackport = 1;
                proxptr->numwrites++;
                proxptr->byteswritten =+ msgbytes;
		break;
	case RA_CONNECTTYPE:
		if ( gread( 0, &connecttype, msgbytes) != msgbytes ) 
                {  
		   syslog(LOG_ERR, "Error: reading connection type from "
		   		   "client: %m");
		   return(-1);
		}
		gotconnecttype = 1;
                proxptr->numwrites++;
                proxptr->byteswritten =+ msgbytes;
		break;
	case RA_END:
		/* got all the info we need?  If not, send error */
			
		if ( gothostname && gotserverport && gotconnecttype  
				 && (gotbackport ^ connecttype) ) 
                {
		   done = 1;
		   break;
		} else 
                {  
		   syslog(LOG_ERR, "Error: not enough proxy info");
		   sendstatus(RA_BADINFO, 0);
		   return(-1);
		} 
				
	default:
		syslog(LOG_ERR, "Error: invalid proxy opcode.");  
		/* return unknown code status error to player */
		sendstatus(RA_BADCODE, 0);
		return(-1);
		/* NOT REACHED */
	}
   }

   alarm(0);  /* "turn-off" alarm */
#ifdef NO_UDP
   /*===========================================================
    * if UDP specified and not compiled for UDP, send an error 
    *==========================================================*/
   if ( connecttype == 0 ) 
   {
      sendstatus(RA_NOUDP, 0);
      syslog(LOG_ERR, "Error: UDP audio streams not supported.");
      return(-1);
   }
#endif /* NO_UDP */
#ifdef LOAD_LIMIT
   if (load_limit_reached == LOAD_EXCEEDED) 
   {
      sendstatus(RA_LIMIT, 0);
      syslog(LOG_ERR, "Error: Audio streams limit reached.");
      return(-1);
   }
   if (load_limit_reached == LOAD_PROBLEM) 
   {
      sendstatus(RA_LIMITPROB, 0);
      syslog(LOG_LVL, "Error: Problem accessing/locking limit lockfile.");
      return(-1);
   }
#endif /* LOAD_LIMIT */

   /*======================================================= 
    * Check if user is permitted to connect to the server 
    *======================================================*/
   if( raprules(proxyptr) != 0)
   {
     syslog(LOG_ERR, "Security Alert: user at %s (%s) is not permitted "
	             "to use the Real Audio Proxy.",
		     proxyptr->srcIP,proxyptr->srcHost);
     sendstatus(RA_NOCONNECT, errno);
     return(-1);
   }

   /* Can we connect to the server */
   if ( (serverfd = serverconnect(proxptr, hostname, serverport)) < 0 ) 
   {
      /* errno is still set from previous call */
      sendstatus(RA_NOCONNECT, errno); 

      return(-1);
   } else 
   {
      /* send success message to player */
      sendstatus(RA_SUCCESS, 0);
   }
   return(connecttype);
}
/*=============================================================================
 *
 *============================================================================*/
void signalerror(int signal)
{
	/*syslog(LOG_LVL, "raproxy: SIGPIPE received.");*/
	ra_exit(1);
}

void timeoutexit(int sig)
{
	/* syslog error? */
	syslog(LOG_LVL, "raproxy: Timeout waiting for proxy info");
	ra_exit(1);
}



#include <ctype.h> 
/*=============================================================================
 * Connect to a server
 *
 *  Args:
 * 	Hostname:  null terminated string with name/IP address
 *	Port:	   port number to connect to.
 * 
 *  Return Value:  file descriptor for connection
 *			or 
 *		-1 for various errors 
 *		(Should probably have multiple errors for different
 *			problems)
 *		
 *============================================================================*/
int serverconnect(struct RAPROXY *proxyptr, char *hostname, unsigned short port)
{
   char			*cp;
   struct hostent	*hp;
   struct sockaddr_in	addr;
   int			fd;
   unsigned long	ipaddr;
   extern int errno;


   /* Check if hostname is an IP address (ie. only digits and dots) */
   ipaddr = inet_addr(proxyptr->srcHost);
   if (ipaddr != (unsigned long) -1) 
   {
      (void) bcopy((char *)&ipaddr, (char *)&addr.sin_addr, sizeof(ipaddr));
   } else 
   {
      /* must be a real hostname, do lookup */
      if ( (hp = gethostbyname(proxyptr->destname)) == (struct hostent *)0 )
      {
	syslog(LOG_ERR,"Error: gethostbyname(%s) failed, errno %d",
		proxyptr->destname,errno);
	return(-1);
      }
      (void) bcopy(hp->h_addr, (char *)&addr.sin_addr, hp->h_length);
   }
   addr.sin_port = htons(port);
   addr.sin_family = AF_INET;
   cp = (char *) inet_ntoa(addr.sin_addr);
   strncpy(proxyptr->destIP,cp,20);
   /* setup socket */
   fd = socket(AF_INET, SOCK_STREAM, 0);
   if ( fd < 0 ) 
   {
      return(-1);
   }
   /* connect to server - errno will still be set if we need it later */
   if ( connect(fd, (struct sockaddr *)&addr, sizeof(addr)) < 0 ) 
   {
	syslog(LOG_ERR,"Error: connect failed, src = %s (%s) dest = %s (%s) "
		"Port = %d",
		proxyptr->srcHost, proxyptr->srcIP,
		proxyptr->destname, proxyptr->destIP, port);
	return(-1);
   }
   return(fd);
}

/*==============================================================================*
 * send proxy protocol status message to client
 * (It would also be useful to append an OS error string for some cases)
 *=============================================================================*/
int sendstatus(unsigned int code, unsigned int os_errno)
{
   short	size;
   int		msgsize;
   char 	*msg;
   unsigned char	opcode;
   char		buf[2048];
   char		*strerror();


	msg = statusmsgs[code];
	/* if we have an errno, append the error to the message */
		
	if ( msg != (char *)NULL ) {
		strncpy(buf, msg, strlen(msg) + 1);
		if ( os_errno )  {
			char *p = strerror(os_errno);

			strncat(buf, p, strlen(p) + 1);
		}
		msgsize = strlen(buf) + 1;
		size = htons(msgsize + 2);
	} else {
		size = htons(2);  
	}

	/* write out message size */
	if ( write(0, &size, 2) != 2 ) {
		return(-1);
	}
	opcode = RA_STATUS;
	if ( write(0, &opcode, 1) != 1 ) {
		return(-1);
	}
	/* write out status code */
	if ( write(0, &code, 1) != 1 ) {
		return(-1);
	}
	if ( msg != (char *)NULL ) {
		/* write out status message */
		if ( write(0, buf, msgsize) != msgsize ) {
			return(-1);
		}
	}
	return(0);
}

#ifndef NO_UDP
/*===========================================================================
 * setup udp audio backchannel sockets from server to client 
 *===========================================================================*/
int udpaudiosetup(unsigned short player_audioport)
{
   int		size;
   struct sockaddr_in	addr, info;

   /* setup bind/listen etc for udp backchannel from server */
   if ( (serveraudiofd = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0 ) 
   {
      /* syslog  error */
      syslog(LOG_ERR, "Error: can't setup socket: %m");
      return(-1);		/* Probably out of sockets */
   }
   (void) bzero (&addr, sizeof (addr));
   addr.sin_family = AF_INET;
   /*========================================================= 
    * port to receive audio from server
    * if you want this to be in some specific port range
    * then add your code to to that here.
    *=======================================================*/
   addr.sin_port = htons(0);
   if ( bind(serveraudiofd, (struct sockaddr *)&addr, sizeof (addr)) < 0 ) 
   {
      syslog(LOG_ERR, "Error: can't bind socket: %m");
      return(-1);
   }

   /* lets get socket info so later we can find out our local port */
   size = sizeof(info);
   if ( getsockname(serveraudiofd, (struct sockaddr *)&info, &size)  < 0 ) 
   {
      syslog(LOG_ERR, "Error: can't getsockname(): %m");
      return(-1);
   }

   /* send server the port number it should use to talk to us */
   if ( write(serverfd, &info.sin_port, 2) != 2) 
   {
      /* syslog error ? */
      syslog(LOG_ERR, "Error: writing backport to server.");
      return(-1);
   }
	
	/* create socket for talking to player audio port */
	if ( (playeraudiofd = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0 ) {
		/* syslog error */
		syslog(LOG_LVL, "raproxy: error creating audio socket to client: %m");
		return(-1);		
	}
	/* get inet info of client/player - we need this later  */
	size = sizeof(playerinfo);
	if ( getpeername(0, (struct sockaddr *)&playerinfo,
						(socklen_t *)&size) < 0 ) {
		/* syslog error ? */
		syslog(LOG_LVL, "raproxy: error getting peername of client: %m");
		return(-1);
	}
	/* now point back to audio port on player */
	playerinfo.sin_port = player_audioport;
	return(0);
}
#endif /* !NO_UDP */


/*========================================================================
 * get proxy protocol opcode from control channel
 *
 * Args: msgbytes - pointer to store number of bytes in message
 *			stream.
 *
 * Returns: -1 on error
 *		    opcode that was read
 *======================================================================*/
int getopcode(short *msgbytes)
{
	unsigned char opcode = 0;

	*msgbytes = 0;
	/* read byte count from stream */
	if ( gread(0, msgbytes, 2) != 2 ) {
		return(-1);
	}
	/* read opcode from stream */
	if ( gread( 0, &opcode, 1) != 1 ) {
		return(-1);
	}
	/* bogus opcode */
	if ( opcode > RA_STATUS ) {
		/* syslog error for this? */
		return(-1);
	}
	/* 
	 * convert # of bytes in message to local byte order (and remove
	 * the byte that was for the opcode)
	 */
	*msgbytes = ntohs(*msgbytes) - 1;
	/* check if # bytes is correct */
	if ( (opcodebytes[opcode] == -1) )
		return(opcode);
 	if (opcodebytes[opcode] != *msgbytes) {
		/* syslog error for this? */
		return(-1);
	}
	return(opcode);
}
/*=============================================================================
 *
 *============================================================================*/
void debugbind(unsigned short debugport)
{
  struct sockaddr_in mya;
  int x;
  int nread;

  if((x = socket(AF_INET,SOCK_STREAM,0)) < 0)
  {
    perror("socket");
    exit(1);
  }
  mya.sin_family = AF_INET;
  bzero(&mya.sin_addr,sizeof(mya.sin_addr));
  mya.sin_port = htons(debugport);
  if(bind(x,(struct sockaddr *)&mya,sizeof(mya)))
  {
    perror("bind");
    exit(1);
  }
  if(listen(x,1) < 0)
  {
    perror("listen");
    exit(1);
  }
  if((nread = accept(x,0,0)) < 0)
  {
    perror("accept");
    exit(1);
  }
  close(0);
  dup(nread);
  close(1);
  dup(nread);
}

#ifdef	DEBUG
/*============================================================================
 * Define DEBUG and set the define below to the port
 * that you want the proxy to bind to.  This can be useful
 * for running the proxy with a debugger.
 * 
 *==========================================================================*/
#define DEBUGPORT	5556
debugit()
{
   struct	sockaddr_in	addr;
   int	sock, newfd, val=1;

   if( (sock = socket(AF_INET,SOCK_STREAM,0)) < 0 ) 
   {
      perror("socket problem");
      exit(1);
   }
   bzero(&addr,sizeof(addr));
   addr.sin_port = htons(DEBUGPORT);
   addr.sin_family = AF_INET;
   if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &val, sizeof val) < 0 ) 
   {
      perror("setsockopt problem");
      exit(1);
   }
   if( bind( sock, (struct sockaddr *)&addr, sizeof(addr)) ) 
   {
      perror("bind problem");
      exit(1);
   }
   if( listen(sock, 1) < 0 ) 
   {
      perror("listen problem");
      exit(1);
   }
   if( ( newfd=accept(sock, 0, 0) ) < 0 ) 
   {
      perror("accept");
      exit(1);
   }
   /* close stdin/out and dup to socket we just setup */
   close(0);
   dup(newfd);
   close(1);
   dup(newfd);
}
/*=============================================================================
 *
 *============================================================================*/
dump(char *buf, int count)
{
   char *p = buf;
   while ( count--)  
   {
      fprintf(stderr, "0x%x ", (unsigned int)*p++);
      if ( (count %10) == 0)
         fprintf(stderr, "\n");
   }
   fprintf(stderr, "\n");
}
#endif /* DEBUG */


#ifdef SUNOS
static char unknown_err[] = "Unknown Error.";

char *
strerror(errnum)
int errnum;
{
        extern int sys_nerr;
        extern char *sys_errlist[];

        if ( errnum >= sys_nerr )
                return (unknown_err);
        else
                return ( sys_errlist[errnum] );
}

#endif /* SUNOS */

#ifdef LOAD_LIMIT

/*============================================================================
 *  "Rudimentary" code for limiting the number of audio streams/proxies
 *  running at the same time.  (LOAD_LIMIT must be defined for this
 *  code to be compiled in.  You also need to #define FLOCK if your
 *  OS uses FLOCK locking,  otherwise FCNTL locking will be used.  Most
 *  people should define FLOCK unless you are straight System V).
 *
 *  We keep a count of the # of proxies running.  This count is kept
 *  as a binary integer in the file mentioned in raproxy.h
 *  At boot time the program raloadinit, needs to be called to
 *  create and initialise this file.
 *
 *  Once the lock/count file is created, we increment/decrement the count
 *  on entry and exit.  If the limit is exceeded, the user receives
 *  an appropriate proxy error message.
 *
 *
 *	Args:  direction  - 1 increment
 *					    0 decrement
 *
 *	Returns:	 0 everything successful
 *				 1 limit exceeded, locking problem, decrement count on exit
 *				 2 some problem, DON'T decrement count on exit
 *
 *
 *  
 *============================================================================*/
#include <sys/file.h>
int raloadlimit(int direction)
{
	int fd;
	int numstreams = 0;

	if ( (fd = open(ralockfile, O_RDWR)) < 0 ) {
		syslog(LOG_LVL, "raproxy: no lock file for streams: %m");
		return(LOAD_PROBLEM);
	}
	if ( lockfile(fd) != 0 ) {
		syslog(LOG_LVL, "raproxy: couldn't lock file for UDP stream limiting: %m");
		return(LOAD_PROBLEM);
	}
	if ( read(fd, &numstreams, ranumbytes) != ranumbytes ) {
		syslog(LOG_LVL, "raproxy: error on lock file for streams: %m");
		return(LOAD_PROBLEM);
	}
	if ( direction )
		++numstreams;
	else
		--numstreams;
	if ( numstreams < 0 ) {
		syslog(LOG_LVL, "raproxy: number of Audio streams < 0????.");
		return(LOAD_PROBLEM);
	}
	if ( numstreams > maxaudiostreams ) {
		syslog(LOG_LVL, "raproxy: Exceeded max number of Audio streams.");
		return(LOAD_EXCEEDED);
	}
	lseek(fd, SEEK_SET, 0);
	if ( write(fd, &numstreams, ranumbytes) != ranumbytes ) {
		syslog(LOG_LVL, "raproxy: write error on lock file for streams: %m");
		return(LOAD_PROBLEM);
	}
	if ( unlockfile(fd) != 0 ) {
		syslog(LOG_LVL, "raproxy: couldn't lock file for UDP stream limiting: %m");
		return(LOAD_PROBLEM);
	}
	if ( close(fd) < 0 ) {
		syslog(LOG_LVL, "raproxy: write error on lock file for streams: %m");
		return(LOAD_PROBLEM);
	}
	return(LOAD_OK);
}

#include <sys/file.h>

int lockfile(int fd)
{

#ifdef FLOCK
	if ( flock(fd, LOCK_EX) < 0 )
		return(1);
	return(0);

#else /* !FLOCK */
	struct flock lock;

	bzero( &lock, sizeof(lock));
	lock.l_type = F_WRLCK;
	if ( fcntl( fd, F_SETLKW, &lock) < 0 ) {
		return(1);
	}
	return(0);

#endif /* FLOCK */
}

int unlockfile(int fd)
{
#ifdef FLOCK
	if ( flock(fd, LOCK_UN) < 0 )
		return(1);
	return(0);

#else /* !FLOCK */
	struct flock lock;

	bzero( &lock, sizeof(lock));
	lock.l_type = F_UNLCK;
	if ( fcntl( fd, F_SETLKW, &lock) < 0 ) {
		return(1);
	}
	return(0);

#endif /* FLOCK */
}
#endif /* LOAD_LIMIT */

/*============================================================================
 *  Read startup/options messages from player/server.
 *  Uses information obtained from options datastream to setup
 *  various relay data connections.
 *=========================================================================*/
int setupdialog()
{
   unsigned short msgbytes; 
   unsigned short backport;
   char 	version = 0;
   int 		done; 
   char 	versionstring[4];
   char 	localbuf[2048];   
   void 	timeoutexit(int);
   extern int 	errno;

   /*================================================= 
    * setup a timeout in case dialog doesn't finish 
    *================================================*/
   signal(SIGALRM, timeoutexit);
   alarm(RA_TIMEOUT);

   /*===================================================================== 
    * read startup info from client, check some of it and copy it back out.
    *	We look for: 
    *		- String "PNA"
    *		- 2 byte version number in network byte order.
    *		- option info (backchannel port, udp or tcp connection, etc.)
    *====================================================================*/

   /* check if first info is string "PNA" followed by version number */
   if ( gread(0, &versionstring, 3) != 3) 
   {
		/* syslog error? */
      return(-1);
   }
   if ( strncmp(versionstring, "PNA", 3) !=  0 ) 
   {
   		/* syslog error? */
      return(-1);
   }
   if ( write(serverfd, &versionstring, 3) != 3) 
   {
		/* syslog error? */
      return(-1);
   }
   /* ignore first byte of version for now */
   if ( gread( 0, &version, 1) != 1 ) 
   {
		/* syslog error? */
      return(-1);
   }
   if ( write( serverfd, &version, 1) != 1 ) 
   {
		/* syslog error? */
      return(-1);
   }
   if ( gread( 0, &version, 1) != 1 ) 
   {
		/* syslog error? */
      return(-1);
   }
   /* check for version 5 or higher */
   if ( (version) < RA_VERSION ) 
   {
		/* syslog error? */
      return(-1);
   }
   if ( write( serverfd, &version, 1) != 1 ) 
   {
		/* syslog error? */
      return(-1);
   }

   done = 0; 
   /*=========================================================
    *
    *========================================================*/
   while ( !done ) 
   {

      switch(getoptionsopcode(&msgbytes))
      {
	case RAO_BACKPORT:
		if ( gread( 0, &backport, msgbytes) != msgbytes ) 
                {
					/* syslog error? */
		   return(-1);
		}
#ifndef NO_UDP
/* setup backport connection and write out "new" dataport. */
		if ( udpaudiosetup(backport) < 0 ) 
                {
			/* syslog error? */
		   return(-1);
		}
		break;
#endif
	case RAO_UDPRESEND:
		/* get resend port from client */
		if ( gread( 0, &clientresendport, msgbytes) != msgbytes ) 
                {
					/* syslog error? */
		   return(-1);
		 }
		/* setup sockets/info for resends to server */ 
		if ( udpresendsetup1() < 0 ) 
                {
		   /* syslog error? */
		   return(-1);
		}
		clientudpresend = 1;
		break;
	case RAO_END:
		/* got all the info we need.  */
		done = 1;
		break;
		
	default:
		/* just read option info and write it out */
		/* 
		 * if you're worried about overflows of this buffer (which
		 * might be possible if someone tries to spoof the protocol)
		 * then use malloc. 
				 */
		if ( gread( 0, &localbuf, msgbytes) != msgbytes ) 
                {
		   /* syslog error? */
		   return(-1);
		}
		if ( write( serverfd, &localbuf, msgbytes) != msgbytes ) 
                {
		   /* syslog error? */
		   return(-1);
		}
		break;
      }
   }

   alarm(0);  /* "turn-off" alarm */
   return(0);
}

/*=========================================================================
 * get startup protocol opcode from control channel
 *
 * Args: msgbytes - pointer to store number of bytes in message
 *			stream.
 *
 * Returns: -1 on error
 *		    opcode that was read
 *========================================================================*/
int getoptionsopcode(short *msgbytes) 
{
   unsigned short opcode = 0;

   *msgbytes = 0;
   /* read option opcode from client */
   if ( gread( 0, &opcode, 2) != 2 ) 
   {
      return(-1);
   }
   /* write option opcode to server */
   if ( write(serverfd, &opcode, 2) != 2 ) 
   {
      return(-1);
   }
   /* End of options has no more info */
   if ( ntohs(opcode) == RAO_END )
      return(RAO_END);
   /* read byte count from client */
   if ( gread(0, msgbytes, 2) != 2 ) 
   {
      return(-1);
   }
   /* write bytecode to server */
   if ( write(serverfd, msgbytes, 2) != 2 ) 
   {
      return(-1);
   }
   /*====================================== 
    * convert info to local byte order
    *=====================================*/
   *msgbytes = ntohs(*msgbytes);
   return(ntohs(opcode));
}

/*=========================================================
 * setup/bind socket that we'll use for resends to server.
 * We write this "new" port out to the server.
 *========================================================*/
int udpresendsetup1()
{
   struct sockaddr_in	addr, info;
   int		size;

   /*=====================================================
    * allocate/setup socket/fd/port FROM which we'll
    * send resend message to server.
    *====================================================*/
	if ( (svrresendfd = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0 ) 
	{
		/* syslog  error */
		syslog(LOG_LVL, "raproxy: can't setup socket: %m");
		return(-1);		/* Probably out of sockets */
	}
	(void) bzero (&addr, sizeof (addr));
	addr.sin_family = AF_INET;
	addr.sin_port = htons(0);
	if ( bind(svrresendfd, (struct sockaddr *)&addr, sizeof (addr)) < 0 ) {
		syslog(LOG_LVL, "raproxy: can't bind socket: %m");
		/* syslog error ? */
		return(-1);
	}

	/* lets find out the local source port we're using to SEND info */
	size = sizeof(info);
	if ( getsockname(svrresendfd, (struct sockaddr *)&info,
						(socklen_t *)&size)  < 0 ) {
		/* syslog error ? */
		syslog(LOG_LVL, "raproxy: can't getsockname(): %m");
		return(-1);
	}

	/* send the above mentioned port number to server */
	if ( write(serverfd, &info.sin_port, 2) != 2) {
		/* syslog error ? */
		syslog(LOG_LVL, "raproxy: error writing resendport to server.");
		return(-1);
	}
	return(0);
}

/*============================================================================
 * Read options from server
 * 1. setup socket that we'll use to listen for udp resends from client.
 * 2. We intercept the resend options/port info from the server and send out 
 *    our new port to the client
 *===========================================================================*/
int udpresendsetup2()
{
   struct sockaddr_in	addr, info;
   int		size;
   int		count;
   unsigned short svrresendport, opcode;
   unsigned char temp;
   char versionstring[4];

   /*====================================================== 
    * allocate/setup socket/fd/port to which we'll listen
    * for resend message.
    *=====================================================*/
   if( (clientresendfd = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0 ) 
   {
      /* syslog  error */
      syslog(LOG_ERR, "Error: can't setup socket: %m");
      return(-1);		/* Probably out of sockets */
   }
   (void) bzero (&addr, sizeof (addr));
   addr.sin_family = AF_INET;
   addr.sin_port = htons(0);
   if ( bind(clientresendfd, (struct sockaddr *)&addr, sizeof (addr)) < 0 ) 
   {
      syslog(LOG_ERR, "Error: can't bind socket: %m");
      return(-1);
   }
   /*===================================================================== 
    * lets find out the source port to which we'll listen for resends
    * from the client.  We'll need this to pass on to the client later.
    *===================================================================*/
   size = sizeof(info);
   if ( getsockname(clientresendfd, (struct sockaddr *)&info,
					(socklen_t *)&size)  < 0 ) 
   {
   		/* syslog error ? */
      syslog(LOG_ERR, "Error: can't getsockname(): %m");
      return(-1);
   }
   /*======================================================================
    * now read info/options from the server
    * We check for PNA, then skip over 6 bytes (nice magic number)
    * Then we check for, options response code ('O' - 4f)
    * Skip a byte, then check for options opcode 07.
    * If 07 then we'll read the port number that follows
    * and pass along the new port number where we'll be listening.
    * 
    * If we don't get see the 4f or 07, then we don't have to worry about
    * udpresends.
    *
    * We copy info out to the client/player as we go along.
    *=====================================================================*/ 

   /* check if first info is string "PNA" followed by version number */
   if ( gread(serverfd, &versionstring, 3) != 3) 
   {
      syslog(LOG_ERR, "Error: Incorrect version number");
      return(-1);
   }
   if ( strncmp(versionstring, "PNA", 3) !=  0 ) 
   {
      /* syslog error? */
 		return(-1);
   }
   if ( write(0, &versionstring, 3) != 3) 
   {
      /* syslog error? */
      return(-1);
   }
   count = 0;
   while ( count < 6 ) 
   {
      if ( gread(serverfd, &temp, 1) != 1) 
      {
         syslog(LOG_ERR, "Error: read error from server getting resend info.");
			/* syslog error ? */
         return(-1);
      }
      if ( write(0, &temp, 1) != 1) 
      {
			/* syslog error ? */
         syslog(LOG_LVL, "raproxy: write error to client getting resend info.");
	 return(-1);
      }
         count++;
   }
   /* read option response from server */
   if ( gread( serverfd, &temp, 1) != 1 ) 
   {
      return(-1);
   }
   if ( write( 0, &temp, 1) != 1 ) 
   {
      return(-1);
   }
   if ( temp == 'O' ) 
   {
      /* read byte count from server (we ignore this) */
      if ( gread( serverfd, &temp, 1) != 1 ) 
      {
         return(-1);
      }
      if ( write( 0, &temp, 1) != 1 ) 
      {
         return(-1);
		}
		/* read opcode from server */
		if ( gread( serverfd, &opcode, 2) != 2 ) {
			return(-1);
		}
		if ( write( 0, &opcode, 2) != 2 ) {
			return(-1);
		}
		/* If it's a resend then replace port info in datastream */
		if (opcode == htons(RAO_UDPRESEND) ) {
			/* get port that resend should go to on server */
			if ( gread( serverfd, &svrresendport, 2) != 2 ) {
				/* syslog error? */
				return(-1);
			}
			/* send port number we're listening on to client */
			if ( write(0, &info.sin_port, 2) != 2) {
				/* syslog error ? */
				syslog(LOG_LVL, "raproxy: error writing resendport to server.");
				return(-1);
			}
			/* get inet info of server - we need this later  */
			size = sizeof(serverinfo);
			if ( getpeername(serverfd,
					(struct sockaddr *)&serverinfo,
					(socklen_t *)&size) < 0 ) {
				/* syslog error ? */
				syslog(LOG_LVL, "raproxy: error getting peername of server: %m");
				return(-1);
			}
			/* now point to server resend port */
			serverinfo.sin_port = svrresendport;
			return(1);
		}
	} 
	/* no option response or resend opcode */ 
	close(clientresendfd);
	close(svrresendfd);
	clientresendfd = 0;
	return(0);
}
/*========================================================================================
 *
 *=======================================================================================*/
gread(int fd, char *buffer, int count)
{
   int offset = 0;
   int numbytes = count;
   int bytes;

   if ( count == 0 )
      return (0);
	
   while ( 1 ) 
   {
	bytes = read(fd, (buffer+offset), numbytes); 
	if ( bytes <= 0 )
		return (-1);
	if ( (bytes+offset) == count )
		return (count);
	offset += bytes;
	numbytes -= bytes;
   }
}
