/*============================================================================
 * filename:		smwrap/bldbody.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * written by:		R. James Livermore 
 *
 * (C) COPYRIGHT R. James Livermore 1995-2000.  All rights reserved.   
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995-2000.
 * All rights reserved.  
 *
 * Date written:	December  16, 1994
 * Last modified:	February   8, 2000 - added LPL
 *
 * function:	build the body of the e-mail message	
 *       
 *		Check for DoS attacks:
 *			maximum header size exceeds 32 KB
 *			maximum message size exceeded
 *			harmful header addresses  char \201-\237
 *
 *
 *============================================================================*/
#include	<sys/types.h>
#include	<sys/file.h>
#include	<sys/stat.h>
#include	<stdio.h> 
#include	<string.h>		
#include	<time.h>
#include	<ctype.h>
#include	<syslog.h>
#include	<netdb.h>
#include	<sys/socket.h>
#include	<sys/signal.h>
#include	<netinet/in.h> 
#include	<unistd.h>  
#include	<stdlib.h>		
#include	"firewall.h"
#include	"smwrap.h"
 
 
/*===========================================================================
 * External variables
 *==========================================================================*/
extern	int		errno;
extern	char		*strtok();		/* ptr to                   */
extern	char		*optarg; 
static	char		*tempfile;  	/* ptr to name of temp file 	    */ 
static	int		curbytes;	/* current message byte count	    */
static  int		hdrbytecnt;	/* current header byte count	    */
static	int		currecip;
static	char		PeerIP[MAXADDRLN];	
static	int		timeout;
static	int		livetim;
#define	TEMPBUFSIZE	256 


/*============================================================================
 * function: bldbody 
 *
 * inputs:
 *              input file
 *		output file
 *              ptr to SMWRAP structure
 *		IPsecure    if 1 then host is secured         
 *              ptr to external e-mail address for outbound mail
 *		ptr to local hostname 
 *		ptr to original SMTP from: name 
 *		ptr to Trace Header 
 *		ptr to Trace buffer
 *
 * outputs:  
 *	returns MSGOK		message OK 
 *		UNEXPEXIT	unexpected departure of peer
 *              MSGTOOBIG       exceeded maximum allowed message size
 *		HDRTOBIG	msg header exceeds maximum allowed size
 *		HDRADDRBAD	bad header address - dangerous char
 *		FPRTERR       	fprintf failed
 *===========================================================================*/
int bldbody(FILE *in, FILE *out,struct SMWRAP *smwpptr,int IPsecure,
            	char *extname,char *lochostname, char *fromname,
		struct tracehdr *tracehdrptr, struct trace  *tracebufadr)
{ 
static	char	cprght[] = 
  		"(C) COPYRIGHT Freemont Avenue Software, Inc. 1995-2000 bldbody,"
  		" V 1.0 00/01/21";
    
   char	buf[BUFSIZ];         
   int	Cccontinue	= 0;
   int	continueline	= 0; 
   int	HDRflg;		
   char tempbuf[TEMPBUFSIZE];
   char trailerbuf[TEMPBUFSIZE];
   char *cptr; 
   char *cptr2; 
   char *cptr3; 
   char *cptr4;
   char	*cp;
   int	fromplus 	= 0;	/* set = 1 after rec From: in body          */ 
   int	i;
   char	*lastbyte; 
   int	maxlines	= 20;   /* Maximum lines scanned  for translation   */ 
   int	msgIDcontinued  = 0;	/* TO: line count			    */
   int	TOcnt		= 0;
   int	x; 
   int	receivedplus    = 0;
   int	reclen;			/* record length			*/ 
   int  records  	= 0;   
   int  return_rec2 	= 0;	/* set = 1 after Return-Receiptient-To:*/
   int  tracerec 	= 0; 
   tempbuf[0] = '\0'; 
   
   HDRflg = 1;			/* start with the Header Data		*/
   tempbuf[TEMPBUFSIZE-1] = '\0';  
   trailerbuf[0] = '\0';
   trailerbuf[sizeof(trailerbuf)-1] = '\0'; 
   /*=========================================================================
    * Read the E-mail Header DATA until:
    *  a blank line is encountered indicating the start of the body or
    *  a EOD is signaled by a line containing a single '.' or
    *  an the peer host makes an unexpected departure. 
    *
    *========================================================================*/
   while(HDRflg) 
   {              
      /* Get the string minus the CRLF */
      if((reclen = getswocrlf(buf,sizeof(buf),in)) < 0) 
      {
         return(UNEXPEXIT);		/* unexpected departure of peer */
      }   
      /*=============================================================
       * If the trace is active trace the first twenty header lines. 	
       *============================================================*/  
      if( tracerec < 20 )
      {
         if( smwpptr->traceflg)
           trace_it(tracehdrptr, tracebufadr,'R', buf); 
         tracerec++;
      } 
      /*=====================================================
       * End of Data if line contains a single period. 
       * If double periods print it and continue.
       *====================================================*/
      if(buf[0] == '.' && buf[1] == '\0')
         break;
      if(buf[0] == '.' && buf[1] == '.') 
      {
         x = fprintf(out,"%s\n",&buf[1]);
	 /*=================================================
          * Check for write error.
          *================================================*/
         if(x == -1 || ferror(out)) 
         {
            syslog(LOG_ERR,"Error: cannot fprintf '..' line '\n': %m");
            return(FPRTERR);
         } 
	 smwpptr->linecnt++;
	 goto getnexthdr;
      }
      /*=====================================================
       * Check for blank line indicating end of Header.
       * If blank line write LF and go to body processing.
       *====================================================*/
      if( reclen == 0)
      {
         x = fprintf(out,"\n"); 
	 /*=================================================
          * Check for write error.
          *================================================*/
         if(x == -1 || ferror(out)) 
         {
            syslog(LOG_ERR,"Error: cannot fprintf blank line '\n': %m");
            return(FPRTERR);
         } 
	 smwpptr->linecnt++;
         break; 
      }  
      /*============================================================ 
       * If mail is comming from a secured host then: 
       *   1. Strip off the "Received: by" lines in the body.
       *   2. Strip off the "X-" lines in the body. 
       *   3. Translate From: user_id@host.domain          
       *============================================================*/ 
      if( IPsecure == 1 )
      {   
         /*=====================================================
          * Examine the first 'maxlines' lines of the body. 
          *====================================================*/
         if( (records < maxlines) || (receivedplus + return_rec2 + fromplus   
                                         + Cccontinue + msgIDcontinued ))
         {  
	    records++;  
            /*==========================================================
             * Check the first line after the "Received by: ".   If it 
	     * is a continuation line or starts with "id " delete it. 
             *=========================================================*/
            if( receivedplus )
            {           
	          
               if( continueline)
               {
                  lastbyte =  &buf[reclen - 1];
                  if( *lastbyte == '=')  
                     continueline = 1;                       
                  else   
                     continueline = 0;
                  continue;
               }  
	       receivedplus = 0;   
               cptr = (char *) &buf; 
               while(isspace(*cptr))
               {
	          cptr++;
               }  
               if( strncasecmp(cptr,"id",2) == 0) 
               {
                  lastbyte =  &buf[reclen - 1];
                  if( *lastbyte == '=')  
                  { 
                     continueline = 1;
                     receivedplus = 1;
                  }                       
                  else   
                     continueline = 0;
                  continue;
               }  
	    }
            /*=========================================================
             * Strip off "Received: " line to hide internal host names	
	     *========================================================*/
            if( strncmp(buf,"Received: ",10) == 0)
            {  
               receivedplus++; 
               lastbyte =  &buf[reclen - 1];
               if( *lastbyte == '=')
                   continueline = 1;
	       continue;                                           
            }     
            /*===========================================
             * Strip off "X-" line	
	     *===========================================*/
            if( strncmp(buf,"X-",2) == 0)
            {
	       continue;                                           
            }  

            /*==========================================================
             * Check the first line after the From: to see if the 
	     * users e-mail address follows.  If <user.name@host.domain>
	     * matches the value passed by mail from:<user.name@host.domain>
             * Does it start with a < and end with
             * throw it away else write it to the file as is. 
             *=========================================================*/
            if( fromplus )
            {  
               if( (reclen < 3 )                            ||  
                   (strncasecmp(buf,"Cc:",3) == 0)          || 
                   (strncmp(buf,"To:",3) == 0)              || 
                   (strncmp(buf,"Date:",5) == 0)            || 
                   (strncmp(buf,"From:",5) == 0)            || 
                   (strncmp(buf,"Subject:",8) == 0)         || 
		   (strncasecmp(buf,"Message-Id:",11) == 0) || 
                   (strncmp(buf,"Sender",6) == 0)           ||
                   (strncmp(buf,"Return-",7) == 0)          ||
                   (strncmp(buf,"X-",2) == 0)               ) 
               { 
                  fromplus = 0;
               }
               else
               {  
                  fromplus = 0;		/* turn off flag	*/   
		  cptr = (char *) &buf; 
                  while(isspace(*cptr))
                     cptr++;
                  if( *cptr == '<')
                  {  
                     strcpy(cptr,extname);  
                  }
               } 
            } 
            /*===========================================================
             * Replace internal e-mail name with external e-mail name 
             * preserving actual name if there is one in front of 
	     * <username@domain>. If the e-mail address does not contain 
	     * '<' or '>' then check for trailing "( real name)".
             *==========================================================*/ 
            if( strncmp(buf,"From:",5) == 0)
            {
               if( strlen(extname) < 2)
               {
                  syslog(LOG_ERR,"Error: unable to translate %s to external"
		                 " name.",
				 buf);
	       }
               else
	       {  
                  if((cptr2 = strchr(buf,'<')) != NULL)
                  {	
            	     /*===================================================== 
                      * Skip over actual name and replace internal e-mail
                      * address with external e-mail address  
                      * Majordomo uses a different SMTP From: name than
                      * found in the From: header line.
                      *===================================================*/
                     if( strcmp(cptr2,fromname) == 0) 
                        strcpy(cptr2,extname);
                     else              
                     {   
                        if(transend(cptr2,tempbuf,lochostname,
				       smwpptr->translate) == 0)
			{
                           strncpy(cptr2,tempbuf,sizeof(tempbuf)-1); 
                        } else 
                        {
                           syslog(LOG_ERR,"Error: From address '%s' in "
				   	  "header can not be translated "
					  "and does not match SMTP Mail "
					  "From  address '%s'.",
					  cptr2,fromname);
			}      
                            
                     }
                  }     
		  /*=======================================================	
                   * If From: line does not have an address of the form 
                   * <name@domain> then treat line as an actual name.	
                   *=======================================================*/
		  else
                  { 
	             if (( cptr2 = strchr(buf,'@')) == NULL)
                     {
                        fromplus = 1;      /* real address on next line */
                     }
                     else
                     {  
			/*========================================
                         * Check for trailing comments and save 
 			 *=======================================*/
			if( (cptr3 = strchr(cptr2,' '))) 
                        {   
                           strncpy(trailerbuf,cptr3,sizeof(trailerbuf)-1);
			}       
                        /* Skip over actual name */
                        if( cptr = strchr(buf,'\"'))
                        {
                          if(cptr < cptr2)
                          {
                             cptr++;
			     if( (cptr4 = strchr(cptr,'\"')) == NULL)
                             {
                                syslog(LOG_ERR,"Error: unbalanced \""
				 	       "in From Header");
			     } else
			     if( cptr4 < cptr2)
				   cptr = cptr4 + 1;	
                           }
                        }
                        else
                           cptr = & buf[5];
                        while(isspace(*cptr))
                              cptr++; 
			if(transend(cptr,tempbuf,lochostname,
		           smwpptr->translate) == 0)
			{
                           strncpy(cptr,tempbuf,sizeof(tempbuf)-1); 
                           strcat(buf,trailerbuf);
                        } else 
                        {
                           syslog(LOG_ERR,"Error: From address '%s' in"
				   	  " header can not be translated "
					  "and does not match SMTP Mail "
					  "From  address '%s'.",
					  cptr,fromname);
			}
                        fromplus = 0;
                     }
                  }
                     
                     
               }
            }  /* End of From: processing	*/  
            /*=============================================================
             * Replace internal Cc: e-mail names with external e-mail names. 
             *===========================================================*/    
	    if( Cccontinue)
            {  
               if( (reclen < 3 )                            ||
                 /*  (strchr(buf,'@') == NULL)) || */
                   (strncasecmp(buf,"Cc:",3) == 0)          || 
                   (strncmp(buf,"To:",3) == 0)              || 
                   (strncmp(buf,"Date:",5) == 0)            || 
                   (strncmp(buf,"From:",5) == 0)            || 
                   (strncmp(buf,"Subject:",8) == 0)         || 
		   (strncasecmp(buf,"Message-Id:",11) == 0) ||
                   (strncmp(buf,"Return-",7) == 0)          ||   
		   (strncmp(buf,"Content-Type:",13) == 0)   ||
                   (strncmp(buf,"In-Reply-To:",12) == 0)    ||
		   (strncmp(buf,"Sender",6) == 0)           ||
                   (strncmp(buf,"References:",11) == 0 )    ||
                   (strncmp(buf,"Mime-Version:",13) == 0)   || 
                   (strncmp(buf,"X-",2) == 0)               || 
                   ( Cccontinue > 2)  )
               {                      
                  Cccontinue = 0;     
               }
               else
               {  
                  /*==================================================
                   * If we get two consecutive lines without an '@'
                   * then increment else reset to 1
                   *=================================================*/
                  if( (strchr(buf,'@') == NULL) )
                    Cccontinue++; 
                  else
                    Cccontinue = 1;
                  transcc(buf, lochostname); 
               }
            } 

            /*=============================================================
             * Replace internal Cc: and To: e-mail names with external
             * e-mail names.  Some mail clients such as Netscape generate
             * CC: so we must use strncasecmp.
             *===========================================================*/    
	    if( (strncasecmp(buf,"Cc:",3) == 0) || (strncmp(buf,"To:",3) == 0))
            {     
	       Cccontinue = 1;
               transcc(buf, lochostname);
            } /* End of Cc: & To: processing 	*/  

            /*==============================================================
             * Check the first line after the Return-Receipt-To; to see if 
             * the users e-mail address follows.  If <user.name@host.domain>
	     * matches the value passed by mail from:<user.name@host.domain> 
	     * Does it start with a < and end with
             * throw it away else write it to the file as is. 
             *============================================================*/
            if( return_rec2 )
            {  
	       return_rec2 = 0;		/* turn off flag	*/    
                  
	       cptr = (char *) &buf; 
	       /* skip over white spaces */        
               while(isspace(*cptr))
               {
	          cptr++;
               }
               if( *cptr == '<')
               {
                  if( strcmp(fromname,cptr) == 0 )
                  {    
                     continue;		/* drop line into bit bucket*/   
		  }	 
               } 
            } 
            /*========================================================
             * Process Return-Receipt-To: 
             *=======================================================*/ 
            if( strncmp(buf,"Return-Receipt-To:",18) == 0)
            {    
               Cccontinue = 0; 		/* reset flag	*/
               if( strlen(extname) < 2)
               {
                  syslog(LOG_ERR,"Error: unable to translate %s to external"
		  		 " name",
				 buf);
	       }
               else
	       {
                  buf[18] = ' '; 
                  buf[19] = '\0';
                  strcat(buf,extname);
                  return_rec2 = 1;
               }
            }
            /*======================================================== 
	     * Process Return-Path: record.
             * Replace internal e-mail name with external e-mail name. 
             *=======================================================*/ 
            if( strncmp(buf,"Return-Path:",12) == 0)
            {  
               Cccontinue = 0; 		/* reset flag	*/
               if( strlen(extname) < 2)
               {
                  syslog(LOG_ERR,"Error: unable to translate %s to external"
		  		 " name",
				 buf);
	       }
               else
	       {   
                  if((cptr2 = strchr(buf,'<')) != NULL)
                  {			/* skip over actual name */ 
                     strcpy(cptr2,extname);
                  }  
		  else
                  {
                     buf[12] = ' '; 
                     buf[13] = '\0'; 
		     strcat(buf,extname);
                  }
               }
            }
            /*=======================================================
             * Message-ID was continued before @ was encountered. 
             * Substitute firewall hostname in Message-Id header	
             *======================================================*/
	    if( msgIDcontinued )
	    {
               msgIDcontinued = 0;  	
	       if( ( cp = strchr(buf,'@')) == (char *) 0)
	       {  
	          syslog(LOG_ERR,"expected <messageid@host.domain> got '%s",
                                 buf);    
               }
	       else
	       {  
		  /*strcat(buf,"@");
                  strcat(buf,lochostname);*/ 
                  cp++;
                  *cp = '\0';  
		  strcat(buf,lochostname);
                  strcat(buf,">");
	       }           
            }  
            /*======================================================= 
             * Substitute firewall hostname in Message-Id header	
             *======================================================*/
	    if( strncasecmp(buf,"Message-Id:",11) == 0)
	    {
               Cccontinue = 0; 		/* reset flag	*/	
	       if( ( cp = strchr(buf,'@')) == (char *) 0)
	       {
	          lastbyte =  &buf[reclen- 1];
                  if( *lastbyte == '=')  
                     msgIDcontinued = 1;                       
                  else  
		     syslog(LOG_ERR,"expected <messageid@host.domain> got '%s",
                                    buf);    
               }
	       else
	       {  
		  /*strcat(buf,"@");
                  strcat(buf,lochostname);*/ 
                  cp++;
                  *cp = '\0';  
		  strcat(buf,lochostname);
                  strcat(buf,">");
	       }           
            }    
              
         }
         
         
      }
      /*==================================================================
       * Process Header data sent from an un-secured host.
       *    Check for excessive number of To: lines 
       *    Check for harmful header addresses (char '\201' -> '\237')
       * If header OK then write line as is. 
       *================================================================*/
      else   
      {
         if(strncmp(buf,"To:",3) == 0) 
	 {
	    if( ++TOcnt > smwpptr->maxreceipts*2)
	    {
	       syslog(LOG_ALERT,"Security Alert: number of TO: lines in the "
	       			"header exceeds %d.",
				smwpptr->maxreceipts*2);
	    }
	 }
         
         for(i=3; i <reclen; i++)
	 {   
	    if( buf[i] > '\200' && buf[i] < '\240' )
	    {
	       syslog(LOG_ALERT,"Security Alert: dangerous character x'%x' in "
	       			"Header address. line %d, character %d, file %s,"
				" client %s",
	       			buf[i],smwpptr->linecnt,i,tempfile,PeerIP);
	    } 
	          
	 }
          
      }     
      /*==================================================================
       * Write header line to output file and check for write error.
       *================================================================*/
      x = fprintf(out,"%s\n",buf); 
      if(x == -1 || ferror(out)) 
      {
         syslog(LOG_ERR,"Error: cannot fprintf(buf) line %d, line length %d."
	    		"current message size %d. %m",
	    		smwpptr->linecnt,reclen,curbytes+reclen);
         return(FPRTERR);
      } 
      smwpptr->linecnt++;
 
      /*======================================================================
       * If maximum Header size is exceeded issue message.
       * 
       *=====================================================================*/
      if(( hdrbytecnt += reclen) > smwpptr->maxheadersz)
            return(HDRTOOBIG); 		/* exceeded maximum header size	     */
      /*======================================================================
       * If maximum message size has been specified accumulate bytes and check
       * limit. 
       *=====================================================================*/
      if(smwpptr->maxbytes > 0) 
      {
         if((curbytes += reclen) > smwpptr->maxbytes)
            return(MSGTOOBIG); 		/* exceeded maximum letter size	*/
      }
getnexthdr: continue;      
   }   /* End of Header Processing  */
   
   /*=========================================================================
    * Read the E-mail Body until:
    *  a EOD is signaled by a line containing a single '.' or
    *  an the peer host makes an unexpected departure      or
    *  maximum messge size is exceeded                     or
    *  a write error occurs.  
    *
    *========================================================================*/
   while(1) 
   {              
      /* Get the string minus the CRLF */
      if(( reclen = getswocrlf(buf,sizeof(buf),in)) < 0) 
      {
         return(UNEXPEXIT);		/* unexpected departure of peer */
      } 
      /*=====================================================
       * End of Data if line contains a single period. 
       *====================================================*/
      if(buf[0] == '.' && buf[1] == '\0')
         break;
        
	
	
	
      /*=====================================================================
       * Write line to disk and check for write error. 
       *=====================================================================*/ 
      x = fprintf(out,"%s\n",buf); 
      
      if(x == -1 || ferror(out)) 
      {
         syslog(LOG_ERR,"Error: cannot fprintf(buf) line %d, line length %d."
	    		"current message size %d. %m",
	    		smwpptr->linecnt,reclen,curbytes+reclen);
         return(FPRTERR);
      } 
      /*======================================================================
       * If maximum message size has been specified accumulate bytes and check
       * limit. 
       *=====================================================================*/
      if(smwpptr->maxbytes > 0) 
      {
         if((curbytes += reclen) > smwpptr->maxbytes)
            return(MSGTOOBIG); 			/* exceeded maximum letter size	*/
      }
   } /* End of Body procesing */
   if(fflush(out) || ferror(out)) 
   {
      syslog(LOG_ERR,"Error: cannot flush output file buffer: %m");
      return(FPRTERR);
   }
   return(MSGOK);
}     
