/*============================================================================
 * filename:		tnproxy/tnproxy.c
 *
 * This software is distributed under the terms of the Livermore Public  
 * License version 1.0.   
 *	      
 *       The Livermore PUBLIC LICENSE (LPL) Version 1.0 
 *                              
 * Copyright (C) 1999-2000 Freemont Avenue Software, Inc, Houston, Texas, USA  
 *
 * Everyone is permitted to copy and distribute this license document.  The 
 * intent of this license is to establish freedom to share and change the 
 * software regulated by this license under the open source model.
 *
 * This license applies to any software containing a notice placed by the 
 * copyright holder saying that it may be distributed under the terms of the 
 * Livermore Public  License version 1.0. Such software is herein referred to as
 * the Software. This license covers modification and distribution of the 
 * Software, use of third-party application programs based on the Software, and
 * development of free software which uses the Software.
 *
 * Granted Rights
 *
 * 1. You are granted the non-exclusive rights set forth in this license
 *    provided you agree to and comply with any and all conditions in this
 *    license. Whole or partial distribution of the Software, or software items
 *    that link with the Software, in any form signifies acceptance of this 
 *    license.
 *
 * 2. You may copy and distribute the Software in unmodified form provided that
 *    the entire package, including, but not restricted to, copyright, trademark
 *    notices and disclaimers, as released by the initial developer of the
 *    Software, is distributed.
 *
 * 3. You may make modifications to the Software and distribute your
 *    modifications, in a form that is separate from the Software, such as
 *    patches. The following restrictions apply to modifications:
 *
 *    a. Modifications must not alter or remove any copyright notices in the
 *       Software.
 *
 *    b. When modifications to the Software are released under this license, a
 *       non-exclusive royalty-free right is granted to the initial developer of
 *       the Software to distribute your modification in future versions of the
 *       Software provided such versions remain available under these terms in
 *       addition to any other license(s) of the initial developer.
 *
 * 4. You may distribute machine-executable forms of the Software or 
 *    machine-executable forms of modified versions of the Software, provided
 *    that you meet these restrictions:
 *
 *    a. You must include this license document in the distribution.
 *
 *    b. You must ensure that all recipients of the machine-executable forms are
 *       also able to receive the complete machine-readable source code to the
 *       distributed Software, including all modifications, without any charge 
 *       beyond the costs of data transfer, and place prominent notices in the
 *       distribution explaining this.
 *
 *    c. You must ensure that all modifications included in the machine-
 *       -executable forms are available under the terms of this license.
 *
 * 5. You may use the original or modified versions of the Software to compile,
 *    link and run application programs legally developed by you or by others. 
 *      
 * 6. You may develop application programs, reusable components and other 
 *    software items that link with the original or modified versions of the
 *    Software. These items, when distributed, are subject to the following
 *    requirements:
 *                   
 *    a. You must ensure that all recipients of machine-executable forms of
 *       these items are also able to receive and use the complete 
 *       machine-readable source code to the items without any charge beyond
 *       the costs of data transfer.
 *           
 *    b. You must explicitly license all recipients of your items to use and 
 *       re-distribute original and modified versions of the items in both 
 *       machine-executable and source code forms. The recipients must  be able
 *       to do so without any charges whatsoever, and they must be able to 
 *       re-distribute to anyone they choose.
 * 
 *    c. If the items are not available to the general public, and the initial
 *       developer of the Software requests a copy of the items, then you must
 *       supply one.
 *	 
 * Limitations of Liability
 *
 * In no event shall the initial developers or copyright holders be liable for 
 * any damages whatsoever, including - but not restricted to - lost revenue or 
 * profits or other direct, indirect, special, incidental or consequential 
 * damages, even if they have been advised of the possibility of such damages, 
 * except to the extent invariable law, if any, provides otherwise.
 *
 * THE SOFTWARE IS PROVIDED BY FREEMONT AVENUE SOFTWARE  ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL FREEMONT AVENUE SOFTWARE OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * This license is governed by the Laws of the State of Texas and any disputes
 * shall be decided by mediation.
 *
 * T.REX, T.REX free edition and other T.REX names are trademarks of Freemont 
 * Avenue Software, Inc. 
 *============================================================================*/
/*=============================================================================
 *
 * written by:		R. James Livermore
 *
 * (C) COPYRIGHT R. James Livermore 1995 - 2000.  All rights reserved.
 *
 * (C) COPYRIGHT Freemont Avenue Software, Incorporated 1995 - 2000.  
 * All right reserved.
 *
 *
 * Date written:	March     16, 1995
 * Last modified:	February   8, 2000 - added LPL
 *
 * function:		telnet proxy server	
 *
 *
 *	
 *	
 * Note:	openlog and syslog always return 0 even if the syslogd is not
 *		active or the disk is full.
 *
 *
 *============================================================================*/
static  char	ident[] = "@(#) tnproxy, V 1.0, 00/01/21"
 			  " (C) Freemont Avenue Software, Inc."
			  " 1995-2000";

#define BINDDEBUG
#define SHORTBUF	512
#include	<stdio.h>
#include	<ctype.h>
#include	<syslog.h>
#include	<fcntl.h>
#include	<utmp.h>
#include	<sys/ioctl.h>
#ifdef __sun
#include	<sys/sockio.h>		/* socket I/O controls 		*/
#endif
#include	<sys/errno.h>
#include	<sys/signal.h>
#include	<sys/time.h>
#include	<sys/times.h>		/* cpu timings			*/
#include	<sys/types.h>
#ifdef _AIX
#include 	<sys/select.h>		/* to support fd_set 		*/
#include	<sys/termio.h>
#else
  #ifndef linux
#include	<sys/stropts.h>
  #endif
#include	<sys/termios.h>
#endif
#ifdef __hppa
#include	<sys/strtio.h>
#endif
#include	<unistd.h>
#include	<stdlib.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<netdb.h>
#include	"arpa/telnet.h"
#include	"firewall.h"
#include	"gwuser.h"
#include	"tnproxy.h"
#include	"des.h"

extern	char	*index();
extern	int	errno;
extern	int	h_errno;
#ifndef linux
extern	char	*sys_errlist[];
#else
extern const char *const sys_errlist[];
#endif
#ifndef	TNPORT
#define	TNPORT	23
#endif
	
static	char			**validests = (char **)0;

static	int			extendperm  = 0;
static	char			authuser[512];
static	int			changeok    = 0;
static  long			clktck      = 0;
static	int			xgwok       = 0;
static	int			rfd         = -1;	/* fd to remote */
static	char			dest[512];
static	unsigned char		prebuf[BUFSIZ]; 
static	int			prebufc     = 0;
static	int			kludgeraw   = 0;
static	int			local_login = 0;/*login to firewall indicator*/
static	int			adm_ok      = 0; /* OK to login firewall */
struct 	timeval			*timeoutp = (struct timeval *)0;
static	time_t			starttime;
static	time_t			endtime;
static  struct tms		tmsstart;
static  struct tms		tmsend;

static	int			inbytcnt    = 0;
static	int			outbytcnt   = 0;
static	int			csecrets = 0; /*client encrypt mode indicator*/
static	int			ssecrets = 0; /*client encrypt mode indicator*/
static	des_key_schedule	ckeysched;
static	des_key_schedule	skeysched;
struct  TNPROXY 		*proxyptr;

/*==========================================================================
 * function prototypes
 *==========================================================================*/ 
int annulopt();
int authenticate(struct GWUSER *gwuptr,char *sourceip, char *failedusers,
                 struct TNPROXY *proxyptr);
static	int cache_option();
#if !defined(__sun)
int chk_spoof(char *pname,struct in_addr inside_ipaddr,int inside_port,
		struct in_addr clnt_ipaddr,int clnt_port,int IPsecure);
#endif   
int check_password(char *password, char oldpasswords[MAXPWDS][PWDSIZ],
			struct GWCONF *conf, char *errstring);

#if defined(__hppa) || defined(linux)
char *ptsname(int fd);
#endif

int islocal(in_addr_t ip);
int connect_local();
void setup_login(char *tty);
void process_iacs(unsigned char *buf,int *x);
int negotiate_encrypt();
int enc_read(int fd, unsigned char *buf, int len, des_key_schedule keysched);
int enc_write(int fd, unsigned char *buf, int len, des_key_schedule keysched);
void debugbind(unsigned short debugport);
int  firstoptions(unsigned char xuf[]);
void securetnp(struct TNPROXY *proxyptr );
int  tnproxconf(struct TNPROXY *proxptr);
int  tnrules(struct TNPROXY *proxptr);
int  usercmd(char *prompt, int promptlen);
struct hostent *Pgethostbyname(const char *name);
extern	char	*hnametoip();  
static	void	trap_sigurg();
static	int	raw_telnet();  
/*static	int	cmdConnect();*/
static	int cmdConnect(int ac, char *av[], char *cbuf);
static	int	cmdHelp();
static	int	cmdQuit(); 

int 	cmdTimeout(int ac,char *av[], char *cbuf);  
int 	cmd_passwd(int ac,char *av[],char *cbuf);
static	int	cmdXforward();
static struct GWUSER *gwuptr;
/*==========================================================
 * Telnet Operation Table:  This table list valid commands 
 *=========================================================*/
typedef	struct	
{
	char	*name;
	char	*hmsg;
	int	(*op)();
} TnOp;
static	TnOp	ops[] = 
{
	"connect",	"   connect hostname [serv/port]",	cmdConnect,
	"telnet",	"   telnet  hostname [serv/port]",	cmdConnect,
	"tn3270",	"   tn3270  hostname [serv/port]",	cmdConnect,
	"safetn",	"   safetn  hostname [serv/port]",	cmdConnect,
        "open",		0,					cmdConnect, 
	"help",		"   help/?",				cmdHelp,
	"quit",		"   quit/exit",				cmdQuit,
	"password",	"   password",				cmd_passwd,
        "close",	0,					cmdQuit,
	"timeout",	"   timeout seconds",			cmdTimeout,
	"exit",		0,					cmdQuit,
	"xforward",	"   xforward [hostname/display]",	cmdXforward,
	"?",		0,					cmdHelp,
	0,		0,					0
};
/*============================================================================
 * main tnproxy function 
 * inputs:   argument count & argument list                                                         
 * 
 * Debug option:   tnproxy tnproxy -D 7700
 *===========================================================================*/
main(int ac, char *argv[])
{   
   struct timeval	timeout;
   int			br;		/* bytes read			*/
   fd_set		rdy;
   float		cpu;            /* cpu time			*/
   float		chcpu;		/* child cpu time		*/
   int			i;
   int			rtncd	= 0;
   int			x;  
   unsigned char	ybuf[3];
   int			z;
   int		runuid = -1;
   int		rungid = -1;
   long		tempport;
   unsigned short	debugport = 9000;	/* default debug port	*/
   char		*clientnull = (char *)0;
   char 	xuf[MAXRECLN];
   char		failedusers[(MAXTRIES+1)*(UNMSIZ+2)];
   char		huf[128];
   char		locIP[IPSIZ]; 		/* local IP address	*/
   char		*prompt;
   int		promptlen;
   struct TNPROXY tnproxy;
   struct sockaddr_in	la;
   struct sockaddr_in	ra;
   struct GWUSER  gwuser;
   gwuptr   = &gwuser;
   proxyptr = &tnproxy; 
   timeoutp = &timeout;
   openlog("tnproxy",LOG_PID|LOG_NDELAY,LOG_DAEMON);

   /*================================================ 
    * Initialize wall clock and cpu clock timings 
    *===============================================*/    
   if( ( clktck = sysconf(_SC_CLK_TCK)) < 0)
   {
      syslog(LOG_ERR,"Error: sysconf(_SC_CLK_TIC) function failed.");
      clktck = 0;		/* set to zero to stop cpu timing.	*/
   }
   time(&starttime);
   if( times(&tmsstart) < 0 )
   {
      syslog(LOG_NOTICE,"Error: times() function failed.");
      clktck = 0;		/* set to zero to stop cpu timing.	*/
   }
   /* initialize variables */
   strcpy(dest,"none");
   strcpy(authuser,"unauth");    
   memset(gwuptr->username,0,sizeof(gwuptr->username));
   memset(failedusers,0,sizeof(failedusers));  
   /*===================================================================
    * Read the tnproxy configuration file and get
    * 	tngroupid, tnuserid, tndirectory, ...
    *===================================================================*/
   if( tnproxconf(proxyptr) < 0) return(-1);
   /*===================================================================
    *	If Debug is specified this it will bind the port and listen
    *	directly (circumventing inetd) so you can run the program under
    *	a debugger
    *=================================================================*/
   if( ac > 2)
   {
      if( strcmp(argv[2],"-D") == 0)
      {
	 /* check for debug port number  */
         if( ac > 3 )
         {
	    if( (strlen(argv[3]) < 6)  && isalldigits(argv[3]) )
            {
               if( (tempport = atoi(argv[3])) > 64000)
               {
                  printf("\ntnproxy: portnumber > 64000. Please try again.\n");
	          return(-1);
               }
               debugport = tempport;
            }
            else
            {
               printf("\ntnproxy: invalid portnumber (%s), must be a positive "
                      "integer less than 64000.\n          Please try again.\n",
                      argv[3]);
               return(-1);
            }
         }
         printf("\n tnproxy: Debug mode specified. Use port %d.\n",
                 debugport);
         debugbind(debugport);
      }
   }

   signal(SIGURG,trap_sigurg);
   /* set out of band signalling on fd 0	*/
#ifndef __hppa
   if( fcntl(0,F_SETOWN,getpid() ) < 0)
   {
      syslog(LOG_NOTICE,"Error: fnctl(0,FSETOWN) failed %m");
   }
#endif
   /*=================================================================
    * Get the hostname, IP address, and secureIP data for client host	
    *================================================================*/
   if( tnpeerinfo(0,proxyptr) ) 
   {
      syslog(LOG_ERR,"Error: Can not get peer name");
      exit(1);
   }
   /* set socket options */
   x = 1;
   (void)setsockopt(0,SOL_SOCKET,SO_KEEPALIVE,(char *)&x,sizeof(x));
   /*======================================================================
    * get local IP address of socket
    *=====================================================================*/
   x = sizeof(la);
   if(getsockname(0,(struct sockaddr *)&la,(socklen_t *)&x) < 0)
   {
      sprintf(xuf,"521 PORT getsockname: %s",sys_errlist[errno]);
      syslog(LOG_NOTICE,"Error: getsockname failed: %s.",sys_errlist[errno]);
      return(say(0,xuf));
   }
   /* convert local IP address to ASCII string in dot decimal format */
   z = sizeof(locIP);
   strncpy(locIP,(char *)inet_ntoa(la.sin_addr),z);
   locIP[z-1] = '\0';
  /*========================================================================
    * Check if host with a secure source IP address is connected via a secure
    * local address. If not issue a Security Alert and drop the connection.
    *=======================================================================*/
   if( (proxyptr->srcIPsecure == SECURED) && (portsecure(locIP) != 0) )
   {
      syslog(LOG_NOTICE,"Security Alert: telnet attempt to unsecured local IP %s "
                        "using secure source IP address %s aka %s.",
		        locIP,proxyptr->sourceIP,proxyptr->srcname);
      exit(1);
   }		

#if !defined(__sun)
   if (getpeername(0,(struct sockaddr *)&ra,(socklen_t *)&z) < 0)
   {
      syslog(LOG_ERR,"Error: getpeername failed for fd 0. %s",
		sys_errlist[errno]);
      exit(1);
   }
   chk_spoof("tnproxy",la.sin_addr,la.sin_port,
		ra.sin_addr,ra.sin_port,proxyptr->srcIPsecure);
#endif

   /* set prompt */
   prompt = "-> ";
   promptlen = strlen(prompt);

   /*========================================================================
    * Send initial telnet options.  "will ECHO", will Supress "Go Ahead"
    *=======================================================================*/

   if(firstoptions((unsigned char *)xuf))
      exit(1);
   /*=================================================================
    * Get local host name and display ready message.	
    *================================================================*/
   if(gethostname(huf,sizeof(huf)))
         	strcpy(huf,"unknown");
   sprintf(xuf,"%s telnet Version %s ready:",huf,"1.0");
   if(say(0,xuf))
         exit(1);
   /*==================================================================
    * If authorization is required or source host is not secure then
    * authenticate the user.
    * Else authenticate the user.
    *=================================================================*/
   if((proxyptr->auth == AUTHREQ) || (proxyptr->srcIPsecure != SECURED) ) 
   {
      rtncd = authenticate(gwuptr, proxyptr->sourceIP, failedusers, proxyptr);
      if( rtncd < 0) exit(1);
      if( rtncd > 0)
      {
         syslog(LOG_ALERT,"Security Alert: multiple authentication failures: "
                          "source host = %s (%s) user(s) = %s",
                           proxyptr->srcname, proxyptr->sourceIP, failedusers);
         exit(1);
      }
      strcpy(proxyptr->username,gwuptr->username);
      strcpy(authuser,gwuptr->username);
      strcpy(proxyptr->groupname,gwuptr->groupname);


      adm_ok = gwuptr->tnaccess & ADM_TN;


      /*================================================================
       * Construct the key schedule while we have the userkey within
       * scope.
       *===============================================================*/
      des_set_key((des_cblock *)md5key(gwuptr->userkey),ckeysched);

   }
   else
   {
      strncpy(proxyptr->username, proxyptr->sourceIP,UNMSIZ);  
      strncpy(authuser, proxyptr->sourceIP, UNMSIZ);
   }
#if !defined(__sun)
   chk_spoof("tnproxy",la.sin_addr,la.sin_port,
		ra.sin_addr,ra.sin_port,proxyptr->srcIPsecure);
#endif

   /*====================================================================
    * Prompt the user for commands until done interacting.
    *====================================================================*/
   while((x = usercmd(prompt,promptlen)) == 0)
		;
   if(x == 1)
      goto leave;
   /*=======================================================================
    * Batten down the hatches and undo the telnet options so the client
    * and server can re-negotiate options. 
    *=====================================================================*/
   securetnp(proxyptr);


   if (!local_login) 
   {
      if( annulopt() )
      {  
         exit(1); 
      }  
      /*=========================================
       * Pass client' initial options to server
       *========================================*/
      if( proxyptr->destPort == TNPORT)
      {
         if( (br = write(rfd, prebuf, prebufc)) < 0)
         {
            syslog(LOG_ERR,"Error: write of client's options failed.");
            exit(1); 
         }
      }      
   }
   /*====================================================================
    * The Main Loop - aka the Livermore Loop
    *===================================================================*/
   while(1)
   {
      FD_ZERO(&rdy);
      FD_SET(0,&rdy);
      if(rfd != -1)
      {
         FD_SET(rfd,&rdy);
      }
      /*====================================================================
       * Set the timeout value for select.
       *====================================================================*/
      timeout.tv_sec = proxyptr->timeout;
      timeout.tv_usec = 0;
#ifdef __hppa
      if((x = select(32,(int *)&rdy,0,0,timeoutp)) < 0)
#else	
      if((x = select(32,&rdy,(fd_set *)0,(fd_set *)0,timeoutp)) < 0)
#endif	
      {
         syslog(LOG_NOTICE,"select: %m");
	 exit(1);
      }

      if( x == 0 )
         break;


      if(!kludgeraw && FD_ISSET(0,&rdy))
      {
         if(rfd == -1)
         {
            say(0,"Remote server has closed connection.");
	    goto leave;
	 }
	 x = Eread(0,xuf,sizeof(xuf));
	 if(x <= 0)
	    goto leave;

         /*===========================================================
          * Some BSD based telnet clients send a null as the first
	  * character to the telnet server. This can confuse the remote
	  * system when communicating via the proxy. We simply drop
	  * the character and the problem goes away.
	  *===========================================================*/
	  if(clientnull == (char *)0 && xuf[0] == 0)
          {
	     x--;
	     clientnull = &xuf[1];
	  }
          else
          {
	     clientnull = xuf;
	  }
         /*=================================================================
          * If local login, trap the IACs and process them if they are
          * important.
          *================================================================*/
          if (local_login && (x > 0))
          {
             process_iacs((unsigned char *)clientnull,&x);
          }
	  if(x && write(rfd,clientnull,x) != x)
          {
	     say(0,"Remote server has closed connection.");
	     goto leave;
	  }
	     outbytcnt += x;
      }


      if(kludgeraw && FD_ISSET(0,&rdy))
         if(raw_telnet())
	    goto leave;
                          
      /*==================================================================
       * Read from the server.
       *================================================================*/
      if(rfd != -1 && FD_ISSET(rfd,&rdy))
      {
         br = read(rfd,xuf,sizeof(xuf));

	 if( br <= 0)
         {
	    say(0,"Remote server has closed connection");
	    goto leave;
	 }
         /*===================================================================
          * Check for IAC WILL ECHO.  If found send the clients saved response 
          * to the server and send all info but "IAC WILL ECHO"  to the     
          * client.
          *=================================================================*/ 
         for( i = 0; i  < br; )
         {
            if( (proxyptr->ProxyEchoMode) && (proxyptr->ClientEchoResp) && 
                (i < ( br - 3))		  && ( xuf[i] == (char)IAC )	&&
                ( xuf[i+1] == (char)WILL) && ( xuf[i+2] == (char)TELOPT_ECHO) )
            {                
               ybuf[0] = IAC;
               ybuf[1] = proxyptr->ClientEchoResp;
               ybuf[2] = TELOPT_ECHO;
               if( write(rfd,ybuf,3) < 0 )
               {
                  say(0,"Remote server has closed conenction."); 
                  syslog(LOG_ERR,"Error: while writing ProxyEchoMode to server");
                  goto leave;
               }
               proxyptr->ClientEchoResp = 0;	/* Reset Echo response */ 
               i = i + 3;
               continue;   
            } 
            if(( x = Ewrite(0,&xuf[i],br - i)) < 0 )
            {
               say(0,"Error writing server response to client.");
               syslog(LOG_ERR,"Error: while writing server response to client.");              
            } 
            i = i + x;
         }

	/* if(Ewrite(0,xuf,x) != x)
	    goto leave; */
	 inbytcnt += x;
      }
   }
leave:
   /*=====================================
    * gather and log statistics
    *====================================*/
   time(&endtime);
   if( times(&tmsend) < 0)
   {
      syslog(LOG_NOTICE,"Error: times(0 error. cpu timing stopped.");
      clktck = 0;
   }
   if( clktck > 1)
   {
      cpu = ( tmsend.tms_utime    + tmsend.tms_stime
	     -tmsstart.tms_utime  - tmsstart.tms_stime)/(1.0*clktck);
      chcpu = ( tmsend.tms_cutime + tmsend.tms_cstime
	     -tmsstart.tms_cutime - tmsstart.tms_cstime)/(1.0*clktck);
   }
   syslog(LOG_NOTICE,"exit source = %s (%s) dest = %s bytesin = %d "
                     "bytesout = %d user = '%s' duration = %d sec "
                     "cpu = %.2f, child cpu = %.2f",
          proxyptr->srcname,proxyptr->sourceIP,dest,inbytcnt,outbytcnt,
          authuser,endtime - starttime,cpu,chcpu);
   exit(0);
} /* end of main routine	*/  

/*===========================================================================
 * function:	RawTelnet
 *
 *      This function is called when we are not talking to a real telnet
 *	server/daemon.  In this  case tnproxy has to tell the client
 * 	that any telnet options it wants are not allowed. 
 *
 * 	PC based NFS clients don't do correct newline mapping in
 * 	telnet mode, they only send a '^M'.  I don't know how to fix this
 *	without breaking something else. 
 *=========================================================================*/
static	int raw_telnet()
{
   unsigned char	j;
   unsigned char	jbuf[4];
   unsigned char	xbuf[SHORTBUF];
   unsigned char	obuf[SHORTBUF];
   int			bcnt;   
   int			bcur;
   int			ocnt;
   static	int	firstNULL = 0;
   /*==================================================================
    * This code handles telnet clients that send a NULL during their
    * first transmission.
    *=================================================================*/   
   bcnt = Eread(0,xbuf,sizeof(xbuf));
   if(bcnt <= 0)
      return(-1);

   ocnt = 0;
   for(bcur = 0; bcur < bcnt; bcur++)
   {
      /* Handle First NULL */
      if(!firstNULL && xbuf[bcur] == 0)
      {
         firstNULL++;
	 continue;
      }

      /* Gather options to send to server */
      if(xbuf[bcur] != IAC)
      {
         obuf[ocnt++] = xbuf[bcur];
	 continue;
      }

      /* If it is a telnet option spoof it. */
      if(bcur + 1 == bcnt)
      {
         if(Eread(0,&j,1) != 1)
	    return(-1);
      }
      else
         j = xbuf[++bcur];

      switch(j)
      {
         case WILL:
	 case WONT:
	    if(bcur + 1 == bcnt)
            {
	       if(Eread(0,&j,1) != 1)
	          return(-1);
	    }
            else
	       j = xbuf[++bcur];
	    jbuf[0] = IAC;
	    jbuf[1] = DONT;
	    jbuf[2] = j;
	    if(Ewrite(0,(char *)jbuf,3) != 3)
	       return(-1);
	    continue;

         case DO:
	 case DONT:
	    if(bcur + 1 == bcnt)
            {
	       if(Eread(0,&j,1) != 1)
	          return(-1);
	    }
            else
	       j = xbuf[++bcur];
	    jbuf[0] = IAC;
	    jbuf[1] = WONT;
	    jbuf[2] = j;
	    if( Ewrite(0,(char *)jbuf,3) != 3 )
	       return(-1);
	    continue;
      }
   }
   if(ocnt > 0 && Ewrite(rfd,obuf,ocnt) != ocnt)
      return(-1);
   outbytcnt += ocnt;
   return(0);
}
/*===========================================================================
 *
 *==========================================================================*/
static	void trap_sigurg(int sig)
{
   int	atmark;
   char	buf[SMBUFSIZE];
   char	c;

   signal(SIGURG,trap_sigurg);
   while(1)
   {
      if(ioctl(0,SIOCATMARK,(char *)&atmark) < 0)
         return;
      if(atmark)
         break;
      read(0,buf,sizeof(buf));
   }
   if(rfd != -1)
   {
      if(recv(0,(char *)&c,sizeof(c),MSG_OOB) < 0)
         return;
      send(rfd,(char *)&c,sizeof(c),MSG_OOB);
   }
}

/*===========================================================================
 *
 *===========================================================================*/
static	void accept_setdest(char *v, int c)
{
   int	dests = 0;

   if(validests == (char **)0)
      validests = (char **)malloc(sizeof(char *) * 2);
   else
   {
      for(dests = 0; validests[dests] != (char *)0; dests++)
			;
      validests = (char **)realloc(validests,(dests + 2) * sizeof(char *));
   }
   if(validests == (char **)0)
      return;
   validests[dests] = v;
   validests[dests + 1] = (char *)0;
}
/*==========================================================================
 * function:	acceptrule
 * inputs: 
 *	argument count
 *	pointer to arguments
 * outputs:
 *
 *=========================================================================*/
acceptrule(int ac, char *argv[])
{
   int	x;
   void	(*op)();

   for(x = 1; x < ac; x++)
   {
      if(argv[x][0] != '-')
         continue;  

      if(!strcmp(argv[x],"-passok"))
      {
         changeok = 1;
	 continue;
      }

      if(!strcmp(argv[x],"-extnd"))
      {
         extendperm = 1;
	 continue;
      }

      if(!strcmp(argv[x],"-xok"))
      {
         xgwok = 1;
	 continue;
      }


      /* options that take parameters and lists */
      op = 0;
      /*
      if(!strcmp(argv[x],"-dest"))
         op = accept_setdest;
      if(op == 0)
      {
         syslog(LOG_ERR,"Error: bad option line %d: %.120s",c->ln,c->argv[x]);
	 exit(1);
      }
      if(++x >= c->argc)
      {
         syslog(LOG_ERR,"Error: malformed line %d: missing option",c->ln);
	 exit(1);
      }
      if(!strcmp(c->argv[x],"{"))
      {
         while(1)
         {
	    if(++x >= c->argc)
            {
	       syslog(LOG_ERR,"Error: malformed line %d: missing option",c->ln);
	       exit(1);
	    }
	    if(!strcmp(c->argv[x],"}"))
	       break;
	    (*op)(c->argv[x],c->ln);
	 }
      }
      else
         (*op)(c->argv[x],c->ln);
      */
   }
   return(0);
}
/*==========================================================================
 * X-Forward
 * inputs:
 *
 * outputs:
 *
 *=========================================================================*/
static	int cmdXforward(int ac, char *av[], char *cbuf)
{ 
   
   char	buf[SMBUFSIZE];
   int	argno	= 0; 			/* argument number	*/
   char	*newav[16];
   int	pid 	= 0;                    /* process ID		*/
   int	i	= 1;
   char timeoutstr[12];
   char xforwardpgm[]  = XFORWARDPGM;
   if( proxyptr->x4ward != X4WARDYES )
   {
      say(0,"Sorry, xforward is not permitted.");
      syslog(LOG_NOTICE,"xforward command issued by %s from %s is not permitted.",
                         authuser, proxyptr->srcname);
      return(0);
   }

   memset(newav, 0, sizeof(newav));
   newav[0] = "xforward";
   newav[1] = "-from";
   newav[2] = proxyptr->sourceIP; /* pass client's IP address, not hostname */
   newav[3] = "-user";
   newav[4] = authuser;
   argno = 5;
   if(ac > 1)
   {
      if (av[i][0] !=  '-')
      {
         newav[5] = "-display";
         newav[6] = av[i];
         argno = 7;
         i++;
      }
      while (i + 1 < ac && argno < 12)
      {
         newav[argno++] = av[i++];
         newav[argno++] = av[i++];
      }
   }
   if( proxyptr->timeout > 30)
   {
      newav[argno++] = "-time";
      sprintf(timeoutstr,"%d",proxyptr->timeout);
      newav[argno]   = (char *) &timeoutstr;
   }

   if((pid = fork()) < 0)
   {
      syslog(LOG_NOTICE, "Error: cannot fork xforward: %m" );
      say(0,"Cannot fork xforward child process: system error");
      return(1);
   }
   /* If parent process simply return	*/
   if(pid > 0)
      return(0);
   /*========================================================================
    * The child process execs the xforward program which handles xforwarding.
    * If the execv failes issues error messages and exit.
    *=======================================================================*/
   if(execv(xforwardpgm,newav) < 0)
   {
      sprintf(buf,"Can't execute: %s. errno = %d, %s.",
		   cbuf,errno,sys_errlist[errno]);
      say(0,buf);
      syslog(LOG_NOTICE,"Error: execv(%s) failed. errno = %d, %s",
			 xforwardpgm, errno, sys_errlist[errno]);
   }
   exit(0);

}

/*=========================================================================
 * cmdConnect
 * inputs:
 *	ac is number of arguments
 *	argument list
 *	av[1] = destination host
 *	av[2] = destination port
 *
 * outputs:
 *      return  0 if problem but user can retry
 *	     	1 if permission denied
 *              2 if connected
 *========================================================================*/
static	int cmdConnect(int ac, char *av[], char *cbuf)
{
   static	char	narg[] = "Remote destination not specified.";
   char			buf[MAXRECLN];
   char			*cp;
   char			ebuf[SHORTBUF];    
   char			*namp;
   unsigned char	opbuf[9];
   unsigned short	port = TNPORT;
   struct hostent	*hp;
   struct sockaddr_in	sin;            
   proxyptr->destPort = port;
   /*====================================================================
    * If destination address is not given write error message & return	
    *===================================================================*/
   if(ac < 2)
      return(sayn(0,narg,sizeof(narg)));
   /*====================================================================
    * If destination port is specified convert ASCII number to integer or
    * service name to integer.  If service not found write error msg.
    *===================================================================*/
   if(ac > 2)
   {
      if(isalldigits(av[2]))
         port = atoi(av[2]);
      else
      {
         struct servent	*sp;

	 sp = getservbyname(av[2],"tcp");
	 if(sp != (struct servent *)0)
	    port = ntohs(sp->s_port);
	 else
         {
	    sprintf(buf,"Unknown port/service: \"%s\"",av[2]);
	    return(say(0,buf));
	 }
      }
   }   
   proxyptr->destPort = port;
   /*====================================================================
    * If destination address is in ASCII dot decimal format use it else
    * convert it from hostname to ASCII dot decimal format.
    *=====================================================================*/
   cp = av[1];
   while(*cp != '\0' && (*cp == '.' || isdigit(*cp)))
		cp++;
   if( *cp == '\0' )
   {
       strncpy(proxyptr->destIP,av[1],20);
   }
   else
   {
      /*==================================================================
       * First try the external DNS server, if that fails try the internal
       * DNS.
       *================================================================*/
      if((hp = gethostbyname(av[1])) == (struct hostent *)0)
      {
         if((hp = Pgethostbyname(av[1])) == (struct hostent *)0)
         {
            syslog(LOG_NOTICE,"Error: hostname (%s) unknown, %d",
	        av[1], h_errno);
            sprintf(ebuf,"Host name '%s' unknown.",av[1]);
            say(0,ebuf);
            return(0);         /* host not found 	*/
         }
      }
      /*=====================================================
       * copy h_addr to sin_addr and convert to ASCII string
       * in Internet Address dot format	
       *====================================================*/
      bcopy(hp->h_addr,&sin.sin_addr,hp->h_length);
      cp = (char *) inet_ntoa(sin.sin_addr);
      strncpy(proxyptr->destIP,cp,20);
   }
   /*====================================================================
    * Check rules to see if request should be permitted or denied.       
    *====================================================================*/
  if( tnrules(proxyptr) != 0 )
   {
        sprintf(ebuf,"Permission denied for user '%s' to connect to %s",
		     authuser,av[1]);
        say(0,ebuf);
	return(1);
   }

   /* convert hostname to IP address */
   if((namp = hnametoip(av[1])) != (char *)0)
   {
      syslog(LOG_NOTICE,"permit source = %s (%s) dest = %s (%s) port %d",
			proxyptr->srcname, proxyptr->sourceIP, av[1], namp, port);
      sprintf(ebuf,"Trying %s port %d...",namp,port);
      if(say(0,ebuf))
         return(1);
   }
   else
   {
      syslog(LOG_ERR,"Error: hostname '%s' is unknown. Source %s (%s).",
                          av[1], proxyptr->srcname, proxyptr->sourceIP);
      sprintf(ebuf,"Error hostname (%s) is unknown.",av[1]);
      if(say(0,ebuf))
         return(1);
      return(0);
   }

   if(port != TNPORT)
   {      
      opbuf[0] = IAC;
      opbuf[1] = WONT;
      opbuf[2] = TELOPT_ECHO;
      opbuf[3] = IAC;
      opbuf[4] = WONT;
      opbuf[5] = TELOPT_SGA;
      opbuf[6] = IAC;
      opbuf[7] = WONT;
      opbuf[8] = TELOPT_TTYPE;
      if(write(0,opbuf,9) != 9)
         return(1);
      kludgeraw = 1;
   }


   /*=======================================================================
    * If the connect command is requesting a connection to a firewall
    * local address, call connect_local to handle.
    *======================================================================*/
   if( local_login = islocal(inet_addr(namp)) )
   {
	if (local_login < 0)
	    exit(1);

	return(connect_local(av[1]));
   }

   /*=======================================================================
    * If safetn is requested, negotiate encryption with client. If the
    * negotiation failed, return 0 so user can start over.
    *======================================================================*/
   {
	int	len;

	len = strlen(av[0]);
	if (!strncasecmp(av[0],"safetn",len))
	{
            if( proxyptr->srcIPsecure == SECURED )
	    {
		say(0,"safetn is only available from an unprotected host.\n");
		return(0);
	    }

	    if (negotiate_encrypt())
		return(0);
	}
   }

   /* connect using IP address in namp NOT av[1]	*/
   if( (rfd = connectserver(namp, port, 0, NULL) ) < 0 )
   {
      if( rfd == -1)
         sprintf(buf,"Error hostname (%s) is unknown.",av[1]);
      else if( rfd == -2)
         sprintf(buf,"Error hostname (%s) is unparasable.",av[1]);
      else if( rfd == -3)
         sprintf(buf,"Error socket error %s for host (%s).",
		 sys_errlist[errno],av[1]);
      else if( rfd == -4)
         sprintf(buf,"Error can not connect to hostname (%s).",av[1]);

      return( say(0,buf) );
   }
   syslog(LOG_NOTICE,"connected source = %s (%s) to dest = %s (%s) port = %d",
		     proxyptr->srcname, proxyptr->sourceIP, av[1],  namp, port);

   strcpy(dest,av[1]);
   return(2);
}

/*==========================================================================
 *
 *========================================================================*/
static	int cmdQuit(int ac, char *av[], char *cbuf)
{
   static char	gby[] = "Disconnecting...";

   (void)sayn(0,gby,sizeof(gby));
   time(&endtime);
   syslog(LOG_NOTICE,"exit source = %s (%s) dest = %s bytesin = %d bytesout = %d user = '%s' duration = %d sec",
   		proxyptr->srcname,proxyptr->sourceIP,dest,inbytcnt,outbytcnt,authuser,endtime - starttime);

   exit(0);
}
/*=============================================================================
 * function:	cmdHelp
 *		Process the Help command. 
 * inputs:	argument count
 *		argument list
 *		ptr to buffer.	 
 * outputs:	list of valid commands sent to client
 *		Returns 0 if no errors.
 *===========================================================================*/
static	int cmdHelp(int ac, char *av[], char *cbuf)
{

   TnOp		*op;
   static char	hhdr[] = "Valid commands are: (unique abbreviations may be used)";

   if(sayn(0,hhdr,sizeof(hhdr)))
      return(1);
   for(op = ops; op->name != (char *)0; op++)
   {
      if(op->hmsg != (char *)0)
         if(say(0,op->hmsg))
      return(1);
   }
   return(0);
}
/*==========================================================================
 * When this function is called from usercmd, ac is always nonzero.
 * When it is called from authuser to force an expired password to be
 * changed, ac is set to 0 so the function returns a -1 if the user cancelled
 * out of the password change.
 * It goes into an infinite loop and exit only if the password has been
 * successfully changed or the user cancels by entering a return.
 *========================================================================*/
int cmd_passwd(int ac,char *av[], char *cbuf)
{
   extern struct GWCONF	conf;
   char			buf1[CBUFSIZ]="";
   char			buf2[CBUFSIZ]="";
   char			*prompt = "Enter new password (or <CR> to quit): ";
   char			*rprompt = "Re-enter new password: ";
   int			plen,rplen;

   /*=====================================================================
    * If user has not authenticated, he/she cannot change password
    * If called from authuser (ac == 0), authuser is not set yet but
    * the user has been authenticated already so we bypass this test.
    *====================================================================*/
   if (ac && !strcmp(gwuptr->username,"unauth"))
      return(say(0,"Unauthenticated user cannot change password."));
   /*=====================================================================
    * Read gwuser.conf file to get required password parameters
    *====================================================================*/
   if (gwuserconf())
      return(say(0,"Cannot change password for now, contact system "
			"administrator."));

   plen = strlen(prompt);
   rplen = strlen(rprompt);

   do {
      if (Ewrite(0,prompt,plen) < 0)
         return(1);
      if(getline(buf1,sizeof(buf1) - 1,prompt,plen,0) < 0)
         return(1);
      /*===============================================================
       * If a null was entered, cancel request
       * by returning 0 to usercmd or -1 to authuser
       *==============================================================*/
      if (strlen(buf1) == 0)
         if (ac)
            return(0);
         else
            return(-1);

      if (Ewrite(0,rprompt,rplen) < 0)
         return(1);
      if(getline(buf2,sizeof(buf2) - 1,rprompt,rplen,0) < 0)
         return(1);
      if (!strcmp(buf1,buf2)) {
         /*===============================================================
          * Validate and then update gwuser password
          *==============================================================*/
         if (check_password(buf1,gwuptr->password,&conf,buf2)) {
             if (say(0,"Password not changed:"))
                return(1);
             if (say(0,buf2))
                return(1);
             continue;
         }
         /*===============================================================
          * Everything checked out OK, now update the password in the
          * user record.
          *==============================================================*/
         if (set_password(gwuptr->username,buf1) < 0)
            return(1);

         return(0);
      }
      else {
        if (say(0,"Mismatched passwords entered, password not changed."))
           return(1);
        if (ac)
           return(0);
      }
   } while (1);
}
/*===========================================================================
 * function:	cmdTimeout 
 *	This function processes the timeout command issued by the user.
 *
 * inputs:
 *	The number of arguments
 *	A ptr to the argument list.
 *	A ptr to the char buffer.     
 * outputs:                      
 *      return code
 *==========================================================================*/   
int cmdTimeout(int ac,char *av[], char *cbuf)                                                                              
{           
   if(ac < 2)
      return(say(0,"Timeout value missing."));   
   if(!isalldigits(av[1]))  
      return(say(0,"Timeout value not all digits."));  
   if( strlen(av[1]) > 8)
      return(say(0,"Timeout value is too long (has more than 8 digits)."));
   proxyptr->timeout = atoi(av[1]);
   timeoutp->tv_sec = proxyptr->timeout; 
   return(say(0,"Timeout reset."));
}
/*===========================================================================
 * function:	usercmd
 * 	This module prompts the user for a command and calls the corresponding
 *	function.  The valid commands are:
 *		connect, telnet, and open all connect.	
 *              help, ?,  quit, close, exit
 *		password is not yet supported
 * inputs:
 *	ptr to user prompt
 *	length of user prompt
 * outputs:
 *	return 0 if user issues an invalid command or
 *		 user makes an error trying to connect
 *	return 1 if unable to write message to user
 *=========================================================================*/
int usercmd(char *prompt, int promptlen)
{
   TnOp		*op;
   static char	badcmd[] = "Command not understood";
   char		buf[CBUFSIZ];
   char		tokbuf[CBUFSIZ];
   char		*tokav[56];
   int		tokac;
   int		l;

   if(write(0,prompt,promptlen) != promptlen)
      return(1);
   if(getline((unsigned char *)buf,sizeof(buf) - 1,prompt,promptlen,1) < 0)
      return(1);
   if(buf[0] == '\0')
      return(0);
   /*================================================= 
    * Build arg list using buffer input	
    *================================================*/
   tokac = enargv(buf,tokav,56,tokbuf,sizeof(tokbuf));
   if(tokac < 0)
   {
      if(sayn(0,badcmd,sizeof(badcmd)))
         return(1);
      return(0);
   }
   if(tokac == 0)
      return(0);

   l = strlen(tokav[0]);
   /*===================================================================
    * Search the Telnet Operation Table and call selected function.
    *==================================================================*/
   for(op = ops; op->name != (char *)0; op++)
   {
      if(!strncasecmp(tokav[0],op->name,l))
         return((*op->op)(tokac,tokav,buf));
   }

   sprintf(buf,"Command \"%s\" is not recognized.",tokav[0]);
   return(say(0,buf));
}   

/*=========================================================================
 * function: cache telnet options
 * 	Cache telnet options for later use.  Some are immediately echoed.
 *	This function is called by getline when ever the client sends 
 *	an IAC.
 * input: 
 *	There are no input parameters. All input is read from client.
 * output:
 *	returns 0 if ok, else a 1.   
 *========================================================================*/
static	int cache_option()
{
   unsigned char	opbuf[3];         /* telnet options response buffer*/

   /*=======================================================================
    * If there is room in prebuf then store: IAC and Option. 
    *=====================================================================*/
   if(prebufc + 1 > sizeof(prebuf))
      return(0);
   prebuf[prebufc++] = IAC;
   if(prebufc + 1 > sizeof(prebuf))
      return(0);
   if(read(0,&prebuf[prebufc++],1) <= 0)	/* read WILL|WONT|DO|DONT */
      return(1);

   switch(prebuf[prebufc - 1])
   {
      case DO: 
                /*=======================================================    
                 * If DO Supress Go Ahead respond with WILL  
                 * If DO ECHO             respond with WILL   
                 * Do not echo commands if already echoed.
                 *=====================================================*/
		if(prebufc + 1 > sizeof(prebuf))
			return(0);
		if(read(0,&prebuf[prebufc++],1) <= 0)
			return(1);

		if((prebuf[prebufc - 1] == TELOPT_SGA) && 
		    proxyptr->ProxySGAMode == 0 )
		{
		   opbuf[0] = IAC;
		   opbuf[1] = WILL;
		   opbuf[2] = prebuf[prebufc - 1];
		   if(write(0,opbuf,3) != 3)
		      return(1);
		   proxyptr->ProxySGAMode = WILL;
                   proxyptr->ClientSGAResp = DO;
        	}

		if( prebuf[prebufc - 1] == TELOPT_ECHO && 
		    proxyptr->ProxyEchoMode == 0)
		{
		   opbuf[0] = IAC;
		   opbuf[1] = WILL;
		   opbuf[2] = prebuf[prebufc - 1];
                   
		   if(write(0,opbuf,3) != 3)
		      return(1);            
	           proxyptr->ProxyEchoMode  = WILL;
		   proxyptr->ClientEchoResp = DO;
		   
		} 

		return(0);

	case WILL:
                 /*=======================================================    
                  * If WILL Term_Type respond with DO   
                  *=====================================================*/

		if(prebufc + 1 > sizeof(prebuf))
			return(0);
		if(read(0,&prebuf[prebufc++],1) <= 0)
			return(1);
		if(prebuf[prebufc - 1] == TELOPT_TTYPE)
		{
		   opbuf[0] = IAC;
		   opbuf[1] = DO;
		   opbuf[2] = TELOPT_TTYPE; 
                   if(write(0,opbuf,3) != 3)
		      return(1);
        	}  
		return(0);
	case WONT:
	case DONT:
                 /*=======================================================    
                  * If WONT or DONT stash option and do NOT reply 
                  *=====================================================*/  
		if(prebufc + 1 > sizeof(prebuf))
			return(0);
		if(read(0,&prebuf[prebufc++],1) <= 0)
			return(1);
		return(0);
	default:
		return(0);
   }
}       

/*===========================================================================
 * getline
 * inputs:
 *	ptr to buffer
 *	size of buffer -1  (allow room for \0)
 *	ptr to prompt
 *	size of prompt
 *	echo ?
 *
 * outputs:
 *      return -1 on error
 *	return number of bytes in line if ok
 *=========================================================================*/
int getline(unsigned char *buf, int siz, char *pro, int plen, int echo)
{
   int		x = 0;
   static int	sawcr = 0;

   while(1)
   {
      if(read(0,(char *)&buf[x],1) != 1)
         return(-1);
      /*==============================================
       * Cache telnet options where ever we see them 
       *=============================================*/
      if(buf[x] == IAC)
      {
         if(cache_option())
            return(-1);
	 continue;
      }

      /* some telnets send NULL-terminated lines in NOECHO :( */
      if(buf[x] == '\0')
         continue;

      /*==================================================================== 
       * If CR is received and PRoxy Echo Mode is on then send back a CRLF 
       * and terminate char string 
       *===================================================================*/
      if(buf[x] == '\r')
      {  
         sawcr = 1;
         if( proxyptr->ProxyEchoMode)
         {
            if(write(0,"\r\n",2) != 2)
	       return(-1);
	 }
	 buf[x] = '\0';
	 return(x);
      }
      /*===================================================================== 
       * If Newline is received and Proxy Echo Mode is on then send back a \n 
       * and terminate char string 
       *====================================================================*/
      if(buf[x] == '\n')
      {
         if(sawcr)
         {
	    sawcr = 0;
	    continue;
	 }
	 if( proxyptr->ProxyEchoMode)
         {
	    if(write(0,"\r\n",2) != 2)
	       return(-1);
         }
	 buf[x] = '\0';
	 return(x);
      }
      else
         sawcr = 0;

      /* control R */
      if(buf[x] == 18)
      {
         if(write(0,"\r\n",2) != 2)
	    return(-1);
	 if(write(0,pro,plen) != plen)
	    return(-1);
	 buf[x] = '\0';
	 if(echo && write(0,buf,x) != x)
	    return(-1);
	 continue;
      }

      /* control U/ control C */
      if(buf[x] == 3 || buf[x] == 21)
      {
         if(write(0,"\r\n",2) != 2)
	    return(-1);
	 x = 0;
	 buf[x] = '\0';
	 return(x);
      }

      /* control D */
      if(buf[x] == 4)
      {
         (void)write(0,"\r\nEOF\r\n",7);
	 return(-1);
      }

      if(buf[x] == 127 || buf[x] == 8)
      {
         unsigned char	xab[4];
	 int		xac;

	 /* backspace or bell */
	 if(x > 0)
         {
	    xab[0] = 0x08;
	    xab[1] = 0x20;
	    xab[2] = 0x08;
	    xac = 3;
	    x--;
	 }
         else
         {
	    xab[0] = 007;
	    xac = 1;
	 }
	 if(write(0,xab,xac) != xac)
	    return(-1);
	 continue;
      }

      if(!isprint(buf[x]))
      {
         unsigned char	xab[1];

	 xab[0] = 007;
	 if(write(0,xab,1) != 1)
	    return(-1);
	 continue;
      }
      /*===============================================================
       * If getline called with Echo option then echo the buffer else
       * write '#' character.  
       *==============================================================*/
      if(echo)
      {
         if(write(0,(char *)&buf[x],1) != 1)
	    return(-1);
      }
      else
      {
         if(write(0,"#",1) != 1)
	    return(-1);
      }
      if(++x >= siz)
      {
         syslog(LOG_NOTICE,"Error: buffer overrun in getline. Number of "
			   "characters %d > %d.",
			   x, siz);
	 return(-1);
      }
   }
}
/*==========================================================================
 * function:	firstoptions 
 *		Send primal telnet options to client and record state.
 *     			WILL	ECHO 
 *     			WILL	Supress Go Ahead
 * inputs:	        
 *
 * outputs:
 *		Return 0 if ok
 *==========================================================================*/
int firstoptions(unsigned char opbuf[])
{
   opbuf[0] = IAC;             		/* Interpret As Command		*/
   opbuf[1] = WILL;			/* Sender wants to enable	*/
   opbuf[2] = TELOPT_ECHO;        	/* ECHO				*/
   opbuf[3] = IAC;                	/* Interpret As Command		*/
   opbuf[4] = WILL;               	/* Sender wants to enable	*/
   opbuf[5] = TELOPT_SGA;         	/* Surpress Go Ahead		*/
   if(write(0,opbuf,6) == 6)
   {
      proxyptr->ProxyEchoMode = WILL;	/* set Will Echo Mode		*/ 
      proxyptr->ProxySGAMode  = WILL;	/* set Will SGA Mode		*/
      return(0); 
   } 
   syslog(LOG_ERR,"Error: unable to send initial telnet options."); 
   return(1);
}
/*=========================================================================
 * Annul telnet options negotiated between client and proxy so that client
 * and server can re-negotiate the options. 
 *
 *========================================================================*/
int annulopt()
{
   fd_set		fs;
   struct timeval	to;
   unsigned char	opbuf[256];	/* options buffer 		*/
   int			rbi = 0;
   int			n   = 0;   
   int			rc  = 0;	/* return code from select()	*/
   int			x   = 0;
   
   while(rbi < prebufc)
   {
      if(prebuf[rbi++] != IAC)		/* Search for IAC	*/
         continue;

      opbuf[0] = IAC;
      opbuf[1] = prebuf[rbi++];
      opbuf[2] = prebuf[rbi++];
      /*==============================================================
       * Undo any options that were turned on by sender or receiver.
       *=============================================================*/
      switch (opbuf[1])
      {
         case DO:  
		if( opbuf[2] == TELOPT_STATUS	||
                    opbuf[2] == TELOPT_ECHO	||  
		    opbuf[2] == TELOPT_XDISPLOC	   
                )
                   break;
	    opbuf[1] = WONT;
	    break;
	 case DONT:  
		
	    opbuf[1] = WONT;
	    break;
	 case WILL:   
            if( opbuf[2] == TELOPT_LOGOUT	||
		opbuf[2] == TELOPT_NAWS		|| 
                opbuf[2] == TELOPT_TSPEED	||
                opbuf[2] == TELOPT_LFLOW	||
                opbuf[2] == TELOPT_LINEMODE	|| 
                opbuf[2] == 39 /*TELOPT_NEW_ENVIRON*/	
	        
              )
               break;
	    opbuf[1] = DONT;
	    break;
	 case WONT:
	    opbuf[1] = DONT;
	    break;
      }

      n = 0;
      switch(opbuf[1])
      {
         case DONT:
	 case WONT:
	    n = 3;
	    if(Ewrite(0,opbuf,n) != n)
	       return(1);
	    break;
      }

      if(!n)
         continue;
      {
         FD_ZERO(&fs);
	 FD_SET(0,&fs); 

         /* set timeout value	*/
         to.tv_usec = 330000;			
         to.tv_sec  = 0;
         /*==================================================================
          * Break out of the loop on errors. 
          * Ignore timeouts, to assist Solaris 2.5.1 clients.	
          *=================================================================*/ 
#ifdef __hppa	
	 if((rc = select(1,(int *)&fs,0,0,&to)) < 1)
#else
	 if((rc = select(1,&fs,(fd_set *)0,(fd_set *)0,&to)) < 1)
#endif	  
         {  
            if( rc < 0)
            { 
               syslog(LOG_ERR,"Error: select() failed for annul of telnet"
                              " option(%.2x%.2x%.2x).",
			      opbuf[0],opbuf[1],opbuf[2]);  
               return(1);
            } 
            else 
            {
               syslog(LOG_DEBUG,"Timeout after %.2f seconds, waiting for "
                                 "response to de-initilize "
        			 "option(%.2x%.2x%.2x). Execution continues.",
			         to.tv_sec + to.tv_usec/1000000.0,
			         opbuf[0],opbuf[1],opbuf[2]);
            }
      
         } 
	 if(FD_ISSET(0,&fs))
         {
	    if(Eread(0,&opbuf[x++],3) <= 0)       
	       return(1);
	 }
      }
   }
   return(0);
}
/*==========================================================================
 *  function say
 * inputs:	file descriptor
 *		s
 * return:	0 if ok
 *==========================================================================*/
say(int fd, char *s)
{
   return(sayn(fd,s,strlen(s)));
}
/*========================================================================
 * function sayn
 * inputs:	file descriptor
 *		ptr to character string
 *		length of string
 * return:	0 if write is ok
 *========================================================================*/
sayn(int fd, char *s, int n)
{
   if(Ewrite(fd,s,n) != n)
      return(1);
   return(Ewrite(fd,"\r\n",2) != 2);
}

/*============================================================================
 *
 *==========================================================================*/
sayfile(int fd, char *fn)
{
   FILE	*f;
   char	buf[BUFSIZ];
   char	*c;

   if((f = fopen(fn,"r")) == (FILE *)0)
      return(1);
   while(fgets(buf,sizeof(buf),f) != (char *)0)
   {
      if((c = index(buf,'\n')) != (char *)0)
         *c = '\0';
      if(say(fd,buf))
      {
         fclose(f);
	 return(1);
      }
   }
   fclose(f);
   return(0);
}
/*=========================================================================
 * securetnp
 * function:
 *	secure the telnet proxy server by: changing to the designated
 * 	directory chrooting to that directory and changing the group id and
 * 	user id.
 *
 *========================================================================*/
void securetnp(struct TNPROXY *proxyptr )
{
   chdir("/");
   if( chdir(proxyptr->tnproxpath) )
   {
         syslog(LOG_NOTICE,"Error: chdir %s failed: %m",proxyptr->tnproxpath);
	 exit(1);
   }
   if( chroot(proxyptr->tnproxpath) )
   {
      syslog(LOG_NOTICE,"Error: chroot %s failed: %m",proxyptr->tnproxpath);
      exit(1);
   }
   chdir("/");
   if( proxyptr->tngroupid != -1 && setgid(proxyptr->tngroupid) )
   {
      syslog(LOG_NOTICE,"Error: cannot setgid %d: %m",proxyptr->tngroupid);
      exit(1);
   }

   if(proxyptr->tnuserid != -1 && setuid(proxyptr->tnuserid))
   {
      syslog(LOG_NOTICE,"tnpsyserr: cannot setuid %d: %m",proxyptr->tnuserid);
      exit(1);
   }
   return;
}
/*======================================================================
 * debugbind
 * input: 	debug port number
 *======================================================================*/
void debugbind(unsigned short debugport)
{
   struct	sockaddr_in	mya;
   int	x;
   int	nread;

   if((x = socket(AF_INET,SOCK_STREAM,0)) < 0)
   {
      perror("socket");
      exit(1);
   }
   memset(&mya, 0, sizeof(mya));
   mya.sin_family = AF_INET;
   mya.sin_port = htons(debugport);

   if(bind(x,(struct sockaddr *)&mya,sizeof(mya)))
   {
      perror("bind");
      exit(1);
   }
   if(listen(x,1) < 0)
   {
      perror("listen");
      exit(1);
   }
   if((nread = accept(x,0,0)) < 0)
   {
      perror("accept");
      exit(1);
   }
   close(0);
   dup(nread);
   close(1);
   dup(nread);
}


/*=======================================================================
 * process_iacs
 * function:
 *		Looks at input buffer from the client and extracts any
 *		important IACs that are there, interpret them and pass them
 *		on to the login process.
 * input:
 *		buf - buffer containing bytes that were just read in from
 *			the client.
 *		x   - Number of bytes in buf.
 * assumption:
 *		1. IAC/SB and IAC/SE sequence always comes in one
 *		   buffer.  I.e., this function doesn't try to remember
 *		   an incomplete IAC sequence from previous calls.
 *======================================================================*/
void process_iacs(unsigned char *buf, int *x)
{
   int	width,height,i,skip;
   struct winsize w;

   for (i=0; i<(*x)-1; i++)
   {
	if (buf[i] == IAC)
	{
	    switch (buf[i+1])
	    {
	    case SB:
		/*==========================================================
		 * Process NAWS suboption to enable window size changes
		 *=========================================================*/
		switch (buf[i+2])
		{
		case TELOPT_NAWS:
		    width = (buf[i+3] << 8) | buf[i+4];
		    height = (buf[i+5] << 8) | buf[i+6];
		    w.ws_row=height;
		    w.ws_col=width;
		    w.ws_xpixel=0;
		    w.ws_ypixel=0;
#ifdef  TIOCSWINSZ
		    (void) ioctl(rfd, TIOCSWINSZ, &w);
#else
#ifdef  TXSETWINSZ
		    (void) ioctl(rfd, TXSETWINSZ, &w);
#endif  /* TXSETWINSZ */
#endif
		    skip = 7;
		    break;
		/*==========================================================
		 * Ignore other suboptions
		 *=========================================================*/
		default:
		    if (skip = (int)memchr(&buf[i+2],IAC,(*x)-i-2))
			skip = skip - (int)buf - i;
		    else
			skip = (*x) - i;
		    break;
		}
		break;
	    /*==============================================================
	     * Ignore DO, DONT, WILL, WONT
	     *=============================================================*/
	    case DO:
	    case DONT:
	    case WILL:
	    case WONT:
		skip = 3;
		break;
	    /*==============================================================
	     * Ignore IAC SE
	     *=============================================================*/
	    case SE:
		skip = 2;
		break;
	    }

	    if ((*x)-i > skip)
	    {
		memcpy(&buf[i],&buf[i+skip],(*x)-i-skip);
		(*x) = (*x) - skip;
		i--;		/* start here next round */
	    }
	    else
		*x = i;
	}
   }
}

/*=======================================================================
 * setup_login
 * function:
 *		Place log entries in utmp to make it look like
 *		our login process is started by init.
 * input:
 *		tty - name of the slave pty device to which the login
 *			process is connected.
 *======================================================================*/
void setup_login(char *tty)
{
   struct utmp utmp;

   bzero(&utmp, sizeof(utmp));
   if (!strncmp(tty, "/dev/", 5))
	tty += 5;
   strncpy(utmp.ut_id, tty, sizeof(utmp.ut_id));
   strncpy(utmp.ut_line, tty, sizeof(utmp.ut_line));
   utmp.ut_type = LOGIN_PROCESS;
   utmp.ut_pid = getpid();
   utmp.ut_time = time((time_t *)0);

/*======================================================================
 * The Null string in the 2nd argument makes login thinks that the login
 * is local.
 *=====================================================================*/
#ifndef __sun
   strncpy(utmp.ut_host, "", sizeof(utmp.ut_host));
#endif /* ndef __sun */
   pututline(&utmp);
   endutent();
}

/*=======================================================================
 * setup_term
 * function:
 *		Get the terminal type from the client side and put it in
 *		the environment so login will use the same terminal type
 *		the client is in.
 * input:
 *
 * output:
 *	0 = term type set in environment
 *	1 = term type not set
 *======================================================================*/
int setup_term()
{   
   unsigned char dott[3]     = {IAC,DO,TELOPT_TTYPE};
   unsigned char sendtt[6]   = {IAC,SB,TELOPT_TTYPE,TELQUAL_SEND,IAC,SE};
   static char 	 termenv[46] = "TERM=";	/* termtype[40], TERM=, null */
   int dottype	= 0;
   int i	= 0;
   int namelen	= 0;
   int nread 	= 0;      
   unsigned char sbuf[BUFSIZ];
   /*======================================================================
    * Send the request to do termtype
    *=====================================================================*/
   if (Ewrite(0,dott,sizeof(dott)) < 0)
   {
	syslog(LOG_ERR,"Error: Failed to send TTYPE request, %s",
			sys_errlist[errno]);
	return(1);
   }

   /*======================================================================
    * Send the request for the client to respond with a term type
    *=====================================================================*/
   if (Ewrite(0,sendtt,sizeof(sendtt)) < 0)
   {
	syslog(LOG_ERR,"Error: Failed to send SENDTTYPE request, %s",
			sys_errlist[errno]);
	return(1);
   }

   /*======================================================================
    * Get client's response
    * The 'while' is so that we can correctly skip the IAC WILL TTYPE
    * response from the client.
    *=====================================================================*/
   while ((nread = Eread(0,sbuf,sizeof(sbuf))) == 3);
   if (nread < 0)
   {
	syslog(LOG_ERR,"Error: Failed to get TTYPE from client, %s",
			sys_errlist[errno]);
	return(1);
   }

   /*======================================================================
    * Look for the termtype in the response
    *=====================================================================*/
   for (i=0; i < nread-6; i++)
   {
	if (sbuf[i] == IAC &&
	    sbuf[i+1] == SB &&
	    sbuf[i+2] == TELOPT_TTYPE &&
	    sbuf[i+3] == TELQUAL_IS)
	{
	    /*=============================================================
	     * Copy the name into the environment string
	     *============================================================*/
	    while (namelen <= 40 && sbuf[i+4+namelen] != IAC)
	    {
		termenv[5+namelen] = tolower(sbuf[i+4+namelen]);
		namelen++;
	    }
	    termenv[5+namelen] = '\0';

	    /*=============================================================
	     * Set the environment
	     *============================================================*/
	    putenv(termenv);
	    return(0);
	}	
   }
   return(1);
}

/*======================================================================
 * connect_local
 * function:
 *		Rather than making a connection to a remote host,
 *		connect_local spawns a child, establishes a pty and starts
 *		a login shell on the firewall.  It is used by administrators
 *		to remotely log in to the firewall.
 * input:
 *	ptr to destination hostname 	
 *======================================================================*/
int connect_local(char *hostname)
{
   int		wfd = -1;	/* fd for pty slave */
   int		pid,x;
   char		*pty;
   char		buf[BUFSIZ];
   struct winsize w = {0, 0, 0, 0,};
   int on=1;

   /*==================================================================
    * If tnproxy.conf specifies auth=no and request is from a protected
    * machine, we have not authenticated the user yet.
    *=================================================================*/
   if((proxyptr->auth != AUTHREQ) && (proxyptr->srcIPsecure == SECURED) )    
   {
	int			rc;
	char		failedusers[(MAXTRIES+1)*(UNMSIZ+2)];
	struct GWUSER	gwuser;

	say(0,"\nAuthentication is required before connection to"
		" firewall is permitted.\n");

	memset(failedusers,'\0',sizeof(failedusers));

	rc = authenticate(&gwuser, proxyptr->sourceIP, failedusers, proxyptr);

	if( rc < 0) exit(1);
	if( rc > 0)
	{
	   syslog(LOG_ALERT,"Security Alert: multiple authentication "
			"failures for firewall login: source host = %s (%s) "
			"user(s) = %s",
			proxyptr->srcname, proxyptr->sourceIP, failedusers);
	   exit(1);
	}

	adm_ok = gwuser.tnaccess & ADM_TN;
	    
	strcpy(proxyptr->username,gwuser.username);
	strcpy(authuser,gwuser.username);
	strcpy(proxyptr->groupname,gwuser.groupname);

	/*================================================================
	 * Construct the key schedule while we have the userkey within
	 * scope.
	 *===============================================================*/
	des_set_key((des_cblock *)md5key(gwuser.userkey),ckeysched);
   }
   /*================================================================
    * Check to make sure this user is OK for logging in to the
    * firewall.
    *===============================================================*/
   if (!adm_ok)
   {
	syslog(LOG_ALERT,"Security Alert: Attempt to login to firewall "
				"by unauthorized user %s.",
				proxyptr->username);
	exit(1);
   }

#ifndef _AIX
   rfd = open("/dev/ptmx",O_RDWR);
   grantpt(rfd);
   unlockpt(rfd);
#else
   rfd = open("/dev/ptc",O_RDWR);
#endif
   if (rfd <= 0)
   {
	syslog(LOG_ERR,"Error: Failed to open master pty, %s.\n",
		sys_errlist[errno]);
	exit(1);
   }
#ifndef _AIX
   pty = ptsname(rfd);
#else
   pty = ttyname(rfd);
#endif

   wfd = open(pty,O_RDWR|O_NOCTTY);
   if (wfd <= 0)
   {
	syslog(LOG_ERR,"Error: Failed to open slave pty, %s.\n",
		sys_errlist[errno]);
	exit(1);
   }

#ifdef TXSETLD
   ioctl(wfd, TXSETLD, "posix");
#endif
#ifndef _AIX
  #ifndef linux
   ioctl(wfd, I_PUSH, "ptem");
   ioctl(wfd, I_PUSH, "ldterm");
  #endif
#endif

   {
	struct termios b;

	tcgetattr(wfd,(struct termios *)&b);
	b.c_cflag = (B9600|CS8|CREAD|HUPCL);
	b.c_lflag = (ISIG|ICANON|ECHO|ECHOE|ECHOK|ECHOKE|ECHOCTL|IEXTEN);
	b.c_iflag = (BRKINT|IGNPAR|ICRNL|IMAXBEL);
	/* Do NOT set flow control stuff on PTY since it is taken care of
	   on the client side */
	b.c_iflag &= ~(IXANY|IXON|IXOFF);
	b.c_oflag = (OPOST|ONLCR|TAB3);
	b.c_cc[VINTR]    = CINTR;
	b.c_cc[VQUIT]    = CQUIT;
	b.c_cc[VERASE]   = CERASE;
	b.c_cc[VKILL]    = CKILL;
	b.c_cc[VEOF]     = CEOF;
	b.c_cc[VEOL]     = 0;
	b.c_cc[VEOL2]    = 0;
	b.c_cc[VSTART]   = CSTART;
	b.c_cc[VSTOP]    = CSTOP;
	b.c_cc[VSUSP]    = 'Z' - '@';
#ifndef linux
	b.c_cc[VDSUSP]   = 'Y' - '@';
#endif
#ifdef _AIX
	b.c_cc[VREPRINT] = 'R' - '@';
	b.c_cc[VDISCRD]  = 'O' - '@';
	b.c_cc[VWERSE]   = 'W' - '@';
#endif
	b.c_cc[VLNEXT]   = 'V' - '@';
	tcsetattr(wfd,TCSANOW,(struct termios *)&b);
   }

#ifdef  TIOCSWINSZ
   (void) ioctl(wfd, TIOCSWINSZ, &w);
#else
#ifdef  TXSETWINSZ
   (void) ioctl(wfd, TXSETWINSZ, &w);
#endif  /* TXSETWINSZ */
#endif  /* TIOCSWINSZ */

   setup_term();

   if ((pid = fork()) < 0)
   {
	syslog(LOG_ERR,"Error: fork failed, %s.",
		sys_errlist[errno]);
	sprintf(buf,"Cannot connect to %s.",hostname);
	return(say(0,buf));
   }

   if (pid == 0)
   {
	int  term;

	setsid();
	
	term = open(pty,O_RDWR);
	if (term <= 0)
	{
	    syslog(LOG_ERR,"Error: Failed to open slave pty, %s.\n",
		sys_errlist[errno]);
	    exit(1);
	}

	close(wfd);
	close(rfd);
	dup2(term,0);
	dup2(term,1);
	dup2(term,2);
	if (term > 2)
	    close(term);

	setup_login(pty);

	execl("/bin/login","login","-p","-h",hostname,(char *)0);

	syslog(LOG_ERR,"Error: Could not exec ksh, %s.",
			sys_errlist[errno]);
	sprintf(buf,"Cannot connect to %s.",hostname);
	exit(say(1,buf));

   }

   /*====================================================================
    * Set the file descriptors
    *===================================================================*/

   close(wfd);
   setsid();

#ifndef __sun
   ioctl(0, FIONBIO, &on);
   ioctl(rfd, FIONBIO, &on);
#endif /* ndef __sun */

   signal(SIGTSTP,SIG_IGN);

   if (negotiate_encrypt())
   {
	say(0,"Connect to firewall denied.\n");
	syslog(LOG_NOTICE,"telnet client does not or cannot do "
			"encryption, login to firewall denied.");
	exit(1);
   }

	/*==================================================================
	 * Request client to negotiate window sizes.
	 *=================================================================*/
   {
	unsigned char xuf[24];

	xuf[0] = IAC;
	xuf[1] = DO;
	xuf[2] = TELOPT_NAWS;

	if(Ewrite(0,xuf,3) != 3)
	{
	    syslog(LOG_ERR,"Error: Failed writing TELOPTS_NAWS, %s.",
			sys_errlist[errno]);
	    exit(1);
	}

	/*==================================================================
	 * Tell client we're not doing these.
	 *=================================================================*/
	xuf[0] = IAC;
	xuf[1] = DONT;
	xuf[2] = TELOPT_TSPEED;
	xuf[3] = IAC;
	xuf[4] = DONT;
	xuf[5] = TELOPT_LFLOW;
	xuf[6] = IAC;
	xuf[7] = DONT;
	xuf[8] = TELOPT_LINEMODE;
	xuf[9] = IAC;
	xuf[10] = DONT;
	xuf[11] = TELOPT_ENVIRON;
	xuf[12] = IAC;
	xuf[13] = WONT;
	xuf[14] = TELOPT_STATUS;
	xuf[15] = IAC;
	xuf[16] = DONT;
	xuf[17] = TELOPT_XDISPLOC;
	xuf[18] = IAC;
	xuf[19] = DO;
	xuf[20] = TELOPT_ECHO;
	xuf[21] = IAC;
	xuf[22] = DONT;
	xuf[23] = TELOPT_ECHO;

	if(Ewrite(0,xuf,24) != 24)
	{
	    syslog(LOG_ERR,"Error: Failed writing TELOPTS, %s.",
			sys_errlist[errno]);
	    exit(1);
	}
   }

   return(2);		/* successful return */
}


/*========================================================================
 * function negotiate_encrypt
 *		Negotiate encryption with a telnet client
 * inputs:
 * return:	0 if successful
 *		<0 if failed
 *========================================================================*/
int negotiate_encrypt()
{
   /*==================================================================
    * Request client to begin encrypted transmission.
    *=================================================================*/
   unsigned char	nebuf[BUFSIZ];
   fd_set		fs;
   struct timeval	to;
   int			i,rc;

   nebuf[0] = IAC;
   nebuf[1] = DO;
   nebuf[2] = TELOPT_ENCRYPT;
   nebuf[3] = IAC;
   nebuf[4] = SB;
   nebuf[5] = TELOPT_ENCRYPT;
   nebuf[6] = ENCRYPT_ENC_KEYID;
   i 	= strlen(proxyptr->username);
   strncpy(&nebuf[7],proxyptr->username,i);
   nebuf[i+7] = IAC;
   nebuf[i+8] = SE;

   if(write(0,nebuf,i+9) != i+9)
   {
	syslog(LOG_ERR,"Error: Failed writing TELOPT_ENCRYPT, %s.",
			sys_errlist[errno]);
	exit(1);
   }

   /*==================================================================
    * Request client to begin encrypted transmission.
    * This loop waits for an IAC SB TELOPT_ENCRYPT from the client and
    * then set the encrypt mode.  If the client does not respond with an
    * IAC SB TELOPT_ENCRYPT, the function returns with a -1.
    *=================================================================*/

   while (!csecrets)
   {
	FD_ZERO(&fs);
	FD_SET(0,&fs);
	to.tv_usec = 0;
	to.tv_sec = 10;		/* wait 10 seconds for IAC WILL ENCRYPT */
#ifndef __hppa	
	if(select(1,&fs,(fd_set *)0,(fd_set *)0,&to) < 1)
#else
	if(select(1,(int *)&fs,0,0,&to) < 1)
#endif	
	{  
	   syslog(LOG_ERR,
			"Error: Select failed while negotiating encryption. "
			"%s.",
			sys_errlist[errno]);
	   return(-1);
	}

	if(FD_ISSET(0,&fs))
	{
	    if((rc=read(0,nebuf,sizeof(nebuf))) <= 0)
	    {
		syslog(LOG_ERR,
			"Error: Failed reading TELOPT_ENCRYPT, %s.",
			sys_errlist[errno]);
		exit(1);
	    }
	    if(rc < 3)
		continue;
	    for (i=0; i<rc-6; i++)
	    {
		if	(nebuf[i]   == IAC &&
			 nebuf[i+1] == SB &&
			 nebuf[i+2] == TELOPT_ENCRYPT &&
			 nebuf[i+3] == ENCRYPT_ENC_KEYID &&
			 nebuf[i+4] == '\0' &&
			 nebuf[i+5] == IAC &&
			 nebuf[i+6] == SE)
		{
		    csecrets = 1;
		    return(0);
		}
	    }
	}
   }
}

/*========================================================================
 * function Eread
 *		Reads from fd and decrypt if necessary.
 * inputs:	file descriptor
 *		ptr to buffer
 *		length to read
 * return:	number of bytes read if read is ok
 *		<0 if failed
 *		(same return values as read())
 *========================================================================*/
Eread(int fd, char *buf, int len)
{

   /*=======================================================================
    * Do normal read if not in encryption mode.
    *======================================================================*/
   if ((fd == 0 && !csecrets) || (fd != 0 && !ssecrets))
   {
	return(read(fd,buf,len));
   }
   /*=======================================================================
    * If fd is 0, we treat fd as the client side.
    *======================================================================*/
   if (fd == 0 && csecrets)
   {
	return(enc_read(fd,(unsigned char *)buf,len,ckeysched));
   }
   /*=======================================================================
    * If fd is not 0, we treat fd as the server side.
    *======================================================================*/
   if (fd == 0 && ssecrets)
   {
	return(enc_read(fd,(unsigned char *)buf,len,skeysched));
   }
}

/*========================================================================
 * function Ewrite
 *		Writes to fd (encrypted if necessary).
 * inputs:	file descriptor
 *		ptr to buffer
 *		length to write
 * return:	number of bytes written if write is ok
 *		<0 if failed
 *		(same return values as write())
 *========================================================================*/
Ewrite(int fd, char *buf, int len)
{

   /*=======================================================================
    * Do normal write if not in encryption mode.
    *======================================================================*/
   if ((fd == 0 && !csecrets) || (fd != 0 && !ssecrets))
   {
	return(write(fd,buf,len));
   }
   /*=======================================================================
    * If fd is 0, we treat fd as the client side.
    *======================================================================*/
   if (fd == 0 && csecrets)
   {
	return(enc_write(fd,(unsigned char *)buf,len,ckeysched));
   }
   /*=======================================================================
    * If fd is not 0, we treat fd as the server side.
    *======================================================================*/
   if (fd == 0 && ssecrets)
   {
	return(enc_write(fd,(unsigned char *)buf,len,skeysched));
   }
}
