/* Test gwuser API */

#include <stdio.h>
#include <time.h>
#include "firewall.h"
#include "gwuser.h"

main()
{
  struct GWUSER user;
  struct GWCONF conf;
  char username[UNMSIZ];
  char password[PWDSIZ];
  char errstring[80];
  int ret;
  int i;

/**********************************************************************/

  printf("*** Test get_gwuser ***\n\n");

  strcpy(username,"waltc");
  printf("username = %s\n\n",username);

  ret = get_gwuser(username,&user);
  printf("user.type = %d\n",user.type); 
  printf("user.random[0] = %d\n",user.random[0]); 
  printf("user.random[1] = %d\n",user.random[1]); 
  printf("user.username = %s\n",user.username); 
  printf("user.realname = %s\n",user.realname); 
  printf("user.phonenum = %s\n",user.phonenum); 
  printf("user.groupname = %s\n",user.groupname); 
  for (i = 0; i < MAXPWDS; i++)
    printf("user.password[%d] = %s\n",i,user.password[i]);
  printf("user.passworddate = %s",ctime(&user.passworddate));
  printf("user.tokentype = %d\n",user.tokentype);
  printf("user.userkey = ");
  printf("%3.3o %3.3o %3.3o %3.3o ",user.userkey[0],user.userkey[1],
         user.userkey[2],user.userkey[3]);
  printf("%3.3o %3.3o %3.3o %3.3o\n",user.userkey[4],user.userkey[5],
         user.userkey[6],user.userkey[7]);
  printf("user.tnaccess = %d\n",user.tnaccess);
  printf("user.ftpaccess = %d\n",user.ftpaccess);
  printf("user.startdate = %s",ctime(&user.startdate));
  printf("user.stopdate = %s",ctime(&user.stopdate));
  printf("user.accesstimes = 0x%x 0x%x 0x%x ...\n",
          user.accesstimes[0],user.accesstimes[1],user.accesstimes[2]);
  printf("user.recorddate = %s",ctime(&user.recorddate));
  printf("user.status = %d\n",user.status);

  printf("\nreturn status = %d\n",ret);

/**********************************************************************/

  printf("\n*** Test get_gwuserconf ***\n\n");

  ret = get_gwuserconf(&conf);
  printf("conf.groupname = %s\n",conf.groupname);
  printf("conf.tokentype = %d\n",conf.tokentype);
  printf("conf.tnaccess = %d\n",conf.tnaccess);
  printf("conf.ftpaccess = %d\n",conf.ftpaccess);
  printf("conf.accesstimes = 0x%x 0x%x 0x%x ...\n",
          conf.accesstimes[0],conf.accesstimes[1],conf.accesstimes[2]);
  printf("conf.password_min_len = %d\n",conf.password_min_len);
  printf("conf.password_min_alpha = %d\n",conf.password_min_alpha);
  printf("conf.password_min_other = %d\n",conf.password_min_other);
  printf("conf.password_max_age = %d\n",conf.password_max_age);
  printf("conf.no_unique_passwords = %d\n",conf.no_unique_passwords);
  printf("conf.no_login_attempts = %d\n",conf.no_login_attempts);

  printf("\nreturn status = %d\n",ret);

/**********************************************************************/

  printf("\n*** Test check_password ***\n\n");

  strcpy(password,"abcdef");
  printf("password = %s\n\n",password);

  ret = check_password(password,user.password,&conf,errstring);
  if (ret < 0)
    printf("%s\n",errstring);

  printf("return status = %d\n\n",ret);

  strcpy(password,"abc001");
  printf("password = %s\n\n",password);

  ret = check_password(password,user.password,&conf,errstring);
  if (ret < 0)
    printf("%s\n",errstring);

  printf("return status = %d\n\n",ret);

  strcpy(password,"abc002");
  printf("password = %s\n\n",password);

  ret = check_password(password,user.password,&conf,errstring);
  if (ret < 0)
    printf("%s\n",errstring);

  printf("return status = %d\n",ret);

/**********************************************************************/

  printf("\n*** Test set_password ***\n\n");

  strcpy(password,"abc003");
  printf("password = %s\n\n",password);

  ret = set_password(username,password);

  printf("return status = %d\n",ret);
}
